#############################################################################
##
#A  tbl/cmplxg33.g                 CHEVIE library                Jean Michel
##
#Y  Copyright (C) 1998 - 2002  The CHEVIE Team
##
##  This file  contains data about  the complex reflection group  G33 in
##  the Shephard-Todd classification.
##
CHEVIE.Revision("tbl/cmplxg33.g",
   "$Id: cmplxg33.g,v 1.3 2003/12/04 11:26:45 chevie Exp $");

CHEVIE.AddData("PrintDiagram","G33",function(indices,title)local s;
  Print(title," ");s:=String("",Length(title)-5);
  Print("    ",indices[3],"\n       /^\\\n",
	s,indices[1],"---",indices[2],"---",indices[4],"---",indices[5]," ",
	IntListToString(indices{[4,2,3,4,2,3]}),"=",
	IntListToString(indices{[3,4,2,3,4,2]}),"\n");
end);

CHEVIE.AddData("BraidRelations","G33",
  [[[1,2,1],[2,1,2]],[[3,2,3],[2,3,2]],[[4,2,4],[2,4,2]],[[4,3,4],[3,4,3]],
   [[4,5,4],[5,4,5]],[[1,3],[3,1]],[[1,4],[4,1]],[[1,5],[5,1]],[[2,5],[5,2]],
   [[3,5],[5,3]],[[4,2,3,4,2,3],[3,4,2,3,4,2]]]);

# This group is derived by  a non-orthogonal projection on coordinates 3
# and 4  from ReflectionSubGroup(G34,[1..5]). If  one replaces the  2 in
# the  5th  root  by  ER(2),  one  obtains  orthogonal  roots  (but  the
# definition field and invariants become worse).
# The  group thus  defined agrees  with Burkhardt,  Math. Annalen  38 pp
# 208--209 up to an interchange of x and z.

CHEVIE.AddData("GeneratingRoots","G33",
  [[ER(-3),-ER(-3),0,0,0],[0,ER(-3),0,0,-ER(-3)],[0,0,0,-ER(-3),ER(-3)],
   [0,0,0,(3+ER(-3))/2,(3-ER(-3))/2],[-1,-1,2,-1,-1]]);

CHEVIE.AddData("GeneratingCoRoots","G33",
  [[-ER(-3),ER(-3),0,0,0],[0,-ER(-3),0,0,ER(-3)],[0,0,0,ER(-3),-ER(-3)],
   [0,0,0,(3-ER(-3))/2,(3+ER(-3))/2],[-1,-1,1,-1,-1]]/3);

CHEVIE.AddData("CartanMat","G33",function()
  return CHEVIE.RawData("GeneratingCoRoots","G33")*
  TransposedMat(CHEVIE.RawData("GeneratingRoots","G33"));
 end);

CHEVIE.AddData("EigenvaluesGeneratingReflections","G33",[1/2,1/2,1/2,1/2,1/2]);

CHEVIE.AddData("Size","G33", 51840);

CHEVIE.AddData("ReflectionCoDegrees","G33",[0,6,8,12,14]);

CHEVIE.AddData("ReflectionDegrees","G33",[4,6,10,12,18]);

CHEVIE.AddData("NrConjugacyClasses","G33", 40);

CHEVIE.AddData("ParabolicInfo","G33",# parabolic types
 [[rec(series:="ST",indices:=[1,2,3,4],rank:=4,p:=3,q:=3)],
  [rec(series:="A",indices:=[1,2,3],rank:=3),
   rec(series:="A",indices:=[5],rank:=1)],
  [rec(series:="A",indices:=[1,2,4,5],rank:=4)],
  [rec(series:="A",indices:=[1],rank:=1),
   rec(series:="A",indices:=[3,4,5],rank:=3)],
  [rec(series:="ST",indices:=[2,3,4,5],rank:=4,p:=3,q:=3)]]);

CHEVIE.AddData("WordsClassRepresentatives","G33",
 [[],[1],[3,1],[1,2],[1,2,3],[2,3,4],[2,4,3],
 [3,4,1],[5,3,1],[1,2,4,5],[1,2,3,4],[1,2,4,3],[5,1,2,3],[5,4,3,2,1],
 [5,4,2,1,3],[4,5,3,4,2,1],[3,4,2,3,1,2],[3,4,2,3,4,2],[4,3,2,4,3,2],
 [4,5,3,4,3,2,1],[5,4,3,2,4,1,2],[3,4,5,2,4,1,2],[3,4,2,3,4,1,2],
 [2,4,3,1,2,4,3],[3,4,5,2,3,4,1,2],[5,2,4,3,1,2,4,3],[4,5,3,4,2,3,1,2,1],
 [3,1,2,4,5,1,2,3,4,2],[5,3,4,2,3,1,2,4,3,2],[5,4,2,3,1,2,4,3,2,1],
 [4,2,3,1,2,4,1,2,3,1,2,1],[3,2,4,5,1,2,4,3,2,4,5,2,4],
 [3,2,4,5,1,2,4,3,2,4,5,1,2,4],[2,3,4,5,2,4,1,2,3,4,5,2,4,1],
 [5,1,2,4,3,1,2,4,5,4,3,1,2,4,3],[3,4,5,2,4,3,1,2,4,5,3,2,4,1,2],
 [5,4,2,1,3,5,4,2,1,3,5,4,2,1,3],[5,3,2,4,2,3,1,2,4,5,4,2,3,1,2,4,1],
 [1,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3],
 [5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3]]);

CHEVIE.AddData("ClassNames","G33",
 [".","1","31","12","123","234","243","341","531","1245",
 "1234","1243","5123","54321","c","453421","342312","342342","432432",
 "4534321","5432412","3452412","3423412","2431243","34523412","52431243",
 "453423121","3124512342","5342312432","5423124321","423124123121",
 "3245124324524","32451243245124","23452412345241","512431245431243",
 "345243124532412","ccc","53242312454231241","1z","z"]);

CHEVIE.AddData("PowerMaps","G33",
 [ , [ 1, 1, 1, 4, 3, 18, 19, 4, 1, 10, 12, 11, 3, 12, 11, 4, 31, 19, 18, 10,
      33,34,31,31,34, 33, 31, 31, 39, 31, 31, 31, 19, 18, 19, 39, 18, 4,1,1],
  [ 1, 2, 3, 1, 5, 2, 2, 2, 9, 10, 18, 19, 13, 35, 37, 39, 3, 1, 1, 20, 36,
      36, 2, 2, 29, 29, 40, 39, 29, 39, 1, 9, 39, 39, 40, 36, 40, 40, 39, 40 ]
   ,, [ 1, 2, 3, 4, 5, 7, 6, 8, 9, 1, 12, 11, 13, 15, 14, 16, 17, 19, 18, 40,
      22, 21,24,23,26,25,27,30,29,28,31,32, 34, 33, 37, 36, 35, 38, 39, 40 ],,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21,22,23,24,25,26,27,28,29,30,31,32, 33, 34, 35, 36, 37, 38, 39, 40 ],,,,
  [ 1, 2, 3, 4, 5, 7, 6, 8, 9, 10, 12, 11, 13, 15, 14, 16, 17, 19, 18, 20,
      22,21,24,23,26,25,27,30,29,28,31, 32, 34, 33, 37, 36, 35, 38, 39, 40 ],,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21,22,23,24,25,26,27,28,29,30,31,32, 33, 34, 35, 36, 37, 38, 39, 40 ],,,,
  [ 1, 2, 3, 4, 5, 7, 6, 8, 9, 10, 12, 11, 13, 15, 14, 16, 17, 19, 18, 20,
      22,21,24,23,26,25,27,30,29,28,31,32,34, 33, 37, 36, 35, 38, 39, 40 ] ]);

CHEVIE.AddData("ClassInfo","G33",
  rec(classtext:=CHEVIE.RawData("WordsClassRepresentatives","G33"),
    classnames:=CHEVIE.RawData("ClassNames","G33"),
    classparams:=CHEVIE.RawData("ClassNames","G33"),
    orders:=[1,2,2,3,4,6,6,6,2,5,9,9,4,18,18,6,6,3,3,
             10,12,12,6,6,12,12,6,6,4,6,3,6,6,6,6,4,6,6,2,2],
    classes:=[1,45,270,480,3240,360,360,1440,270,5184,2880,2880,3240,2880,
  2880, 1440, 2160, 40, 40, 5184, 2160, 2160, 720, 720, 2160, 2160, 240, 720,
  540, 720, 240, 2160, 360, 360, 40, 540, 40, 480, 45, 1 ]));

CHEVIE.AddData("ClassName", "G33", x->x);

CHEVIE.AddData("CharInfo","G33",function()local res;
  res:=rec(charparams:=[[1,0],[1,45],[5,28],[5,1],[5,30],[5,3],[6,20],
    [6,5],[10,8,"''"],[10,17,"''"],[10,8,"'"],[10,17,"'"],[15,12],[15,9],
    [15,2],[15,23],[20,6],[20,15],[24,4],[24,19],[30,18],[30,3],[30,6],[30,15],
    [30,4],[30,13],[40,14,"'"],[40,5,"'"],[40,14,"''"],[40,5,"''"],[45,12],
    [45,9],[45,10],[45,7],[60,10],[60,7],[64,8],[64,9],[81,6],[81,11]],
# here the labelling is as follows: phi_10,8' has fake degree q^28+q^26+...,
# phi_40,5' has fake degree q^31+q^29+2q^27+...
# phi_10,8' tensored by sign is phi_10,17' and
# phi_40,5' tensored by sign is phi_40,14'
  positionId:=1,
  positionSgn:=2,
  positionRefl:=4);
  res.b:=List(res.charparams,x->x[2]);
  res.spetsRationality:=[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,2,2,1,1];
  return res;
end);

CHEVIE.AddData("CycPolSchurElements","G33",
[ [1,0,2,2,2,2,2,3,3,3,4,4,5,6,6,6,9,10,12,18],
  [1,-45,2,2,2,2,2,3,3,3,4,4,5,6,6,6,9,10,12,18],
  [(3+ER(-3))/2,-28,2,2,2,2,2,3,3,3,4,4,6,6,6,1/9,4/9,7/9,1/12,7/12,5/18,11/18,
    17/18],
  [(3-ER(-3))/2,-1,2,2,2,2,2,3,3,3,4,4,6,6,6,2/9,5/9,8/9,5/12,11/12,1/18,7/18,
   13/18],
  [(3-ER(-3))/2,-28,2,2,2,2,2,3,3,3,4,4,6,6,6,2/9,5/9,8/9,5/12,11/12,1/18,7/18,
  13/18],
  [(3+ER(-3))/2,-1,2,2,2,2,2,3,3,3,4,4,6,6,6,1/9,4/9,7/9,1/12,7/12,5/18,11/18,
   17/18], [2,-18,2,2,2,2,2,3,3,3,5,6,6,6], [2,-3,2,2,2,2,2,3,3,3,5,6,6,6],
  [6*E(3)^2,-4,2,2,2,2,2,3,3,3,5/6,5/6,5/6,1/18,7/18,13/18],
  [6*E(3),-13,2,2,2,2,2,3,3,3,1/6,1/6,1/6,5/18,11/18,17/18],
  [6*E(3),-4,2,2,2,2,2,3,3,3,1/6,1/6,1/6,5/18,11/18,17/18],
  [6*E(3)^2,-13,2,2,2,2,2,3,3,3,5/6,5/6,5/6,1/18,7/18,13/18],
  [1,-12,2,2,2,2,2,3,3,3,4,4,6,6,6], [1,-9,2,2,2,2,2,3,3,3,4,4,6,6,6],
  [1,-2,2,2,2,2,2,3,3,3,4,4,6,6,6,12],
  [1,-23,2,2,2,2,2,3,3,3,4,4,6,6,6,12], [3,-4,2,2,2,2,2,3,3,3,6,6,6],
  [3,-13,2,2,2,2,2,3,3,3,6,6,6], [2,-3,2,3,3,3,4,4,5,6,12],
  [2,-18,2,3,3,3,4,4,5,6,12], [2,-18,2,2,2,2,2,3,3,3,6,6,6,10],
  [2,-3,2,2,2,2,2,3,3,3,6,6,6,10],
  [-6*E(3)^2,-4,2,2,2,2,2,1/3,1/3,1/3,6,6,6,2/9,5/9,8/9],
  [-6*E(3),-13,2,2,2,2,2,2/3,2/3,2/3,6,6,6,1/9,4/9,7/9],
  [-6*E(3),-4,2,2,2,2,2,2/3,2/3,2/3,6,6,6,1/9,4/9,7/9],
  [-6*E(3)^2,-13,2,2,2,2,2,1/3,1/3,1/3,6,6,6,2/9,5/9,8/9],
  [3-ER(-3),-13,2,3,3,3,4,4,5/6,2/9,5/9,8/9,1/12,7/12],
  [3+ER(-3),-4,2,3,3,3,4,4,1/6,1/9,4/9,7/9,5/12,11/12],
  [3+ER(-3),-13,2,3,3,3,4,4,1/6,1/9,4/9,7/9,5/12,11/12],
  [3-ER(-3),-4,2,3,3,3,4,4,5/6,2/9,5/9,8/9,1/12,7/12],
  [(3-ER(-3))/2,-10,2,2,2,2,2,1/3,1/3,1/3,4,4,5/6,5/6,5/6,1/12,7/12],
  [(3+ER(-3))/2,-7,2,2,2,2,2,2/3,2/3,2/3,4,4,1/6,1/6,1/6,5/12,11/12],
  [(3+ER(-3))/2,-10,2,2,2,2,2,2/3,2/3,2/3,4,4,1/6,1/6,1/6,5/12,11/12],
  [(3-ER(-3))/2,-7,2,2,2,2,2,1/3,1/3,1/3,4,4,5/6,5/6,5/6,1/12,7/12],
  [1,-10,2,2,2,2,2,3,3,3,6,6,6], [1,-7,2,2,2,2,2,3,3,3,6,6,6],
  [2,-8,3,3,3,5,9], [2,-8,3,3,3,5,9], [1,-6,2,2,2,2,2,4,4,5,10],
  [1,-11,2,2,2,2,2,4,4,5,10] ]
);

CHEVIE.AddData("vpolfakedegrees","G33",[[[1],0],[[1],45],
 [[1,0,0,0,0,0,1,0,1,0,0,0,1,0,1],28],
 [[1,0,0,0,0,0,1,0,1,0,0,0,1,0,1],1],
 [[1,0,1,0,0,0,1,0,1,0,0,0,0,0,1],30],
 [[1,0,1,0,0,0,1,0,1,0,0,0,0,0,1],3],
 [[1,0,0,0,0,0,1,0,1,0,0,0,1,0,1,0,0,0,0,0,1],20],
 [[1,0,0,0,0,0,1,0,1,0,0,0,1,0,1,0,0,0,0,0,1],5],
 [[1,0,1,0,0,0,1,0,2,0,0,0,1,0,2,0,1,0,0,0,1],8],
 [[1,0,1,0,0,0,1,0,2,0,0,0,1,0,2,0,1,0,0,0,1],17],
 [[1,0,0,0,1,0,2,0,1,0,0,0,2,0,1,0,0,0,1,0,1],8],
 [[1,0,0,0,1,0,2,0,1,0,0,0,2,0,1,0,0,0,1,0,1],17],
 [[1,0,0,0,1,0,2,0,1,0,1,0,3,0,1,0,1,0,2,0,1,0,0,0,1],12],
 [[1,0,0,0,1,0,2,0,1,0,1,0,3,0,1,0,1,0,2,0,1,0,0,0,1],9],
 [[1,0,1,0,1,0,2,0,2,0,1,0,2,0,2,0,1,0,1,0,1],2],
 [[1,0,1,0,1,0,2,0,2,0,1,0,2,0,2,0,1,0,1,0,1],23],
 [[1,0,1,0,1,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,0,1,0,1],6],
 [[1,0,1,0,1,0,2,0,2,0,2,0,2,0,2,0,2,0,2,0,1,0,1,0,1],15],
 [[1,0,2,0,1,0,2,0,4,0,2,0,2,0,4,0,2,0,1,0,2,0,1],4],
 [[1,0,2,0,1,0,2,0,4,0,2,0,2,0,4,0,2,0,1,0,2,0,1],19],
 [[1,0,1,0,2,0,3,0,3,0,3,0,4,0,3,0,3,0,3,0,2,0,1,0,1],18],
 [[1,0,1,0,2,0,3,0,3,0,3,0,4,0,3,0,3,0,3,0,2,0,1,0,1],3],
 [[1,0,2,0,1,0,3,0,4,0,2,0,3,0,5,0,2,0,2,0,3,0,1,0,0,0,1],6],
 [[1,0,2,0,1,0,3,0,4,0,2,0,3,0,5,0,2,0,2,0,3,0,1,0,0,0,1],15],
 [[1,0,0,0,1,0,3,0,2,0,2,0,5,0,3,0,2,0,4,0,3,0,1,0,2,0,1],4],
 [[1,0,0,0,1,0,3,0,2,0,2,0,5,0,3,0,2,0,4,0,3,0,1,0,2,0,1],13],
 [[1,0,2,0,1,0,3,0,5,0,3,0,4,0,6,0,4,0,3,0,4,0,2,0,1,0,1],14],
 [[1,0,2,0,1,0,3,0,5,0,3,0,4,0,6,0,4,0,3,0,4,0,2,0,1,0,1],5],
 [[1,0,1,0,2,0,4,0,3,0,4,0,6,0,4,0,3,0,5,0,3,0,1,0,2,0,1],14],
 [[1,0,1,0,2,0,4,0,3,0,4,0,6,0,4,0,3,0,5,0,3,0,1,0,2,0,1],5],
 [[2,0,2,0,2,0,5,0,5,0,3,0,6,0,6,0,3,0,4,0,4,0,1,0,1,0,1],12],
 [[2,0,2,0,2,0,5,0,5,0,3,0,6,0,6,0,3,0,4,0,4,0,1,0,1,0,1],9],
 [[1,0,1,0,1,0,4,0,4,0,3,0,6,0,6,0,3,0,5,0,5,0,2,0,2,0,2],10],
 [[1,0,1,0,1,0,4,0,4,0,3,0,6,0,6,0,3,0,5,0,5,0,2,0,2,0,2],7],
 [[1,0,2,0,2,0,4,0,6,0,5,0,6,0,8,0,6,0,5,0,6,0,4,0,2,0,2,0,1],10],
 [[1,0,2,0,2,0,4,0,6,0,5,0,6,0,8,0,6,0,5,0,6,0,4,0,2,0,2,0,1],7],
 [[1,0,1,0,2,0,5,0,5,0,5,0,8,0,8,0,5,0,7,0,7,0,3,0,3,0,3,0,1],8],
 [[1,0,3,0,3,0,3,0,7,0,7,0,5,0,8,0,8,0,5,0,5,0,5,0,2,0,1,0,1],9],
 [[1,0,2,0,4,0,5,0,7,0,8,0,9,0,9,0,9,0,8,0,7,0,5,0,4,0,2,0,1],6],
 [[1,0,2,0,4,0,5,0,7,0,8,0,9,0,9,0,9,0,8,0,7,0,5,0,4,0,2,0,1],11]]);

CHEVIE.AddData("Irr","G33",
[[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1],
[1,-1,1,1,-1,-1,-1,-1,-1,1,1,1,1,-1,-1,1,1,1,1,-1,-1,
-1,-1,-1,1,1,-1,1,1,1,1,-1,1,1,-1,-1,-1,-1,1,-1],
[5,-3,1,2,-1,2*E(3)+E(3)^2,E(3)+2*E(3)^2,0,1,0,-E(3),-E(3)^2,
-1,-E(3),-E(3)^2,0,1,E(3)-2*E(3)^2,-2*E(3)+E(3)^2,0,E(3)^2,
E(3),-E(3)+E(3)^2,E(3)-E(3)^2,E(3),E(3)^2,-1,E(3)-E(3)^2,1,
-E(3)+E(3)^2,-1,1,E(3)+2*E(3)^2,2*E(3)+E(3)^2,E(3)-2*E(3)^2,1,
-2*E(3)+E(3)^2,2,-3,5],
[5,3,1,2,1,-2*E(3)-E(3)^2,-E(3)-2*E(3)^2,0,-1,0,-E(3),-E(3)^2,
-1,E(3),E(3)^2,0,1,E(3)-2*E(3)^2,-2*E(3)+E(3)^2,0,-E(3)^2,
-E(3),E(3)-E(3)^2,-E(3)+E(3)^2,E(3),E(3)^2,1,E(3)-E(3)^2,1,
-E(3)+E(3)^2,-1,-1,E(3)+2*E(3)^2,2*E(3)+E(3)^2,-E(3)+2*E(3)^2,-1,
2*E(3)-E(3)^2,-2,-3,-5],
[5,-3,1,2,-1,E(3)+2*E(3)^2,2*E(3)+E(3)^2,0,1,0,-E(3)^2,-E(3),
-1,-E(3)^2,-E(3),0,1,-2*E(3)+E(3)^2,E(3)-2*E(3)^2,0,E(3),
E(3)^2,E(3)-E(3)^2,-E(3)+E(3)^2,E(3)^2,E(3),-1,-E(3)+E(3)^2,1,
E(3)-E(3)^2,-1,1,2*E(3)+E(3)^2,E(3)+2*E(3)^2,-2*E(3)+E(3)^2,1,
E(3)-2*E(3)^2,2,-3,5],
[5,3,1,2,1,-E(3)-2*E(3)^2,-2*E(3)-E(3)^2,0,-1,0,-E(3)^2,-E(3),
-1,E(3)^2,E(3),0,1,-2*E(3)+E(3)^2,E(3)-2*E(3)^2,0,-E(3),
-E(3)^2,-E(3)+E(3)^2,E(3)-E(3)^2,E(3)^2,E(3),1,-E(3)+E(3)^2,1,
E(3)-E(3)^2,-1,-1,2*E(3)+E(3)^2,E(3)+2*E(3)^2,2*E(3)-E(3)^2,-1,
-E(3)+2*E(3)^2,-2,-3,-5],
[6,-2,2,0,0,1,1,-2,2,1,0,0,0,0,0,-2,-1,-3,-3,1,-1,-1,
1,1,-1,-1,3,1,2,1,3,-1,1,1,-3,2,-3,0,-2,6],
[6,2,2,0,0,-1,-1,2,-2,1,0,0,0,0,0,-2,-1,-3,-3,-1,1,1,
-1,-1,-1,-1,-3,1,2,1,3,1,1,1,3,-2,3,0,-2,-6],
[10,2,-2,1,0,-2*E(3)+E(3)^2,E(3)-2*E(3)^2,-1,-2,0,E(3)^2,E(3),
0,E(3)^2,E(3),-1,1,5*E(3)+2*E(3)^2,2*E(3)+5*E(3)^2,0,-E(3)^2,
-E(3),-1,-1,-E(3),-E(3)^2,1,-1,2,-1,1,1,E(3)-2*E(3)^2,
-2*E(3)+E(3)^2,5*E(3)+2*E(3)^2,2,2*E(3)+5*E(3)^2,1,2,10],
[10,-2,-2,1,0,2*E(3)-E(3)^2,-E(3)+2*E(3)^2,1,2,0,E(3)^2,E(3),
0,-E(3)^2,-E(3),-1,1,5*E(3)+2*E(3)^2,2*E(3)+5*E(3)^2,0,E(3)^2,
E(3),1,1,-E(3),-E(3)^2,-1,-1,2,-1,1,-1,E(3)-2*E(3)^2,
-2*E(3)+E(3)^2,-5*E(3)-2*E(3)^2,-2,-2*E(3)-5*E(3)^2,-1,2,-10],
[10,2,-2,1,0,E(3)-2*E(3)^2,-2*E(3)+E(3)^2,-1,-2,0,E(3),E(3)^2,
0,E(3),E(3)^2,-1,1,2*E(3)+5*E(3)^2,5*E(3)+2*E(3)^2,0,-E(3),
-E(3)^2,-1,-1,-E(3)^2,-E(3),1,-1,2,-1,1,1,-2*E(3)+E(3)^2,
E(3)-2*E(3)^2,2*E(3)+5*E(3)^2,2,5*E(3)+2*E(3)^2,1,2,10],
[10,-2,-2,1,0,-E(3)+2*E(3)^2,2*E(3)-E(3)^2,1,2,0,E(3),E(3)^2,
0,-E(3),-E(3)^2,-1,1,2*E(3)+5*E(3)^2,5*E(3)+2*E(3)^2,0,E(3),
E(3)^2,1,1,-E(3)^2,-E(3),-1,-1,2,-1,1,-1,-2*E(3)+E(3)^2,
E(3)-2*E(3)^2,-2*E(3)-5*E(3)^2,-2,-5*E(3)-2*E(3)^2,-1,2,-10],
[15,-1,-1,0,-1,2,2,2,-1,0,0,0,-1,0,0,2,-1,6,6,0,0,0,
-1,-1,0,0,3,-1,3,-1,3,-1,2,2,6,3,6,0,-1,15],
[15,1,-1,0,1,-2,-2,-2,1,0,0,0,-1,0,0,2,-1,6,6,0,0,0,
1,1,0,0,-3,-1,3,-1,3,1,2,2,-6,-3,-6,0,-1,-15],
[15,7,3,3,1,1,1,1,3,0,0,0,1,0,0,1,0,-3,-3,0,-1,-1,
-2,-2,-1,-1,0,-2,-1,-2,0,0,1,1,-3,-1,-3,3,7,15],
[15,-7,3,3,-1,-1,-1,-1,-3,0,0,0,1,0,0,1,0,-3,-3,0,1,
1,2,2,-1,-1,0,-2,-1,-2,0,0,1,1,3,1,3,-3,7,-15],
[20,4,4,-1,0,-2,-2,1,4,0,-1,-1,0,-1,-1,1,1,2,2,0,0,0,
1,1,0,0,5,1,0,1,5,1,-2,-2,2,0,2,-1,4,20],
[20,-4,4,-1,0,2,2,-1,-4,0,-1,-1,0,1,1,1,1,2,2,0,0,0,
-1,-1,0,0,-5,1,0,1,5,-1,-2,-2,-2,0,-2,1,4,-20],
[24,8,0,3,0,2,2,-1,0,-1,0,0,0,0,0,-1,0,6,6,-1,0,0,2,
2,0,0,0,2,0,2,0,0,2,2,6,0,6,3,8,24],
[24,-8,0,3,0,-2,-2,1,0,-1,0,0,0,0,0,-1,0,6,6,1,0,0,
-2,-2,0,0,0,2,0,2,0,0,2,2,-6,0,-6,-3,8,-24],
[30,-10,2,3,0,-1,-1,-1,2,0,0,0,0,0,0,-1,-1,3,3,0,1,1,
-1,-1,1,1,3,-1,-2,-1,3,-1,-1,-1,3,-2,3,3,-10,30],
[30,10,2,3,0,1,1,1,-2,0,0,0,0,0,0,-1,-1,3,3,0,-1,-1,
1,1,1,1,-3,-1,-2,-1,3,1,-1,-1,-3,2,-3,-3,-10,-30],
[30,6,2,0,0,2*E(3)+E(3)^2,E(3)+2*E(3)^2,0,2,0,0,0,0,0,0,0,
-1,-3*E(3)+6*E(3)^2,6*E(3)-3*E(3)^2,0,-E(3)^2,-E(3),-E(3)+E(3)^2,
E(3)-E(3)^2,-E(3),-E(3)^2,-3,E(3)-E(3)^2,2,-E(3)+E(3)^2,-3,-1,
E(3)+2*E(3)^2,2*E(3)+E(3)^2,-3*E(3)+6*E(3)^2,2,6*E(3)-3*E(3)^2,0,6,30],
[30,-6,2,0,0,-2*E(3)-E(3)^2,-E(3)-2*E(3)^2,0,-2,0,0,0,0,0,0,
0,-1,-3*E(3)+6*E(3)^2,6*E(3)-3*E(3)^2,0,E(3)^2,E(3),E(3)-E(3)^2,
-E(3)+E(3)^2,-E(3),-E(3)^2,3,E(3)-E(3)^2,2,-E(3)+E(3)^2,-3,1,
E(3)+2*E(3)^2,2*E(3)+E(3)^2,3*E(3)-6*E(3)^2,-2,-6*E(3)+3*E(3)^2,0,6,-30],
[30,6,2,0,0,E(3)+2*E(3)^2,2*E(3)+E(3)^2,0,2,0,0,0,0,0,0,0,
-1,6*E(3)-3*E(3)^2,-3*E(3)+6*E(3)^2,0,-E(3),-E(3)^2,E(3)-E(3)^2,
-E(3)+E(3)^2,-E(3)^2,-E(3),-3,-E(3)+E(3)^2,2,E(3)-E(3)^2,-3,-1,
2*E(3)+E(3)^2,E(3)+2*E(3)^2,6*E(3)-3*E(3)^2,2,-3*E(3)+6*E(3)^2,0,6,30],
[30,-6,2,0,0,-E(3)-2*E(3)^2,-2*E(3)-E(3)^2,0,-2,0,0,0,0,0,0,
0,-1,6*E(3)-3*E(3)^2,-3*E(3)+6*E(3)^2,0,E(3),E(3)^2,
-E(3)+E(3)^2,E(3)-E(3)^2,-E(3)^2,-E(3),3,-E(3)+E(3)^2,2,
E(3)-E(3)^2,-3,1,2*E(3)+E(3)^2,E(3)+2*E(3)^2,
-6*E(3)+3*E(3)^2,-2,3*E(3)-6*E(3)^2,0,6,-30],
[40,-8,0,1,0,-2*E(3),-2*E(3)^2,1,0,0,E(3),E(3)^2,0,E(3),
E(3)^2,1,0,8*E(3)+2*E(3)^2,2*E(3)+8*E(3)^2,0,0,0,-2*E(3),
-2*E(3)^2,0,0,-2,-2*E(3)^2,0,-2*E(3),-2,0,-2*E(3)^2,-2*E(3),
8*E(3)+2*E(3)^2,0,2*E(3)+8*E(3)^2,1,-8,40],
[40,8,0,1,0,2*E(3),2*E(3)^2,-1,0,0,E(3),E(3)^2,0,-E(3),
-E(3)^2,1,0,8*E(3)+2*E(3)^2,2*E(3)+8*E(3)^2,0,0,0,2*E(3),
2*E(3)^2,0,0,2,-2*E(3)^2,0,-2*E(3),-2,0,-2*E(3)^2,-2*E(3),
-8*E(3)-2*E(3)^2,0,-2*E(3)-8*E(3)^2,-1,-8,-40],
[40,-8,0,1,0,-2*E(3)^2,-2*E(3),1,0,0,E(3)^2,E(3),0,E(3)^2,
E(3),1,0,2*E(3)+8*E(3)^2,8*E(3)+2*E(3)^2,0,0,0,-2*E(3)^2,
-2*E(3),0,0,-2,-2*E(3),0,-2*E(3)^2,-2,0,-2*E(3),-2*E(3)^2,
2*E(3)+8*E(3)^2,0,8*E(3)+2*E(3)^2,1,-8,40],
[40,8,0,1,0,2*E(3)^2,2*E(3),-1,0,0,E(3)^2,E(3),0,-E(3)^2,
-E(3),1,0,2*E(3)+8*E(3)^2,8*E(3)+2*E(3)^2,0,0,0,2*E(3)^2,
2*E(3),0,0,2,-2*E(3),0,-2*E(3)^2,-2,0,-2*E(3),-2*E(3)^2,
-2*E(3)-8*E(3)^2,0,-8*E(3)-2*E(3)^2,-1,-8,-40],
[45,-3,-3,0,1,3*E(3)^2,3*E(3),0,-3,0,0,0,1,0,0,0,0,
-9*E(3),-9*E(3)^2,0,E(3)^2,E(3),0,0,E(3),E(3)^2,0,0,1,0,0,
0,3*E(3),3*E(3)^2,-9*E(3),1,-9*E(3)^2,0,-3,45],
[45,3,-3,0,-1,-3*E(3)^2,-3*E(3),0,3,0,0,0,1,0,0,0,0,
-9*E(3),-9*E(3)^2,0,-E(3)^2,-E(3),0,0,E(3),E(3)^2,0,0,1,0,
0,0,3*E(3),3*E(3)^2,9*E(3),-1,9*E(3)^2,0,-3,-45],
[45,-3,-3,0,1,3*E(3),3*E(3)^2,0,-3,0,0,0,1,0,0,0,0,
-9*E(3)^2,-9*E(3),0,E(3),E(3)^2,0,0,E(3)^2,E(3),0,0,1,0,0,
0,3*E(3)^2,3*E(3),-9*E(3)^2,1,-9*E(3),0,-3,45],
[45,3,-3,0,-1,-3*E(3),-3*E(3)^2,0,3,0,0,0,1,0,0,0,0,
-9*E(3)^2,-9*E(3),0,-E(3),-E(3)^2,0,0,E(3)^2,E(3),0,0,1,0,
0,0,3*E(3)^2,3*E(3),9*E(3)^2,-1,9*E(3),0,-3,-45],
[60,-4,4,-3,0,2,2,-1,4,0,0,0,0,0,0,-1,1,6,6,0,0,0,
-1,-1,0,0,-3,-1,0,-1,-3,1,2,2,6,0,6,-3,-4,60],
[60,4,4,-3,0,-2,-2,1,-4,0,0,0,0,0,0,-1,1,6,6,0,0,0,
1,1,0,0,3,-1,0,-1,-3,-1,2,2,-6,0,-6,3,-4,-60],
[64,0,0,-2,0,0,0,0,0,-1,1,1,0,1,1,0,0,-8,-8,-1,0,0,
0,0,0,0,4,0,0,0,4,0,0,0,-8,0,-8,-2,0,64],
[64,0,0,-2,0,0,0,0,0,-1,1,1,0,-1,-1,0,0,-8,-8,1,0,0,
0,0,0,0,-4,0,0,0,4,0,0,0,8,0,8,2,0,-64],
[81,9,-3,0,-1,0,0,0,-3,1,0,0,-1,0,0,0,0,0,0,1,0,0,0,
0,0,0,0,0,-3,0,0,0,0,0,0,-3,0,0,9,81],
[81,-9,-3,0,1,0,0,0,3,1,0,0,-1,0,0,0,0,0,0,-1,0,0,0,
0,0,0,0,0,-3,0,0,0,0,0,0,3,0,0,9,-81]]);

CHEVIE.AddData("CharTable","G33",function()local res;
  res:=rec(size:=51840, order:=51840,
    identifier:="G33", name:="G33",
    powermap:=CHEVIE.RawData("PowerMaps","G33"),
    irreducibles:=CHEVIE.RawData("Irr","G33"),
    irredinfo:=List(CHEVIE.RawData("CharInfo","G33")().charparams,x->
      rec(charparam:=x,charname:=CHEVIE.RawData("CharName","G33")(x,rec()))),
    galomorphisms:=Group((4,5)(6,7)(10,11)(12,13)(14,15)(16,17)(18,19)(20,21)
     (25,26)(28,29)),
    text:="origin: Dixon's Algorithm");
  Inherit(res,CHEVIE.RawData("ClassInfo","G33"));
  res.centralizers := List(res.classes,x->res.size/x);
  return CHEVIE.compat.MakeCharacterTable(res);
end);

CHEVIE.AddData("HeckeRepresentation","G33",function(para,i)
  local p,r,rep,f1,f5,f7,f10;
  p:=para[1][2];r:=para[1][1];
  f1:=r->List([1..5],x->[[r]]);
  f5:=function(p,r,a) return
[[[r,0,0,0,0],[-r,p,0,0,0],[0,0,p,0,0],[0,0,0,p,0],[0,0,0,0,p]],[[p,p,0,0,0],
[0,r,0,0,0],[0,a*p,p,0,0],[0,p,0,p,0],[0,0,0,0,p]],[[p,0,0,0,0],[0,p,
-a^2*r,0,0],[0,0,r,0,0],[0,0,-r,p,0],[0,0,0,0,p]],[[p,0,0,0,0],[0,p,0,-r,
0],[0,0,p,p,0],[0,0,0,r,0],[0,0,0,-r,p]],[[p,0,0,0,0],[0,p,0,0,0],[0,0,p,0,0],
[0,0,0,p,p],[0,0,0,0,r]]]*(p*r)^0;end;
  f7:=function(r,p) return
 [[[r,-r^2,-p*r-p^2-r^2,-r^2,r,0],[0,p,0,0,0,0],[0,0,p,0,0,0],[0,0,0,p,0,0],[0,
0,0,0,p,0],[0,0,-p^2,-r^2,0,r]],[[p,0,0,0,-p-r,-p-r],[p*r^-1,r,r,r,-1,
-1-p*r^-1],[0,0,p,0,1,1],[0,0,0,p,0,0],[0,0,0,0,p+r,r],[0,0,0,0,-p,0]],[[r,
-r^2,0,-r^2,0,p],[0,p,0,0,0,0],[0,0,p,0,0,0],[0,0,0,p,0,0],[0,0,-r^2,-p*r,r,
0],[0,0,0,0,0,p]],[[p,0,0,0,0,0],[0,p+r,p+2*r,p,-1,0],[0,0,p,0,0,0],[0,-r,
-p-2*r,0,1,0],[0,0,0,0,p,0],[-r,0,-p*r-p^2-r^2,0,0,r]],[[r,0,0,0,r,p],[0,r,r,
r,0,0],[0,0,p,0,0,0],[0,0,0,p,0,0],[0,0,0,0,p,0],[0,0,0,0,0,p]]];end;
  f10:=function(r,p,a) return List(f5(r,p,a),x->ExteriorPower(x,2)/r);end;
  rep:=[[f1,r],[f1,p],
  [f5,p,r,E(3)],[f5,r,p,E(3)],[f5,p,r,E(3)^2],[f5,r,p,E(3)^2],
  [f7,r,p],[f7,p,r],
  [f10,r,p,E(3)],[f10,p,r,E(3)],[f10,r,p,E(3)^2],[f10,p,r,E(3)^2]];
  if IsBound(rep[i]) then 
    return ApplyFunc(rep[i][1],rep[i]{[2..Length(rep[i])]})+0*Product(para[1]);
  else return false;fi;
end);

CHEVIE.AddData("Representation","G33",function(i)local r,f;
  r:=CHEVIE.RawData("HeckeRepresentation","G33")(List([1..5],i->[1,-1]),i);
  if r<>false then return r;fi;
  f:=i->CHEVIE.RawData("Representation","G33")(i);
  if i=13 then return List(f(7),x->ExteriorPower(x,2));
  elif i=14 then return -f(13);
  elif i=15 then return List(f(3),x->SymmetricPower(x,2));
  elif i=16 then return -f(15);
  elif i=19 then return List(f(3),x->SchurFunctor(x,[2,1,1,1]));
  elif i=20 then return -f(19);
  elif i=23 then return Zip(f(3),f(7),KroneckerMatrix);
  elif i=24 then return -f(23);
  elif i=25 then return ComplexConjugate(f(23));
  elif i=26 then return -f(25);
  elif i=27 then return List(f(5),x->SchurFunctor(x,[2,1]));
  elif i=28 then return -f(27);
  elif i=29 then return ComplexConjugate(f(27));
  elif i=30 then return -f(29);
  elif i=31 then return List(f(9),x->ExteriorPower(x,2));
  elif i=32 then return -f(31);
  elif i=33 then return ComplexConjugate(f(31));
  elif i=34 then return -f(33);
  else return false;
  fi;
end);

CHEVIE.AddData("UnipotentCharacters","G33",function()local J;J:=E(3);
 return rec(
  harishChandra:=[
  rec(relativeType:=rec(series:="ST",indices:=[1..5],rank:=5,ST:=33),
 levi:=[], parameterExponents:=[1,1,1,1,1],
       charNumbers:=[1..40], eigenvalue:=1, cuspidalName:="",
       TeXCuspidalName:=""),
   rec(relativeType:=rec(series:="ST",indices:=[1,5],rank:=2,ST:=4),
levi:=[2..4],
       parameterExponents:=[[3,0,0]],
       charNumbers:=[41,58,57,59,43,44,51],
       eigenvalue:=J, cuspidalName:="G3,3,3[E3]",
       TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
   rec(relativeType:=rec(series:="ST",indices:=[1,5],rank:=2,ST:=4),
levi:=[2..4],
       parameterExponents:=[[0,3,3]],
       charNumbers:=[64,46,45,47,55,56,54],
       eigenvalue:=J^2, cuspidalName:="G3,3,3[E3^2]",
       TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]"),
   rec(relativeType:=rec(series:="ST",indices:=[4],rank:=1,p:=6,q:=1),
       levi:=[1,2,3,209],
       parameterExponents:=[[5,4,1,0,1,4]],
       charNumbers:=[42,49,60,63,61,48],
       eigenvalue:=-1, cuspidalName:="D4",
       TeXCuspidalName:="D_4"),
   rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..5], parameterExponents:=[],
       charNumbers:=[52], eigenvalue:=E(4), cuspidalName:="G33[I]",
       TeXCuspidalName:="G_{33}[i]"),
   rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..5], parameterExponents:=[],
       charNumbers:=[53], eigenvalue:=-E(4), cuspidalName:="G33[-I]",
       TeXCuspidalName:="G_{33}[-i]"),
   rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..5], parameterExponents:=[],
       charNumbers:=[62], eigenvalue:=-J, cuspidalName:="G33[-E3]",
       TeXCuspidalName:="G_{33}[-\\zeta_3]"),
   rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..5], parameterExponents:=[],
       charNumbers:=[50], eigenvalue:=-J^2, cuspidalName:="G33[-E3^2]",
       TeXCuspidalName:="G_{33}[-\\zeta_3^2]")],
  families:=[ Family("C1",[1]),
 Family(ConjugateFamily(CHEVIE.families.X(3)),[4,6,41]),
 Family("C1",[15]),
 Family("C2",[22,8,19,42]),
 Family(ConjugateFamily(CHEVIE.families.X(6)),
  [25,30,17,28,23,45,48,43,50,9,47,44,11,49,46],
  rec(delta1:=[1,1,1,1,1,1,-1,1,1,-1,-1,1,1,1,1])),
 Family("C1",[39]),
 Family("C1",[36]),
 Family(ConjugateFamily(CHEVIE.families.X(3)),[34,32,51]),
 # changed Gunter 22/9/99 from C2 to C2d; and to C2h on 26.2.2003
 # and back 27.2.2003:
 Family("C2d",[37,38,52,53 ]),
 Family("C1",[14]),
 Family(CHEVIE.families.X(3),[33,31,54]),
 Family("C1",[40]),
 Family("C1",[35]),
 Family("C1",[13]),
 Family(CHEVIE.families.X(6),[26,29,18,27,24,57,60,55,62,10,59,56,12,61,58],
  rec(delta1:=[ 1, 1, 1, 1, 1, 1, -1, 1, 1, -1, -1, 1, 1, 1, 1 ])),
 Family("C2",[ 21,7,20,63]),
 Family("C1",[16]),
 Family(CHEVIE.families.X(3),[3,5,64]),
 Family("C1",[2])],
 a:=[0,45,28,1,28,1,18,3,4,13,4,13,12,9,2,23,4,13,3,18,18,3,4,13,4,13,13,4,13,4,
  10,7,10,7,10,7,8,8,6,11,1,3,4,4,4,4,4,4,4,4,7,8,8,10,13,13,13,13,13,13,13,13,
  18,28],
 A:=[0,45,44,17,44,17,42,27,32,41,32,41,36,33,22,43,32,41,27,42,42,27,32,41,32,
  41,41,32,41,32,38,35,38,35,38,35,37,37,34,39,17,27,32,32,32,32,32,32,32,32,35,
  37,37,38,41,41,41,41,41,41,41,41,42,44]);
end);

# for the following see
# Burkhardt, Math. Annalen 38 pp 208--209
# and Orlik, Contemporary mathematics vol. 90 (1989) pp 223--226
# here we have interchanged the x and z of Burkhardt

CHEVIE.AddData("Invariants","G33",
[ function(x,y,z,t,u)local a1,a4;
    a1:=-(y^3+u^3+t^3+x^3);
    a4:=y*u*t*x;
    return z^4-8*a1*z+48*a4;end,
  function(x,y,z,t,u)local a1,a2,a4;
    a1:=-(y^3+u^3+t^3+x^3);
    a2:=(y*u)^3+(y*t)^3+(y*x)^3+(u*t)^3+(u*x)^3+(t*x)^3;
    a4:=y*u*t*x;
    return z^6+20*a1*z^3+96*a2-8*a1^2+360*a4*z^2;end,
  function(x,y,z,t,u)local a1,a2,a3,a4;
    a1:=-(y^3+u^3+t^3+x^3);
    a2:=(y*u)^3+(y*t)^3+(y*x)^3+(u*t)^3+(u*x)^3+(t*x)^3;
    a3:=-((y*u*t)^3+(u*t*x)^3+(y*t*x)^3+(y*u*x)^3);
    a4:=y*u*t*x;
    return -z^4*a2+(9*a3-a1*a2)*z+a4*(z^6-a1*z^3+6*a2-2*a1^2)+9*a4^2*z^2;end,
# Note: the 3rd invariant of degree 10 is Determinant(Hessian(J4))/63700992
  function(x,y,z,t,u)local a1,a2,a3,a4;
    a1:=-(y^3+u^3+t^3+x^3);
    a2:=(y*u)^3+(y*t)^3+(y*x)^3+(u*t)^3+(u*x)^3+(t*x)^3;
    a3:=-((y*u*t)^3+(u*t*x)^3+(y*t*x)^3+(y*u*x)^3);
    a4:=y*u*t*x;
    return 5*a2*z^6+(99*a3+a1*a2)*z^3+216*a4^3-36*a1*a3+24*a2^2-4*a1^2*a2+
    a4*(3*z^8+33*a1*z^5+(18*a2+30*a1^2)*z^2)+a4^2*(243*z^4+108*a1*z);end,
  function(x,y,z,t,u)local a1,a2,a3,a4;
    a1:=-(y^3+u^3+t^3+x^3);
    a2:=(y*u)^3+(y*t)^3+(y*x)^3+(u*t)^3+(u*x)^3+(t*x)^3;
    a3:=-((y*u*t)^3+(u*t*x)^3+(y*t*x)^3+(y*u*x)^3);
    a4:=y*u*t*x;
    return 4*a3*z^9+(54*a4^3+12*a1*a3-a2^2)*z^6+
    (162*a1*a4^3-18*a2*a3+12*a1^2*a3-2*a1*a2^2)*z^3+
    (27*a3^2-18*a1*a2*a3+4*a1^3*a3+4*a2^3-a1^2*a2^2)+
    a4*(6*a2*z^8+(54*a3+12*a1*a2)*z^5+(243*a4^3+54*a1*a3-36*a2^2+6*a1^2*a2)
     *z^2)+a4^2*(3*z^10+18*a1*z^7+(54*a2+27*a1^2)*z^4+
     (162*a3-54*a1*a2+12*a1^3)*z);end]);

CHEVIE.AddData("BasicDerivations","G33",function()return function(x,y,z,t,u)
return [[4*x,6*y*z,10*z-1/96*x*y,12*t-1/32*y^2,18*u-1/32*t*y],
[6*y,-5184*u+9*x^2*z,6*t-1/64*x^3,63*x*z-3/64*x^2*y,-3/64*t*x^2+180*z^2],
[10*z,6*t*z-9*u*x,-1/384*t*x+3/128*y*z,9/2*u-1/128*t*y+9/128*x^2*z,
3/64*u*y+9/32*x*z^2-1/32*t^2],[12*t,-27*u*y+63*x*z^2,
9/2*u+3/128*t*y-5/128*x^2*z,-15/128*x*y*z+9/128*t*x^2+90*z^2,
-21/64*t*x*z+9/64*u*x^2+27/32*y*z^2],[18*u,-27*t*u+180*z^3,
3/64*u*y-1/32*x*z^2,9/64*u*x^2-3/32*y*z^2,45/64*u*x*z-3/8*t*z^2]];
end;end);

# the discriminant as a polynomial in the invariants
# it is equal to Determinant(BasicDerivations)*262144/729
CHEVIE.AddData("Discriminant","G33",function()return function(x,y,z,t,u)
return 243302400*t*u*x*y*z^5-483072*t*u*x^2*y^2*z^4+144*t*u*x^3*y^3*z^3-
11520*u*x*y^3*z^5-108*t*x*y^4*z^5-72*t*u*y^5*z^3-14592*t*u*x^5*z^4-
47185920000*t*u*z^6-72*t*u*x^6*y*z^3-737280000*x*y*z^8-34560*t*u^2*x*y^3*z^2-
6635520*t*u^2*y^2*z^3-24*t*u^2*x^2*y^4*z+57360384*t*u^2*x^3*z^3-
186624*t*u^2*x^4*y*z^2+27*u*x^2*y^4*z^4+48*t*u^2*x^5*y^2*z+24576000*u*y^2*z^6+
270336000*t*x^2*z^7-24*t*u^2*x^8*z-3822059520*t*u^3*x*z^2-875520*t*x^3*y*z^6+
2654208*t*u^3*x^2*y*z+4608*t*u^3*y^4-4608*t*u^3*x^6-230400*t*y^3*z^6-
57753600*u*x^3*z^6+254803968*t*u^4*y+177408*u*x^4*y*z^5+216*t*x^4*y^2*z^5-
54*u*x^5*y^2*z^4-108*t*x^7*z^5+27*u*x^8*z^4+30*t^2*u*x*y^4*z^2-
65617920*t^2*u*x^2*z^4+107520*t^2*x*y^2*z^5+254720*t^2*u*x^3*y*z^3+
77056*t^2*u*y^3*z^3-60*t^2*u*x^4*y^2*z^2+21233664000*u^2*x*z^5+
36*u^2*x*y^5*z^2+65536000*t^2*y*z^6+30*t^2*u*x^7*z^2-2654208*t^2*u^2*x*y*z^2-
128286720*u^2*x^2*y*z^4+48384*t^2*u^2*x^2*y^2*z+5662310400*t^2*u^2*z^3-
8*t^2*u^2*x^3*y^3+4*t^2*u^2*y^5+25344*t^2*u^2*x^5*z+4*t^2*u^2*x^6*y+
1382400*x^2*y^2*z^7-1105920*t^2*u^3*y^2+231168*u^2*x^3*y^2*z^3+
1548288*t^2*u^3*x^3-1536*u^2*y^4*z^3-72*u^2*x^4*y^3*z^2+113664*t^2*x^4*z^5-
8448*u^2*x^6*z^3+36*u^2*x^7*y*z^2-29952*t^3*u*x*y^2*z^2-21626880*t^3*u*y*z^3+
17915904*u^3*x*y^2*z^2-2123366400*u^3*y*z^3-31488*t^3*u*x^4*z^2-
39321600*t^3*x*z^5+24576*t^3*x^2*y*z^4-7077888*t^3*u^2*x^2*z-4352*t^3*u^2*y^3-
3840*t^3*u^2*x^3*y-27648*u^3*x^2*y^3*z-113246208*t^3*u^3-8*t^3*x^3*y^2*z^3+
12*u^3*x^3*y^4-432*x^3*y^3*z^6-8626176*u^3*x^4*z^2+4*t^3*y^4*z^3+
27648*u^3*x^5*y*z-4*u^3*y^6-12*u^3*x^6*y^2+4*t^3*x^6*z^3+4*u^3*x^9+
10616832*t^4*u*x*z^2-6144*t^4*u*x^2*y*z+2*t^4*u*x^3*y^2-t^4*u*y^4-t^4*u*x^6+
1179648*t^4*u^2*y+764411904*u^4*x^2*z-4096*t^4*y^2*z^3-442368*u^4*y^3-
1327104*u^4*x^3*y-4096*t^4*x^3*z^3-12230590464*u^5+1024*t^5*u*y^2+
1024*t^5*u*x^3+1048576*t^5*z^3+216*y^5*z^6-55296*x^5*z^7-262144*t^6*u+
216*x^6*y*z^6+104857600000*z^9;
end;end);
