#############################################################################
##
#A  tbl/cmplximp.g        CHEVIE library        Gunter Malle and  Jean Michel
##
#Y  Copyright (C) 1998 - 2001  The CHEVIE Team
##
##  This file contains data about imprimitive complex reflection groups
##
CHEVIE.Revision("tbl/cmplximp.g",
   "$Id: cmplximp.g,v 1.5 2003/12/04 11:26:45 chevie Exp $");

CHEVIE.AddData("PrintDiagram","imp",function(arg)
  local p,q,r,indices,j,indent,title,g;
  p:=arg[1];q:=arg[2];r:=arg[3];indices:=arg[4];title:=arg[5];
  Print(title," ");
  indent:=Length(title)+1;g:=i->String("",indent-i);
  if q=1 then
    Print(indices[1],"(",p,")==");
    for j in [2..Length(indices)-1] do Print(indices[j],"--");od;
    Print(indices[Length(indices)],"\n");
  elif p=q then
    Print(indices[1],"\n",g(0),"|\\\n");
    if p<>3 then Print(String(p,indent));else Print(g(0));fi;
    Print("|=",indices[3]);
    for j in [4..r] do Print(" - ",indices[j]);od;Print("\n");
    Print(g(0),"|/\n",g(0),indices[2],"\n");
  elif q=2 then
    Print(indices[2],"\n",g(2),"/3|");
    if r>=3 then Print("\\");fi;
    Print("\n");
    if p/q>2 then Print(g(Length(String(p/q))+5),"(",p/q,")");
    else Print(g(3));
    fi;
    Print(indices[1],"  | ");
    for j in [3..r] do Print(indices[j+1]);if j<>r then Print("-");fi;od;
    Print("\n",g(2),"\\ |");
    if r>=3 then Print("/");fi;
    Print("\n",String(indices[3],indent+1),
      "   ",IntListToString(indices{[1,2,3]}),
      "=",IntListToString(indices{[2,3,1]}),
      "=",IntListToString(indices{[3,1,2]}),"\n");
  else
    Print(indices[2],"\n",g(2),"/",q+1," ");
    if r>=3 then Print("\\");fi;
    Print("\n");
    if p/q>2 then Print(g(Length(SPrint(p/q))+5),"(",p/q,")");
    else Print(g(3));
    fi;
    Print(indices[1],"   ");if r>=3 then Print("=");fi;
    for j in [3..r] do Print(indices[j+1]);if j<>r then Print("-");fi;od;
    Print("\n",g(2),"\\  ");
    if r>=3 then Print("/");fi;
    Print("\n",String(indices[3],indent+1));
    j:=CHEVIE.RawData("BraidRelations","imp")(p,q,r);
    for g in [1..Minimum(3,r)] do
      Print("   ",IntListToString(indices{j[g][1]}),
              "=",IntListToString(indices{j[g][2]}));
    od;
    Print("\n");
  fi;
end);

CHEVIE.AddData("BraidRelations","imp",function(p,q,r)local i,b,res;
  b:=function(i,j,o)local p;
    p:=function(i,j)return List([1..o],k->i*(k mod 2)+j*((1-k)mod 2));end;
    return [p(i,j),p(j,i)];
  end;
  res:=[];
  if q=1 then
    if r>=2 then if p=1 then Add(res,b(1,2,3)); else Add(res,b(1,2,4));fi;fi;
    Append(res,List([3..r],i->b(i,i-1,3)));
    for i in [3..r] do Append(res,List([1..i-2],j->b(i,j,2)));od;
  elif p=q then
    Add(res,b(1,2,p));
    if r>=3 then
      Append(res,[[[1,2,3,1,2,3],[3,1,2,3,1,2]],b(1,3,3),b(2,3,3)]);fi;
    Append(res,List([4..r],i->b(i,i-1,3)));
    for i in [4..r] do Append(res,List([1..i-2],j->b(i,j,2)));od;
  else Add(res,[[1,2,3],[2,3,1]]);
    i:=b(2,3,q-1);
    Add(res,[Concatenation([1,2],i[2]),Concatenation([3,1],i[1])]);
    if r>=3 then
      if q<>2 then Add(res,[[2,3,4,2,3,4],[4,2,3,4,2,3]]);fi;
      Append(res,[b(2,4,3),b(3,4,3),b(1,4,2)]);
    fi;
    Append(res,List([5..r+1],i->b(i,i-1,3)));
    for i in [5..r+1] do Append(res,List([1..i-2],j->b(i,j,2)));od;
  fi;
  return res;
end);

CHEVIE.AddData("Size", "imp", function(p, q, r)
  return p^r * Factorial(r) / q;
end);

CHEVIE.AddData("ReflectionName","imp",function(arg)local n,option;
  option:=arg[Length(arg)];
  if arg[3]=1 and arg[2]=1 then 
    if IsBound(option.TeX) then return SPrint("Z_{",arg[1],"}");
    else return SPrint("Z",arg[1]);fi;
  else 
    if IsBound(option.TeX) then
         n:=SPrint("G_{",arg[1],",",arg[2],",",arg[3],"}");
    else n:=SPrint("G",arg[1],",",arg[2],",",arg[3]);fi;
   if Length(arg)=5 then PrintToString(n,"(",Format(arg[4],option),")");fi;
   return n;
  fi;
end);

CHEVIE.AddData("GeneratingRoots","imp",function(p,q,r)local roots,v,i;
  if q=1 then v:=[1..r]*0;v[1]:=1;roots:=[v];
  else
    if q<>p then v:=[1..r]*0;v[1]:=1;roots:=[v];
    else roots:=[];
    fi;
    v:=[1..r]*0;v[1]:=-E(p);v[2]:=1;Add(roots,v);
  fi;
  for i in [2..r] do v:=[1..r]*0;v[i]:=1;v[i-1]:=-1;Add(roots,v);od;
  return roots;
end);

CHEVIE.AddData("EigenvaluesGeneratingReflections","imp",
 function(p,q,r)local res;
  res:=[1..r]*0+1/2;
  if q=1 then res[1]:=1/p;
  elif q<>p then res:=Concatenation([q/p],res);
  fi;
  return res;
end);

CHEVIE.AddData("CartanMat", "imp",function(p,q,r)local rt,rbar,e;
  rt:=CHEVIE.RawData("GeneratingRoots","imp")(p,q,r);
  rbar:=ComplexConjugate(rt);
  e:=CHEVIE.RawData("EigenvaluesGeneratingReflections","imp")(p,q,r);
  e:=1-List(e,x->E(Denominator(x))^Numerator(x));
  e:=List([1..Length(e)],i->e[i]*rbar[i]/(rbar[i]*rt[i]));
  return List(e,x->List(rt,y->x*y));
end);

CHEVIE.AddData("ReflectionCoDegrees","imp",function(p,q,r)local res;
  res:=p*[0..r-1];
  if p=q and p>=2 and r>2 then res[r]:=res[r]-r;fi;
  return res;
end);

CHEVIE.AddData("ReflectionDegrees","imp",function(p,q,r)
  return Concatenation(p*[1..r-1],[r*p/q]);end);

CHEVIE.AddData("ParabolicInfo","imp",function(p,q,r)local i,res,norm;
  norm:=function(p,q,r,indices)
    if r>=3 or (r=2 and p<>q) then
       return rec(series:="ST",indices:=indices,rank:=r,p:=p,q:=q);
    elif r=2 then
      if p=3 then return rec(series:="A",indices:=indices,rank:=2);
      elif p=4 then return rec(series:="B",indices:=indices,rank:=2);
      elif p=6 then return rec(series:="G",indices:=indices,rank:=2);
      else return rec(series:="I",indices:=indices,bond:=p,rank:=2);
      fi;
    elif p/q>2 then
        return rec(series:="ST",indices:=indices,rank:=1,p:=p/q,q:=1);
    else return rec(series:="A",indices:=indices,rank:=1);
    fi;
  end;
  res:=[[rec(series:="A",indices:=[2..r],rank:=r-1)]];
  Add(res,[norm(p,q,r-1,[1..r-1])]);
  if q=1 then
    for i in [2..r-1] do
      Add(res,[norm(p,q,i-1,[1..i-1]),
               rec(series:="A",indices:=[i+1..r],rank:=r-i)]);
    od;
  elif p=q then
    if r>1 then
      Add(res,[rec(series:="A",indices:=Concatenation([1],[3..r]),rank:=r-1)]);
      Add(res,[norm(p,q,2,[1,2]),rec(series:="A",indices:=[4..r],rank:=r-3)]);
    fi;
    for i in [4..r-1] do Add(res,
        [rec(series:="ST",indices:=[1..i-1],rank:=i-1,p:=p,q:=q),
         rec(series:="A",indices:=[i+1..r],rank:=r-i)]);
    od;
  elif q=2 and r=2 then
    res:=[[norm(p/q,1,1,[1])],[norm(2,1,1,[2])],[norm(2,1,1,[3])]];
  else Error("not implemented");
  fi;
  return res;
end);

CHEVIE.AddData("NrConjugacyClasses","imp",function(p,q,r)
  if [q,r]=[2,2] then return p*(p+6)/4;
  elif q=1 then return NrPartitionTuples(r,p);
  else return Length(CHEVIE.RawData("ClassInfo","imp")(p,q,r).classtext);
  fi;
end);

CHEVIE.AddData("ClassInfo","imp",function(p,q,r)local res,times,trans,I,i,j,a,S;
  times:=function(e,o)return Concatenation(List([1..e],x->o));end;
  if [q,r]=[2,2] and not IsBound(CHEVIE.othermethod) then 
    res:=rec(classtext:=[],classparams:=[],classnames:=[]);
    for i in [0..p-1] do for j in [0..QuoInt(p-i-1,2)] do
      Add(res.classparams,Concatenation([1..j]*0+1,[1..i]*0));
      Add(res.classtext,Concatenation([1..j]*0+1,times(i,[1,2,3])));
      Add(res.classnames,String(Concatenation(times(j,"1"),times(i,"z"))));
    od;od;
    for j in [2,3] do
      for i in [0..p/2-1] do Add(res.classparams,Concatenation([j],[1..i]*0));
	Add(res.classtext,Concatenation([j],times(i,[1,2,3])));
	Add(res.classnames,String(Concatenation(String(j),times(i,"z"))));
      od;
    od;
    res.malle:=[];
    for a in [0..p-1] do 
       Append(res.malle,List([0..QuoInt(p-a-1,2)],m->[3,a,m]));od;
    Append(res.malle,List([0..p/2-1],m->[1,m]));
    Append(res.malle,List([0..p/2-1],m->[2,m]));
    return res;
  elif q=1 then
    res:=rec(classparams:=PartitionTuples(r,p));
    res.classtext:=List(res.classparams,function(S)local l,w,d;
      S:=Concatenation(List([1..p], i->List(S[i],t->[t,i-1])));
      Sort(S,function(a,b)return a[1]<b[1] or a[1]=b[1] and a[2]>b[2];end);
      l:=0;w:=[];
      for d in S do
        Append(w,times(d[2],Concatenation([l+1,l..2],[1..l+1])));
	# non-reduced word because this is the one used by Halverson-Ram
	# for characters of the Hecke algebra (see below).
	Append(w,[l+2..l+d[1]]);
	l:=l+d[1];
      od;
      return w;
    end);
    res.classnames:=List(res.classparams,CHEVIE.RawData("ClassName","imp"));
    res.orders:=List(res.classparams,m->Lcm(List([1..Length(m)],function(i)
       if Length(m[i])=0 then return 1;
       else return Lcm(m[i]*p/Gcd(i-1,p));fi;end)));
    res.centralizers:=List(res.classparams,m->p^Sum(m,Length)*
     Product(List(m,pp->Product(Collected(pp),y->Factorial(y[2])*y[1]^y[2]))));
    return res;
  else
  # According  to Hugues  ``On  decompositions  in complex  imprimitive 
  # reflection groups'' Indagationes 88 (1985) 207--219:                
  #
  # Let l=(S_0,..,S_{p-1}) be  a p-partition of r specifying  a class C 
  # of G(p,1,r) as  in the above code;  C is in G(p,q,r)  iff q divides 
  # sum_i i*|S_i|;  C splits  in d  classes for  the largest  d|q which 
  # divides all parts  of all S_i and  such that |S_i|=0 if  d does not 
  # divide i;  if w is in  C and t  is the first generator  of G(p,1,r) 
  # then t^i w t^-i for i in [0..d-1] are representatives of classes of 
  # G(p,q,r) which meet C.                                              

    trans:=function(w)local d,res,l,i,add,word;
    # translate words  in G(p,1,r) into  words of G(p,q,r); use  that if
    # t,s2 (resp. s1,s2)  are the first 2 generators  of G(p,1,r) (resp.
    # G(p,p,r)) then  s1=s2^t thus  s2^(t^i)= (s1s2)^i  s2 [the  first 3
    # generators of G(p,q,r) are t^q,s1,s2].
    #Print(IntListToString(w),"=>");
     d:=0;res:=[];
     word:=function(l,i)return List(i+[l,l-1..1],j->1+(j mod 2));end;
     add:=function(a)local l; # here we try to reduce words
       l:=Length(res);
       if l>0 and res[l]=a then res:=res{[1..l-1]};
       elif p=q and a in [1,2] and l>=q and res{[l-q+1..l]}=word(q,3-a)
       then res:=Concatenation(res{[1..l-q]},word(q-1,3-a));
       else Add(res,a);
       fi;
     end;
     for l in w do
       if l=1 then d:=d+1;
       elif l<>2 then add(l);
       else d:=d mod p;
	 if d=0 then add(2);
	 else for i in [1..p-d-1] do add(1);add(2);od;add(1);
	 fi;
       fi;
     od;
     d:=d mod p;
     if d mod q<>0 then Error();
     elif d<>0 then res:=Concatenation(1+res,[1..d/q]*0+1);
     elif p<>q then res:=1+res;
     fi;
    #Print(IntListToString(res),"\n");
     return res;
    end;

    I:=CHEVIE.RawData("ClassInfo","imp")(p,1,r);
    res:=rec(classtext:=[],classparams:=[],classnames:=[],orders:=[],
      centralizers:=[]);
    for i in Filtered([1..Length(I.classparams)],i->
      List(I.classparams[i],Length)*[0..p-1] mod q=0)
    do
      S:=I.classparams[i];
      a:=Concatenation(S);Add(a,q);
      Append(a,Filtered([1..p],j->Length(S[j])<>0)-1);
      a:=ApplyFunc(Gcd,a); # number of pieces the class splits
      for j in [0..a-1] do
    #   Print("i=",i," j=",j," text=<",IntListToString(I.classtext[i]),"> ");
	Add(res.classtext,
	  trans(Concatenation([1..j]*0+1,I.classtext[i],[1..p-j]*0+1)));
	if a>1 then Add(res.classparams,Concatenation(S,[p*j/a]));
	else Add(res.classparams,S);
	fi;
	Add(res.orders,I.orders[i]);
	Add(res.centralizers,I.centralizers[i]*a/q);
      od;
    od;
    res.classnames:=List(res.classparams,CHEVIE.RawData("ClassName","imp"));
    return res;
  fi;
end);

CHEVIE.AddData("ClassName", "imp", function(p)local j;
  if IsList(p) and ForAll(p, IsList) then return PartitionTupleToString(p);
  elif IsList(p) and ForAll(p, IsInt) then return IntListToString(p);
  elif IsList(p) and ForAll(p{[1..Length(p)-1]},IsList) and IsInt(p[Length(p)])
  then j:=p[Length(p)]/(Length(p)-1);
    j:=Format(E(Denominator(j))^Numerator(j));
    if j="1" then j:="+";elif j="-1" then j:="-";fi;
    return SPrint(PartitionTupleToString(p{[1..Length(p)-1]}),j);
  else Error(); # should not happen
  fi;
end);

CHEVIE.AddData("PowerMaps","imp",function(p,q,r)local pow,pp,pw,res;
  if q=1 then
    pow:=function(p,n)local e,res,k,l,g,j;
      e:=Length(p);
      res:=List([1..e],x->[]);
      for k in [1..e] do
       for l in p[k] do
	 g:=Gcd(n,l);
	 for j in [1..g] do Add(res[1+((n*(k-1)/g)mod e)],l/g);od;
       od;
      od;
      for k in [1..e] do
	Sort(res[k]);res[k]:=Reversed(res[k]);
      od;
      return res;
    end;

    pp:=CHEVIE.RawData("ClassInfo","imp")(p,q,r).classparams;
    res:=[];
    for pw in Set(Factors(Factorial(r)*p)) do
       res[pw]:=List(pp,x->Position(pp,pow(x,pw)));
    od;
    return res;
  else
    CHEVIE.compat.InfoChevie("# CHEVIEData(PowerMaps,imp)(",
                                          p,",",q,",",r,") not implemented\n");
    return false;
  fi;
end);

CHEVIE.AddData("ReflectionDegrees","imp",function(p,q,r)
  return Concatenation(p*[1..r-1],[r*p/q]);
end);

CHEVIE.AddData("CharInfo","imp",function(p,q,r)local ct,res,t,tt,r,s;
  res:=rec();
  if q=1 then res.charparams:=PartitionTuples(r,p);
  else
    res.charparams:=[];
    for t in PartitionTuples(r,p) do
      tt:=List([1..q]*p/q,i->t{Concatenation([i+1..Length(t)],[1..i])});
      if t=Minimum(tt) then
	s:=Position(tt,t);
	t:=t{[1..s*p/q]};
	if s=q then Add(res.charparams,t);
	else s:=q/s;
	  Append(res.charparams,List([0..s-1],i->Concatenation(t,[E(s)^i])));
	fi;
      fi;
    od;
    if p=q then t:=List([1..p],x->[]);t[Length(t)]:=[1..r]*0+1;
      res.positionSgn:=Position(res.charparams,t);
    fi;
    if [q,r]=[2,2] then
# .malle: indexing of chars as in Malle's paper on rank 2 cyclotomic algebras.
      res.malle:=List(res.charparams,function(t)local pos,p;
	  if IsCyc(t[Length(t)]) then
	    if t[Length(t)]=1 then return [1,2,1,Position(t,[1])];
	    else                   return [1,1,2,Position(t,[1])];
	    fi;
	  else p:=Length(t)/2;
	    pos:=Filtered([1..Length(t)],i->Length(t[i])>0);
	    if Length(pos)=1 then
	      if t[pos[1]]=[2] then return [1,1,1,pos[1]-p];
	      else                  return [1,2,2,pos[1]-p];
	      fi;
	    elif pos[1]<=p then return [2,-1,pos[1],pos[2]-p];
	    else                return [2,1,pos[2]-p,pos[1]-p];
	    fi;
	  fi;
	end);
    elif [p,q,r]=[3,3,3] then res.malle:=
     [[2,3,"''"],[2,3,"'''"],[2,3,"'"],[3,4],[3,5],[1,9],[3,2],[3,1],
      [2,3,"''''"],[1,0]];
    elif [p,q,r]=[3,3,4] then res.malle:=
     [[12,6],[4,10],[6,8],[4,11],[1,18],[12,3],[6,5,"''"],[8,4],[8,5],
      [6,5,"'"],[3,9],[6,2],[2,6],[4,2],[4,1],[3,3],[1,0]];
# here the labeling is defined by phi_{6,5}' being the one which appears
# in the tensor square of the reflection representation phi_{4,1}
    elif [p,q,r]=[3,3,5] then res.malle:=
     [[30,10],[20,12],[5,19],[10,14],[10,15],[5,20],[1,30],[30,7,"'"],[40,6],
      [30,7,"''"],[10,11],[15,10],[20,9],[20,8],[15,11],[10,12],[4,18],
      [30,4],[20,5],[10,8],[10,7],[20,6],[5,12],[20,3],[10,6],[15,4],[15,5],
      [10,5],[6,9],[10,3],[10,2],[5,6],[5,2],[5,1],[4,3],[1,0]];
  # here the labeling is defined by phi_{30,7}'' being the one which appears
  # in the tensor 4th power of the reflection representation phi_{5,1}
    elif [p,q,r]=[4,4,3] then res.malle:=[[6,3],[3,6,"'"],[3,5],[3,6,"''"],
      [1,12],[3,2,"'"],[3,2,"''"],[3,1],[2,4],[1,0]];
  # here the labeling is defined by phi_{3,2}'' being the complex
  # conjugate of phi_{3,1} and phi_{3,6}'' the complex conjugate of phi_{3,5}
    fi;
  fi;
  t:=List([1..p],x->[]);t[p+1-p/q]:=[r];
  res.positionId:=Position(res.charparams,t);
  if p=1 then res.positionRefl:=Position(res.charparams,[[r-1,1]]);
  else t:=List([1..p],x->[]);t{Minimum(p-p/q,p-2)+[1,2]}:=[[r-1],[1]];
    res.positionRefl:=Position(res.charparams,t);
  fi;
  if p/q=2 then t:=List([1..p],x->[]);t[Length(t)]:=[1..r]*0+1;
    res.positionSgn:=Position(res.charparams,t);
  fi;
  return res;
end);

CHEVIE.AddData("CharSymbols","imp",function(p,q,r)local s,ss,res;
  if q=1 then return SymbolsDefect(p,r,0,1);
  elif q=p then ss:=SymbolsDefect(p,r,0,0);
    res:=[];
    for s in ss do p:=PositionProperty([1..Length(s)-1],
                    i->s{Concatenation([i+1..Length(s)],[1..i])}=s);
      if p=false then Add(res,s);
      else Append(res,List([1..Length(s)/p],i->s));
      fi;
    od;
    return res;
  else return false;
  fi;
end);

CHEVIE.AddData("FakeDegree","imp",function(p,q,r,c,v)
  if q=1 then
    return Value(CycPolFakeDegreeSymbol(SymbolPartitionTuple(c,1)),v);
  elif q=p then
    c:=CHEVIE.RawData("CharSymbols","imp")(p,q,r)[Position(
       CHEVIE.RawData("CharInfo","imp")(p,q,r).charparams,c)];
    return Value(CycPolFakeDegreeSymbol(c),v);
  else return false;
  fi;
end);

CHEVIE.AddData("CharName","imp",function(p,option)local res,s;
  if IsCyc(p[Length(p)]) then
    res:=PartitionTupleToString(p{[1..Length(p)-1]});
    Add(res,'.');
    if p[Length(p)]=1 then Add(res,'+');
    elif p[Length(p)]=-1 then Add(res,'-');
    else Append(res,Format(p[Length(p)],option));
    fi;
    return String(res);
  elif Sum(p,Sum)=1 then
       return Format(E(Length(p))^(Position(p,[1])-1),option);
  else return PartitionTupleToString(p);
  fi;
end);

CHEVIE.AddData("SchurElement","imp",function(p,q,r,phi,para)
  local X,Y,Z,x1,x2,y1,y2,zk,zl,w,m,S,ci;
  if r=1 then
    X:=para[1];m:=PositionProperty(phi,x->Length(x)=1);
    return Product(X{Difference([1..p],[m])},x->1-X[m]/x);
  elif q=1 then
    if IsBound(CHEVIE.Mathas) then
      q:=-para[2][1]/para[2][2];Z:=para[1];
      x1:=function(l)if Length(l)=0 then return 0;else return l[1];fi;end;
      #w is the list of dual partitions
      w:=List(phi,l->List([1..x1(l)],k->Number(l,p->p>=k)));
      S:=(-1)^(r*(p-1));
      S:=S*Product([1..p],s->Z[s]^(r-Sum(phi[s])));
      S:=S*Product([1..p],s->Product([1..Length(phi[s])],i->
        Product([1..phi[s][i]],j->Sum([0..phi[s][i]+w[s][j]-i-j],l->q^l))));
      S:=S*Product([1..p],t->Product([t+1..p],s->Product([1..Length(phi[s])],
       i->Product([1..phi[s][i]],j->q^(j-i)*Z[s]-Z[t]))));
      S:=S*Product([1..p],s->Product([1..Length(phi[s])],
       i->Product([1..phi[s][i]],j->Product([s+1..p],t->
        (q^(j-i)*Z[s]-q^x1(phi[t])*Z[t])*Product([1..x1(phi[t])],k->
	  q^(j-i)*Z[s]-q^(k-1-w[t][k])*Z[t])))));
      S:=S/Product([1..p],s->Product([1..Length(phi[s])],
       i->Product([1..phi[s][i]],j->Product([s+1..p],t->
        Product([1..x1(phi[t])],k->q^(j-i)*Z[s]-q^(k-w[t][k])*Z[t])))));
      S:=S/q^(Sum(w,l->Sum(l,p->p*(p-1)/2))+
          Sum(w,l->Sum([1..Length(l)],i->(i-1)*l[i])));
      return S;
    else
      S:=SymbolPartitionTuple(phi,0);
      m:=QuoInt(Sum(S,Length),p);
      q:=-para[2][1]/para[2][2];Z:=para[1];
      return Product([1..p],i->Product(S[i],l->Product([1..l],k->
	  Product(Z,w->q^k*Z[i]-w))))*
	  Product([1..p],i->Product([i+1..p],j->(Z[i]-Z[j])^m))*
	  q^Sum([1..m-1],i->Binomial(i*p+1,2))/
	  Product([1..p],i->Product([i+1..p],j->Product(S[i],
       l->Product(S[j],m->q^l*Z[i]-q^m*Z[j]))))/
       (-1)^(Binomial(p,2)*Binomial(m,2)+r*(p-1))/(q-1)^r/q^(Sum(S,Sum)-r)/
       Product(Z)^r/Product([1..p],i->Product(Filtered(Cartesian(S[i],S[i]),
	   x->x[1]>x[2]),x->Z[i]*(q^x[1]-q^x[2])));
     fi;
  elif [q,r]=[2,2] and not IsBound(CHEVIE.new) then
   X:=para[2];Y:=para[3];Z:=para[1];
   ci:=CHEVIE.imp.CharInfo(p,q,r);
   phi:=ci.malle[Position(ci.charparams,phi)];
   if phi[1]=1 then
     x1:=X[phi[2]];x2:=X[3-phi[2]];y1:=Y[phi[3]];y2:=Y[3-phi[3]];
     zk:=Z[phi[4]];Z:=Z{Difference([1..p/2],[phi[4]])};
     return (x2-x1)*(y2-y1)*Product(Z,z->(z-zk)*(x2*y2*z-x1*y1*zk))/
       (x2*y2)^(p/2)/Product(Z)^2;
   else
     zl:=Z[phi[3]];zk:=Z[phi[4]];Z:=Z{Difference([1..p/2],phi{[3,4]})};
     w:=phi[2]*GetRoot(X[1]*X[2]*Y[1]*Y[2]*zl*zk*
       E(p/q)^(2-phi[3]-phi[4]),2)*E(p)^(phi[3]+phi[4]-2);
     return -2*Product(X,x->Product(Y,y->x*y*zl-w))*Product(Z,z->(z-zk)*(z-zl))/
       Product(X)^2/Product(Y)^2/zl^3/zk/Product(Z)^2;
   fi;
  elif p=q then
    if IsCyc(phi[Length(phi)]) then m:=Length(phi)-1;
      phi:=Concatenation(List([1..p/m],i->phi{[1..m]}));
    else m:=p;
    fi;
    return CHEVIE.imp.SchurElement(p,1,r,phi,
      Concatenation([List([0..p-1],i->E(p)^i)],para{[2..Length(para)]}))/m;
  elif para[2]=para[3] then
    if IsCyc(phi[Length(phi)]) then m:=Length(phi)-1;
      phi:=Concatenation(List([1..p/m],i->phi{[1..m]}));
    else m:=p;
    fi;
    if para[1]=List([1..p/q],i->E(p/q)^(i-1)) then
        para:=[List([0..p-1],i->E(p)^i),para[2]];
    else para:=[Concatenation(TransposedMat(List(para[1],i->List([0..q-1],
      j->E(q)^j)*GetRoot(i,q)))),para[2]];
    fi;
    return p/q*CHEVIE.imp.SchurElement(p,1,r,phi,para)/m;
  else CHEVIE.compat.InfoChevie("# SchurElements(H(G(",
                     p,",",q,",",r,"),",para,") not implemented\n");
    return false;
  fi;
end);

CHEVIE.AddData("HeckeCharTable","imp",function(p,q,r,para)
  local X,Y,Z,res,cl,GenericEntry,pow,d,I,LIM,HooksBeta,StripsBeta,Strips,
                                Delta,StripsCache,chiCache,code,j,ci;
  res:=rec();
  res.name:=SPrint("H(G(",p,",",q,",",r,"))");
  res.identifier:=res.name;
  res.degrees:=CHEVIE.RawData("ReflectionDegrees","imp")(p,q,r);
  res.size:=Product(res.degrees);
  res.order:=Product(res.degrees);
  res.dim:=r;
  ci:=CHEVIE.RawData("CharInfo","imp")(p,q,r);
  if r=1 then
    res.reflclasses:=[2];
    res.orders:=List([0..p-1],i->p/Gcd(i,p));
    res.irreducibles:=List([1..p],i->List([0..p-1],j->para[1][i]^j));
    res.classes:=[1..p]*0+1;
  elif q=1 then
    cl:=CHEVIE.RawData("ClassInfo","imp")(p,q,r);
    d:=List([1..p],x->[]);d[1]:=[p-1,1];
    res.reflclasses:=[Position(cl.classparams,d)];
    d[1]:=[1..p-1]*0+1;d[2]:=[1];
    Add(res.reflclasses,Position(cl.classparams,d));
    res.centralizers:=cl.centralizers;
    res.orders:=cl.orders;
    res.classes:=List(res.centralizers,x->res.size/x);
    res.powermap:=CHEVIE.RawData("PowerMaps","imp")(p,q,r);

    # character table of the Hecke algebra of G(p,1,r) parameters v and [q,-1]
    # according to "Characters of Iwahori-Hecke algebras of G(r,p,n)"
    # Halverson and Ram, Canadian Journal of math. 50 (1998) 167--192

    # The next function returns the list of all hooks of area less than or equal
    # to s in the Ferrers-Young diagram of the partition with beta-numbers S.
    # Each hook is returned as a record with the following fields:
    #  .area
    #  .hooklength number of rows -1
    #  .start      the beta-number which is decreased by removing the hook
    #  .startpos   the position of that beta-number in the list
    #  .stoppos    the position it will occupy after being decreased
    #  .DC         the list of dull corners, given by their axial position
    #  .SC         the list of sharp corners, given by their axial position
    HooksBeta:=function(S,s)local res,i,j,e,k,z,zi;
      res:=[];e:=Length(S);
      if e=0 then return res;fi;
      j:=e;
      for i in [S[e]-1,S[e]-2..0] do
	if not i in S then
	while j>0 and S[j]>i do j:=j-1;od;
	k:=j+1;
	while k<=e and S[k]-i<=s do
	  z:=[i];Append(z,S{[j+1..k-1]});
	  zi:=Filtered([2..Length(z)],i->z[i]-z[i-1]>1);
	  Add(res,rec(area:=S[k]-i,hooklength:=k-j-1,start:=S[k],startpos:=k,
	    stoppos:=j+1,DC:=z{zi}-e,
	    SC:=z{Concatenation(zi-1,[Length(z)])}+1-e));
	  k:=k+1;
	od;
	fi;
      od;
      return res;
    end;

    # The next function returns as a list of lists all broken border strips
    # (union of disjoint hooks) of area less than or equal to s in the diagram
    # of the partition  with beta-numbers S.
    StripsBeta:=function(S,s)local res,j,hook,hs,h;
      res:=[[]];
      for hook in HooksBeta(S,s) do
	if s=hook.area then Add(res,[hook]);
	else j:=hook.stoppos-1-Length(S);
	  for hs in StripsBeta(S{[1..hook.stoppos-1]},s-hook.area) do
	    for h in hs do h.SC:=h.SC+j;h.DC:=h.DC+j;od;
	    Add(hs,hook);Add(res,hs);
	  od;
	fi;
      od;
      return res;
    end;

    StripsCache:=rec();

    code:=function(arg)local S,res,p;res:=[];
      for S in arg do for p in S do Append(res,p);Add(res,-1);od;od;
      p:=".0123456789abcdefghijklmnopqrstuvwxyz";return p{2+res};
    end;

    # The next function returns as a GAP list all collections of broken border
    # strips of total area equal to s coming from the various beta-lists in the
    # symbol S. Each collection is represented by a GAP record containing the
    # statistical information about it necessary to compute the function Delta
    # in Ram-Halverson 2.17. These records have the following fields:
    #   area       total area
    #   cc         number of connected components (hooks)
    #   hooklength Sum of hooklengths of individual hooks
    #   DC         the list of all dull corners, represented by a pair:
    #                which beta list they come from, axial position
    #   SC         the list of all sharp corners, represented by a pair:
    #                which beta list they come from, axial position
    #   remainder  the symbol left after removing the strip collection
    Strips:=function(S,s)
      local apply, e, name, res, hs, ss, a, r;

      apply:=function(S,hs)local h;
	S:=ShallowCopy(S);
	for h in hs do S{[h.stoppos..h.startpos]}:=
	  Concatenation([h.start-h.area],S{[h.stoppos..h.startpos-1]});
        od;
	while Length(S)>0 and S[1]=0 do S:=S{[2..Length(S)]}-1;od;
	return S;
      end;
      e:=Length(S);
      if e=0 then if s=0 then
       return [rec(SC:=[],DC:=[],cc:=0,hooklength:=0,area:=0,remainder:=[])];
      else return [];fi;fi;
      name:=code(S,[[s]]);
      if IsBound(StripsCache.(name)) then return StripsCache.(name);fi;
      res:=[];
      for hs in StripsBeta(S[e],s) do
	hs:=rec(area:=Sum(hs,x->x.area),
		cc:=Length(hs),
		hooklength:=Sum(hs,x->x.hooklength),
		SC:=Concatenation(List(hs,x->List(x.SC,y->[e,y]))),
		DC:=Concatenation(List(hs,x->List(x.DC,y->[e,y]))),
		remainder:=apply(S[e],hs)
		);
	for a in Strips(S{[1..e-1]},s-hs.area) do
          # since there is no `Copy' in GAP 4
          ss := rec();
          for r in RecFields(a) do
            ss.(r) := ShallowCopy(a.(r));
          od;
	  Append(ss.SC,hs.SC);
	  Append(ss.DC,hs.DC);
	  Add(ss.remainder,hs.remainder);
	  ss.cc:=ss.cc+hs.cc;
	  ss.hooklength:=ss.hooklength+hs.hooklength;
	  ss.area:=ss.area+hs.area;
	  Add(res,ss);
	od;
      od;
      StripsCache.(name):=res;
      return res;
    end;

    # the function Delta of Ram-Halverson 2.17, modified to take in account that
    # our eigenvalues for T_2..T_r are Q[1] and Q[2] instead of q and -q^-1
    Delta:=function(k,hs,Q,v)local res,ctSC,ctDC,q,
      ElementarySymmetricFunction,HomogeneousSymmetricFunction;
      res:=1;
      if hs.cc>1 then
	  if k=1 or Q[1]=-Q[2] then return 0;
	  else res:=res*(Q[1]+Q[2])^(hs.cc-1);
	  fi;
      fi;
      q:=-Q[1]/Q[2];
      res:=res*(-1)^hs.hooklength*Q[1]^(hs.area-hs.cc)*q^(-hs.hooklength);
      if k=0 then return res;fi;
      ctSC:=List(hs.SC,x->v[x[1]]*q^x[2]);
      ctDC:=List(hs.DC,x->v[x[1]]*q^x[2]);
      res:=res*Product(ctSC)*Product(ctDC)^-1;
      if k=1 then return res;fi;

      ElementarySymmetricFunction:=function(t,v)
	return Sum(Combinations([1..Length(v)],t),x->Product(v{x}));end;

      HomogeneousSymmetricFunction:=function(t,v)
	return Sum(Combinations(Concatenation(List([1..t],
	          x->[1..Length(v)])),t),x->Product(v{x}));end;

      return res*(-1)^(hs.cc-1)*Sum(List([0..Minimum(Length(ctDC),k-hs.cc)],
	t->(-1)^t*ElementarySymmetricFunction(t,ctDC)*
	HomogeneousSymmetricFunction(k-t-hs.cc,ctSC)));
    end;

    chiCache:=rec(); LIM:=r;

    GenericEntry:=function(lambda,mu)local bp,i,rest,res,name,n;
      n:=Sum(lambda,Sum);
      if n=0 then return 1;fi;
      if n<LIM then
	name:=code(lambda,mu);
	if IsBound(chiCache.(name)) then return chiCache.(name);fi;
      fi;
      bp:=Maximum(Concatenation(lambda));i:=PositionProperty(lambda,x->bp in x);
    # here choice of bp and i corresponds to choice (Sort) in classtext
      rest:=ShallowCopy(lambda);rest[i]:=rest[i]{[2..Length(rest[i])]};
      res:=(-Product(para[2]))^((i-1)*(n-bp))*Sum(Strips(mu,bp),
	function(x)local d;d:=Delta(i-1,x,para[2],para[1]);
	 if d=0 then return d;
	 else return d*GenericEntry(rest,x.remainder);
	 fi;
	 end);
      if n<LIM then chiCache.(name):=res;fi;
      return res;
    end;

    res.irreducibles:=List(List(cl.classparams,x->List(x,BetaSet)),
        x->List(cl.classparams,y->GenericEntry(y,x)));
  elif [q,r]=[2,2] and not IsBound(CHEVIE.othermethod) then
   cl:=CHEVIE.RawData("ClassInfo","imp")(p,q,r).classparams;
   X:=para[2];Y:=para[3];Z:=para[1];
   GenericEntry:=function(char,class)local w;
    char:=ci.malle[Position(ci.charparams,char)];
    if char[1]=1 then
      w:=[Z[char[4]],X[char[2]],Y[char[3]]];
      return Product(class,function(i)
       if i=0 then return Product(w); else return w[i]; fi;end);
    else
      w:=char[2]*GetRoot(X[1]*X[2]*Y[1]*Y[2]*Z[char[3]]*Z[char[4]]*
	E(p/q)^(2-char[3]-char[4]),2)*E(p)^(char[3]+char[4]-2);
      class:=List([0..3],i->Number(class,j->i=j));
      if class[2]>0 then char:=Sum(Z{char{[3,4]}},x->x^class[2]);
      elif class[3]>0 then char:=Sum(X);
      elif class[4]>0 then char:=Sum(Y);
      else char:=2;
      fi;
      return w^class[1]*char;
    fi;
   end;
   res.orders:=List(cl,function(c)
     if Length(c)>0 and c[1] in [2,3] then return Lcm(2,p/Gcd(Number(c,x->x=0),p));
     else return Lcm(p/Gcd(Number(c,x->x=0),p),(p/2)/Gcd(Number(c,x->x=1),p/2));
     fi;end);
   res.classes:=List(cl,function(c)
     if Length(c)>0 and c[1] in [2,3] then return p/q;
     elif 1 in c then return 2;else return 1;fi;end);
   res.irreducibles:=List(ci.charparams,
      char->List(cl,class->GenericEntry(char,class)));
  else 
    cl:=CHEVIE.RawData("ClassInfo","imp")(p,q,r);
    res.centralizers:=cl.centralizers;
    res.orders:=cl.orders;
    res.classes:=List(res.centralizers,x->res.size/x);
    res.irreducibles:=List([1..Length(res.classes)],i->CharRepresentationWords(
      CHEVIE.RawData("HeckeRepresentation","imp")(p,q,r,para,i),cl.classtext));
  fi;
  res.centralizers:=List(res.classes,x->res.size/x);
  res.parameter:=para;
  res.irreducibles:=res.irreducibles*Product(para,Product)^0;
  return CHEVIE.compat.MakeCharacterTable(res, "set Format");
end);

CHEVIE.AddData("HeckeRepresentation","imp",function(p,q,r,para,i)
  local X,Y,t,p,x,a,b,c,v,d,T,S,m,extra,l,m1,p1rRep;
  if not IsList(para) then para:=[para];fi;
  if [q,r]=[1,2] then X:=para[2];Y:=para[1];#integral matrices in this case
    t:=PartitionTuples(2,p)[i];
    if Number(t,x->x<>[])=1 then
      p:=PositionProperty(t,x->x<>[]);
      if t[p]=[2] then return X[1]^0*[[[Y[p]]],[[X[1]]]];
      else return X[1]^0*[[[Y[p]]],[[X[2]]]];
      fi;
    else  p:=Filtered([1..Length(t)],i->t[i]<>[]);
      return X[1]^0*[[[Y[p[1]],0],[-1,Y[p[2]]]],
		     [[X[1],X[1]*Y[p[1]]+X[2]*Y[p[2]]],[0,X[2]]]];
    fi;
  elif [p,q,r]=[3,3,3] then 
    x:=-para[2][1]/para[2][2];a:=1;b:=1;c:=1;
    r:=x^0*[[[[-1,0],[-1,x]],[[x,-x],[0,-1]],[[x,-x],[0,-1]]],
     [[[-1,0],[-1,x]],[[x,-x],[0,-1]],[[-1,0],[-1,x]]],
     [[[-1,0],[-1,x]],[[x,-x],[0,-1]],[[-1+x,1],[x,0]]],
     [[[-1,0,0],[0,-1,0],[0,-1,x]],[[-1,0,0],[0,x,-x],[0,0,-1]],
      [[(E(3)*x-E(3)*x^2)/(1-E(3)*x),-E(3),-1],
       [(-E(3)^2*x+x^3)/(1-2*E(3)*x+E(3)^2*x^2),(-1-E(3)^2*x)/(1-E(3)*x),
        E(3)^2*x/(1-E(3)*x)],[(E(3)*x-E(3)^2*x^3)/(1-2*E(3)*x+E(3)^2*x^2),
        -E(3)^2*x/(1-E(3)*x),-1/(1-E(3)*x)]]],
     [[[-1,0,0],[0,x,0],[0,x,-1]],[[-1,0,0],[0,-1,1],[0,0,x]],
      [[(E(3)^2*x-E(3)^2*x^2)/(1-E(3)^2*x),E(3)^2*x,x],
       [(E(3)-x^2)/(1-2*E(3)^2*x+E(3)*x^2),(-1-E(3)*x)/(1-E(3)^2*x),
        E(3)*x/(1-E(3)^2*x)],[(-E(3)^2+E(3)*x^2)/(1-2*E(3)^2*x+E(3)*x^2),
        -E(3)*x/(1-E(3)^2*x),-1/(1-E(3)^2*x)]]],
     [[[-1]],[[-1]],[[-1]]],
     [[[x,0,0],[0,-1,0],[0,-1,x]],[[x,0,0],[0,x,-x],[0,0,-1]],
      [[(-1+x)/(1-E(3)*x),-E(3)^2,-1],[(E(3)^2*x-x^3)/(1-2*E(3)*x+E(3)^2*x^2),
        (-E(3)^2*x-E(3)*x^2)/(1-E(3)*x),E(3)^2*x/(1-E(3)*x)],
       [(-x+E(3)*x^3)/(1-2*E(3)*x+E(3)^2*x^2),-E(3)^2*x/(1-E(3)*x),
        -E(3)*x^2/(1-E(3)*x)]]],
     [[[x,0,0],[0,x,0],[0,x,-1]],[[x,0,0],[0,-1,1],[0,0,x]],
      [[(-1+x)/(1-E(3)^2*x),E(3)*x,x],[(-E(3)+x^2)/(1-2*E(3)^2*x+E(3)*x^2),
        (-E(3)*x-E(3)^2*x^2)/(1-E(3)^2*x),E(3)*x/(1-E(3)^2*x)],
       [(1-E(3)^2*x^2)/(1-2*E(3)^2*x+E(3)*x^2),-E(3)*x/(1-E(3)^2*x),
        -E(3)^2*x^2/(1-E(3)^2*x)]]],
     [[[-1,0],[-1,x]],[[-1,0],[-1,x]],[[x,-x],[0,-1]]],
     [[[x]],[[x]],[[x]]]];
     return r[i];
  elif [p,q,r]=[4,4,3] then 
     x:=-para[2][1]/para[2][2];
     r:=x^0*
      [[[[-E(4)*x,E(4),0,0,0,0],[(-E(4)+1)*x+(-E(4)-1)*x^2,-1+(E(4)+1)*x,0,0,
          0,0],[0,0,E(4)*x,-E(4),0,0],[0,0,(E(4)+1)*x+(E(4)-1)*x^2,
	  -1+(-E(4)+1)*x,0,0],[0,0,0,0,x,-1],[0,0,0,0,0,-1]],
       [[-1,1,0,0,0,0],[0,x,0,0,0,0],[0,0,-1,1,0,0],[0,0,0,x,0,0],
        [0,0,0,0,-1,1],[0,0,0,0,0,x]],
       [[-1/2+(1/2)*x,0,-1,0,0,0],[(E(4)-1)/4+(1/2)*x+((-E(4)-1)/4)*x^2,
        (-E(4)-1)/2+((E(4)+1)/2)*x,(-E(4)-1)/2+((E(4)-1)/2)*x,0,
	(E(4)+1)/4+((E(4)+1)/4)*x^2,0],[-1/4+(-1/2)*x+(-1/4)*x^2,0,
	-1/2+(1/2)*x,0,0,0],[(E(4)-1)/8+((E(4)-3)/8)*x+((-E(4)-3)/8)*x^2+
	((-E(4)-1)/8)*x^3,0,(-E(4)-1)/4+(1/2)*x+((E(4)-1)/4)*x^2,
	(E(4)-1)/2+((-E(4)+1)/2)*x,(E(4)+1)/8+((E(4)+1)/8)*x+((E(4)+1)/8)*x^2+
	((E(4)+1)/8)*x^3,(-E(4)-1)/4+((-E(4)-1)/4)*x^2],
	[-1+E(4)*x,-E(4)+1,0,0,(E(4)-1)/2+((-E(4)+1)/2)*x,0],
	[-1/2+((E(4)-1)/2)*x+(E(4)/2)*x^2,(-E(4)+1)/2+((-E(4)+1)/2)*x,
	-E(4)+x,E(4)-1,E(4)/2+(-E(4)/2)*x^2,(-E(4)-1)/2+((E(4)+1)/2)*x]]],
      [[[x,0,0],[0,-1,0],[x,0,-1]],[[-1,0,0],[0,x,0],[0,(-E(4)+1)*x,-1]],
       [[-1,0,1],[0,-1,(E(4)+1)/2],[0,0,x]]],
      [[[x,0,0],[x,-1,0],[x,0,-1]],[[-1,2,0],[0,x,0],[0,(-E(4)+1)*x,-1]],
       [[-1,0,1],[0,-1,(E(4)+1)/2],[0,0,x]]],
      [[[x,0,0],[x,-1,0],[x,0,-1]],[[-1,2,0],[0,x,0],[0,(E(4)+1)*x,-1]],
       [[-1,0,1],[0,-1,(-E(4)+1)/2],[0,0,x]]],
      [[[-1]],[[-1]],[[-1]]],
      [[[-1,0,0],[0,x,0],[-1,0,x]],[[x,0,0],[0,-1,0],[0,E(4)-1,x]],
       [[x,0,-x],[0,x,((-E(4)-1)/2)*x],[0,0,-1]]],
      [[[-1,0,0],[-1,x,0],[-1,0,x]],[[x,-2*x,0],[0,-1,0],[0,-E(4)-1,x]],
       [[x,0,-x],[0,x,((E(4)-1)/2)*x],[0,0,-1]]],
      [[[-1,0,0],[-1,x,0],[-1,0,x]],[[x,-2*x,0],[0,-1,0],[0,E(4)-1,x]],
       [[x,0,-x],[0,x,((-E(4)-1)/2)*x],[0,0,-1]]],
      [[[-1,0],[-1,x]],[[-1,0],[-1,x]],[[x,-x],[0,-1]]],
      [[[x]],[[x]],[[x]]]];
    return r[i];
  else
    S:=CHEVIE.imp.CharInfo(p,q,r).charparams[i];
    # S is a p-tuple of partitions of area r
    p1rRep:=function()local Q,pos,ct;
    # Model of Ariki,  Halverson-Ram for reps of G(p,1,r): 
    # needs rational fractions if the parameters are indeterminates
      if r>1 then Q:=-para[2][1]/para[2][2];else Q:=0;fi;
      pos:=function(t,i)local j,k,l;# return [j,k,p] if i at [k,p] in t[j]
	for j in [1..Length(t)] do for k in [1..Length(t[j])] do
	  l:=Position(t[j][k],i); if l<>false then return [j,k,l];fi;
	od; od;
      end;
      ct:=p->para[1][p[1]]*Q^(p[3]-p[2]);
      T:=Tableaux(S);
      return Concatenation([DiagonalMat(List(T,S->ct(pos(S,1))))],
	List([2..r],i->List([1..Length(T)],function(j)local S,v,a,b,p,tll;
	  S:=T[j];  a:=pos(S,i); b:=pos(S,i-1);
	  S:=List(S, a-> List(a, ShallowCopy)); # no `Copy' in GAP 4
	  S[a[1]][a[2]][a[3]]:=i-1; S[b[1]][b[2]][b[3]]:=i; 
	  if para[2][1]=-para[2][2] then
	    if a[1]=b[1] then tll:=para[2][1]/(a[3]+b[2]-a[2]-b[3]);
	    else tll:=0; 
	    fi;
	  else tll:=Sum(para[2])/(1-ct(b)/ct(a));
	  fi;
	  v:=[1..Length(T)]*0; v[j]:=tll; 
	  p:=Position(T,S);if p<>false then v[p]:=tll-para[2][2];fi;
	  return v;end)))*Product(para,Product)^0;
    end;
    if q=1 then return p1rRep();
    elif p=q then para:=[List([0..p-1],i->E(p)^i),para[1]];
    else # When q<>p implements only the 2-parameter case
      if para[2]<>para[3] then
	Error("3-parameter Hecke algebra for G(",p,",",q,",",r,
	   ") not implemented\n");
      elif para[1]=List([1..p/q],i->E(p/q)^(i-1)) then
	  para:=[List([0..p-1],i->E(p)^i),para[2]];
      else para:=[Concatenation(TransposedMat(List(para[1],i->List([0..q-1],
	j->E(q)^j)*GetRoot(i,q)))),para[2]];
      fi;
    fi;
    extra:=false;
    if IsCyc(S[Length(S)]) then 
      extra:=S[Length(S)];
      d:=Length(S)-1;
      S:=Concatenation(List([1..p/d],i->List(S{[1..d]},ShallowCopy)));
    fi;
    v:=p1rRep();
    if p=q then v:=Concatenation([v[2]^v[1]],v{[2..Length(v)]});
    elif q>1 then v:=Concatenation([v[1]^q,v[2]^v[1]],v{[2..Length(v)]});
    fi;
    if extra<>false then
      m:=PermListList(T,List(T,S->S{Concatenation([d+1..p],[1..d])}));
      m:=Cycles(m,[1..Length(T)]);
      l:=List([0,-1..1-p/d],i->extra^i);m1:=List(m,x->x[1]);
      return List(v,x->List(m,c->l*x{c}{m1}));
    else return v;
    fi;
  fi;
end);

CHEVIE.AddData("Representation","imp",function(p,q,r,i)local o;
  o:=CHEVIE.RawData("EigenvaluesGeneratingReflections","imp")(p,q,r);
  o:=List(o,Denominator);
  return CHEVIE.RawData("HeckeRepresentation","imp")
         (p,q,r,List(o,x->List([0..x-1],i->E(x)^i)),i);
end);

CHEVIE.AddData("CharTable","imp",function(p,q,r)local o;
  o:=CHEVIE.RawData("EigenvaluesGeneratingReflections","imp")(p,q,r);
  o:=List(o,Denominator);
  return CHEVIE.RawData("HeckeCharTable","imp")
	 (p,q,r,List(o,x->List([0..x-1],i->E(x)^i)));
end);

##############################################################################
##  Symbols, Fourier matrix, Frobenius eigenvalues                          ##
##  as in: G. Malle, "Unipotente Grade...", J. Algebra 177 (1995), Sect. 4  ##
##  and 6 for family of G(e,1,n) or G(e,e,n) whose symbols have entries as  ##
##  in picol = Collected(list of entries)                        GM 26.10.00##
##############################################################################
FourierImprimitive:=function(e,picol)
  local eps,symbol,m,pi,ll,i,j,k,l,frobs,schon,reps,equiv,d,sym,symbs,mat,orb,s,
        newsymbs, newmat, newfrobs, mult, newmult, fr, I,p, newsigns;
  I:=Sum(picol,x->x[2]);d:=I mod e;
  if not d in [0,1] then
    Print("Error: Length(pi) should be =0 or 1 mod e !\n");
  fi;
  pi:=Concatenation(List(picol,x->[1..x[2]]*0+x[1])); m:=(I-d)/e;
  picol:=List(picol,i->i[2]);
  symbol:=function(l) local sy, j;
    sy:=List([1..e],j->[]);
    for j in [1..I] do Add(sy[l[j]+1],pi[j]);od;
    return sy;
  end;
  ll:=List(Cartesian(List(picol,i->Arrangements([0..e-1],i))),Concatenation);
  p:=m*Binomial(e,2);
  ll:=Filtered(ll,i->(Sum(i)-p) mod e=0);
  symbs:=[]; equiv:=[];
  for i in [1..Length(ll)] do
    sym:=symbol(ll[i]);
    p:=Position(symbs,sym);
    if p<>false then Add(equiv[p],i);
    else Add(symbs,sym); Add(equiv,[i]);
    fi;
  od;
# Print("ll=",ll,"\n");
# Print("symbs=",symbs,"\n");
# Print("equiv=",equiv,"\n");
  reps:=List(equiv,x->x[1]);
  eps:=List(ll,l->(-1)^Sum([1..I],i->Number([i+1..I],j->l[i]<l[j])));
  mat:=(-1)^(m*(e-1))*List(equiv,i->Sum(i,j->List(reps,
    k->eps[j]*eps[k]*E(e)^(-ll[j]*ll[k]))))/(E(4)^Binomial(e-1,2)*ER(e)^e)^m;
  frobs:=E(12)^(-(e^2-1)*m)*List(ll{reps},i->E(2*e)^(-i*i-e*Sum(i)));
  newsigns:=List(symbs,i->(-1)^(Binomial(e,2)*Binomial(m,2)+
                       Sum([1..e-1],j->j*Binomial(Length(i[j+1]),2))));
  mat:=List([1..Length(mat)],i->List([1..Length(mat)],
                                      j->newsigns[i]*newsigns[j]*mat[i][j]));
  if d=1 then return [symbs,mat,frobs];fi;

  schon:=List([1..Length(symbs)],j->0);
  reps:=[]; equiv:=[]; mult:=[];
  for i in [1..Length(symbs)] do
    if schon[i]=0 then
      reps:=Concatenation(reps,[i]);
      orb:=List([1..e],j->symbs[i]{1+List([j..j+e-1],x->x mod e)});
      s:=Length(Set(orb));  # Symmetriegruppe
      mult:=Concatenation(mult,[s]);
      mat[i]:=s*mat[i];
      equiv:=Concatenation(equiv,[Filtered([1..Length(symbs)],
                      j->symbs[j] in orb)]);
      for j in equiv[Length(reps)] do schon[j]:=1; od;
    fi;
  od;
  mat:=List(mat{reps},i->i{reps});
  symbs:=symbs{reps}; frobs:=frobs{reps};
  newsymbs:=[]; newmat:=[]; newfrobs:=[]; newmult:=[];
  for i in [1..Length(symbs)] do
    Append(newsymbs,List([1..e/mult[i]],j->[symbs[i],E(e/mult[i])^j]));
    Append(newfrobs,List([1..e/mult[i]],j->frobs[i]));
    Append(newmult,List([1..e/mult[i]],j->mult[i]));
    mat[i]:=Concatenation(List([1..Length(symbs)],j->
                          List([1..e/mult[j]],k->mat[i][j]*mult[j]/e)));
  od;
  newmat:=[];
  for i in [1..Length(symbs)] do
      newmat:=Concatenation(newmat,List([1..e/mult[i]],j->List(mat[i],
                ShallowCopy)));
  od;
  for i in [1..Length(newsymbs)] do
    for j in [1..Length(newsymbs)] do if newsymbs[i][1]=newsymbs[j][1] then
      if newsymbs[i][2]=newsymbs[j][2] then
         newmat[i][j]:=newmat[i][j] + (e-newmult[i])/e;
      else
         newmat[i][j]:=newmat[i][j] - newmult[i]/e;
      fi;
    fi; od;
  od;
  fr:=IdentityMat(Length(newfrobs));
  for i in [1..Length(newfrobs)] do fr[i][i]:=newfrobs[i]; od;
  if (newmat*fr)^3<>IdentityMat(Length(newfrobs)) then
     Print("(S*T)^3<>1\n");
  fi;
  return([newsymbs,newmat,newfrobs]);
end;

# makes a family from Collected(symbol S) in spets G(e,e,r) or G(e,1,r)
MakeFamilyImprimitive:=function(e,coll)local m,d,res,r,ud,fd,cs,sgn,s,j,l,
  DefSymbol,PossSymbol;
  DefSymbol:=S->(Binomial(e,2)*m-List(S,Length)*[0..e-1]) mod e;
  PossSymbol:=s->Filtered(List([0..e-1],i->s{1+List([i..i+e-1],x->x mod e)}),
    x->DefSymbol(x)=0);
  m:=QuoInt(Sum(coll,x->x[2]),e);d:=Sum(coll,x->x[2])-e*m;
  r:=FourierImprimitive(e,coll);
  l:=Length(r[1]);
  if l<>1 and r[2]=IdentityMat(l) then
    r[3]:=[r[3][1]]; r[2]:=[[1]]; r[1]:=[r[1][1]]; l:=1;
  fi;
  s:=r[1];
  if d=0 then s:=List(s,x->x[1]);
              cs:=CHEVIE.RawData("CharSymbols","imp")(e,e,RankSymbol(s[1]));
  else        cs:=CHEVIE.RawData("CharSymbols","imp")(e,1,RankSymbol(s[1]));
  fi;
  if Length(s)=1 then return Family("C1",[Position(cs,s[1])]);fi;
  res:=rec(fourierMat:=r[2],eigenvalues:=r[3]);
  res.name:=IntListToString(Concatenation(List(coll,x->[1..x[2]]*0+x[1])));
  res.TeXName:=String(Concatenation(List(coll,function(x)
      if x[2]=1 then return String(x[1]);
      else return SPrint(x[1],"^{",x[2],"}");fi;end)));
  res.charNumbers:=List(s,x->PositionProperty(cs,y->x in PossSymbol(y)));
  if d=0 then
    sgn:=res.charNumbers*0+1;
    for j in [1..l] do
      if s[j]<>cs[res.charNumbers[j]] then
	sgn[j]:=Value(CycPolGenericDegreeSymbol(s[j])/
	              CycPolGenericDegreeSymbol(cs[res.charNumbers[j]]),1);
	res.fourierMat[j]:=res.fourierMat[j]*sgn[j];
	res.fourierMat{[1..l]}[j]:=res.fourierMat{[1..l]}[j]*sgn[j];
    #   InfoChevie(i,": should be ",StringSymbol(s[j])," instead of ",
    #     StringSymbol(cs[res.charNumbers[j]])," rel. sgn.",sgn[j],"\n");
      fi;
    od;
  fi;
  # the next should be improved
  res.charLabels:=List([1..Length(res.charNumbers)],String);
  res.TeXCharLabels:=List([1..Length(res.charNumbers)],String);
  res.special:=1;
  return res;
end;

# JM 30/11/2000 we have to decide how to represent cuspidals of imprimitive
# groups -- the function below is an ad-hoc solution for now

ImprimitiveCuspidalName:=function(arg) local S,option,r,s;
  S:=arg[1];if Length(arg)=2 then option:=arg[2];else option:="";fi;
  r:=RankSymbol(S);s:=IntListToString(List(S,Length));
  if r=0 then return "";
  elif r=1 then
    if Length(S)=3 then if option="TeX" then return "Z_3";
                                        else return "Z3";
					fi;
    else if option="TeX" then return Concatenation("Z^{",s,"}");
         else return Concatenation("Z[",s,"]");
	 fi;
    fi;
  else if option="TeX" then return SPrint("B_{",r,"}^{",s,"}");
       else return SPrint("B",r,"[",s,"]");
       fi;
  fi;
end;

CHEVIE.AddData("UnipotentCharacters","imp",function(p,q,r)
 local uc,cusp,ReducedSymbol,n;
 if q=1 then
   uc:=rec(charSymbols:=CHEVIE.RawData("CharSymbols","imp")(p,1,r));
   ReducedSymbol:=function(S)
    while 0 in Intersection(S) do S:=List(S,x->ShiftBeta(x,-1));od;
    return S;
   end;
   cusp:=Set(List(uc.charSymbols,
      S->ReducedSymbol(List(S,x->[0..Length(x)-1]))));
   SortParallel(List(cusp,RankSymbol),cusp);
   uc.harishChandra:=List(cusp,function(c)local cr,res;
    cr:=RankSymbol(c);
    res:=rec(levi:=[1..cr]);
    if cr<r then res.parameterExponents:=[List(c,Length)];
    else res.parameterExponents:=[];
    fi;
    Append(res.parameterExponents,[2+cr..r]*0+1);
    res.relativeType:=rec(series:="ST",indices:=[1+cr..r],rank:=r-cr,p:=p,q:=1);
    res.eigenvalue:=E(24)^(-2*(p^2-1)*QuoInt(Sum(c,Length),p))*
	E(2*p)^Sum([0..p-1],i->-(i^2+p*i)*Length(c[i+1]));
    res.charNumbers:=List(List(CHEVIE.RawData("CharSymbols","imp")(p,1,r-cr)
      {[1..Length(PartitionTuples(r-cr,p))]},x->List(x,PartBeta)),
         x->Position(uc.charSymbols,SymbolPartitionTuple(x,List(c,Length))));
    res.cuspidalName:=ImprimitiveCuspidalName(c);
    res.TeXCuspidalName:=ImprimitiveCuspidalName(c,"TeX");
    return res;end);
    uc.families:=List(Set(List(uc.charSymbols,x->Collected(Concatenation(x)))),
      y->MakeFamilyImprimitive(p,y));
    SortParallel(List(uc.families,x->x.charNumbers),uc.families);
    if r=1 then # just this cases implemented; others should be too
      uc.families[1].special:=(p^2-3*p+4)/2; uc.families[1].cospecial:=1;
    elif [p,r]=[3,2] then
      uc.families[2].special:=2; uc.families[2].cospecial:=1;
      uc.families[4].special:=5; uc.families[4].cospecial:=3;
    fi;
    uc.a:=List(uc.charSymbols,LowestPowerGenericDegreeSymbol);
    uc.A:=List(uc.charSymbols,HighestPowerGenericDegreeSymbol);
    return uc;
  elif [p,q,r]=[3,3,3] then
    return rec(
      harishChandra:=[
	rec(relativeType:=rec(series:="ST",indices:=[1..3],rank:=3,p:=3,q:=3),
            levi:=[],parameterExponents:=[1,1,1],
	    charNumbers:=[1..10], eigenvalue:=1, cuspidalName:="",
	    TeXCuspidalName:=""),
	rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
            levi:=[1..3],parameterExponents:=[],
	    charNumbers:=[11], eigenvalue:=E(3), cuspidalName:="G3,3,3[E3]",
	    TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
	rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
            levi:=[1..3],parameterExponents:=[],
	    charNumbers:=[12], eigenvalue:=E(3)^2, cuspidalName:="G3,3,3[E3^2]",
	    TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]")],
      charSymbols:=CHEVIE.RawData("CharSymbols","imp")(p,q,r),
      families:=[
	Family("C1",[10]),
	Family(ConjugateFamily(CHEVIE.families.X(3)),[8,7,11]),
	Family("C1",[3]),
	Family("C1",[1]),
	Family("C1",[2]),
	Family("C1",[9]),
	Family(CHEVIE.families.X(3),[4,5,12]),
	Family("C1",[6])],
	a:=[3,3,3,4,4,9,1,1,3,0,1,4],
        A:=[6,6,6,8,8,9,5,5,6,0,5,8]);
  elif [p,q,r]=[3,3,4] then
    return rec(
      harishChandra:=[
    rec(relativeType:=rec(series:="ST",indices:=[1..4],rank:=4,p:=3,q:=3),
      levi:=[],parameterExponents:=[1,1,1,1],
        charNumbers:=[1..17], eigenvalue:=1, cuspidalName:="",
        TeXCuspidalName:=""),
    rec(relativeType:=rec(series:="ST",indices:=[4],rank:=1,p:=3,q:=1),
      levi:=[1..3],parameterExponents:=[3],
        charNumbers:=[18,19,20], eigenvalue:=E(3),cuspidalName:="G3,3,3[E3]",
        TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
    rec(relativeType:=rec(series:="ST",indices:=[4],rank:=1,p:=3,q:=1),
      levi:=[1..3], parameterExponents:=[[0,3,3]],
        charNumbers:=[23,21,22], eigenvalue:=E(3)^2,
	cuspidalName:="G3,3,3[E3^2]",
        TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]"),
      ],
      charSymbols:=CHEVIE.RawData("CharSymbols","imp")(p,q,r),
      families:=[
     Family("C1",[17]),
     Family(ConjugateFamily(CHEVIE.families.X(3)),[15,14,18]),
     Family("C1",[12]),
     Family("C1",[16]),
     Family("C1",[6]),
     Family(CHEVIE.families.QZ(3),[13,9,8,10,19,22,7,21,20],
       rec(delta1:=[1,1,1,-1,1,-1,-1,1,-1],special:=3,cospecial:=2)),
     Family("C1",[1]),
     Family("C1",[3]),
     Family("C1",[11]),
     Family(CHEVIE.families.X(3),[2,4,23]),
     Family("C1",[5])],
     a:=[6,10,8,10,18,3,4,4,4,4,9,2,4,1,1,3,0,1,4,4,4,4,10],
     A:=[15,17,16,17,18,12,14,14,14,14,15,10,14,8,8,9,0,8,14,14,14,14,17]);
  elif [p,q,r]=[3,3,5] then
    return rec(
      harishChandra:=[
    rec(relativeType:=rec(series:="ST",indices:=[1..5],rank:=5,p:=3,q:=3),
      levi:=[], parameterExponents:=[1,1,1,1,1],
        charNumbers:=[1..36],
        eigenvalue:=1, cuspidalName:="",
        TeXCuspidalName:=""),
    rec(relativeType:=rec(series:="ST",indices:=[4,5],rank:=2,p:=3,q:=1),
      levi:=[1..3],parameterExponents:=[3,1],
        charNumbers:=[37, 38, 39, 40, 41, 42, 43, 44, 45 ],
	eigenvalue:=E(3),cuspidalName:="G3,3,3[E3]",
        TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
    rec(relativeType:=rec(series:="ST",indices:=[4,5],rank:=2,p:=3,q:=1),
      levi:=[1..3],parameterExponents:=[[0,3,3],1],
        charNumbers:=[ 51, 48, 50, 46, 47, 49, 54, 52, 53 ],
	eigenvalue:=E(3)^2,cuspidalName:="G3,3,3[E3^2]",
        TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]")],
      charSymbols:=CHEVIE.RawData("CharSymbols","imp")(p,q,r),
    families:=[
     Family("C1",[36]),
     Family(ConjugateFamily(CHEVIE.families.X(3)),[34,33,43]),
     Family("C1",[35]),
     Family(ConjugateFamily(CHEVIE.families.X(3)),[31,30,37]),
     Family("C1",[24]),
     Family("C1",[18]),
     Family(CHEVIE.families.QZ(3),[32,27,26,28,38,53,25,52,39],
       rec(delta1:=[1,1,1,-1,1,-1,-1,1,-1],special:=3,cospecial:=2)),
     Family(CHEVIE.families.X(3),[19,22,47]),
     Family(CHEVIE.families.QZ(3),[9,10,8,21,44,46,20,49,45],
       rec(delta1:=[1,1,1,1,-1,-1,1,1,1])),
     Family(ConjugateFamily(CHEVIE.families.X(3)),[14,13,41]),
     Family("C1",[29]),
     Family(CHEVIE.families.QZ(3),[23,11,16,12,42,50,15,48,40],
       rec(delta1:=[1,-1,-1,1,-1,-1,1,1,1],special:=4,cospecial:=7)),
     Family("C1",[1]),
     Family("C1",[2]),
     Family(CHEVIE.families.X(3),[4,5,54]),
     Family("C1",[17]),
     Family(CHEVIE.families.X(3),[3,6,51]),
     Family("C1",[7])],
     a:=[10,12,19,14,14,19,30,6,6,6,10,10,8,8,10,10,18,4,5,6,6,5,10,3,4,4,4,4,
      9,2,2,4,1,1,3,0,2,4,4,10,8,10,1,6,6,6,5,10,6,10,19,4,4,14],
     A:=[26,27,29,28,28,29,30,24,24,24,26,26,25,25,26,26,27,20,22,24,24,22,26,
      18,20,20,20,20,21,16,16,20,11,11,12,0,16,20,20,26,25,26,11,24,24,24,22,
      26,24,26,29,20,20,28]);
  elif [p,q,r]=[4,4,3] then
    return rec(
      harishChandra:=[
    rec(relativeType:=rec(series:="ST",indices:=[1..3],rank:=3,p:=4,q:=4),
        levi:=[], parameterExponents:=[1,1,1],charNumbers:=[1..10],
	eigenvalue:=1, cuspidalName:="",
        TeXCuspidalName:=""),
    rec(relativeType:=rec(series:="ST",indices:=[3],rank:=1,p:=4,q:=1),
        levi:=[1,2],parameterExponents:=[[2,2,0,0]],charNumbers:=[11,12,13,14],
	eigenvalue:=-1, cuspidalName:="B2",TeXCuspidalName:="B_2"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
        levi:=[1..3],parameterExponents:=[],charNumbers:=[15],eigenvalue:=E(4),
	cuspidalName:="G4,4,3[I]",TeXCuspidalName:="G_{4,4,3}[i]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
        levi:=[1..3],parameterExponents:=[],charNumbers:=[16],eigenvalue:=-E(4),
	cuspidalName:="G4,4,3[-I]",TeXCuspidalName:="G_{4,4,3}[-i]"),
      ],
      charSymbols:=CHEVIE.RawData("CharSymbols","imp")(p,q,r),
      families:=[
       Family("C1",[10]),
       Family(ConjugateFamily(CHEVIE.families.X(4)),[8,6,7,12,15,11],
         rec(delta1:=[1,1,1,1,-1,-1])),
       Family("C1",[1]),
       Family("C1",[9]),
       Family(CHEVIE.families.X(4),[3,2,4,14,16,13],
         rec(delta1:=[1,1,1,1,-1,-1])),
       Family("C1",[5])],
       a:=[ 3, 5, 5, 5, 12, 1, 1, 1, 4, 0, 1, 1, 5, 5, 1, 5 ],
       A:=[ 9, 11, 11, 11, 12, 7, 7, 7, 8, 0, 7, 7, 11, 11, 7, 11 ]);
  else return false;
  fi;
end);

CHEVIE.AddData("Invariants","imp",function(p,q,r)local v;
  v:=List([1..r-1],i->function(arg)
    return Sum(Arrangements([1..r],i),a->Product(arg{a})^p);end);
  Add(v,function(arg)return Product(arg)^(p/q);end);
  return v;
#   pmat(m);
end);

CHEVIE.AddData("PhiFactors","timp",function(p,q,r,phi)local res,o;
  o:=OrderPerm(phi);
  if p=q then
    if p mod o=0 then
      if phi=(1,2,4) then return [1,1,E(3)^2];
      else res:=[1..r]*0+1;res[Length(res)]:=E(o); return res;
      fi;
    elif p=3 and r=3 and o=4 then return [E(4),1,-E(4)];
    fi;
  fi;
  Error("wrong arguments");
end);

CHEVIE.AddData("CharName","timp",function(arg)return arg[2];end);

CHEVIE.AddData("ReducedInRightCoset","timp",function(W,phi)
  local e,y,sets,sets2,i,scalar,v,m,z,p2;
  # quads of roots which have the same CartanMat and give representatives of 
  # W-orbits of quads of reflections satisfying Ruth relations
  sets:=[[1,2,3,44],[21,3,1,32],[3,11,2,36],[22,3,2,16]]; # for order 3
  sets2:=[[1,50,3,12], # 2
          [3,52,2,23], # 11
          [1,16,3,43], # 38
          [2,37,3,15], # 14
          [50,3,52,38], # 53
          [1,23,3,22]]; # 45
  p2:=[2,11,38,14,53,45];
  for i in sets do
    y:=Set(Reflections(W){i});
    e:=RepresentativeOperation(W,y,OnSets(y,phi),OnSets);
    if e<>false then 
      return [i{[1..3]},phi*e^-1];
    fi;
  od;
  for i in [1..Length(sets2)] do
    y:=W.rootInclusion{sets2[i]};
    v:=Set(y);
    e:=RepresentativeOperation(W,v,OnSets(v,phi),OnSets);
    if e<>false and PermListList(y,OnTuples(y,phi*e^-1))=(1,2,3,4) then 
      return [[sets2[i][1],p2[i],sets2[i][3]],phi*e^-1];
    fi;
  od;
  return false;
  end
);

CHEVIE.AddData("ClassInfo","timp",function(p,q,r,phi)
  if [p,q,r]=[3,3,3] then
    if phi=(1,4,2) then
      return rec( classtext:=[[],[3],[1],[2,1],[3,1],[3,2,1],[2,3,1,2,3,1]],
        classparams:=[[],[3],[1],[2,1],[3,1],[3,2,1],[2,3,1,2,3,1]],
        classnames:=["Id","3","1","21","31","321","231231"]);
    elif phi=(1,2,4) then
      return rec( classtext:=[[],[3],[1],[1,2],[3,1],[3,1,2],[1,3,2,1,3,2]],
        classparams:=[[],[3],[1],[1,2],[3,1],[3,1,2],[1,3,2,1,3,2]],
        classnames:=["Id","3","1","12","31","312","132132"]);
    elif phi=(1,2,3,4) then
      return rec( classtext:=[[],[1],[1,2],[1,2,3],[1,2,1],[1,2,1,3]],
        classparams:=[[],[1],[1,2],[1,2,3],[1,2,1],[1,2,1,3]],
        classnames:=["Id","1","12","123","121","1213"]);
    else Error("should not be here");
    fi;
  else
    CHEVIE.Diagnose("ClassInfo not implemented");return false;
  fi;
end);

CHEVIE.AddData("CharParams","timp",function(p,q,r,phi)
  if [p,q,r]=[3,3,3] then
    if phi=(1,4,2) or phi=(1,2,4) then
      return [[[],[],[3]],[[],[],[1,1,1]],[[],[],[2,1]],[[],[1,1],[1]],
       [[],[2],[1]],[[],[1],[1,1]],[[],[1],[2]]];
    elif phi=(1,2,3,4) then return [[[],[],[3]],[[],[],[1,1,1]],[[],[1,1],[1]],
     [[],[2],[1]],[[],[1],[1,1]],[[],[1],[2]]];
    else Error("should not happen");
    fi;
  else
    CHEVIE.Diagnose("CharParams not implemented");return false;
  fi;
end);

CHEVIE.AddData("CharName","timp",CHEVIE.imp.CharName);

CHEVIE.AddData("CharTable","timp",function(p,q,r,phi)local res;
  if [p,q,r]=[3,3,3] then
    if phi=(1,4,2) then res:=
    rec(size:=54, order:=54, centralizers:=[ 18, 6, 6, 18, 3, 6, 18 ],
    identifier:="3'G(3,3,3)", name:="3'G(3,3,3)",
    # orders:=[ 3, 6, 6, 3, 9, 6, 3 ],
    classes:=[ 3, 9, 9, 3, 18, 9, 3 ],
    irreducibles:=[[1,1,1,1,1,1,1],[1,-1,-1,1,1,-1,1],[2,0,0,2,-1,0,2],
     E(3)*[-ER(-3),            -1,-E(3)^2,2*E(3)+E(3)^2,0,-E(3),-E(3)-2*E(3)^2],
     E(3)*[-ER(-3),             1, E(3)^2,2*E(3)+E(3)^2,0, E(3),-E(3)-2*E(3)^2],
      [-2*E(3)-E(3)^2,-E(3)^2,     -1, ER(-3),      0,-E(3), E(3)+2*E(3)^2],
      [-2*E(3)-E(3)^2, E(3)^2,      1, ER(-3),      0, E(3), E(3)+2*E(3)^2]]);
    elif phi=(1,2,4) then res:=
    rec(size:=54, order:=54, centralizers:=[ 18, 6, 6, 18, 3, 6, 18 ],
    identifier:="3G(3,3,3)", name:="3G(3,3,3)",
    # orders:=[ 3, 6, 6, 3, 9, 6, 3 ],
    classes:=[ 3, 9, 9, 3, 18, 9, 3 ],
    irreducibles:=[[1,1,1,1,1,1,1],[1,-1,-1,1,1,-1,1],[2,0,0,2,-1,0,2],
      E(3)^2*[ER(-3),-1,-E(3),(-3-ER(-3))/2,0,-E(3)^2,(3-ER(-3))/2],
      E(3)^2*[ER(-3),1,E(3),(-3-ER(-3))/2,0,E(3)^2,(3-ER(-3))/2],
      [(3+ER(-3))/2,-E(3),-1,-ER(-3),0,-E(3)^2,(-3+ER(-3))/2],
      [(3+ER(-3))/2,E(3),1,-ER(-3),0,E(3)^2,(-3+ER(-3))/2]]);
    elif phi=(1,2,3,4) then res:=
      rec(size:=54, order:=54, centralizers:=[6,6,6,6,6,6],
      identifier:="4G(3,3,3)", name:="4G(3,3,3)",
      # orders:=[ 4,12,12,4,12,12],
      classes:=[ 9,9,9,9,9,9],
      irreducibles:=[[1,1,1,1,1,1],[1,-1,1,-1,-1,1],
       [1,E(3),E(3)^2,1,E(3)^2,E(3)],[1,-E(3),E(3)^2,-1,-E(3)^2,E(3)],
       [1,E(3)^2,E(3),1,E(3),E(3)^2],[1,-E(3)^2,E(3),-1,-E(3),E(3)^2]]);
    else Error("should not happen");
    fi;
  else
    CHEVIE.Diagnose("CharTable not implemented");return false;
  fi;
  res.text:="origin: Dixon's Algorithm";
  return CHEVIE.compat.MakeCharacterTable(res);
end);

CHEVIE.AddData("UnipotentCharacters","timp",function(p,q,r,phi)local res,a;
  if [p,q,r]=[3,3,3] then
    if phi=(1,4,2) then 
  return rec(
  harishChandra:=[
 #  rec(relativeType:=rec(series:="ST",indices:=[1,2,44,3],p:=3,q:=1,rank:=2),
    rec(relativeType:=rec(series:="ST",indices:=[1,2],p:=3,q:=1,rank:=2),
      levi:=[  ], eigenvalue:=1,
      parameterExponents:=[[2,0,1],1], cuspidalName:="",
      TeXCuspidalName:="",
      charNumbers:=[7,3,5,2,4,9,1,6,8])],
  almostHarishChandra:=[
    rec(relativeType:=rec(orbit:=[rec(series:="ST",indices:=[1..3],
     p:=3,q:=3,rank:=3)],
      twist:=(1,2,4)),
      levi:=[  ], eigenvalue:=1, cuspidalName:="", TeXCuspidalName:="",
      charNumbers:=[1..7]),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	charNumbers:=[8], eigenvalue:=E(3), cuspidalName:="G3,3,3[E3]",
	TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	charNumbers:=[9], eigenvalue:=E(3)^2, cuspidalName:="G3,3,3[E3^2]",
	TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]")],
  families:=[
    Family("C1",[1]),
    Family("C1",[2]),
    Family("C1",[3]),
    Family(ConjugateFamily(CHEVIE.families.X(3)),[7,5,8]),
    Family(ConjugateFamily(CHEVIE.families.X(3)),[6,4,9])],
  a:=[0,9,3,4,1,4,1,1,4],
  A:=[0,9,6,8,5,8,5,5,8]);
    elif phi=(1,2,4) then 
  return rec(
  harishChandra:=[
  # rec(relativeType:=rec(series:="ST",indices:=[1,2,44,3],p:=3,q:=1,rank:=2),
    rec(relativeType:=rec(series:="ST",indices:=[1,2],p:=3,q:=1,rank:=2),
      levi:=[  ], eigenvalue:=1,
      parameterExponents:=[[2,1,0],1], cuspidalName:="",
      TeXCuspidalName:="",
      charNumbers:=[7,5,3,9,4,2,1,8,6])],
  almostHarishChandra:=[
    rec(relativeType:=rec(orbit:=[rec(series:="ST",indices:=[1..3],
     p:=3,q:=3,rank:=3)],
      twist:=(1,2,4)),
      levi:=[  ], eigenvalue:=1, cuspidalName:="", TeXCuspidalName:="",
      charNumbers:=[1..7]),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	charNumbers:=[8], eigenvalue:=E(3), cuspidalName:="G3,3,3[E3]",
	TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	charNumbers:=[9], eigenvalue:=E(3)^2, cuspidalName:="G3,3,3[E3^2]",
	TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]")],
  families:=[
    Family("C1",[1]),
    Family("C1",[2]),
    Family("C1",[3]),
    Family(CHEVIE.families.X(3),[7,5,8]),
    Family(CHEVIE.families.X(3),[6,4,9])],
  a:=[0,9,3,4,1,4,1,1,4],
  A:=[0,9,6,8,5,8,5,5,8]);
    elif phi=(1,2,3,4) then 
  res:=rec(
  harishChandra:=[
    rec(relativeType:=rec(series:="ST",indices:=[1],p:=6,q:=1,rank:=1),
      levi:=[  ], eigenvalue:=1,
      parameterExponents:=[[3,0,1,2,1,2]], cuspidalName:="",
      TeXCuspidalName:="",
      charNumbers:=[1..6]),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	parameterExponents:=[],charNumbers:=[7], eigenvalue:=E(3)^2,
	cuspidalName:="4G3,3,3[E3^2]",
	TeXCuspidalName:="4G_{3,3,3}[\\zeta_3^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	parameterExponents:=[],charNumbers:=[8], eigenvalue:=E(3),
	cuspidalName:="4G3,3,3[E3]",
	TeXCuspidalName:="4G_{3,3,3}[\\zeta_3]")],
  almostHarishChandra:=[
    rec(relativeType:=rec(orbit:=[rec(series:="ST",indices:=[1..3],
     p:=3,q:=3,rank:=3)],
      twist:=(1,2,3,4)),
      levi:=[  ], eigenvalue:=1, cuspidalName:="", TeXCuspidalName:="",
      charNumbers:=[1..6]),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	charNumbers:=[7], eigenvalue:=E(3), cuspidalName:="G3,3,3[E3]",
	TeXCuspidalName:="G_{3,3,3}[\\zeta_3]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0), levi:=[1..3],
	charNumbers:=[8], eigenvalue:=E(3)^2, cuspidalName:="G3,3,3[E3^2]",
	TeXCuspidalName:="G_{3,3,3}[\\zeta_3^2]")],
  families:=[
    Family("C1",[1]),
    Family("C1",[2]),
    Family(ConjugateFamily(CHEVIE.families.X(3)),[3,5,7],rec(delta1:=[1,1,-1])),
    Family(CHEVIE.families.X(3),[4,6,8],rec(delta1:=[1,1,-1]))],
  a:=[0,9,4,1,4,1,4,1],
  A:=[0,9,8,5,8,5,8,5]);
    res.families[3].eigenvalues[3]:=E(3)^2;
    res.families[4].eigenvalues[3]:=E(3);
    a:=1;
    res.families[3].fourierMat[3]:=a*res.families[3].fourierMat[3];
    res.families[4].fourierMat[3]:=GaloisCyc(a,-1)*res.families[4].fourierMat[3];
    return res;
    else Error("should not go here");return false;
    fi;
  else
    CHEVIE.Diagnose("UnipChars not implemented");return false;
  fi;
end);
