#############################################################################
##
#A  tbl/coxh3.g                 CHEVIE library      Meinolf Geck, Jean Michel
##
#Y  Copyright (C) 1992 - 2004  The CHEVIE Team
##
##  This file contains data for Coxeter groups and Hecke algebras of type H3.
##
CHEVIE.Revision("tbl/coxh3.g",
   "$Id: coxh3.g,v 1.3 2003/12/04 11:26:45 chevie Exp $");

CHEVIE.AddData("ReflectionDegrees","H3",[2,6,10]);

CHEVIE.AddData("Size", "H3", function(arg) return 120; end);

# from Humphreys, "Reflection Groups and Coxeter Groups"
CHEVIE.AddData("GeneratingRoots", "H3", function(arg)local a, b;
  a:=(1+ER(5))/4; b:=(-1+ER(5))/4;
  return [[a,-1/2,b],[-a,1/2,b],[1/2,b,-a]];
end);

CHEVIE.AddData("NrConjugacyClasses","H3", 10);

CHEVIE.AddData("cyclestructure","H3",[]);
CHEVIE.AddData("generators","H3",[]);

CHEVIE.AddData("CartanMat","H3",[[2,-(1+ER(5))/2,0],[-(1+ER(5))/2,2,-1],[0,-1,2]]);

CHEVIE.AddData("PowerMaps","H3",[,[1,1,7,1,5,3,3,5,7,1],[1,2,7,4,1,9,3,10,6,10],,
  [ 1, 2, 1, 4, 5, 10, 1, 8, 10, 10 ],, [ 1, 2, 7, 4, 5, 9, 3, 8, 6, 10 ] ]);

CHEVIE.AddData("WordsClassRepresentatives","H3",
 [[],[1],[1,2],[1,3],[2,3],[1,2,3],[1,2,1,2],[1,2,1,2,3],
  [1,2,1,2,3,2,1,2,3],[1,2,1,2,1,3,2,1,2,1,3,2,1,2,3]]);

CHEVIE.AddData("ClassName", "H3", x->x);

CHEVIE.AddData("ClassInfo","H3",function()local res;
  res:=rec(
  classtext:=CHEVIE.RawData("WordsClassRepresentatives","H3"),
  orders:=[1,2,5,2,3,10,5,6,10,2],
  classes:=[ 1, 15, 12, 15, 20, 12, 12, 20, 12, 1 ]);
  res.classnames:=List(res.classtext,IntListToString);res.classnames[1]:=".";
  res.classparams:=res.classnames;
  return res;
end);

CHEVIE.AddData("CharInfo","H3",function()local res;
  res:=rec(
  charparams:=[[1,15],[1,0],[5,5],[5,2],[3,6],[3,8],[3,1],[3,3],[4,3],[4,4]],
  positionId:=2,positionSgn:=1,positionRefl:=7);
  res.b:=List(res.charparams,x->x[2]);
  res.spetsRationality:=[1,1,1,1,1,1,1,1,2,2];
  return res;
end);

CHEVIE.AddData("vpolheckeirreducibles","H3",
[[[[1],0],[[-1],0],[[1],0],[[1],0],[[1],0],[[-1],0],[[1],0],[[-1],0],
  [[-1],0],[[-1],0]],
 [[[1],0],[[1],2],[[1],4],[[1],4],[[1],4],[[1],6],[[1],8],[[1],10],
  [[1],18],[[1],30]],
 [[[5],0],[[-3,0,2],0],[[1,0,-1],0],[[2,0,-2,0,1],0],[[1,0,-2],0],[[],0],
  [[1,0,0,0,-1],0],[[1],4],[[],0],[[-5],12]],
 [[[5],0],[[-2,0,3],0],[[-1,0,1],2],[[1,0,-2,0,2],0],[[-2,0,1],2],[[],0],
  [[-1,0,0,0,1],4],[[-1],6],[[],0],[[5],18]],
 [[[3],0],[[-2,0,1],0],[[1,0,E(5)+E(5)^4],0],[[1,0,-2],0],[[1,0,-1],0],
  [[-E(5)-E(5)^4],2],[[1,0,0,0,E(5)^2+E(5)^3],0],[[],0],[[-E(5)^2-E(5)^3],6],
  [[3],10]],
 [[[3],0],[[-2,0,1],0],[[1,0,E(5)^2+E(5)^3],0],[[1,0,-2],0],[[1,0,-1],0],
  [[-E(5)^2-E(5)^3],2],[[1,0,0,0,E(5)+E(5)^4],0],[[],0],[[-E(5)-E(5)^4],6],
  [[3],10]],
 [[[3],0],[[-1,0,2],0],[[E(5)+E(5)^4,0,1],2],[[-2,0,1],2],[[-1,0,1],2],
  [[E(5)+E(5)^4],4],[[E(5)^2+E(5)^3,0,0,0,1],4],[[],0],[[E(5)^2+E(5)^3],12],
  [[-3],20]],
 [[[3],0],[[-1,0,2],0],[[E(5)^2+E(5)^3,0,1],2],[[-2,0,1],2],[[-1,0,1],2],
  [[E(5)^2+E(5)^3],4],[[E(5)+E(5)^4,0,0,0,1],4],[[],0],[[E(5)+E(5)^4],12],
  [[-3],20]],
 [[[4],0],[[-2,0,2],0],[[-1],2],[[1,0,-2,0,1],0],[[1,0,-1,0,1],0],[[1],3],
  [[-1],4],[[-1],5],[[1],9],[[-4],15]],
 [[[4],0],[[-2,0,2],0],[[-1],2],[[1,0,-2,0,1],0],[[1,0,-1,0,1],0],[[-1],3],
  [[-1],4],[[1],5],[[-1],9],[[4],15]]]);

CHEVIE.AddData("CycPolSchurElements","H3",
[ [1,-15,2,2,2,3,5,6,10], [1,0,2,2,2,3,5,6,10], [1,-5,2,2,2,3,6],
  [1,-2,2,2,2,3,6], [(5+ER(5))/2,-6,2,2,2,2/5,3/5,1/10,9/10],
  [(5-ER(5))/2,-6,2,2,2,1/5,4/5,3/10,7/10],
  [(5+ER(5))/2,-1,2,2,2,2/5,3/5,1/10,9/10],
  [(5-ER(5))/2,-1,2,2,2,1/5,4/5,3/10,7/10], [2,-3,3,5], [2,-3,3,5] ]
);

CHEVIE.AddData("vpolfakedegrees","H3",
[ [ [ 1 ], 15 ], [ [ 1 ], 0 ], [ [ 1, 0, 1, 0, 1, 0, 1, 0, 1 ], 5 ],
  [ [ 1, 0, 1, 0, 1, 0, 1, 0, 1 ], 2 ], [ [ 1, 0, 0, 0, 1, 0, 0, 0, 1 ], 6 ],
  [ [ 1, 0, 1, 0, 1 ], 8 ], [ [ 1, 0, 0, 0, 1, 0, 0, 0, 1 ], 1 ],
  [ [ 1, 0, 1, 0, 1 ], 3 ], [ [ 1, 0, 0, 0, 1, 0, 1, 0, 1 ], 3 ],
  [ [ 1, 0, 1, 0, 1, 0, 0, 0, 1 ], 4 ] ]);

###########################################################################
##
#F HeckeCharTable( <v> )  character table of the Hecke algebra of type H3
##

CHEVIE.AddData("HeckeCharTable","H3",function(param,sqrtparam)
 local a, q, v, ci, tbl;
 a:=(1+ER(5))/2;
 q:=-param[1][1]/param[1][2];
 if not IsBound(sqrtparam[1]) then v:=GetRoot(q,2,"CharTable(Hecke(H3))");
 else v:=sqrtparam[1];
 fi;
 ci := CHEVIE.RawData("ClassInfo", "H3")();
 tbl:=rec(
  identifier:="H(H3)",
  text:="the representing matrices are those of Lusztig (1981)",
  parameter := [ q, q, q ],
  cartan:=CHEVIE.RawData("CartanMat","H3"),
  size := 120, order := 120,
  powermap:=CHEVIE.RawData("PowerMaps","H3"),
  irreducibles:=List(CHEVIE.RawData("vpolheckeirreducibles","H3"),
                     i->List(i,j->FastValue(j,v))),
  irredinfo:=List(CHEVIE.RawData("CharInfo","H3")().charparams,x->
     rec(charparam:=x,charname:=CHEVIE.RawData("CharName","H3")(x,rec()))));
  Inherit(tbl,ci);
  tbl.centralizers:=List(tbl.classes,x->tbl.size/x);
  tbl := CHEVIE.compat.MakeCharacterTable(tbl);
  CHEVIE.compat.AdjustHeckeCharTable(tbl,param);
  return tbl;
end);

CHEVIE.AddData("Representation","H3",function(i)
  return CHEVIE.RawData("HeckeRepresentation","H3")
  ([[1,-1],[1,-1],[1,-1]],[1,1,1],i);end);

# W-graphs given by Ivan Marin.
# see the comments before WGraphToRepresentation for the format.
# An integer instead of a graph says that the graph is dual to that
# of index specified by the integer.
CHEVIE.AddData("WGraphs","H3",[[[[1,2,3]],[]],1,
 [[[2],[1,2],[1,3],[1,3],[2,3]],[[-1,[[1,3],[2,4],[3,5],[4,5]]]]],3,
 [[[1,2],[1,3],[2,3]],[[-1,[[1,2]]],[(-1-ER(5))/2,[[2,3]]]]],
 [[[1,2],[1,3],[2,3]],[[-1,[[1,2]]],[(-1+ER(5))/2,[[2,3]]]]],
 5,6,[[[1],[2],[1,3],[2,3]],[[1,[[1,2,3],[2,3,4],[3,4]]]]],9]);

CHEVIE.AddData("WGraph","H3",function(i)local gr;
 gr:=CHEVIE.RawData("WGraphs","H3");
 if IsInt(gr[i]) then return DualWGraph(3,gr[gr[i]]); else return gr[i]; fi;
end);

CHEVIE.AddData("HeckeRepresentation","H3",function(param,sqrtparam,i)local v;
 if not IsBound(sqrtparam[1]) then 
     v:=GetRoot(-param[1][1]/param[1][2],2,"Representation(Hecke(H3),[",i,"])");
 else v:=sqrtparam[1];
 fi;
 return -param[1][2]*WGraphToRepresentation(3,CHEVIE.RawData("WGraph","H3")(i),v);
end);

CHEVIE.AddData("UnipotentCharacters","H3",function()local res;
  res:=rec(
  harishChandra:=[
    rec(relativeType:=rec(series:="H",indices:=[ 1 .. 3 ],rank:=3),
 levi:=[  ], eigenvalue:=1,
      parameterExponents:=[ 1, 1, 1 ], cuspidalName:="",
      TeXCuspidalName:="",
      charNumbers:=[ 1 .. 10 ]),
    rec(relativeType:=rec(series:="A",indices:=[ 3 ],rank:=1),
 levi:=[ 1 .. 2 ], eigenvalue:=E(5)^2,
      parameterExponents:=[ 5 ], cuspidalName:="I2(5)[1,3]",
      TeXCuspidalName:="I_2(5)[1,3]",
      charNumbers:=[ 11, 13 ]),
    rec(relativeType:=rec(series:="A",indices:=[ 3 ],rank:=1),
 levi:=[ 1 .. 2 ], eigenvalue:=E(5)^3,
      parameterExponents:=[ 5 ], cuspidalName:="I2(5)[1,2]",
      TeXCuspidalName:="I_2(5)[1,2]",
      charNumbers:=[ 12, 14 ]),
    rec(relativeType:=rec(series:="A",indices:=[  ],rank:=0),
 levi:=[ 1 .. 3 ], eigenvalue:=E(4),
      parameterExponents:=[  ], cuspidalName:="H3[I]",
      TeXCuspidalName:="H_3[i]",
      charNumbers:=[ 15 ]),
    rec(relativeType:=rec(series:="A",indices:=[  ],rank:=0),
 levi:=[ 1 .. 3 ], eigenvalue:=-E(4),
      parameterExponents:=[  ], cuspidalName:="H3[-I]",
      TeXCuspidalName:="H_3[-i]",
      charNumbers:=[ 16 ])],
  families:=[
    Family("C1",[ 2 ]),
    Family("HS",[ 7, 8, 14, 13 ]),
    Family("C1",[ 4 ]),
    Family("C2d",[ 9, 10, 15, 16 ]),
    Family("C1",[ 3 ]),
    Family("HS",[ 5, 6, 12, 11 ]),
    Family("C1",[ 1 ])],
  a:=[ 15, 0, 5, 2, 6, 6, 1, 1, 3, 3, 6, 6, 1, 1, 3, 3 ],
  A:=[ 15, 0, 13, 10, 14, 14, 9, 9, 12, 12, 14, 14, 9, 9, 12, 12 ]);
  return res;
end);
