#############################################################################
##
#A  tbl/exceptio.g             CHEVIE library                     Jean Michel
##
#Y  Copyright (C) 1999 - 2001  The CHEVIE Team
##
##  This file contains various code which is common to several (but not all)
##  types of reflection groups.
##
CHEVIE.Revision("tbl/exceptio.g",
   "$Id: exceptio.g,v 1.5 2003/12/04 11:26:45 chevie Exp $");

CHEVIE.AddData("CharName",["E6","E7","E8","F4","G2","2E6","2F4","H3","H4",
 "G4_7","G8_15","G16_22","G24","G25","G26","G27","G29","G31","G32","G33","G34"],
function(x,option)local s;
  if IsBound(option.TeX) then s:="\\phi_"; else s:="phi"; fi;
  Append(s,SPrint("{",x[1],",",x[2],"}"));
  if Length(x)=3 then Append(s,x[3]);fi;
  return String(s);
end);

CHEVIE.IndirectAddData("CartanMat",["G25","G26","G29","G31","G32","G34"],
  function(t)local r,rbar,e;
  r:=CHEVIE.RawData("GeneratingRoots",t);
  rbar:=ComplexConjugate(r);
  e:=CHEVIE.RawData("EigenvaluesGeneratingReflections",t);
  e:=1-List(e,x->E(Denominator(x))^Numerator(x));
  e:=List([1..Length(e)],i->e[i]*rbar[i]/(rbar[i]*r[i]));
  return List(e,x->List(r,y->x*y));
  end);

CHEVIE.IndirectAddData("ReflectionName",
  ["G24","G25","G27","G29","G31","G32","G33","G34","E6","E7","E8","2E6","2F4",
   "3D4","H3","H4"],
  t->function(option)local i,o;
  i:=["G24","G25","G27","G29","G31","G32","G33","G34","E6","E7","E8",
   "2E6","2F4","3D4","H3","H4"];
  o:=["G_{24}","G_{25}","G_{27}","G_{29}","G_{31}","G_{32}","G_{33}","G_{34}",
   "E_6","E_7","E_8","{}^2E_6","{}^2F_4","{}^3D_4","H_3","H_4"];
  if IsBound(option.TeX) then return o[Position(i,t)];else return t;fi;end);

CHEVIE.IndirectAddData("ReflectionName",["A","D","2A","2D"],
t->function(r,option)local i,o;
  i:=["A","D","2A","2D"];o:=["A","D","{}^2A","{}^2D"];
  if IsBound(option.TeX) then 
       return SPrint(o[Position(i,t)],"_",TeXBracket(r));
  else return SPrint(t,r);fi;
  end);

CHEVIE.IndirectAddData("CharTable",["3D4","E6","2E6","E7","E8",
 "F4","2F4","G2","H3","H4"],
 t->function()local res,rank;
  rank:=Position("12345678",t[Length(t)]);
  res:=CHEVIE.RawData("HeckeCharTable",t)(List([1..rank],x->[1,-1]),
                                          List([1,rank],x->1));
  CHEVIE.compat.ChangeIdentifier(res, String(Concatenation("W(",t,")")));
  return res;
end);

CHEVIE.IndirectAddData("LowestPowerFakeDegrees",["A","B","D"],t->function(n)
  return List(CHEVIE.RawData("CharParams",t)(n),CHEVIE.RawData("Charb",t));
end);

CHEVIE.IndirectAddData("SchurElement",["E6","E7","E8","H3","H4"],
t->function(phi,q,rootparam)
  return Value(CycPol(CHEVIE.RawData("CycPolSchurElements",t)
  [Position(CHEVIE.RawData("CharInfo",t)().charparams,phi)]),-q[1][1]/q[1][2]);
end);

CHEVIE.IndirectAddData("SchurElement",["G24","G27","G29","G33","G34"],
t->function(phi,q)
  return Value(CycPol(CHEVIE.RawData("CycPolSchurElements",t)
  [Position(CHEVIE.RawData("CharInfo",t)().charparams,phi)]),-q[1][1]/q[1][2]);
end);

CHEVIE.IndirectAddData("PoincarePolynomial",["G24","G27","G29","G33","G34",
  "H3","H4","E6","E7","E8"],
t->function(q)return Product(CHEVIE.RawData("ReflectionDegrees",t),
  x->Sum([0..x-1],y->(-q[1][1]/q[1][2])^y));
end);

CHEVIE.IndirectAddData("FakeDegree",
["G2","F4","E6","E7","E8","H3","H4","G32","G33","G34"],
t->function(phi,q)return FastValue(CHEVIE.RawData("vpolfakedegrees",t)
        [Position(CHEVIE.RawData("CharInfo",t)().charparams,phi)],q);
end);

CHEVIE.IndirectAddData("PrintDiagram",["E6","E7","E8"],
  t->function(indices,title)local i,r,digits,l;digits:="678";
  Print(title," ");
  r:=Position(digits,t[2])+5;
  l:=Length(String(indices[1]))+Length(String(indices[3]))+4;
  Print(String("",l-1),indices[2],"\n");
  Print(String("",Length(title)+l),"|\n");
  Print(String("",Length(title)-2),indices[1]);
  for i in [3..r] do Print(" - ",indices[i]);od;
  Print("\n");
end);

CHEVIE.IndirectAddData("PrintDiagram",["H3","H4"],t->function(indices,title)
  local i;
  Print(title," ");
  Print(String("",Length(String(indices[1]))-1),"5 \n");
  Print(String("",Length(title)-1),indices[1]," - ",indices[2]," - ",indices[3]);
  if t="H4" then Print(" - ",indices[4]);fi;
  Print("\n");
end);

CHEVIE.IndirectAddData("HighestPowerGenericDegrees",["H3","H4","E6","E7","E8"],
 t->function()local N;
  N:=Sum(CHEVIE.RawData("ReflectionDegrees",t),x->x-1);
  return List(CHEVIE.RawData("CycPolSchurElements",t),
                          x->N-Degree(CycPol(x)));end);

CHEVIE.IndirectAddData("LowestPowerGenericDegrees",["H3","H4","E6","E7","E8"],
 t->function()
          return List(CHEVIE.RawData("CycPolSchurElements",t),x->-x[2]);end);

CHEVIE.IndirectAddData("HighestPowerFakeDegrees",["H3","H4","E6","E7","E8",
  "F4","G2"], t->function()return List(CHEVIE.RawData("vpolfakedegrees",t),
      x->Length(x[1])+x[2]-1);end);

############################################################################
#  G4_22Helper:=function(c,e,x,n,p)
#
#  This function is a helper for char. tables of Hecke algebras G4--G22
#  c is a vector, e an integer vector same length
#  return vector c[i]*(E(n)^p*x^(1/n))^e[i]
#
#  The point of this routine is to avoid unnecessary root extractions
#  during evaluation (i.e., only get n/Gcd(n,e[i])th roots where c[i]<>0)
#
G4_22Helper:=function(c,e,x,n,p)local nz,r,res;
  nz:=Filtered([1..Length(c)],i->c[i]<>0*c[i]);
  r:=Gcd(Concatenation(e{nz},[n]));
  x:=GetRoot(x,n/r)*E(n)^(p*r);
  res:=c*x^0;
  res{nz}:=List(nz,i->c[i]*x^(e[i]/r));
  return res;
end;

G4_22Test:=function(res,rows,i)local l,o;
  res.irreducibles:=rows{i};
  if Length(Set(res.irreducibles))<>Length(res.classes) then
    l:=List(rows,x->Position(rows,x));
    if Length(Set(l))<>Length(res.classes) then
       Error("specialization not semi-simple");fi;
    l:=List(Set(l),x->Filtered([1..Length(l)],i->l[i]=x));
    Print("*** WARNING: bad choice of character restrictions for this specialization\n");
    o:=Filtered(l,x->Number(i,j->j in x)>1);
    Print(" over-represented by ",Intersection(Union(o),i)," : ",o,"\n");
    Print(" absent : ",Filtered(l,x->Number(i,j->j in x)=0),"\n");
  fi;
end;

############################################################################
#  VcycSchurElement(Y,data,model)
#
#  This function computes the Schur elements for G4-22,  G25-26, G28, G32
#  according to the data computed by M. Chlouveraki.
#  Y is the list of parameters to take in account.
#
VcycSchurElement:=function(Y,data,r)local i,vars,res,n,monomial,nr,root;
  n:=Length(Y);vars:=Y{data{1+[1..n]}};
  monomial:=v->Product([1..Length(v)],i->vars[i]^v[i]);
  if IsBound(r.coeff) then res:=r.coeff;else res:=1;fi;
  if IsBound(r.factor) then res:=res*monomial(r.factor);fi;
  if IsBound(r.root) then
    vars:=vars+0*Product(vars);vars[n+1]:=ChevieIndeterminate(vars);
#   vars:=vars+0*vars[n+1];
  elif IsBound(r.rootUnity) then vars[n+1]:=r.rootUnity^data[n+2]; fi;
  res:=res*Product(r.vcyc,
    x->Value(CyclotomicPolynomial(Cyclotomics,x[2]),monomial(x[1])));
  if IsBound(r.root) then
    nr:=Lcm(List(r.root,Denominator));root:=monomial(nr*r.root);
    if IsBound(r.rootCoeff) then root:=root*r.rootCoeff;fi;
    return EvalPolRoot(res,root,nr,data[n+2]);
  else return res;
  fi;
end;
