# try to make family i-th family of W fit family record g 
fitfam:=function(W,i,g)local n,v,p,f,r,uc,m;
  uc:=UnipotentCharacters(W);
  f:=uc.families[i];
  p:=PsMatMat(g.fourierMat,f.fourierMat,g.eigenvalues,f.eigenvalues);
  p:=Elements(PsMatStab(g.fourierMat,g.eigenvalues))*p;
  v:=List(p,x->LsToPermAndSigns(PsToLs(x,Length(g.fourierMat))));
  SortParallel(List(v,x->Number(x[2],y->y<0)),v);
  Print("perm=",v[1][1],"\n");
  m:=[Concatenation(["char"],uc.charNames{f.charNumbers})];
  for r in v do
   Add(m,Concatenation([Number(r[2],x->x<0)],Permuted(r[2],r[1]^-1)));
  od;
  Print(StringTable(m));
  if IsBound(g.name) then n:=g.name;else n:="Z3";fi;
  for r in v do
    Print("Family(\"",n,"\",",Permuted(f.charNumbers,r[1]),
	  ",rec(delta1:=",r[2],"))\n");
  od;
  return v;
end;

# EnnolaTest(W,a) show Ennola of families of W corresp. to
# family a (attached to an abstract group) in the CS basis.
EnnolaTest:=function(W,a)
  local e,f,p,g,m,W,i,j,Z,A,find,uc,sgn,tbl,l,VecChi,ind,En,ud,fd,special;
# vector of (x,\psi)->\chi(x)\omega_\psi(z)(x,psi) o l'lment central z 
# est donn par son numro de classe et le caractre central chi par son 
# numro de caractre.
# One of these should describe Ennola in the basis of Character sheaves
  VecChi:=function(f,z,chi)local g,basis,z; g:=f.group;
    basis:=List([1..Length(f.chi)],i->rec(x:=f.x[i],chi:=f.chi[i]));
    z:=ConjugacyClasses(g)[z].representative;
    return List(basis,function(b)local cent; cent:=Centralizer(g,b.x);
      return f.chi[chi][PositionClass(g,b.x)]*b.chi[PositionClass(cent,z)]/
	b.chi[PositionClass(cent,())];end);
  end;
  uc:=UnipotentCharacters(W);
  ud:=CycPolUnipotentDegrees(W);
  fd:=uc.operations.FakeDegrees(uc,X(Rationals));
  En:=Ennola(W);
  if Length(En)>1 then Error("ambiguity in Ennola");fi;
  En:=En[1];
  ind:=Filtered([1..Length(uc.families)],i->Length(uc.families[i].charNumbers)=
    Length(a.fourierMat));
  for i in ind do
    f:=uc.families[i];
    sgn:=(-1)^uc.A[f.charNumbers[1]];
    special:=PositionProperty(f.charNumbers,j->ud[j].valuation=fd[j].valuation);
    Print("\nFamily ",i," sgn=",sgn," a.special=",a.special,"\n");
    if special<>f.special then 
      Print("*** special=",special," but f.special=",f.special,"\n");fi;
    e:=En.ps[i];
    m:=f.fourierMat;
    if IsBound(f.delta1) then m:=m^DiagonalMat(f.delta1);fi;
    p:=PermMatMat(a.fourierMat,m,a.eigenvalues,f.eigenvalues);
    Print("perm from M(Gamma) to F:",p,"\n");
    if p=false then
      if IsBound(f.name) then e:=f.name;else e:="??";fi;
      p:=PsMatMat(a.fourierMat,m,a.eigenvalues,f.eigenvalues);
      if p=false then Print("!!!!!!!!!!! no match for family ",e,"\n");
      else Print("!!!!!!! family ",e," could be matched by ",
        PsToLs(p,Length(m)),"\n");
      fi;
    else
    e:=LsToMat(e);
    if IsBound(f.delta1) then e:=e^DiagonalMat(f.delta1);fi;
    e:=OnMatrices(e,p^-1);special:=special^(p^-1);
    if IsCoxeterGroup(W) then g:=MatStab(a.fourierMat,a.eigenvalues);
    else g:=PsMatStab(a.fourierMat,a.eigenvalues);
    fi;
    e:=List(Elements(g),x->rec(mat:=e^LsToMat(PsToLs(x,Length(e))),
      perm:=x,special:=1+((special^x-1)mod Length(e))));
    for p in e do p.mat:=p.mat^(a.fourierMat^-1);od;
    if not ForAny(e,x->IsDiagonalMat(x.mat))then Error("Ennola should be diagonal");fi;
    if not ForAll(e,x->IsDiagonalMat(x.mat))then 
      Z:=Filtered(e,x->not IsDiagonalMat(x.mat));
      e:=Filtered(e,x->IsDiagonalMat(x.mat));
      Z:=List(Z,x->x.perm);
      Print("!!!! bad permutations (giving non diagonal Ennola):\n");
      Print(Z,"\n");
    fi;
    for p in e do p.mat:=DiagonalOfMat(p.mat);od;
    Sort(e);
    g:=a.group;
    Z:=List(Elements(Centre(g)),x->PositionClass(g,x));
    A:=Filtered([1..Length(ConjugacyClasses(g))],
       i->a.chi[i][PositionClass(g,())]=1);
    find:=function(v)local i,j;
      for i in Z do for j in A do
	if v=sgn*VecChi(a,i,j) then return rec(z:=i,chi:=j,sgn:="");
        elif v=-sgn*VecChi(a,i,j) then return rec(z:=i,chi:=j,sgn:="-");
        fi;
      od;od;
      Error("not found");
      return false;
    end;
    l:=[];
    for j in [1..Length(e)] do p:=find(e[j].mat);
    if false then
      if j=1 or l[Length(l)].mat<>p then 
        Add(l,rec(perm:=e[j].perm,mat:=p));
      else Add(l[Length(l)].perm,e[j].perm);
      fi;
    else e[j].mat:=p; Add(l,e[j]);
    fi;
    od;
    Print(Join(uc.charNames{f.charNumbers}," "),"\n");
    tbl:=[["elm","z","chi","sgn","special"]];
    for m in l do
      m.perm:=OrderPerm(m.perm);
      m.mat.z:=Representative(ConjugacyClasses(g)[m.mat.z]);
      m.mat.chi:=a.chi[m.mat.chi];
      Add(tbl,[m.perm,m.mat.z,m.mat.chi,m.mat.sgn,m.special]);
    od;
    Print(StringTable(tbl));
    fi;
  od;
end;

# compares matrices up to sign
showsgn:=function(a,b)local res,i;
  res:=List([1..Length(a)],
         i->String(List([1..Length(a[i])],function(j) 
  if a[i][j]=b[i][j] then
    if a[i][j]=0 then return '0';
    else return '+';
    fi;
  elif a[i][j]=-b[i][j] then return '-';
  else return '*';
  fi;
  end)));
  for i in [1..Length(res)] do Print(res[i],"\n");od;
end;

# permutes a family..
pf:=function(x,p)local f;
  x:=ShallowCopy(x);
  x.fourierMat:=OnMatrices(x.fourierMat,p);
  for f in ["x","chi","charNumbers","eigenvalues","unpdeg","fakdeg"] do
    if IsBound(x.(f)) then x.(f):=Permuted(x.(f),p);fi;
  od;
  if IsBound(x.fourierperm) then x.fourierperm:=x.fourierperm^(p^-1);fi;
  return x;
end;

# returns list of line discrepancies up to sign
cmpsgn:=function(m,m1)
  return List([1..Length(m)],
      function(i)local a,b,res,j;
      a:=m[i];b:=m1[i];res:=0;
      for j in [1..Length(a)] do 
        if a[j]<>b[j] and a[j]<>-b[j] then res:=res+1;fi;od;
      return res;end
      );
end;

# display one of Gunter's records
displayfam:=function(f)local mat;
  mat:=[Concatenation(["No.","UnipDeg","Fake Deg","Eigen"],
       List([1..Length(f.fourierMat)],x->""))];
  Append(mat,TransposedMat(Concatenation([
  List([1..Length(f.fourierMat)],String),
  List(f.unpdeg,x->String(CycPol(x))),
  List(f.fakdeg,x->String(CycPol(x))),
  List(f.eigenvalues,Format)],List(f.fourierMat,x->List(x,Format)))));
  Print(StringTable(mat));
end;

transf:=function(r)local i,res,f,q;
  res:=[];q:=X(Cyclotomics);
  for i in [1..Length(r.frob)] do
    res[i]:=rec(fourierMat:=r.foumat[i],eigenvalues:=r.frob[i],
      unpdeg:=r.unpdeg[i],fakdeg:=r.fakdeg[i]);
  od;
  for i in [1..Length(res)] do
    for f in [Length(res[i].fakdeg)+1..Length(res[i].unpdeg)] do
      res[i].fakdeg[f]:=res[i].fakdeg[1]*0;
    od;
    res[i].fakdeg:=res[i].fakdeg*q^0;
    res[i].unpdeg:=res[i].unpdeg*q^0;
  od;
  return res;
end;

cmpfam:=function(arg) # cmpfam(transf(Gunter's record), W [, family numbers])
  local i,j,gun,gfam,myfam,W,indices,perm,uc,n,p,q,ud,fd,a,b,p1;
  gun:=arg[1];W:=arg[2];
  if Length(arg)>=3 then 
    if IsList(arg[3]) then indices:=arg[3];else indices:=[arg[3]];fi;
  else indices:=[1..Length(gun)];
  fi;
  q:=X(Cyclotomics);q.name:="q";
  uc:=UnipotentCharacters(W);
  ud:=UnipotentDegrees(W,q);
  fd:=FakeDegrees(uc,q);
  for i in indices do
    gfam:=gun[i];
    myfam:=uc.families[i];n:=myfam.charNumbers;
    myfam.unpdeg:=ud{n};myfam.fakdeg:=fd{n};
    if ForAll(["fakdeg","unpdeg","fourierMat","eigenvalues"],
      f->gfam.(f)=myfam.(f)) then Print("family #",i," agrees\n");
    else 
      p:=function(f,i)return [f.fakdeg[i],Set([f.unpdeg[i],-f.unpdeg[i]])];end;
      p:=PermListList(List([1..Length(myfam.eigenvalues)],i->p(myfam,i)),
                      List([1..Length(gfam.eigenvalues)],i->p(gfam,i)));
      if p<>false then
        p1:=function(f,i)return [f.eigenvalues[i],f.fakdeg[i],
	   Set([f.unpdeg[i],-f.unpdeg[i]])];end;
        p1:=PermListList(List([1..Length(myfam.eigenvalues)],i->p1(myfam,i)),
                         List([1..Length(gfam.eigenvalues)],i->p1(gfam,i)));
        if p1<>false then p:=p1;fi;
        Print("family #",i,": p=",p,"\n");
        myfam:=pf(myfam,p^-1);
    #   if gfam.fourierMat<>myfam.fourierMat then
    #     myfam.fourierMat:=per(myfam.fourierMat,cv(myfam.fourierMat,gfam.fourierMat,cmpeq));
    #   fi;
	fi;
      fi;
      if gfam.fourierMat<>myfam.fourierMat then
         if ComplexConjugate(myfam.fourierMat)=gfam.fourierMat then
           Print("## Gunter's fourierMat is conjugate to mine\n");
         elif Set(cmpsgn(gfam.fourierMat,myfam.fourierMat))<>[0] then
         Print("## gunter's family #",i,"\n");displayfam(gfam);
         Print("##       my family #",i,"\n");displayfam(myfam);
         fi;
	 showsgn(gfam.fourierMat,myfam.fourierMat);
      fi;
      if gfam.eigenvalues<>myfam.eigenvalues then
         for j in [1..Length(gfam.eigenvalues)] do
	   if gfam.eigenvalues[j]<>myfam.eigenvalues[j] then
       Print("## gunter's frob#",i,".",j,":",Format(gfam.eigenvalues[j]),"\n");
       Print("##       my frob#",i,".",j,":",Format(myfam.eigenvalues[j]),"\n");
	   fi;
	 od;
      fi;
      if gfam.fakdeg<>myfam.fakdeg then
         for j in [1..Length(gfam.fakdeg)] do
	   if gfam.fakdeg[j]<>myfam.fakdeg[j] then
         Print("## gunter's fakdeg#",i,".",j,":",Format(gfam.fakdeg[j]),"\n");
         Print("##       my fakdeg#",i,".",j,"=",uc.families[i].charNumbers[j],
                         ":",Format(myfam.fakdeg[j]),"\n");
	   fi;
	 od;
      fi;
      if gfam.unpdeg<>myfam.unpdeg then
         for j in [1..Length(gfam.unpdeg)] do
	   if gfam.unpdeg[j]<>myfam.unpdeg[j] then
	     b:=[];
	     for a in [1..Length(myfam.unpdeg)] do
	       if myfam.unpdeg[a]=gfam.unpdeg[j] then Add(b,a);
	       elif myfam.unpdeg[a]=-gfam.unpdeg[j] then Add(b,-a);
	       fi;
	     od;
	     if Length(b)<>0 then
               Print("## gunter's unpdeg#",i,".",j," found at",b,
                 "=",myfam.charNumbers{List(b,AbsInt)},"\n");
	     else
         Print("## gunter's unpdeg#",i,".",j,":",CycPol(gfam.unpdeg[j]),"\n");
         Print("##       my unpdeg#",i,".",j,":",CycPol(myfam.unpdeg[j]),"\n");
	     fi;
	   fi;
	 od;
      fi;   
  od;
end;
