# Programs to get the list of ud (Unipotent Degrees) + Frobenius eigenvalues
# as outlined in ``Split Spetses...''

# Given a list d of ud for W, saturate it by Ennola.
ennolacomplete:=function(W,d)local z,pz,i,p,cd,pp,ocd;
  z:=OrderCenter(W);
  cd:=Collected(d);ocd:=ShallowCopy(cd);
  for i in [1..z-1] do
    Print("#d=",Length(d),"\n");
    for p in d do
       pz:=CycPolOps.EnnolaTwist(p,E(z)^i);
       if PositionsSgn(d,pz)=[] then 
         Add(d,pz);
	 pp:=PositionProperty(cd,x->x[1]=p);
	 Add(cd,[pz,cd[pp][2]]);
       fi;
       Print(Sum(cd,x->x[2]),".\c");
    od;
  od;
  Print("#d=",Length(d),"\n");
  cd:=Difference(cd,ocd);
  return Concatenation(List(cd,x->List([1..x[2]],y->x[1])));
end;

# find positions in ud(W) of elts of list l of rec(deg:=xx,eig:=xx)
finddeinW:=function(W,l)local ud,res,p,m,eigs,uw;
  res:=[];ud:=CycPolUnipotentDegrees(W);
  uw:=UnipotentCharacters(W);eigs:=Eigenvalues(uw,[1..Length(ud)]);
  while Length(l)>0 do
    m:=Filtered([1..Length(l)],i->l[i].deg in [l[1].deg,-l[1].deg]);
    if IsBound(l[1].eig) then m:=Filtered(m,i->l[i].eig=l[1].eig);fi;
    p:=List(PositionsSgn(ud,l[1].deg),AbsInt);
    if IsBound(l[1].eig) then p:=Filtered(p,y->eigs[y]=l[1].eig);fi;
    if Length(p)<>Length(m) then 
      Error("only ",Length(m)," out of ",Length(p)," ",l[1].deg,"reached\n");
    else
      UniteSet(res,p);l:=l{Difference([1..Length(l)],m)};
    fi;
  od;
  return res;
end;

abbr:=function(l)local res,er,br,i;
  if Length(l)=0 then return "[]";fi;
  res:=[]; br:=l[1];er:=br;
  for i in [2..Length(l)] do
    if l[i]<>er+1 then Add(res,[br,er]);br:=l[i];er:=br;
    else er:=er+1;
    fi;
  od;
  Add(res,[br,er]);
  return Join(List(res,function(x)
    if x[1]<>x[2] then return SPrint(x[1],"..",x[2]);
    else return String(x[1]);
    fi;end));
end;

# find which aA's for W are not represented by the ud of indices l
remainaA:=function(W,l)local ud,uw,aA,h,q,fd,remain,r,p;
  uw:=UnipotentCharacters(W);ud:=CycPolUnipotentDegrees(W);
  h:=uw.harishChandra[1].charNumbers;
  aA:=TransposedMat([uw.a,uw.A]){h}; 
  aA:=List(Set(aA),x->rec(a:=x[1],A:=x[2],
     fd:=Filtered([1..Length(h)],i->[uw.a[h[i]],uw.A[h[i]]]=x),
     ud:=Filtered(l,i->[uw.a[i],uw.A[i]]=x)));
  q:=X(Cyclotomics);q.name:="q";
  fd:=FakeDegrees(W,q);
  remain:=[];
  for r in aA do
    p:=Sum(fd{r.fd},x->x^2)-Sum(ud{r.ud},x->Value(x*ComplexConjugate(x),q));
    if p<>0*p then
#    Print("For a=",r.a," and A=",r.A," remains to find norm: ",CycPol(p),"\n");
      Add(remain,[r.a,r.A]);
    fi;
  od;
  return remain;
end;

# returns as a cycpol the i-th schur elem of the hecke algebra  for the
# cyclic group with params given.
tocycp:=function(param,i)local den,c,mod1,vcyc,d;
  mod1:=function(x)x:=x-Int(x);if x<0 then x:=x+1;fi;return x;end;
  vcyc:=function(a,b)
    if a=0 then return E(Denominator(b))^Numerator(b);
    else return List((b+[0..a-1])/a,mod1);fi;end;
  d:=List(param{Difference([1..Length(param)],[i])},x->param[i]-x);
  den:=Lcm(List(d,x->Denominator(x[2])));
  return [den,Product(d,x->CycPol(1-E(Denominator(x[1]))^Numerator(x[1])*
    X(Cyclotomics)^(den*x[2])))];
end;
    
# for each elt of s in turn, substract from l the first occurence of it
subtractlist:=function(l,s)local e;
  for e in s do l:=l{Difference([1..Length(l)],[Position(l,e)])};od;
  return l;
end;

# arrangements of val completed by an arrangement of other with in the
# resulting arrangement val[i] positioned at an element of pos[i]
solveit:=function(positions,val,pos,other)local p,pp,v,v1,res,a,head,tail;
  if Length(val)=0 then return List(Arrangements(other,Length(other)),
      a->TransposedMat([a,positions]));fi;
  p:=pos[1];
  pp:=Filtered([1..Length(val)],i->pos[i]=p);
  v:=val{pp};
  res:=[];
  for a in Arrangements(other,Length(p)-Length(pp)) do
    v1:=Concatenation(v,a);
    head:=List(Arrangements(v1,Length(v1)),x->TransposedMat([x,p]));
    tail:=solveit(Difference(positions,p),
         val{Difference([1..Length(val)],pp)},
         pos{Difference([1..Length(val)],pp)},subtractlist(other,a));
    Append(res,List(Cartesian(head,tail),Concatenation));
  od;
  return res;
end;

# determine series h: should be a regular number such that W_G(Phi_h-Sylow)
# has only one hyperplane orbit
# r is rec with fields W and chars: list of [already known] (deg,eig)
detseries:=function(r,h)local ud,uw,s,W,h,ser,par,tbl,i,poss,rest,a,mod1,p,H,
  res,expected,cnt,c,bad,ho,root,ss,tocyc,pp,pars,omegachi;
  mod1:=function(x)x:=x-Int(x);if x<0 then x:=x+1;fi;return x;end;
  W:=r.group; 
  s:=CuspidalPairs(W,h,DRank(W,h));
  if Length(s)>1 then Error("there should be only one series\n");fi;
  s:=s[1];
  if Size(s.levi)>1 then Error(h," is not regular\n");fi;
  SeriesOps.RelativeGroup(s);
  ho:=HyperplaneOrbits(s.WGL);
  if Length(ho)>1 then Error("WGL should have only one hyperplane orbit");fi;
  ho:=ho[1];
  SeriesOps.WGLdims(s);
  SeriesOps.degRLG(s);
  ud:=CycPolUnipotentDegrees(W);uw:=UnipotentCharacters(W);
  # start with know chars corresponding to linear chars of WGL (parameters)
  ser:=rec(ind:=Filtered(r.chars,i->AbsInt(Value(ud[i],E(h)))=1));
  ser.a:=uw.a{ser.ind}; ser.A:=uw.A{ser.ind};
  if not IsBound(W.coN) then W.coN:=W.N;fi;
  ser.degparam:=(W.N+W.coN-ser.a-ser.A)/(ho.e_s*ho.N_s);
  ser.eigen:=List(Eigenvalues(uw,ser.ind),AsRootOfUnity);
  p:=(W.N+W.coN-Set(List(remainaA(W,r.chars),Sum)))/(ho.e_s*ho.N_s);
  p:=Concatenation(List(p,x->List([1..ho.e_s-Length(ser.eigen)],i->x)));
  p:=Filtered(Combinations(p,ho.e_s-Length(ser.eigen)),x->
    Sum(x)+Sum(ser.degparam)=W.N/ho.N_s);
  Print("Trying ",h,"-series e_s=",ho.e_s,"\n");
  # here each line of p is possible degparam for other parameters
  if IsBound(s.e) then
  # In the cyclic case, for a parameter x=\zeta_e^i(\zeta_h\inv q)^p,
  # the Frobenius eigenvalue Fr is (x_(q=1))^(e/h), so Fr=i/h-pe/h^2 (mod 1)
    ser.specialization:=List(ser.eigen*h+ser.degparam*ho.e_s/h,x->
      List([0..ho.e_s/h-1],y->h*y+x mod h));
    tbl:=TransposedMat([ser.ind,ser.eigen,
      List(ser.ind,i->ser.degparam[Position(ser.ind,i)]),ser.specialization]);
    SortParallel(List(tbl,x->x[4]),tbl);
    tbl:=Concatenation([["ind","eig","degparam","specialize"]],tbl);
    Print("Known part of ",h,"-series\n",StringTable(tbl));
    poss:=Concatenation(List(p,o->solveit([0..s.e-1],ser.degparam,
      ser.specialization,o)));
    poss:=List(poss,function(v)local res;res:=[];
      for x in v do res[x[2]+1]:=x[1];od;return res;end);
    Print(Length(poss)," possibilities of params\n");
    poss:=List(poss,l->List([1..Length(l)],i->[mod1((i-1)/s.e-l[i]/h),l[i]]));
    p:=PositionProperty(ser.specialization,
       x->Length(x)=Number(ser.specialization,y->y=x));
    i:=ser.specialization[p][1]+1;
    expected:=List(ser.ind,i->s.degRLG/ud[i]*Value(ud[i],E(h)));
    cnt:=0;
    poss:=Filtered(poss,function(x)local r;r:=tocycp(x,i);
      cnt:=cnt+1;if cnt mod 100=0 then Print(".\c");fi;
      return r[2]=CycPolOps.DescentOfScalars(expected[p],r[1]);end);
    if Length(poss)>1 then Error("more than one poss");fi;
    H:=Hecke(ComplexReflectionGroup(s.e,1,1),
      [List(poss[1],x->E(Denominator(x[1]))^Numerator(x[1])*Mvp("q")^x[2])]);
    res:=List(SchurElements(H),x->CycPol(ScalMvp(Value(x,["q",X(Cyclotomics)]))));
    if ForAny([1..Length(ser.ind)],
      i->not expected[i] in res{ser.specialization[i]+1}) then Error();fi;
    res:=List([1..s.e],i->rec(deg:=s.degRLG/res[i]*Value(res[i],E(h))/s.e,
      eig:=H.parameter[1][i].coeff[1]^(s.e/h)));
  else
    p:=List(p,x->Concatenation(ser.degparam,x));
    expected:=List(ser.ind,i->s.degRLG/ud[i]*SignInt(Value(ud[i],E(h))));
    res:=[];
    pp:=CharParams(s.WGL){Concatenation([1],ho.det_s)};
    root:=r->E(Denominator(r))^Numerator(r);
    tocyc:=x->CycPol(ScalMvp(Value(x,["q",X(Cyclotomics)])));
    for c in p do
      pars:=List(Arrangements(c,ho.e_s),a->
        List([0..ho.e_s-1],i->root(mod1(i/ho.e_s-a[i+1]/h))*Mvp("q")^a[i+1]));
      Print(Length(pars)," to try:\c");
      for par in pars do
        Print(Product(par)," \c");
        H:=Hecke(s.WGL,[par]);
        ss:=List(pp,x->SchurElement(H,x));
        if ForAll(ss,x->ForAll(x.elm,y->ForAll(y.coeff,IsInt))) then
          ss:=List(ss,tocyc);
          if ForAll(expected,i->i in ss) then Add(res,par);fi;
        fi;
      od;
    od;
    Print("\n");
    expected:=List(Filtered(r.chars,i->Value(ud[i],E(h))<>0),
       i->s.degRLG/ud[i]*SignInt(Value(ud[i],E(h))));
    res:=Filtered(res,function(par)
      H:=Hecke(s.WGL,[par]);
      ss:=List(SchurElements(H),tocyc);
      return ForAll(expected,i->i in ss);
     end);
    H:=Hecke(s.WGL,[res[1]]);ss:=List(SchurElements(H),tocyc);
    ss:=List(ss,x->s.degRLG/x);
    i:=PositionRegularClass(s.WGL,h);
    omegachi:=List(CharTable(H).irreducibles,x->(x[i]/x[1]));
    omegachi:=List(omegachi,x->x.coeff[1]);
    res:=List([1..NrConjugacyClasses(s.WGL)],i->rec(deg:=ss[i],eig:=omegachi[i]));
  fi;
  return Difference(finddeinW(W,res),r.chars);
end;

# Find (unipotent degrees, eigenvalues) for W
getunpdeg:=function(W)local r,d,n,nbu,uc,ud,h,z,k,l,s,process;
  uc:=UnipotentCharacters(W);
  ud:=CycPolUnipotentDegrees(W);
  nbu:=Length(ud);
  z:=OrderCenter(W); 
  s:=SchurElements(Hecke(W,X(Cyclotomics)));
  l:=List(s,x->rec(deg:=CycPol(s[PositionId(W)]/x),eig:=1));
  r:=Set(finddeinW(W,l));h:=Copy(r);
  r:=rec(group:=W,chars:=Set(r));
  process:=function(n)
     Print("Found ",abbr(Difference(n,r.chars)));
     UniteSet(r.chars,n);
     Print(" --- ",nbu-Length(r.chars)," still to find\n");
     return Length(r.chars)=nbu;
  end;
  Print("starting with principal series=",abbr(r.chars),"\n");
  for k in [1..z-1] do
    l:=List(h,i->rec(deg:=CycPolOps.EnnolaTwist(ud[i],E(z)^k),
                     eig:=EigenEnnola(W,i,k)));
    l:=finddeinW(W,l);
    Print("By ",E(z)^k,"-Ennola ");
    if process(l) then return;fi;
  od;
  for h in Filtered(uc.harishChandra,
             h->Sum(h.relativeType,x->x.rank)>=2 and h.levi<>[]) do
    h.relativeType:=List(h.relativeType,
      function(t)t.operations:=ReflTypeOps;return t;end);
    Print("By 1-series R_",
      ReflectionName(ReflectionSubgroup(W,h.levi)),"(",
      h.cuspidalName,")"," with W_G(L,\lambda)=",
      ReflectionName(h.relativeType),"\n");
    if process(h.charNumbers) then return;fi;
  od;
  for d in Reversed(CyclicRegularNumbers(W)) do
   n:=detseries(r,d);
   process(n);
  od;
  if ReflectionName(W)="H4" then
    for d in [3,5,10] do
     n:=detseries(r,d);
     if process(n) then return;fi;
    od;
  fi;
  return r;
end;

# find pairs of families with same a and A
dbfams:=function(W)local uc,aA,db,l,f;
  uc:=UnipotentCharacters(W);
  aA:=List(uc.families,
    f->[uc.a[f.charNumbers[1]],uc.a[f.charNumbers[1]]]);
  db:=List(Filtered(Collected(aA),x->x[2]>1),x->
    Filtered([1..Length(aA)],i->aA[i]=x[1]));
  for l in db do
    Print("families ",l);
    for f in l do
      f:=uc.families[f].charNumbers;
      Print(" a=",uc.a[f[1]]," A=",uc.A[f[1]]," #=",Length(f),"\n");
    od;
  od;
end;
