# positionclass of the "canonical" generator of the center
getz:=W->PositionRegularClass(W,OrderCenter(W));
  
getc:=W->PositionRegularClass(W,Maximum(ReflectionDegrees(W)));

HeckeCharValuesParabolic:=function(H,I,w)local W,R,rgens;
  W:=Group(H);
  R:=ReflectionSubgroup(W,I);
  rgens:=R.rootInclusion{R.generatingReflections};
  Print("w=",w);
  if not ForAll(R.rootRestriction{w},i->i in R.generatingReflections) then 
    return false;fi;
  H:=HeckeCharValues(Hecke(R,H.parameter{W.orbitRepresentative{rgens}}),w);
  if false in H then return false;fi;
  R:=InductionTable(R,W).scalar;
  return R*H;
end;

HeckeCharValuesRootPi:=function(H,d)local W,v,v1;
  W:=Group(H);
  v:=List(HeckeCentralMonomials(H),m->m^(1/d));
  v1:=CharTable(W).irreducibles{[1..Length(v)]}[PositionRegularClass(W,d)];
  return Zip(v,v1,function(x,y)return x*y;end);
end;

HeckeCentralCharacters:=function(H)local W,v,v1,v2,z,spec;
  W:=Group(H);
  z:=Size(Centre(W));
  v:=List(HeckeCentralMonomials(H),m->GetRoot(m,z));
  spec:=Concatenation(Set(Concatenation(List(H.parameter,
   function(p)local e;e:=Length(p);
    return List([1..e],function(i)local v;
      v:=ScalMvp(p[i]);
      if v<>false then
        if v<>E(e)^(i-1) then Error(v," is not ",E(e)^(i-1));fi;
        return [];
      fi;
      if p[i].coeff<>[1] or Length(p[i].elm[1].coeff)<>1 then 
        Error(p[i]," is not a power of a variable");fi;
      return [p[i].elm[1].elm[1],GetRoot(E(e)^(i-1),p[i].elm[1].coeff[1])];
    end);end))));
  v1:=CharTable(W).irreducibles{[1..Length(v)]}[PositionRegularClass(W,z)];
  v2:=CharTable(W).irreducibles{[1..Length(v)]}[PositionClass(W,())];
  return Zip(v,v1,v2,function(x,y,z)return x*y/z/Value(Mvp(x),spec);end);
end;

# cutz(l,z) for classtext l return [n,l'] such that l=l'+z^n
# cutz(l,z,c) for classtext l return [n,m,l'] such that l=l'+c^m+z^n
cutz:=function(arg)local l,z,c,nz,nc;
  l:=arg[1];z:=arg[2];
  nz:=0;
  while Length(l)>=Length(z) and l{[1+Length(l)-Length(z)..Length(l)]}=z do
    nz:=nz+1;
    l:=l{[1..Length(l)-Length(z)]};
  od;
  if  Length(arg)=2 then return [nz,l];fi;
  nc:=0;c:=arg[3];
  while Length(l)>=Length(c) and l{[1+Length(l)-Length(c)..Length(l)]}=c do
    nc:=nc+1;
    l:=l{[1..Length(l)-Length(c)]};
  od;
  return [nz,nc,l];
end;

if false then
formatz:=function(arg)local b;
  b:=ApplyFunc(cutz,arg);
  if Length(b)=2 then
    return SPrint(IntListToString(b[2]),List([1..b[1]],x->'z'));
  else
    return SPrint(IntListToString(b[3]),List([1..b[2]],x->'c'),List([1..b[1]],x->'z'));
  fi;  
end;
else
formatz:=function(arg)local b;
  arg:=List(arg,IntListToString);
  arg[1]:=Replace(arg[1],arg[2],"z");
  if Length(arg)=3 then arg[1]:=Replace(arg[1],arg[3],"c");fi;  
  return String(arg[1]);
end;
fi;

# checks class representatives cunningly chosen w.r.t. parabolics
checkparabolic:=function(W)
  local WI,p,c,ct,zt,z,i,I,j,n,k,cl,a,b,res,f,pz,nums,cc,triples,s;
  pz:=k->String(List([1..k],x->'z'));
  c:=getz(W);
  ct:=ChevieClassInfo(W).classtext;
  zt:=ct[c];
  cc:=ct[getc(W)];
  if cutz(zt,cc)[2]<>[] then Error("z=",zt," is not power of c=",cc,"\n");fi;
  Print("c=",IntListToString(cc)," z=",formatz(zt,[99],cc),"\n");
  cl:=List(ConjugacyClasses(W),Representative);
  z:=cl[c];
  n:=W.nbGeneratingReflections;
  nums:=[];
  f:=function(i)local res;AddSet(nums,i);
    res:=SPrint("class ",String(i,3),":",formatz(ct[i],zt,cc));
    if formatz(ct[i],zt,cc)<>ChevieClassInfo(W).classnames[i] then
      PrintToString(res,"(",ChevieClassInfo(W).classnames[i],")");fi;
    return res;
  end;
  res:=[];triples:=[];
  for i in [1..n] do
    I:=Difference([1..n],[i]);
    WI:=ReflectionSubgroup(W,I);
    if WI.semisimpleRank=W.semisimpleRank then
      Print("not parabolic:",ReflectionName(WI),"\n");
    else
    p:=FusionConjugacyClasses(WI,W);
      Print("parabolic:",ReflectionName(WI)," gives classes ",p,"\n");
    for j in p do
      s:=IntListToString(ChevieClassInfo(WI).classtext[Position(p,j)]);
      if not IsSubset(I,Set(ct[j])) 
   #      and Length(Set(ct[j]))=n 
      then
        Add(res,SPrint(f(j)," could be ",s));
        Add(triples,[j,formatz(ct[j],zt,cc),s]);
      fi;
      for k in [1..OrderPerm(z)-1] do
        a:=PositionClass(W,cl[j]*z^k);
        b:=cutz(ct[a],zt);
        if Length(Set(b[2]))=n then
          Add(res,SPrint(f(a)," could be written as ",s,pz(k)));
          Add(triples,[a,formatz(ct[a],zt,cc),SPrint(s,pz(k))]);
        fi;
      od;
    od;
    fi;
  od;
  for i in [1..Length(ct)] do
    b:=cutz(ct[i],zt);I:=Set(b[2]);
    if Length(I)<n then
      if Length(I)=0 then Add(res,f(i));
      else Add(res,SPrint(f(i)," is in ",pz(b[1]),"W_",IntListToString(I)));
      fi;
    elif b[1]>0 then Add(res,SPrint(f(i)));
    fi;
  od;
  for i in Set(res) do Print(i,"\n");od;
  Print("bad classes:",Difference([1..Length(ct)],nums),"\n");
  return triples;
end;

showregular:=function(W)local tbl,txt,d,cl,q,already,i,zt,cc,lpi;
  tbl:=[["RegEig","class","th. lg","lg","txt","name"]];
  txt:=ChevieClassInfo(W).classtext;
  zt:=txt[getz(W)];
  cc:=txt[getc(W)];Print("c=",IntListToString(cc),"\n");
  cl:=List(ConjugacyClasses(W),Representative);
  lpi:=Sum(ReflectionDegrees(W)+ReflectionCoDegrees(W));
  already:=[];
  for d in Reversed(RegularNumbers(W)) do
    q:=[];
    for i in [0..d-1] do
      q:=PositionRegularClass(W,i/d);
      if not q in already then
        AddSet(already,q);
        Add(tbl,[SPrint(i/d),q,lpi*i/d,Length(txt[q]),formatz(txt[q],zt,cc),
	  ChevieClassInfo(W).classnames[q]]);
      fi;
    od;
  od;
  Print(StringTable(tbl));
end;

# character values of Hecke algebra H on words non-cuspidal * z^i
fromparabolic:=function(H)local W,reps,n,i,t,v,a,zt,c;
  W:=Group(H); reps:=ChevieClassInfo(W).classtext; n:=Length(reps);
  t:=List([1..n],x->[1..n]*0+Unknown());
  zt:=ChevieClassInfo(W).classtext[getz(W)];
  v:=HeckeCentralCharacters(H);
  for i in [1..n] do
    a:=cutz(reps[i],zt);
    Print("class ",i,":z^",a[1],".",IntListToString(a[2]),"\n");
    if Length(Set(a[2]))<W.nbGeneratingReflections then
      c:=HeckeCharValuesParabolic(H,Set(a[2]),a[2]);
      if c<>false then
        Print(ReflectionName(ReflectionSubgroup(W,Set(a[2]))),"\n");
        t{[1..n]}[i]:=Zip(c,v,function(x,y)return x*y^a[1];end);
      fi;
    fi;
  od;
  return t;
end;

fromHI:=function(H,I)local W,reps,n,i,t,v,a,zt,c,nm,R,rgens,tbl,vv,HR;
  W:=Group(H); reps:=ChevieClassInfo(W).classtext; n:=Length(reps);
  t:=List([1..n],x->[1..n]*0+Unknown());
  zt:=ChevieClassInfo(W).classtext[getz(W)];
  v:=HeckeCentralCharacters(H);
  R:=ReflectionSubgroup(W,I);
  rgens:=R.rootInclusion{R.generatingReflections};
  nm:=ReflectionName(R);
  HR:=Hecke(R,H.parameter{W.orbitRepresentative{rgens}});
  tbl:=InductionTable(R,W).scalar;
  for i in [1..n] do
    a:=cutz(reps[i],zt);
    if IsSubset(I,Set(a[2])) and ForAll(a[2],i->i in rgens) then
      vv:=HeckeCharValues(HR,a[2]);
      if not false in vv then
        c:=tbl*vv;
        Print("class ",i,":",nm,"\n");
        t{[1..n]}[i]:=Zip(c,v,function(x,y)return x*y^a[1];end);
      fi;
    fi;
  od;
  return t;
end;

# merge chartable t with partial table vals
merge:=function(t,vals)local i,j;
  for i in [1..Length(t)] do
    if IsBound(vals[i]) then
    for j in [1..Length(t[i])] do
      if IsBound(vals[i][j]) and not IsUnknown(vals[i][j]) then 
        if not IsUnknown(t[i][j]) and t[i][j]<>vals[i][j] then Error(i,",",j);fi;
	t[i][j]:=vals[i][j];
      fi;
    od;
    fi;
  od;
end;

# give a primitive root of pi -- fills char for its powers
fromrootpi:=function(H,w)local W,p,o,v,v1,n,reps,t,x,bad,i,spec;
  W:=Group(H);
  o:=(Sum(ReflectionDegrees(W)+ReflectionCoDegrees(W)))/Length(w);
  if OrderPerm(EltWord(W,w))<>o then Error(w," is not root of pi");fi;
  p:=List([1..o-1],i->PositionClass(W,EltWord(W,w)^i));
  Print("gives classes ",p,"\n");
  p:=Set(List(p,i->Position(p,i)));
  p:=List(p,x->[x,PositionClass(W,EltWord(W,w)^x)]);
  reps:=ChevieClassInfo(W).classtext;
  bad:=Filtered([1..Length(p)],
         i->reps[p[i][2]]<>Concatenation(List([1..p[i][1]],y->w)));
  if bad<>[] then
    for i in bad do
    Print("Warning!! ",p[i][2],"-th representative is ",reps[p[i][2]],
                 " instead of ",w,"^",p[i][1],"\n");
    od;
  fi;
  spec:=Concatenation(Set(Concatenation(List(H.parameter,
   function(p)local e;e:=Length(p);
    return List([1..e],function(i)local v;
      v:=ScalMvp(p[i]);
      if v<>false then
        if v<>E(e)^(i-1) then Error(v," is not ",E(e)^(i-1));fi;
        return [];
      fi;
      if p[i].coeff<>[1] or Length(p[i].elm[1].coeff)<>1 then 
        Error(p[i]," is not a power of a variable");fi;
      return [p[i].elm[1].elm[1],GetRoot(E(e)^(i-1),p[i].elm[1].coeff[1])];
    end);end))));
  n:=Length(reps);
  t:=List([1..n],x->[1..n]*0+Unknown());
  for x in p{Difference([1..Length(p)],bad)} do
    v:=Zip(HeckeCentralMonomials(H),CharTable(W).irreducibles,
       function(m,c)return m^(x[1]/o)*c[x[2]]/Value(Mvp(m^(x[1]/o)),spec);end);
    t{[1..n]}[x[2]]:=v;
  od;
  return t;
end;

fromreps:=function(arg)local H,inds,t,W,r,cl,i,n;
  H:=arg[1];
  W:=Group(H); cl:=ChevieClassInfo(W).classtext; n:=Length(cl);
  if Length(arg)=1 then inds:=[1..n];else inds:=arg[2];fi;
  t:=List([1..n],x->[1..n]*0+Unknown());
  for i in inds do
    r:=Representations(H,i);
    if r<>false then 
      Print(i," \c");
      t[i]:=CharRepresentationWords(r,cl);fi;
  od;
  Print("\n");
  return t;
end;

myeig:=function(table,i,class)local v;
  v:=Eigenvalues(table,table.irreducibles[i],class);
  return Concatenation(List([1..Length(v)],i->List([1..v[i]],j->i/Length(v))));
end;

coxclasses:=W->Set(List(Arrangements(W.generators,Length(W.generators)),
   x->PositionClass(W,Product(x))));

refssmaller:=function(W,w)local refs, r;
  refs:=Reflections(W);
  r:=Set(List(refs,x->Position(refs,x)));
  return Filtered(r,x->ReflectionLength(W,refs[x]^-1*w)<ReflectionLength(W,w));
end;

refl2:=function(W,w)local m; m:=MatXPerm(W,w); return RankMat(m-m^0);end;

test:=function(W)local a,b;
  Stime();
  a:=Set(List(HurwitzOrbitItems(W.generators),x->Position(Reflections(W),x)));
  Print("Hurwitz:",Stime(),"\n");
  b:=refssmaller( W, Product( W.generators ) );
  Print("smaller:",Stime(),"\n");
  return a=b;
end;

#Check eigenvalues of Coxeter elements
CheckCox:=function(W)local h,c,cl,i,ct,refs,n,gens,tbl,ref;
  PrintDiagram(W);
  h:=Maximum(ReflectionDegrees(W));
  c:=PositionRegularClass(W,h);
  n:=Length(W.generators);
  cl:=coxclasses(W);
  if not c in cl then
    Print("******* Warning *****: ",h,"-regular class not product of gens\n");
  fi;
  ct:=CharTable(W);
  refs:=[1..Length(ct.irreducibles)];
  gens:=List(W.generators,i->[PositionClass(W,i),W.rank-1+E(OrderPerm(i))]);
  refs:=Filtered(refs,i->ct.irreducibles[i][1]=W.rank);
  refs:=Filtered(refs,i->ForAll(gens,v->ct.irreducibles[i][v[1]]=v[2]));
  ref:=ChevieCharInfo(W).positionRefl;
  Print("Chevie's reflection representation is number:",ref,"\n");
  Print("Reflection reps where generators are distinguished:",refs,"\n");
  Print("classes for products of generators:\n");
  for i in cl do 
    Print("class ",i,"\n");
    tbl:=[Concatenation(["rep","eigenvalues"],List([1..W.rank-1],x->""))];
    Append(tbl,List(refs,j->Concatenation([j],myeig(ct,j,i))));
    Print(StringTable(tbl),"\n");
  od;
  Print("\nh=",h,"-regular class =",c,"=",ChevieClassInfo(W).classtext[c],"\n");
end;

ParabolicClosure:=function(W,I)local v,gens;
  v:=Base(Intersection(List(W.matgens{I},x->VectorSpace(NullspaceMat(x-x^0),Cyclotomics))));
  gens:=Filtered([1..Length(W.roots)],i->v*MatXPerm(W,Reflection(W,i))=v);
  return ReflectionSubgroup(W,gens);
end;

# find for each char. x of 1-param Hecke H an e such that x is in C[q^{1/e}]
gete:=function(H)local x,ct,fp;
  fp:=function(p)local mod1;
    if IsCyc(p) then return [1];fi;
    mod1:=x->x-Int(x);
    p:=Filtered(p.elm,x->Length(x.elm)=1);
    p:=List(p,x->mod1(x.coeff[1]));
    return Set(List(Union(Set(p),[0]),Denominator));
  end;
  ct:=CharTable(H);
  if ct<>false then 
    ct:=ct.irreducibles; return List(ct,x->Lcm(Union(List(x,fp))));
  else
    return List(HeckeCharValuesRootPi(H,OrderCenter(Group(H))),x->Lcm(fp(x)));
  fi;
end;

# check "z/e": for each family if characters of Spetsial algebra in family
# split over q^{1/e} then a+A is divisible by |ZW|/e
checkze:=function(W)local uc,e,z,f,aA,fe;
  uc:=UnipotentCharacters(W);
  e:=ChevieCharInfo(W).spetsRationality;
  z:=OrderCenter(W);
  Print("   z=",z,"\n");
  for f in uc.families do
    aA:=uc.a[f.charNumbers[1]]+uc.A[f.charNumbers[1]];
    fe:=List(f.charNumbers,i->Position(uc.harishChandra[1].charNumbers,i));
    fe:=Filtered(fe,x->x<>false);
    fe:=Lcm(e{fe});
    Print([aA,fe,z/Gcd(aA,z),aA/(z/fe)],"\n");
  od;
end;
