#############################################################################
##
#A  init.g       VKCURVE package         David Bessis and Jean Michel
##
#Y  Copyright (C) 2001 - 2002  University Paris VII, France.
##
##  This is the init file of the VKCURVE package.
## 
#############################################################################

if not IsBound(VKCURVEPATH) then 
  VKCURVEPATH:=LOADED_PACKAGES.vkcurve;
fi;

ReadVK:= function(name)
  if not ReadPath(VKCURVEPATH, name, ".g", "ReadVK") then
     Error("VKCURVE library file '", name, "' must exist and be readable");
  fi;
end;

RequirePackage("chevie");
ReadVK("patch");

AUTO(ReadVK("action"),VKQuotient,DBVKQuotient,BnActsOnFn);
AUTO(ReadVK("loops"),LoopsAroundPunctures);
AUTO(ReadVK("plbraid"),LBraidToWord);
AUTO(ReadVK("polyroot"),NewtonRoot,SeparateRoots,SeparateRootsInitialGuess,
  FindRoots);
AUTO(ReadVK("pres"),ShrinkPresentation,DisplayPresentation,
 TryConjugatePresentation,ConjugatePresentation);
AUTO(ReadVK("global"),Segments,PrepareFundamentalGroup,FinishFundamentalGroup,
  FundamentalGroup);
AUTO(ReadVK("util"),BigNorm,SmallNorm,Rho,Horner,DecimalToRat,
  ComplexToComplexRat,DecimalLog,MinPos,Dispersal,DistSeg,Deriv,
  ResultantMat,Discy,ComplexRatToGaussian,Cut);
AUTO(ReadVK("truemono"),FollowMonodromy);
AUTO(ReadVK("segtobrd"),ApproxFollowMonodromy);
AUTO(ReadVK("mvp"),MvpOps,Mvp,IsMvp,ScalMvp,quadratMvp,Jacobian,Hessian);
AUTO(ReadVK("mvrf"),RatFrac,IsRatFrac,MvpGcd,MvpLcm,LaurentDenominator);

PresentationFpGroup(FreeGroup(2));; # fudge to read PresentationOps
PresentationOps.Display:=DisplayPresentation; # so as to be able to do this

VKCURVE:=rec( 
  version:="1.2 (16-10-2003)",
  monodromyApprox:=false,
  showSingularProj:=false, 
  showBraiding:=false,
  showLoops:=false,
  showAction:=false,
  showSegments:=false,
  showInsideSegments:=false,
  showWorst:=false,
  showZeros:=false,
  showNewton:=false,
  showgetbraid:=false,
  showRoots:=false,
  showallnewton:=false,# for NewtonRoot
  NewtonLim:=800,      # for NewtonRoot
  AdaptivityFactor:=10, # for ApproxFollowMonodromy
  shrinkBraid:=false
);

if BANNER then
Print("\n  Welcome  to  the  VKCURVE  package,  Version ",VKCURVE.version,"\n",
"    http://www.math.jussieu.fr/~jmichel/vkcurve.html\n\n",
"  David Bessis,  Jean Michel\n",
"  CNRS -- Universities Lyon I, Paris VII and Picardie\n");
fi;

x:=Mvp("x");y:=Mvp("y");
