#############################################################################
##
#A  tbl/cmplxg34.g       CHEVIE library          Gunter Malle and Jean Michel
##
#Y  Copyright (C) 1998 - 2001  The CHEVIE Team
##
##  This file contains data about the complex reflection group
##  of type G34 in the Shephard-Todd classification.
##
CHEVIE.Revision("tbl/cmplxg34.g",
   "$Id: cmplxg34.g,v 1.3 2003/12/04 11:26:45 chevie Exp $");

CHEVIE.AddData("PrintDiagram","G34",function(indices,title)local s;
  Print(title," ");s:=String("",Length(title)-5);
  Print(s,"  ",indices[3],"\n       /^\\\n",
	s,indices[1],"---",indices[2],"---",indices[4],
	"---",indices[5],"---",indices[6]," ",
	IntListToString(indices{[4,2,3,4,2,3]}),"=",
	IntListToString(indices{[3,4,2,3,4,2]}),"\n");
end);

CHEVIE.AddData("BraidRelations","G34",
  [[[1,2,1],[2,1,2]],[[3,2,3],[2,3,2]],[[4,2,4],[2,4,2]],[[4,3,4],[3,4,3]],
   [[4,5,4],[5,4,5]],[[1,3],[3,1]],[[1,4],[4,1]],[[1,5],[5,1]],[[2,5],[5,2]],
   [[3,5],[5,3]],[[5,6,5],[6,5,6]],[[1,6],[6,1]],[[2,6],[6,2]],[[3,6],[6,3]],
   [[4,6],[6,4]],[[4,2,3,4,2,3],[3,4,2,3,4,2]]]);

# with the following choice of simple roots (of norm 6)
# the set of all 756 roots are the short vectors of the Coxeter-Todd lattice
# See Conway & Sloane Math.Proc.Camb.Phil.Soc. 93(1983) 421--440
CHEVIE.AddData("GeneratingRoots","G34",
  [[ER(-3),-ER(-3),0,0,0,0],[0,ER(-3),0,0,0,-ER(-3)],[0,0,0,0,-ER(-3),ER(-3)],
  [0,0,0,0,(3+ER(-3))/2,(3-ER(-3))/2],[-1,-1,-E(3),-E(3)^2,-1,-1],
  [0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,0,0]]);

CHEVIE.AddData("EigenvaluesGeneratingReflections","G34",
  [1/2,1/2,1/2,1/2,1/2,1/2]);

CHEVIE.AddData("Size","G34", 39191040);

CHEVIE.AddData("ReflectionCoDegrees","G34",[0,12,18,24,30,36]);

CHEVIE.AddData("ReflectionDegrees","G34",[6,12,18,24,30,42]);

CHEVIE.AddData("NrConjugacyClasses","G34", 169);

CHEVIE.AddData("ParabolicInfo","G34",# parabolic types
 [[rec(series:="ST",indices:=[1..5],rank:=5,ST:=33)],
  [rec(series:="ST",indices:=[3,4,2,1],rank:=4,p:=3,q:=3),
   rec(series:="A",indices:=[6],rank:=1)],
  [rec(series:="A",indices:=[1,2,3],rank:=3),
   rec(series:="A",indices:=[5,6],rank:=2)],
  [rec(series:="A",indices:=[1,2,4,5,6],rank:=5)],
  [rec(series:="A",indices:=[1],rank:=1),
   rec(series:="A",indices:=[3,4,5,6],rank:=4)],
  [rec(series:="ST",indices:=[2,3,4,5,6],rank:=5,p:=3,q:=3)]]);

CHEVIE.AddData("WordsClassRepresentatives","G34",
[[], [1], [2,1], [3,1], [5,2,1], [3,2,1], [3,4,2],[5,3,1],[4,3,2],[6,4,3,2],#10
  [6,5,2,1], [5,4,2,1], [3,4,2,1], [4,3,2,1], [5,3,2,1], [6,3,4,2], [6,4,3,1],
  [6,5,4,3,1], [6,4,3,2,1], [6,5,3,4,2],#20
  [5,4,3,2,1], [6,5,4,3,2], [5,3,4,2,1], [6,5,3,2,1], [6,5,4,2,1], [6,3,4,2,1],
  [3,4,2,3,4,2], [6,5,3,4,2,1], [5,3,2,4,2,1], [4,2,3,1,2,1],#30
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1], [4,3,2,4,3,2],
  [6,5,3,2,4,2,1], [5,4,2,3,1,2,1], [6,3,4,2,3,4,2], [6,3,4,5,2,4,2],
  [6,4,3,2,4,3,2], [6,4,5,2,4,3,2], [6,4,2,3,1,2,1], [3,4,2,3,4,2,1],#40
  [6,5,4,2,3,2,1], [4,3,2,4,3,2,1], [5,4,2,3,4,2,1], [4,5,2,4,3,2,1],
  [6,5,4,3,2,4,3,2], [6,5,3,4,2,3,4,2],
  [1,2,4,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,4,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],
  [6,3,4,2,3,4,2,1], [6,3,4,5,2,4,2,1],#50
  [5,3,4,2,3,4,2,1], [6,4,3,2,4,3,2,1], [5,4,3,2,4,3,2,1], [6,5,4,2,3,1,2,1],
  [6,4,5,3,4,3,2,1],
  [1,3,4,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1],
  [4,5,3,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [4,5,3,4,2,3,1,2,1], [5,6,4,5,4,3,2,4,3,2], [6,5,3,4,2,1,6,5,3,4,2,1],#60
  [4,5,2,3,4,2,3,1,2,1], [3,2,4,5,3,2,4,1,2,1],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,6,4,5,3,4,2,3,4,2], [4,5,2,4,1,2,3,1,2,1],
  [5,2,4,3,1,2,4,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,3,2,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,3,4,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,6,4,5,4,3,2,4,3,2,1],
  [4,5,3,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],#70
  [1,2,3,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,6,4,5,3,4,2,3,4,2,1],
  [5,4,3,2,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],
  [4,2,3,1,2,4,1,2,3,1,2,1],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,4,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,3,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,2,1,3,5,4,2,1,3,5,4,2,1,3],
  [1,2,4,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],#80
  [3,4,5,2,3,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,3,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,2,1,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1],
  [1,3,2,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,4,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,5,2,4,3,1,2,4,5,3,2,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1],
  [1,2,3,4,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],
  [3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1],#90
  [5,3,4,2,3,1,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1],
  [5,3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1],
  [6,5,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],
  [2,3,4,5,2,4,1,2,3,4,5,2,4,1],
  [6,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],
  [6,4,3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],
  [6,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1],
  [3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1],
  [4,3,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1],#100
  [3,4,2,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],
  [6,3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],
  [6,4,3,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],
  [3,2,4,5,1,2,4,3,2,4,5,2,4],
  [6,3,4,2,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,6,4,5,3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1],
  [4,2,3,1,2,4,1,2,3,1,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [2,3,4,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1],#110
  [1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1],
  [5,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1],
  [5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,5,2,3,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,4,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,5,2,3,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,3,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1],#120
  [3,4,5,2,4,3,1,2,4,5,3,2,4,1,2],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1],
  [5,3,4,2,3,1,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],
  [3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,4,3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,3,2,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],#130
  [6,3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,2,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1],
  [1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1],
  [1,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,4,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,4,5,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,5,2,4,3,1,2,4,5,3,2,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],#140
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,
  4,2,1,3,5,4,2,1,3],
  [5,3,4,2,3,1,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,2,4,5,1,2,4,3,2,4,5,1,2,4],
  [5,4,3,2,4,1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,1,2,4,3,1,2,4,5,4,3,1,2,4,3],
  [3,4,2,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,3,4,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],#150
  [5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,2,1,3,5,4,
  2,1,3,5,4,2,1,3],
  [1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,3,2,4,2,3,1,2,4,5,4,2,3,1,2,4,1],
  [1,2,4,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,3,4,2,3,1,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,3,5,6,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1],
  [1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],#160
  [5,3,2,4,2,3,1,2,4,5,4,2,3,1,2,4,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,3,4,2,3,1,2,4,3,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [3,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [5,3,2,4,2,3,1,2,4,5,4,2,3,1,2,4,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,
  4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1],
  [1,2,3,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,
  2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,
  1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,
  6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,
  5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,
  3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1,6,5,3,4,2,1]]
);

CHEVIE.AddData("ClassNames","G34",
 List(CHEVIE.RawData("WordsClassRepresentatives","G34"),
 function(w)
   local digits;digits:="123456";
   if Length(w)=0 then
     return ".";
   else return String(Replace(digits{w},
     "653421653421653421653421653421653421653421","z","653421","c"));
   fi;
end));

CHEVIE.AddData("ClassName","G34",x->x);

CHEVIE.AddData("PowerMaps","G34",
  [,[1,1,3,1,3,4,27,1,32,32,11,12,14,13,4,27,3,12,
      13,64,14,59,13,17,11, 14, 32, 60, 3, 74, 63, 27, 65, 12, 32, 45, 27, 46,
      74, 74, 11, 74, 95, 145, 46, 45, 139, 86, 74, 164, 95, 74, 145, 78, 91,
      86, 139, 74, 160, 63, 74, 74, 60, 135, 142, 96, 96, 139, 156, 86, 17,
      123, 96, 74, 119, 133, 64, 78, 27, 46, 96, 157, 133, 138, 143, 139, 90,
      122, 138, 122, 165, 124, 122, 11, 27, 130, 135, 46, 27, 130, 74, 27,
      130, 74, 74, 14, 160, 122, 74, 130, 135, 138, 135, 130, 95, 45, 12,
      145, 119, 124, 142, 155, 90, 155, 157, 155, 130, 133, 95, 130, 130, 74,
      138, 155, 160, 160, 32, 133, 86, 165, 1, 1, 142, 4, 32, 145, 32, 32,
      74, 45, 1, 3, 3, 13, 122, 165, 122, 59, 122, 135, 135, 124, 155, 90,
      155, 155, 160, 160, 157 ],
  [ 1, 2, 1, 4, 2, 6, 2, 8, 2, 4, 1, 12, 27, 32, 15, 4, 4, 18, 37, 6, 148, 6,
      79, 6, 8, 35, 1, 75, 142, 4, 75, 1, 33, 34, 2, 35, 2, 37, 8, 2, 8, 2,
      121, 121, 32, 27, 117, 117, 4, 85, 65, 4, 65, 100, 85, 34, 34, 151, 4,
      119, 142, 142, 119, 4, 65, 143, 121, 18, 33, 18, 144, 33, 121, 1, 75,
      99, 144, 130, 151, 99, 65, 15, 79, 35, 85, 12, 121, 141, 147, 142, 143,
      144, 8, 141, 142, 142, 142, 79, 141, 141, 151, 151, 151, 8, 142, 147,
      142, 151, 141, 151, 141, 148, 151, 2, 143, 148, 117, 143, 119, 15, 121,
      1, 65, 4, 6, 8, 4, 37, 121, 1, 2, 2, 27, 2, 1, 2, 151, 32, 12, 121,
      141, 142, 143, 144, 142, 121, 141, 151, 151, 147, 151, 141, 151, 99, 1,
      65, 4, 144, 2, 1, 2, 6, 141, 143, 142, 151, 141, 151, 144 ],,
  [ 1, 2, 3, 4, 5, 6, 9, 8, 7, 16, 11, 1, 14, 13, 15, 10, 17, 2, 26, 22, 23,
      20, 21, 24, 25, 19, 32, 31, 29, 30, 28, 27, 33, 151, 37, 38, 35, 36,
      39, 42, 41, 40, 44, 43, 46, 45, 88, 163, 52, 55, 53, 49, 51, 54, 50,
      166, 108, 58, 64, 63, 62, 61, 60, 59, 65, 66, 73, 159, 72, 134, 71, 69,
      67, 74, 75, 89, 158, 78, 148, 150, 81, 120, 112, 128, 85, 155, 140,
      163, 76, 165, 164, 169, 126, 94, 145, 96, 107, 116, 147, 100, 149, 137,
      110, 104, 105, 154, 97, 166, 109, 103, 167, 83, 168, 131, 118, 98, 141,
      115, 119, 82, 121, 155, 156, 157, 162, 93, 127, 84, 146, 130, 114, 132,
      138, 159, 160, 161, 102, 133, 122, 87, 141, 142, 143, 144, 95, 129, 99,
      79, 101, 80, 151, 152, 153, 106, 122, 123, 124, 77, 134, 135, 136, 125,
      88, 91, 90, 108, 111, 113, 92 ],,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21, 22, 23, 24, 25, 26, 27, 88, 29, 30, 163, 32, 33, 34, 35, 36, 37,
      38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
      56, 57, 58, 59, 122, 61, 62, 155, 64, 65, 66, 67, 68, 69, 70, 71, 72,
      73, 74, 141, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89,
      90, 91, 92, 93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105,
      106, 107, 108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 1,
      120, 121, 122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133,
      134, 135, 136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147,
      148, 149, 150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161,
      162, 163, 164, 165, 166, 167, 168, 169 ],,,,
  [ 1, 2, 3, 4, 5, 6, 9, 8, 7, 16, 11, 12, 14, 13, 15, 10, 17, 18, 26, 22,
      23, 20, 21, 24, 25, 19, 32, 31, 29, 30, 28, 27, 33, 34, 37, 38, 35, 36,
      39, 42, 41, 40, 44, 43, 46, 45, 48, 47, 52, 55, 53, 49, 51, 54, 50, 57,
      56, 58, 64, 63, 62, 61, 60, 59, 65, 66, 73, 70, 72, 68, 71, 69, 67, 74,
      75, 89, 158, 78, 148, 150, 81, 120, 112, 128, 85, 139, 140, 163, 76,
      165, 164, 169, 126, 94, 145, 96, 107, 116, 147, 100, 149, 137, 110,
      104, 105, 154, 97, 166, 109, 103, 167, 83, 168, 131, 118, 98, 117, 115,
      119, 82, 121, 155, 156, 157, 162, 93, 127, 84, 146, 130, 114, 132, 138,
      159, 160, 161, 102, 133, 86, 87, 141, 142, 143, 144, 95, 129, 99, 79,
      101, 80, 151, 152, 153, 106, 122, 123, 124, 77, 134, 135, 136, 125, 88,
      91, 90, 108, 111, 113, 92 ],,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
      39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56,
      57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74,
      75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92,
      93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107,
      108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
      122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135,
      136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
      150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163,
      164, 165, 166, 167, 168, 169 ],,,,
  [ 1, 2, 3, 4, 5, 6, 9, 8, 7, 16, 11, 12, 14, 13, 15, 10, 17, 18, 26, 22,
      23, 20, 21, 24, 25, 19, 32, 31, 29, 30, 28, 27, 33, 34, 37, 38, 35, 36,
      39, 42, 41, 40, 44, 43, 46, 45, 48, 47, 52, 55, 53, 49, 51, 54, 50, 57,
      56, 58, 64, 63, 62, 61, 60, 59, 65, 66, 73, 70, 72, 68, 71, 69, 67, 74,
      75, 89, 158, 78, 148, 150, 81, 120, 112, 128, 85, 139, 140, 163, 76,
      165, 164, 169, 126, 94, 145, 96, 107, 116, 147, 100, 149, 137, 110,
      104, 105, 154, 97, 166, 109, 103, 167, 83, 168, 131, 118, 98, 117, 115,
      119, 82, 121, 155, 156, 157, 162, 93, 127, 84, 146, 130, 114, 132, 138,
      159, 160, 161, 102, 133, 86, 87, 141, 142, 143, 144, 95, 129, 99, 79,
      101, 80, 151, 152, 153, 106, 122, 123, 124, 77, 134, 135, 136, 125, 88,
      91, 90, 108, 111, 113, 92 ],,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
      39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56,
      57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74,
      75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92,
      93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107,
      108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
      122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135,
      136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
      150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163,
      164, 165, 166, 167, 168, 169 ],,,,
  [ 1, 2, 3, 4, 5, 6, 9, 8, 7, 16, 11, 12, 14, 13, 15, 10, 17, 18, 26, 22,
      23, 20, 21, 24, 25, 19, 32, 31, 29, 30, 28, 27, 33, 34, 37, 38, 35, 36,
      39, 42, 41, 40, 44, 43, 46, 45, 48, 47, 52, 55, 53, 49, 51, 54, 50, 57,
      56, 58, 64, 63, 62, 61, 60, 59, 65, 66, 73, 70, 72, 68, 71, 69, 67, 74,
      75, 89, 158, 78, 148, 150, 81, 120, 112, 128, 85, 139, 140, 163, 76,
      165, 164, 169, 126, 94, 145, 96, 107, 116, 147, 100, 149, 137, 110,
      104, 105, 154, 97, 166, 109, 103, 167, 83, 168, 131, 118, 98, 117, 115,
      119, 82, 121, 155, 156, 157, 162, 93, 127, 84, 146, 130, 114, 132, 138,
      159, 160, 161, 102, 133, 86, 87, 141, 142, 143, 144, 95, 129, 99, 79,
      101, 80, 151, 152, 153, 106, 122, 123, 124, 77, 134, 135, 136, 125, 88,
      91, 90, 108, 111, 113, 92 ],,,,,,
  [ 1, 2, 3, 4, 5, 6, 9, 8, 7, 16, 11, 12, 14, 13, 15, 10, 17, 18, 26, 22,
      23, 20, 21, 24, 25, 19, 32, 31, 29, 30, 28, 27, 33, 34, 37, 38, 35, 36,
      39, 42, 41, 40, 44, 43, 46, 45, 48, 47, 52, 55, 53, 49, 51, 54, 50, 57,
      56, 58, 64, 63, 62, 61, 60, 59, 65, 66, 73, 70, 72, 68, 71, 69, 67, 74,
      75, 89, 158, 78, 148, 150, 81, 120, 112, 128, 85, 139, 140, 163, 76,
      165, 164, 169, 126, 94, 145, 96, 107, 116, 147, 100, 149, 137, 110,
      104, 105, 154, 97, 166, 109, 103, 167, 83, 168, 131, 118, 98, 117, 115,
      119, 82, 121, 155, 156, 157, 162, 93, 127, 84, 146, 130, 114, 132, 138,
      159, 160, 161, 102, 133, 86, 87, 141, 142, 143, 144, 95, 129, 99, 79,
      101, 80, 151, 152, 153, 106, 122, 123, 124, 77, 134, 135, 136, 125, 88,
      91, 90, 108, 111, 113, 92 ],,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
      39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56,
      57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74,
      75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92,
      93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107,
      108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
      122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135,
      136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
      150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163,
      164, 165, 166, 167, 168, 169 ],,,,,,
  [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20,
      21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
      39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56,
      57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74,
      75, 76, 77, 78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92,
      93, 94, 95, 96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107,
      108, 109, 110, 111, 112, 113, 114, 115, 116, 117, 118, 119, 120, 121,
      122, 123, 124, 125, 126, 127, 128, 129, 130, 131, 132, 133, 134, 135,
      136, 137, 138, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
      150, 151, 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163,
      164, 165, 166, 167, 168, 169 ],,,,
  [ 1, 2, 3, 4, 5, 6, 9, 8, 7, 16, 11, 12, 14, 13, 15, 10, 17, 18, 26, 22,
      23, 20, 21, 24, 25, 19, 32, 31, 29, 30, 28, 27, 33, 34, 37, 38, 35, 36,
      39, 42, 41, 40, 44, 43, 46, 45, 48, 47, 52, 55, 53, 49, 51, 54, 50, 57,
      56, 58, 64, 63, 62, 61, 60, 59, 65, 66, 73, 70, 72, 68, 71, 69, 67, 74,
      75, 89, 158, 78, 148, 150, 81, 120, 112, 128, 85, 139, 140, 163, 76,
      165, 164, 169, 126, 94, 145, 96, 107, 116, 147, 100, 149, 137, 110,
      104, 105, 154, 97, 166, 109, 103, 167, 83, 168, 131, 118, 98, 117, 115,
      119, 82, 121, 155, 156, 157, 162, 93, 127, 84, 146, 130, 114, 132, 138,
      159, 160, 161, 102, 133, 86, 87, 141, 142, 143, 144, 95, 129, 99, 79,
      101, 80, 151, 152, 153, 106, 122, 123, 124, 77, 134, 135, 136, 125, 88,
      91, 90, 108, 111, 113, 92 ] ]);

CHEVIE.AddData("ClassInfo","G34",
  rec(classtext:=CHEVIE.RawData("WordsClassRepresentatives","G34"),
    classnames:=CHEVIE.RawData("ClassNames","G34"),
    classparams:=CHEVIE.RawData("ClassNames","G34"),
    orders:=[1,2,3,2,6,4,6,2,6,6,3,5,9,9,4,6,6,10,18,12,18,
  12, 18, 12, 6, 18, 3, 42, 6, 6, 42, 3, 8, 10, 6, 18, 6, 18, 6, 6, 6, 6, 12,
  12, 9, 9, 30, 30, 6, 24, 12, 6, 12, 18, 24, 30, 30, 6, 6, 21, 6, 6, 21, 6,
  4, 12, 12, 30, 24, 30, 12, 24, 12, 3, 14, 18, 12, 9, 6, 18, 12, 12, 18, 18,
  8, 15, 12, 6, 18, 6, 12, 12, 6, 6, 6, 6, 6, 18, 6, 6, 6, 6, 6, 6, 6, 18, 6,
  6, 6, 6, 6, 18, 6, 6, 12, 18, 10, 12, 7, 12, 4, 3, 12, 6, 12, 6, 6, 18, 12,
  3, 6, 6, 9, 6, 3, 6, 6, 9, 15, 12, 2, 2, 4, 4, 6, 12, 6, 6, 6, 18, 2, 6, 6,
  18, 3, 12, 6, 12, 6, 3, 6, 12, 6, 12, 6, 6, 6, 6, 12 ],
    classes:=
  [ 1, 126, 3360, 2835, 60480, 68040, 5040, 11340, 5040, 45360, 120960, 653184,
  120960, 120960, 408240, 45360, 90720, 653184, 362880, 544320, 362880,
  544320, 362880, 544320, 1088640, 362880, 560, 933120, 90720, 90720, 933120,
  560, 816480, 653184, 5040, 362880, 5040, 362880, 272160, 30240, 1088640,
  30240, 272160, 272160, 120960, 120960, 653184, 653184, 90720, 816480,
  272160, 90720, 272160, 725760, 816480, 653184, 653184, 30240, 90720,
  933120, 90720, 90720, 933120, 90720, 34020, 272160, 272160, 653184, 816480,
  653184, 544320, 816480, 272160, 10080, 933120, 120960, 544320, 725760,
  5040, 120960, 272160, 408240, 362880, 362880, 816480, 653184, 68040, 1,
  120960, 2835, 34020, 68040, 11340, 120960, 45360, 45360, 90720, 362880,
  560, 560, 30240, 5040, 5040, 272160, 90720, 120960, 90720, 126, 10080,
  5040, 3360, 362880, 60480, 5040, 272160, 362880, 653184, 272160, 933120,
  408240, 68040, 1, 34020, 2835, 68040, 11340, 45360, 362880, 272160, 560,
  5040, 30240, 120960, 126, 3360, 60480, 5040, 120960, 653184, 68040, 1,
  2835, 34020, 68040, 45360, 272160, 560, 5040, 30240, 120960, 126, 3360,
  60480, 120960, 1, 34020, 2835, 544320, 126, 3360, 60480, 68040, 1, 34020,
  2835, 126, 3360, 60480, 68040 ]));

CHEVIE.AddData("CharInfo","G34",function()local res;
  res:=rec(charparams:=
[[1,0],[1,126],[6,5],[6,89],[6,1],[6,85],[15,58],[15,16],
 [15,56],[15,14],[20,33,"'"],[20,33,"''"],[21,60],[21,6],[21,4],[21,70],[21,2],
 [21,68],[35,60],[35,6],[35,36],[35,18],[56,57],[56,3],[56,45],[56,9],
 [70,45,"'"],[70,9,"'"],[70,45,"'''"],[70,45,"''"],[70,9,"''"],[70,9,"'''"],
 [84,17],[84,37],[84,13],[84,41],[90,6],[90,48],[105,10],[105,46],[105,40],
 [105,4],[105,50],[105,38],[105,8,"''"],[105,8,"'"],[105,22],[105,28],[105,20],
 [105,26],[120,21,"'"],[120,21,"''"],[120,5],[120,47],[120,7],[120,49],[126,5],
 [126,41],[126,7],[126,43],[140,21],[140,30],[140,12],[189,24],[189,18],
 [210,30],[210,12],[210,10],[210,40],[210,38],[210,8],[210,17],[210,29],
 [210,13],[210,25],[280,30,"''"],[280,30,"'"],[280,12,"''"],[280,12,"'"],
 [315,36],[315,6],[315,24],[315,18],[315,10],[315,28],[315,14],[315,32],
 [336,34],[336,10],[336,32],[336,8],[336,17],[336,25],[336,19],[336,23],
 [384,11],[384,29],[384,13],[384,31],[384,34],[384,10],[384,32],[384,8],
 [420,30],[420,12],[420,21],[420,11],[420,31],[420,7],[420,35],[420,16],
 [420,22],[420,14],[420,20],[504,33],[504,9],[504,21],[504,15],[540,17],
 [540,19],[540,21,"'"],[540,21,"''"],[560,27],[560,9],[560,18,"'"],
 [560,18,"'''"],[560,18,"''"],[630,27],[630,15],[630,16],[630,22],[630,14],
 [630,20],[630,11],[630,25],[630,13],[630,23],[720,16],[720,20],[729,24],
 [729,12],[729,28],[729,10],[729,26],[729,14],[756,16],[756,22],[756,14],
 [756,20],[840,17],[840,19],[840,13,"''"],[840,23,"'"],[840,11],[840,25],
 [840,13,"'"],[840,23,"''"],[896,24],[896,12],[896,21],[896,15],[945,16],
 [945,22],[945,14],[945,20],[1260,17],[1260,19],[1280,18],[1280,15]],
# here the labelling is as follows:
# phi{105,8}' is the conjugate of phi{105,4}, phi{840,13}'  of phi{840,11}
# and phi{840,23}' of phi{840,19}.
# phi{70,9}', phi{70,45}' and phi{560,18}' are real.
# phi{20,33}' and phi{70,9}'' occur in phi{6,1} tensor phi{15,14}
# [this differs from Malle 'on the generic degrees...']
# phi{70,9}'' tensor sign is phi{70,45}''
# phi{120,21}' occurs in the permutation character induced from A_5
# phi{280,12}',phi{280,30}'',phi{560,18}''' are in phi_{6,1}tensor phi_{336,17}
# phi_{540,21}' occurs in phi{6,1} tensor phi{105,20}
  positionId:=1,
  positionSgn:=2,
  positionRefl:=5);
  res.b:=List(res.charparams,x->x[2]);
  res.spetsRationality:=[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,
    2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
    1,3,3,3,3,3,3,1,1,1,1,1,1,1,1,1,1,1,1,2,2,2,2,1,1,1,1,1,1,1,1];
  return res;
end);

CHEVIE.AddData("CycPolSchurElements","G34",
[ [1,0,2,2,2,2,2,2,3,3,3,3,3,3,4,4,5,6,6,6,6,6,6,7,8,9,10,12,12,14,15,18,21,24,
   30,42],
  [1,-126,2,2,2,2,2,2,3,3,3,3,3,3,4,4,5,6,6,6,6,6,6,7,8,9,10,12,12,14,15,18,21,
     24,30,42],
  [(3+ER(-3))/2,-1,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,5,6,6,6,5/6,5/6,5/6,7,9,
     10,12,1/12,7/12,14,2/15,8/15,11/15,14/15,18,1/21,4/21,10/21,13/21,16/21,
        19/21,1/30,7/30,13/30,19/30,5/42,11/42,17/42,23/42,29/42,41/42],
  [(3-ER(-3))/2,-85,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,5,6,6,6,1/6,1/6,1/6,7,9,
     10,12,5/12,11/12,14,1/15,4/15,7/15,13/15,18,2/21,5/21,8/21,11/21,17/21,
        20/21,11/30,17/30,23/30,29/30,1/42,13/42,19/42,25/42,31/42,37/42],
  [(3-ER(-3))/2,-1,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,5,6,6,6,1/6,1/6,1/6,7,9,
     10,12,5/12,11/12,14,1/15,4/15,7/15,13/15,18,2/21,5/21,8/21,11/21,17/21,
        20/21,11/30,17/30,23/30,29/30,1/42,13/42,19/42,25/42,31/42,37/42],
  [(3+ER(-3))/2,-85,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,5,6,6,6,5/6,5/6,5/6,7,9,
     10,12,1/12,7/12,14,2/15,8/15,11/15,14/15,18,1/21,4/21,10/21,13/21,16/21,
        19/21,1/30,7/30,13/30,19/30,5/42,11/42,17/42,23/42,29/42,41/42],
  [6*E(3)^2,-46,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,7,2/9,5/9,
     8/9,5/12,5/12,11/12,11/12,5/18,11/18,17/18,1/42,13/42,19/42,25/42,31/42,
        37/42],
  [6*E(3),-4,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,7,1/9,4/9,7/9,
     1/12,1/12,7/12,7/12,1/18,7/18,13/18,5/42,11/42,17/42,23/42,29/42,41/42],
  [6*E(3),-46,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,7,1/9,4/9,
  7/9,1/12,1/12,7/12,7/12,1/18,7/18,13/18,5/42,11/42,17/42,23/42,29/42,41/42],
  [6*E(3)^2,-4,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,7,2/9,5/9,
    8/9,5/12,5/12,11/12,11/12,5/18,11/18,17/18,1/42,13/42,19/42,25/42,31/42,
      37/42],
  [42,-15,2,2,2,2,2,2,3,3,3,3,3,3,5/6,5/6,5/6,5/6,5/6,5/6,1/42,13/42,19/42,
    25/42,31/42,37/42],
  [42,-15,2,2,2,2,2,2,3,3,3,3,3,3,1/6,1/6,1/6,1/6,1/6,1/6,5/42,11/42,17/42,
    23/42,29/42,41/42],
  [2,-57,2,2,2,2,2,2,3,3,3,3,3,3,4,4,5,6,6,6,6,6,6,12,12,15,18],
  [2,-3,2,2,2,2,2,2,3,3,3,3,3,3,4,4,5,6,6,6,6,6,6,12,12,15,18],
  [(3+ER(-3))/2,-2,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,5,6,6,6,1/6,1/6,1/6,8,9,
    10,12,5/12,11/12,1/15,4/15,7/15,13/15,18,1/24,7/24,13/24,19/24,11/30,17/30,
      23/30,29/30],
  [(3-ER(-3))/2,-68,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,5,6,6,6,5/6,5/6,5/6,8,9,
    10,12,1/12,7/12,2/15,8/15,11/15,14/15,18,5/24,11/24,17/24,23/24,1/30,7/30,
      13/30,19/30],
  [(3-ER(-3))/2,-2,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,5,6,6,6,5/6,5/6,5/6,8,9,
    10,12,1/12,7/12,2/15,8/15,11/15,14/15,18,5/24,11/24,17/24,23/24,1/30,7/30,
      13/30,19/30],
  [(3+ER(-3))/2,-68,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,5,6,6,6,1/6,1/6,1/6,8,9,
    10,12,5/12,11/12,1/15,4/15,7/15,13/15,18,1/24,7/24,13/24,19/24,11/30,17/30,
      23/30,29/30],
  [2,-57,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,9,10,12,12,30],
  [2,-3,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,9,10,12,12,30],
  [3,-28,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,8],
  [3,-10,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,8],
  [2,-57,2,2,3,3,3,3,3,3,4,4,5,6,6,8,9,12,12,15,24],
  [2,-3,2,2,3,3,3,3,3,3,4,4,5,6,6,8,9,12,12,15,24],
  [3,-41,2,2,2,2,2,2,3,3,3,3,3,3,5,6,6,6,6,6,6,10,12,12],
  [3,-5,2,2,2,2,2,2,3,3,3,3,3,3,5,6,6,6,6,6,6,10,12,12],
  [1,-45,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,9,12,12,18],
  [1,-9,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,9,12,12,18],
  [-3*E(3),-41,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,5/12,5/12,11/12,11/12,
2/15,8/15,11/15,14/15,1/30,7/30,13/30,19/30],
  [-3*E(3)^2,-41,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,1/12,1/12,7/12,7/12,
1/15,4/15,7/15,13/15,11/30,17/30,23/30,29/30],
  [-3*E(3),-5,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,5/12,5/12,11/12,11/12,
   2/15,8/15,11/15,14/15,1/30,7/30,13/30,19/30],
  [-3*E(3)^2,-5,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,1/12,1/12,7/12,7/12,
   1/15,4/15,7/15,13/15,11/30,17/30,23/30,29/30],
  [-6*E(3)^2,-7,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,5,6,6,6,1/6,1/6,1/6,1/9,4/9,7/9,
   1/18,7/18,13/18,11/30,17/30,23/30,29/30],
  [-6*E(3)^2,-31,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,5,6,6,6,1/6,1/6,1/6,1/9,4/9,7/9,
   1/18,7/18,13/18,11/30,17/30,23/30,29/30],
  [-6*E(3),-7,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,5,6,6,6,5/6,5/6,5/6,2/9,5/9,8/9,
   5/18,11/18,17/18,1/30,7/30,13/30,19/30],
  [-6*E(3),-31,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,5,6,6,6,5/6,5/6,5/6,2/9,5/9,8/9,
   5/18,11/18,17/18,1/30,7/30,13/30,19/30],
  [3,-4,2,2,2,2,2,2,3,3,3,4,4,6,6,6,7,9,12,14,18],
  [3,-46,2,2,2,2,2,2,3,3,3,4,4,6,6,6,7,9,12,14,18],
  [3,-6,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,8,2/9,5/9,8/9,5/12,
   5/12,11/12,11/12,1/18,7/18,13/18],
  [-6*E(3)^2,-46,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/9,4/9,
   7/9,5/12,5/12,11/12,11/12,14,1/18,7/18,13/18,2/21,5/21,8/21,11/21,17/21,
    20/21],
  [3,-36,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,8,1/9,4/9,7/9,
   1/12,1/12,7/12,7/12,5/18,11/18,17/18],
  [-6*E(3),-4,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/9,5/9,8/9,
   1/12,1/12,7/12,7/12,14,5/18,11/18,17/18,1/21,4/21,10/21,13/21,16/21,19/21],
  [-6*E(3),-46,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/9,5/9,8/9,
   1/12,1/12,7/12,7/12,14,5/18,11/18,17/18,1/21,4/21,10/21,13/21,16/21,19/21],
  [3,-36,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,8,2/9,5/9,8/9,
   5/12,5/12,11/12,11/12,1/18,7/18,13/18],
  [3,-6,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,8,1/9,4/9,7/9,1/12,
   1/12,7/12,7/12,5/18,11/18,17/18],
  [-6*E(3)^2,-4,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/9,4/9,
   7/9,5/12,5/12,11/12,11/12,14,1/18,7/18,13/18,2/21,5/21,8/21,11/21,17/21,
    20/21],
  [-6,-13,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,5/6,5/6,5/6,5/6,5/6,5/6,2/9,5/9,
   8/9,1/30,7/30,13/30,19/30],
  [-6,-19,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,1/6,1/6,1/6,1/6,1/6,1/6,1/9,4/9,
   7/9,11/30,17/30,23/30,29/30],
  [-6,-13,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,1/6,1/6,1/6,1/6,1/6,1/6,1/9,4/9,
   7/9,11/30,17/30,23/30,29/30],
  [-6,-19,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,5/6,5/6,5/6,5/6,5/6,5/6,2/9,5/9,
   8/9,1/30,7/30,13/30,19/30], [7,-15,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6],
  [7,-15,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6],
  [3-ER(-3),-4,2,2,3,3,3,2/3,2/3,2/3,4,4,6,1/6,7,8,9,12,5/12,11/12,2/21,5/21,
   8/21,11/21,17/21,20/21,1/24,7/24,13/24,19/24],
  [3+ER(-3),-46,2,2,3,3,3,1/3,1/3,1/3,4,4,6,5/6,7,8,9,12,1/12,7/12,1/21,4/21,
   10/21,13/21,16/21,19/21,5/24,11/24,17/24,23/24],
  [3+ER(-3),-4,2,2,3,3,3,1/3,1/3,1/3,4,4,6,5/6,7,8,9,12,1/12,7/12,1/21,4/21,
   10/21,13/21,16/21,19/21,5/24,11/24,17/24,23/24],
  [3-ER(-3),-46,2,2,3,3,3,2/3,2/3,2/3,4,4,6,1/6,7,8,9,12,5/12,11/12,2/21,5/21
,8/21,11/21,17/21,20/21,1/24,7/24,13/24,19/24],
  [3,-5,2,2,2,2,2,2,3,3,3,4,4,5,6,6,6,9,10,12,18],
  [3,-41,2,2,2,2,2,2,3,3,3,4,4,5,6,6,6,9,10,12,18],
  [3,-5,2,2,2,2,2,2,3,3,3,4,4,5,6,6,6,9,10,12,18],
  [3,-41,2,2,2,2,2,2,3,3,3,4,4,5,6,6,6,9,10,12,18],
  [2,-18,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,9],
  [2,-27,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,9],
  [2,-9,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,9],
  [6,-19,2,2,2,2,2,2,3,3,3,4,4,5,6,6,6,18],
  [6,-13,2,2,2,2,2,2,3,3,3,4,4,5,6,6,6,18],
  [1,-30,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,12,12],
  [1,-12,2,2,2,2,2,2,3,3,3,3,3,3,4,4,6,6,6,6,6,6,12,12],
  [3,-6,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/9,4/9,7/9,5/12,
5/12,11/12,11/12,5/18,11/18,17/18,1/24,7/24,13/24,19/24],
  [3,-36,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/9,5/9,8/9,1/12
,1/12,7/12,7/12,1/18,7/18,13/18,5/24,11/24,17/24,23/24],
  [3,-36,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/9,4/9,7/9,5/12
,5/12,11/12,11/12,5/18,11/18,17/18,1/24,7/24,13/24,19/24],
  [3,-6,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/9,5/9,8/9,1/12,
1/12,7/12,7/12,1/18,7/18,13/18,5/24,11/24,17/24,23/24],
  [-3*E(3),-11,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/9,5/9,8/
9,1/18,7/18,13/18],
  [-3*E(3)^2,-23,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/9,4/9,
7/9,5/18,11/18,17/18],
  [-3*E(3)^2,-11,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/9,4/9,
7/9,5/18,11/18,17/18],
  [-3*E(3),-23,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/9,5/9,8/
9,1/18,7/18,13/18],
  [-3*E(3),-28,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,5/12,5/12,11/12,11/12,1/24
,7/24,13/24,19/24],
  [-3*E(3)^2,-28,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,1/12,1/12,7/12,7/12,5/24
,11/24,17/24,23/24],
  [-3*E(3)^2,-10,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,1/12,1/12,7/12,7/12,5/24
,11/24,17/24,23/24],
  [-3*E(3),-10,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,5/12,5/12,11/12,11/12,1/24
,7/24,13/24,19/24], [3,-36,2,2,2,2,2,2,3,3,3,4,4,6,6,6,8,9,12,18],
  [3,-6,2,2,2,2,2,2,3,3,3,4,4,6,6,6,8,9,12,18],
  [6,-19,2,2,2,2,2,2,3,3,3,4,4,6,6,6,9,10],
  [6,-13,2,2,2,2,2,2,3,3,3,4,4,6,6,6,9,10],
  [3,-10,2,2,2,2,2,2,3,3,3,4,4,6,6,6,8,9,18],
  [3,-28,2,2,2,2,2,2,3,3,3,4,4,6,6,6,8,9,18],
  [3,-10,2,2,2,2,2,2,3,3,3,4,4,6,6,6,8,9,18],
  [3,-28,2,2,2,2,2,2,3,3,3,4,4,6,6,6,8,9,18],
  [3-ER(-3),-31,2,2,3,3,3,2/3,2/3,2/3,4,4,5,6,1/6,9,12,5/12,11/12,1/15,4/15,7
/15,13/15],
  [3+ER(-3),-7,2,2,3,3,3,1/3,1/3,1/3,4,4,5,6,5/6,9,12,1/12,7/12,2/15,8/15,11/
15,14/15],
  [3+ER(-3),-31,2,2,3,3,3,1/3,1/3,1/3,4,4,5,6,5/6,9,12,1/12,7/12,2/15,8/15,11
/15,14/15],
  [3-ER(-3),-7,2,2,3,3,3,2/3,2/3,2/3,4,4,5,6,1/6,9,12,5/12,11/12,1/15,4/15,7/
15,13/15],
  [-6*E(3),-13,2,2,3,3,3,2/3,2/3,2/3,4,4,5,1/6,1/6,2/9,5/9,8/9,5/12,5/12,11/12,
   11/12,1/24,7/24,13/24,19/24],
  [-6*E(3),-19,2,2,3,3,3,2/3,2/3,2/3,4,4,5,1/6,1/6,2/9,5/9,8/9,5/12,5/12,11/12,
   11/12,1/24,7/24,13/24,19/24],
  [-6*E(3)^2,-13,2,2,3,3,3,1/3,1/3,1/3,4,4,5,5/6,5/6,1/9,4/9,7/9,1/12,1/12,7/
12,7/12,5/24,11/24,17/24,23/24],
  [-6*E(3)^2,-19,2,2,3,3,3,1/3,1/3,1/3,4,4,5,5/6,5/6,1/9,4/9,7/9,1/12,1/12,7/
12,7/12,5/24,11/24,17/24,23/24],
  [3-ER(-3),-8,2,3,3,3,1/3,1/3,1/3,5,5/6,7,9,2/15,8/15,11/15,14/15,1/21,4/21,
10/21,13/21,16/21,19/21],
  [3+ER(-3),-29,2,3,3,3,2/3,2/3,2/3,5,1/6,7,9,1/15,4/15,7/15,13/15,2/21,5/21,
8/21,11/21,17/21,20/21],
  [3+ER(-3),-8,2,3,3,3,2/3,2/3,2/3,5,1/6,7,9,1/15,4/15,7/15,13/15,2/21,5/21,8
/21,11/21,17/21,20/21],
  [3-ER(-3),-29,2,3,3,3,1/3,1/3,1/3,5,5/6,7,9,2/15,8/15,11/15,14/15,1/21,4/21
,10/21,13/21,16/21,19/21],
  [3-ER(-3),-29,2,3,3,3,1/3,1/3,1/3,5,5/6,7,9,2/15,8/15,11/15,14/15,1/21,4/21
,10/21,13/21,16/21,19/21],
  [3+ER(-3),-8,2,3,3,3,2/3,2/3,2/3,5,1/6,7,9,1/15,4/15,7/15,13/15,2/21,5/21,8
/21,11/21,17/21,20/21],
  [3+ER(-3),-29,2,3,3,3,2/3,2/3,2/3,5,1/6,7,9,1/15,4/15,7/15,13/15,2/21,5/21,
8/21,11/21,17/21,20/21],
  [3-ER(-3),-8,2,3,3,3,1/3,1/3,1/3,5,5/6,7,9,2/15,8/15,11/15,14/15,1/21,4/21,
10/21,13/21,16/21,19/21], [2,-27,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,18],
  [2,-9,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,18],
  [2,-18,2,2,2,2,2,2,3,3,3,3,3,3,6,6,6,6,6,6,18],
  [-6*E(3)^2,-7,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,6,6,6,1/6,1/6,1/6,2/9,5/9,8/9,10,
   1/15,4/15,7/15,13/15,5/18,11/18,17/18],
  [-6*E(3)^2,-31,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,6,6,6,1/6,1/6,1/6,2/9,5/9,8/9,
10,1/15,4/15,7/15,13/15,5/18,11/18,17/18],
  [-6*E(3),-7,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,6,6,6,5/6,5/6,5/6,1/9,4/9,7/9,10,
2/15,8/15,11/15,14/15,1/18,7/18,13/18],
  [-6*E(3),-31,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,6,6,6,5/6,5/6,5/6,1/9,4/9,7/9,10
,2/15,8/15,11/15,14/15,1/18,7/18,13/18],
  [6*E(3)^2,-13,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,5/6,5/6,5/6,5/6,5/6,5/6,1/9,4/9
,7/9,10,1/12,1/12,7/12,7/12],
  [6*E(3),-19,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,1/6,1/6,1/6,1/6,1/6,1/6,2/9,5/9,8
/9,10,5/12,5/12,11/12,11/12],
  [6*E(3),-13,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,1/6,1/6,1/6,1/6,1/6,1/6,2/9,5/9,8
/9,10,5/12,5/12,11/12,11/12],
  [6*E(3)^2,-19,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,5/6,5/6,5/6,5/6,5/6,5/6,1/9,4/9
,7/9,10,1/12,1/12,7/12,7/12], [3,-31,2,2,2,2,2,2,3,3,3,5,6,6,6,9,10,18],
  [3,-7,2,2,2,2,2,2,3,3,3,5,6,6,6,9,10,18],
  [6,-19,2,2,3,3,3,4,4,5,6,8,9,12], [6,-13,2,2,3,3,3,4,4,5,6,8,9,12],
  [6,-15,2,2,2,2,2,2,3,3,3,6,6,6,7,18],
  [6,-15,2,2,2,2,2,2,3,3,3,6,6,6,7,18],
  [-42,-15,2,2,2,2,2,2,1/3,1/3,1/3,1/3,1/3,1/3,6,6,6,6,6,6,2/21,5/21,8/21,11/
21,17/21,20/21],
  [-42,-15,2,2,2,2,2,2,2/3,2/3,2/3,2/3,2/3,2/3,6,6,6,6,6,6,1/21,4/21,10/21,13
/21,16/21,19/21], [2,-27,2,2,3,3,3,3,3,3,4,4,6,6,9,12,12],
  [2,-9,2,2,3,3,3,3,3,3,4,4,6,6,9,12,12],
  [2,-18,2,2,3,3,3,3,3,3,4,4,6,6,9,12,12],
  [6,-15,2,2,3,3,3,3,3,3,4,4,1/6,1/6,5/12,5/12,11/12,11/12,1/21,4/21,10/21,13
/21,16/21,19/21],
  [6,-15,2,2,3,3,3,3,3,3,4,4,5/6,5/6,1/12,1/12,7/12,7/12,2/21,5/21,8/21,11/21
,17/21,20/21], [3,-23,2,2,2,2,2,2,3,3,3,4,4,6,6,6,9,18],
  [3,-11,2,2,2,2,2,2,3,3,3,4,4,6,6,6,9,18],
  [(3-ER(-3))/2,-14,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,12,1/
12,7/12],
  [(3+ER(-3))/2,-20,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,12,5/
12,11/12],
  [(3+ER(-3))/2,-14,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,12,5/
12,11/12],
  [(3-ER(-3))/2,-20,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,12,1/
12,7/12],
  [(3-ER(-3))/2,-11,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,12,1/
12,7/12],
  [(3-ER(-3))/2,-23,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,12,1/
12,7/12],
  [(3+ER(-3))/2,-11,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,12,5/
12,11/12],
  [(3+ER(-3))/2,-23,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,12,5/
12,11/12], [6,-15,2,2,3,3,3,4,4,6,7,9,12], [6,-15,2,2,3,3,3,4,4,6,7,9,12]
    , [3,-24,2,2,2,2,2,2,4,4,5,7,8,10,14],
  [3,-10,2,2,2,2,2,2,4,4,5,7,8,10,14], [3,-24,2,2,2,2,2,2,4,4,5,7,8,10,14]
    , [3,-10,2,2,2,2,2,2,4,4,5,7,8,10,14],
  [3,-24,2,2,2,2,2,2,4,4,5,7,8,10,14], [3,-10,2,2,2,2,2,2,4,4,5,7,8,10,14]
    ,
  [-6*E(3)^2,-13,2,2,2,2,2,2,1/3,1/3,1/3,1/3,1/3,1/3,5,6,6,6,5/6,5/6,5/6,1/12
,1/12,7/12,7/12,5/18,11/18,17/18],
  [-6*E(3),-19,2,2,2,2,2,2,2/3,2/3,2/3,2/3,2/3,2/3,5,6,6,6,1/6,1/6,1/6,5/12,5
/12,11/12,11/12,1/18,7/18,13/18],
  [-6*E(3),-13,2,2,2,2,2,2,2/3,2/3,2/3,2/3,2/3,2/3,5,6,6,6,1/6,1/6,1/6,5/12,5
/12,11/12,11/12,1/18,7/18,13/18],
  [-6*E(3)^2,-19,2,2,2,2,2,2,1/3,1/3,1/3,1/3,1/3,1/3,5,6,6,6,5/6,5/6,5/6,1/12
,1/12,7/12,7/12,5/18,11/18,17/18],
  [6,-13,2,2,3,3,3,2/3,2/3,2/3,4,4,1/6,1/6,8,1/9,4/9,7/9,5/12,5/12,11/12,11/12,
   1/15,4/15,7/15,13/15],
  [6,-19,2,2,3,3,3,2/3,2/3,2/3,4,4,1/6,1/6,8,1/9,4/9,7/9,5/12,5/12,11/12,11/12,
   1/15,4/15,7/15,13/15],
  [6,-13,2,2,3,3,3,1/3,1/3,1/3,4,4,5/6,5/6,8,2/9,5/9,8/9,1/12,1/12,7/12,7/12,
2/15,8/15,11/15,14/15],
  [6,-19,2,2,3,3,3,1/3,1/3,1/3,4,4,5/6,5/6,8,2/9,5/9,8/9,1/12,1/12,7/12,7/12,
2/15,8/15,11/15,14/15],
  [3,-11,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,6,6,6,5/6,5/6,5/6,1/9,4/9,7/9,1/12,1/12,
   7/12,7/12,5/18,11/18,17/18],
  [3,-23,2,2,2,2,2,2,3,3,3,1/3,1/3,1/3,6,6,6,5/6,5/6,5/6,1/9,4/9,7/9,1/12,1/12,
   7/12,7/12,5/18,11/18,17/18],
  [3,-11,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,6,6,6,1/6,1/6,1/6,2/9,5/9,8/9,5/12,5/12,
   11/12,11/12,1/18,7/18,13/18],
  [3,-23,2,2,2,2,2,2,3,3,3,2/3,2/3,2/3,6,6,6,1/6,1/6,1/6,2/9,5/9,8/9,5/12,5/12,
   11/12,11/12,1/18,7/18,13/18], [2,-21,2,3,3,3,3,3,3,5,6,9,15],
  [2,-12,2,3,3,3,3,3,3,5,6,9,15], [2,-21,2,3,3,3,3,3,3,5,6,9,15],
  [2,-12,2,3,3,3,3,3,3,5,6,9,15],
  [6,-13,2,2,2,2,2,2,1/3,1/3,1/3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/15,8/15,
11/15,14/15,1/18,7/18,13/18],
  [6,-19,2,2,2,2,2,2,2/3,2/3,2/3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/15,4/15,
7/15,13/15,5/18,11/18,17/18],
  [6,-13,2,2,2,2,2,2,2/3,2/3,2/3,2/3,2/3,2/3,4,4,6,6,6,1/6,1/6,1/6,1/15,4/15,
7/15,13/15,5/18,11/18,17/18],
  [6,-19,2,2,2,2,2,2,1/3,1/3,1/3,1/3,1/3,1/3,4,4,6,6,6,5/6,5/6,5/6,2/15,8/15,
11/15,14/15,1/18,7/18,13/18], [6,-15,2,2,2,2,2,2,3,3,3,6,6,6,9,14],
  [6,-15,2,2,2,2,2,2,3,3,3,6,6,6,9,14], [6,-15,3,3,3,3,3,3,6,6,7,12,12],
  [42,-15,3,3,3,3,3,3,6,6,6,6,6,6,14] ]);

CHEVIE.AddData("Irr","G34",
[[1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1],[1,-1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,1,-1,-1,
-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,
1,1,1,1,1,1,1,-1,-1,-1,1,1,1,1,1,1,1,1,-1,-1,-1,-1,-1,-1,-1,1,1,1,-1,1,-1,1,1,
1,-1,-1,1,1,-1,1,1,1,1,-1,-1,1,1,1,1,-1,1,1,-1,-1,-1,-1,1,1,1,-1,1,-1,1,-1,-1,
-1,1,-1,1,1,1,1,-1,1,1,1,-1,-1,1,-1,-1,1,-1,-1,1,-1,1,-1,-1,1,1,-1,1,1,1,-1,1,
-1,1,-1,-1,1,-1,1,-1,1,1,1,1,-1,-1,1,-1,-1,1,1,1,-1,1,-1,-1],[6,4,3,2,1,2,
(5+ER(-3))/2,0,(5-ER(-3))/2,-E(3),0,1,(3+ER(-3))/2,(3-ER(-3))/2,0,-E(3)^2,-1,
-1,E(3)^2,-E(3)^2,-E(3),-E(3),-E(3)^2,-1,0,E(3),-3*E(3),E(3),1,2,E(3)^2,
-3*E(3)^2,0,1,(-1-3*ER(-3))/2,1,(-1+3*ER(-3))/2,1,0,-2*E(3),0,-2*E(3)^2,
(3+ER(-3))/2,(3-ER(-3))/2,ER(-3),-ER(-3),-E(3)^2,-E(3),2*E(3)^2,0,-E(3),
2*E(3),-E(3)^2,0,0,E(3),E(3)^2,2,-E(3)^2,-E(3)^2,-2*E(3),-2*E(3)^2,-E(3),
-E(3),2,1,ER(-3),-E(3)^2,0,-E(3),1,0,-ER(-3),0,1,(3+ER(-3))/2,E(3)^2,0,
(1-3*ER(-3))/2,-ER(-3),-1,0,-E(3),E(3)^2,0,E(3)^2,0,-6*E(3),(3-ER(-3))/2,
-2*E(3),-2*E(3),-2*E(3),0,0,E(3)^2,1,E(3),-1,3*E(3)^2,3,2*E(3)^2,
(-5-ER(-3))/2,2+ER(-3),0,-2,(-3-ER(-3))/2,E(3)^2,-4*E(3),0,2-ER(-3),-3*E(3),
-E(3)^2,-E(3),-2-ER(-3),E(3),-1,-1,E(3)^2,-1,0,0,6*E(3)^2,2*E(3)^2,2*E(3)^2,
2*E(3)^2,0,-1,E(3),(-3-ER(-3))/2,-3,-2+ER(-3),-2,(-3+ER(-3))/2,4*E(3)^2,
3*E(3)^2,E(3)^2,(-5+ER(-3))/2,(-3-ER(-3))/2,E(3),0,-6,-2,-2,-2,E(3),
(-3+ER(-3))/2,3*E(3),(1+3*ER(-3))/2,2*E(3),ER(-3),-4,-3,-1,(-3+ER(-3))/2,
6*E(3),2*E(3),2*E(3),E(3),4*E(3),3*E(3),E(3),2*E(3),-6*E(3)^2,-2*E(3)^2,
-2*E(3)^2,-4*E(3)^2,-3*E(3)^2,-E(3)^2,-2*E(3)^2],[6,-4,3,2,-1,-2,
(-5-ER(-3))/2,0,(-5+ER(-3))/2,-E(3),0,1,(3+ER(-3))/2,(3-ER(-3))/2,0,-E(3)^2,
-1,1,-E(3)^2,E(3)^2,E(3),E(3),E(3)^2,1,0,-E(3),-3*E(3),E(3),1,2,E(3)^2,
-3*E(3)^2,0,-1,(1+3*ER(-3))/2,-1,(1-3*ER(-3))/2,-1,0,2*E(3),0,2*E(3)^2,
(-3-ER(-3))/2,(-3+ER(-3))/2,ER(-3),-ER(-3),-E(3)^2,-E(3),2*E(3)^2,0,-E(3),
2*E(3),-E(3)^2,0,0,-E(3),-E(3)^2,-2,-E(3)^2,-E(3)^2,-2*E(3),-2*E(3)^2,-E(3),
-E(3),2,1,-ER(-3),E(3)^2,0,E(3),-1,0,ER(-3),0,1,(3+ER(-3))/2,-E(3)^2,0,
(-1+3*ER(-3))/2,-ER(-3),-1,0,E(3),-E(3)^2,0,E(3)^2,0,-6*E(3),(3-ER(-3))/2,
-2*E(3),-2*E(3),2*E(3),0,0,E(3)^2,1,E(3),1,3*E(3)^2,3,-2*E(3)^2,(5+ER(-3))/2,
-2-ER(-3),0,-2,(-3-ER(-3))/2,E(3)^2,4*E(3),0,-2+ER(-3),-3*E(3),E(3)^2,E(3),
2+ER(-3),E(3),1,-1,E(3)^2,-1,0,0,6*E(3)^2,2*E(3)^2,2*E(3)^2,-2*E(3)^2,0,-1,
-E(3),(3+ER(-3))/2,-3,2-ER(-3),2,(-3+ER(-3))/2,-4*E(3)^2,3*E(3)^2,-E(3)^2,
(5-ER(-3))/2,(-3-ER(-3))/2,E(3),0,-6,-2,-2,2,E(3),(3-ER(-3))/2,3*E(3),
(-1-3*ER(-3))/2,-2*E(3),ER(-3),4,-3,1,(-3+ER(-3))/2,6*E(3),2*E(3),2*E(3),
-E(3),-4*E(3),3*E(3),-E(3),-2*E(3),-6*E(3)^2,-2*E(3)^2,-2*E(3)^2,4*E(3)^2,
-3*E(3)^2,E(3)^2,2*E(3)^2],[6,4,3,2,1,2,(5-ER(-3))/2,0,(5+ER(-3))/2,-E(3)^2,0,
1,(3-ER(-3))/2,(3+ER(-3))/2,0,-E(3),-1,-1,E(3),-E(3),-E(3)^2,-E(3)^2,-E(3),-1,
0,E(3)^2,-3*E(3)^2,E(3)^2,1,2,E(3),-3*E(3),0,1,(-1+3*ER(-3))/2,1,
(-1-3*ER(-3))/2,1,0,-2*E(3)^2,0,-2*E(3),(3-ER(-3))/2,(3+ER(-3))/2,-ER(-3),
ER(-3),-E(3),-E(3)^2,2*E(3),0,-E(3)^2,2*E(3)^2,-E(3),0,0,E(3)^2,E(3),2,-E(3),
-E(3),-2*E(3)^2,-2*E(3),-E(3)^2,-E(3)^2,2,1,-ER(-3),-E(3),0,-E(3)^2,1,0,
ER(-3),0,1,(3-ER(-3))/2,E(3),0,(1+3*ER(-3))/2,ER(-3),-1,0,-E(3)^2,E(3),0,E(3),
0,-6*E(3)^2,(3+ER(-3))/2,-2*E(3)^2,-2*E(3)^2,-2*E(3)^2,0,0,E(3),1,E(3)^2,-1,
3*E(3),3,2*E(3),(-5+ER(-3))/2,2-ER(-3),0,-2,(-3+ER(-3))/2,E(3),-4*E(3)^2,0,
2+ER(-3),-3*E(3)^2,-E(3),-E(3)^2,-2+ER(-3),E(3)^2,-1,-1,E(3),-1,0,0,6*E(3),
2*E(3),2*E(3),2*E(3),0,-1,E(3)^2,(-3+ER(-3))/2,-3,-2-ER(-3),-2,(-3-ER(-3))/2,
4*E(3),3*E(3),E(3),(-5-ER(-3))/2,(-3+ER(-3))/2,E(3)^2,0,-6,-2,-2,-2,E(3)^2,
(-3-ER(-3))/2,3*E(3)^2,(1-3*ER(-3))/2,2*E(3)^2,-ER(-3),-4,-3,-1,(-3-ER(-3))/2,
6*E(3)^2,2*E(3)^2,2*E(3)^2,E(3)^2,4*E(3)^2,3*E(3)^2,E(3)^2,2*E(3)^2,-6*E(3),
-2*E(3),-2*E(3),-4*E(3),-3*E(3),-E(3),-2*E(3)],[6,-4,3,2,-1,-2,(-5+ER(-3))/2,
0,(-5-ER(-3))/2,-E(3)^2,0,1,(3-ER(-3))/2,(3+ER(-3))/2,0,-E(3),-1,1,-E(3),E(3),
E(3)^2,E(3)^2,E(3),1,0,-E(3)^2,-3*E(3)^2,E(3)^2,1,2,E(3),-3*E(3),0,-1,
(1-3*ER(-3))/2,-1,(1+3*ER(-3))/2,-1,0,2*E(3)^2,0,2*E(3),(-3+ER(-3))/2,
(-3-ER(-3))/2,-ER(-3),ER(-3),-E(3),-E(3)^2,2*E(3),0,-E(3)^2,2*E(3)^2,-E(3),0,
0,-E(3)^2,-E(3),-2,-E(3),-E(3),-2*E(3)^2,-2*E(3),-E(3)^2,-E(3)^2,2,1,ER(-3),
E(3),0,E(3)^2,-1,0,-ER(-3),0,1,(3-ER(-3))/2,-E(3),0,(-1-3*ER(-3))/2,ER(-3),-1,
0,E(3)^2,-E(3),0,E(3),0,-6*E(3)^2,(3+ER(-3))/2,-2*E(3)^2,-2*E(3)^2,2*E(3)^2,0,
0,E(3),1,E(3)^2,1,3*E(3),3,-2*E(3),(5-ER(-3))/2,-2+ER(-3),0,-2,(-3+ER(-3))/2,
E(3),4*E(3)^2,0,-2-ER(-3),-3*E(3)^2,E(3),E(3)^2,2-ER(-3),E(3)^2,1,-1,E(3),-1,
0,0,6*E(3),2*E(3),2*E(3),-2*E(3),0,-1,-E(3)^2,(3-ER(-3))/2,-3,2+ER(-3),2,
(-3-ER(-3))/2,-4*E(3),3*E(3),-E(3),(5+ER(-3))/2,(-3+ER(-3))/2,E(3)^2,0,-6,-2,
-2,2,E(3)^2,(3+ER(-3))/2,3*E(3)^2,(-1+3*ER(-3))/2,-2*E(3)^2,-ER(-3),4,-3,1,
(-3-ER(-3))/2,6*E(3)^2,2*E(3)^2,2*E(3)^2,-E(3)^2,-4*E(3)^2,3*E(3)^2,-E(3)^2,
-2*E(3)^2,-6*E(3),-2*E(3),-2*E(3),4*E(3),-3*E(3),E(3),2*E(3)],[15,-5,3,-1,1,
-1,4*E(3)^2,3,4*E(3),2*E(3)^2,0,0,ER(-3),-ER(-3),-1,2*E(3),-1,0,1,-E(3),1,
-E(3)^2,1,-1,0,1,6*E(3)^2,E(3)^2,-1,2,E(3),6*E(3),1,0,4,E(3),4,E(3)^2,0,
-2*E(3)^2,0,-2*E(3),2*E(3)^2,2*E(3),(-3+ER(-3))/2,(-3-ER(-3))/2,0,0,2*E(3),
E(3)^2,0,2*E(3)^2,0,0,E(3),0,0,-2,-E(3),E(3),2*E(3)^2,2*E(3),E(3)^2,-E(3)^2,3,
0,2,0,E(3),0,-1,E(3)^2,2,0,1,(3+ER(-3))/2,-E(3),0,4,(-3+ER(-3))/2,0,-E(3),
E(3),E(3)^2,1,0,-E(3),15*E(3)^2,(3-ER(-3))/2,-E(3)^2,3*E(3)^2,-E(3)^2,
3*E(3)^2,0,2*E(3),2,-E(3)^2,E(3)^2,6*E(3),6,-2*E(3),4*E(3)^2,4*E(3)^2,0,2,
ER(-3),-E(3),-5*E(3)^2,0,4*E(3),3*E(3)^2,E(3)^2,E(3)^2,4*E(3)^2,0,E(3),0,0,1,
-E(3)^2,-1,15*E(3),3*E(3),-E(3),-E(3),3*E(3),2,E(3),2*E(3)^2,6,4*E(3),-2,
(3-ER(-3))/2,-5*E(3),3*E(3),E(3),4*E(3),(3+ER(-3))/2,0,-E(3)^2,15,-1,3,-1,
2*E(3)^2,2*E(3),6*E(3)^2,4,-2*E(3)^2,(-3-ER(-3))/2,-5,3,1,-ER(-3),15*E(3)^2,
3*E(3)^2,-E(3)^2,-E(3)^2,-5*E(3)^2,3*E(3)^2,E(3)^2,-E(3)^2,15*E(3),3*E(3),
-E(3),-5*E(3),3*E(3),E(3),-E(3)],[15,5,3,-1,-1,1,-4*E(3)^2,-3,-4*E(3),
2*E(3)^2,0,0,ER(-3),-ER(-3),-1,2*E(3),-1,0,-1,E(3),-1,E(3)^2,-1,1,0,-1,
6*E(3)^2,E(3)^2,-1,2,E(3),6*E(3),-1,0,-4,-E(3),-4,-E(3)^2,0,2*E(3)^2,0,2*E(3),
-2*E(3)^2,-2*E(3),(-3+ER(-3))/2,(-3-ER(-3))/2,0,0,2*E(3),E(3)^2,0,2*E(3)^2,0,
0,E(3),0,0,2,-E(3),E(3),2*E(3)^2,2*E(3),E(3)^2,-E(3)^2,3,0,-2,0,-E(3),0,1,
-E(3)^2,-2,0,1,(3+ER(-3))/2,E(3),0,-4,(-3+ER(-3))/2,0,-E(3),-E(3),-E(3)^2,1,0,
E(3),15*E(3)^2,(3-ER(-3))/2,-E(3)^2,3*E(3)^2,E(3)^2,-3*E(3)^2,0,2*E(3),2,
-E(3)^2,-E(3)^2,6*E(3),6,2*E(3),-4*E(3)^2,-4*E(3)^2,0,2,ER(-3),-E(3),5*E(3)^2,
0,-4*E(3),3*E(3)^2,-E(3)^2,-E(3)^2,-4*E(3)^2,0,-E(3),0,0,1,-E(3)^2,1,15*E(3),
3*E(3),-E(3),E(3),-3*E(3),2,-E(3),-2*E(3)^2,6,-4*E(3),2,(3-ER(-3))/2,5*E(3),
3*E(3),-E(3),-4*E(3),(3+ER(-3))/2,0,E(3)^2,15,-1,3,1,2*E(3)^2,-2*E(3),
6*E(3)^2,-4,2*E(3)^2,(-3-ER(-3))/2,5,3,-1,-ER(-3),15*E(3)^2,3*E(3)^2,-E(3)^2,
E(3)^2,5*E(3)^2,3*E(3)^2,-E(3)^2,E(3)^2,15*E(3),3*E(3),-E(3),5*E(3),3*E(3),
-E(3),E(3)],[15,-5,3,-1,1,-1,4*E(3),3,4*E(3)^2,2*E(3),0,0,-ER(-3),ER(-3),-1,
2*E(3)^2,-1,0,1,-E(3)^2,1,-E(3),1,-1,0,1,6*E(3),E(3),-1,2,E(3)^2,6*E(3)^2,1,0,
4,E(3)^2,4,E(3),0,-2*E(3),0,-2*E(3)^2,2*E(3),2*E(3)^2,(-3-ER(-3))/2,
(-3+ER(-3))/2,0,0,2*E(3)^2,E(3),0,2*E(3),0,0,E(3)^2,0,0,-2,-E(3)^2,E(3)^2,
2*E(3),2*E(3)^2,E(3),-E(3),3,0,2,0,E(3)^2,0,-1,E(3),2,0,1,(3-ER(-3))/2,
-E(3)^2,0,4,(-3-ER(-3))/2,0,-E(3)^2,E(3)^2,E(3),1,0,-E(3)^2,15*E(3),
(3+ER(-3))/2,-E(3),3*E(3),-E(3),3*E(3),0,2*E(3)^2,2,-E(3),E(3),6*E(3)^2,6,
-2*E(3)^2,4*E(3),4*E(3),0,2,-ER(-3),-E(3)^2,-5*E(3),0,4*E(3)^2,3*E(3),E(3),
E(3),4*E(3),0,E(3)^2,0,0,1,-E(3),-1,15*E(3)^2,3*E(3)^2,-E(3)^2,-E(3)^2,
3*E(3)^2,2,E(3)^2,2*E(3),6,4*E(3)^2,-2,(3+ER(-3))/2,-5*E(3)^2,3*E(3)^2,E(3)^2,
4*E(3)^2,(3-ER(-3))/2,0,-E(3),15,-1,3,-1,2*E(3),2*E(3)^2,6*E(3),4,-2*E(3),
(-3+ER(-3))/2,-5,3,1,ER(-3),15*E(3),3*E(3),-E(3),-E(3),-5*E(3),3*E(3),E(3),
-E(3),15*E(3)^2,3*E(3)^2,-E(3)^2,-5*E(3)^2,3*E(3)^2,E(3)^2,-E(3)^2],[15,5,3,
-1,-1,1,-4*E(3),-3,-4*E(3)^2,2*E(3),0,0,-ER(-3),ER(-3),-1,2*E(3)^2,-1,0,-1,
E(3)^2,-1,E(3),-1,1,0,-1,6*E(3),E(3),-1,2,E(3)^2,6*E(3)^2,-1,0,-4,-E(3)^2,-4,
-E(3),0,2*E(3),0,2*E(3)^2,-2*E(3),-2*E(3)^2,(-3-ER(-3))/2,(-3+ER(-3))/2,0,0,
2*E(3)^2,E(3),0,2*E(3),0,0,E(3)^2,0,0,2,-E(3)^2,E(3)^2,2*E(3),2*E(3)^2,E(3),
-E(3),3,0,-2,0,-E(3)^2,0,1,-E(3),-2,0,1,(3-ER(-3))/2,E(3)^2,0,-4,
(-3-ER(-3))/2,0,-E(3)^2,-E(3)^2,-E(3),1,0,E(3)^2,15*E(3),(3+ER(-3))/2,-E(3),
3*E(3),E(3),-3*E(3),0,2*E(3)^2,2,-E(3),-E(3),6*E(3)^2,6,2*E(3)^2,-4*E(3),
-4*E(3),0,2,-ER(-3),-E(3)^2,5*E(3),0,-4*E(3)^2,3*E(3),-E(3),-E(3),-4*E(3),0,
-E(3)^2,0,0,1,-E(3),1,15*E(3)^2,3*E(3)^2,-E(3)^2,E(3)^2,-3*E(3)^2,2,-E(3)^2,
-2*E(3),6,-4*E(3)^2,2,(3+ER(-3))/2,5*E(3)^2,3*E(3)^2,-E(3)^2,-4*E(3)^2,
(3-ER(-3))/2,0,E(3),15,-1,3,1,2*E(3),-2*E(3)^2,6*E(3),-4,2*E(3),(-3+ER(-3))/2,
5,3,-1,ER(-3),15*E(3),3*E(3),-E(3),E(3),5*E(3),3*E(3),-E(3),E(3),15*E(3)^2,
3*E(3)^2,-E(3)^2,5*E(3)^2,3*E(3)^2,-E(3)^2,E(3)^2],[20,0,2,-4,0,0,-3*ER(-3),0,
3*ER(-3),-1,2,0,-1,-1,0,-1,2,0,-ER(-3),0,-ER(-3),0,ER(-3),0,0,ER(-3),-7,1,-2,
2,1,-7,0,0,-3*ER(-3),ER(-3),3*ER(-3),-ER(-3),0,0,0,0,-ER(-3),ER(-3),-1,-1,0,0,
2,0,1,2,1,1,0,0,0,0,2,-1,-2,-2,-1,2,4,-1,ER(-3),0,0,0,0,0,-ER(-3),2,1,1,0,-1,
-3*ER(-3),1,1,0,ER(-3),ER(-3),0,0,0,-20,1,4,-4,0,0,-2,1,1,-2,ER(-3),7,7,0,
3*ER(-3),-3*ER(-3),0,-2,1,-2,0,-2,3*ER(-3),-2,-ER(-3),0,3*ER(-3),-1,-ER(-3),0,
-1,-1,0,0,20,4,-4,0,0,-1,-ER(-3),ER(-3),-7,-3*ER(-3),0,-1,0,2,0,-3*ER(-3),-1,
0,0,-20,4,-4,0,1,-ER(-3),7,3*ER(-3),0,1,0,-2,0,1,20,4,-4,0,0,2,0,0,-20,-4,4,0,
-2,0,0],[20,0,2,-4,0,0,3*ER(-3),0,-3*ER(-3),-1,2,0,-1,-1,0,-1,2,0,ER(-3),0,
ER(-3),0,-ER(-3),0,0,-ER(-3),-7,1,-2,2,1,-7,0,0,3*ER(-3),-ER(-3),-3*ER(-3),
ER(-3),0,0,0,0,ER(-3),-ER(-3),-1,-1,0,0,2,0,1,2,1,1,0,0,0,0,2,-1,-2,-2,-1,2,4,
-1,-ER(-3),0,0,0,0,0,ER(-3),2,1,1,0,-1,3*ER(-3),1,1,0,-ER(-3),-ER(-3),0,0,0,
-20,1,4,-4,0,0,-2,1,1,-2,-ER(-3),7,7,0,-3*ER(-3),3*ER(-3),0,-2,1,-2,0,-2,
-3*ER(-3),-2,ER(-3),0,-3*ER(-3),-1,ER(-3),0,-1,-1,0,0,20,4,-4,0,0,-1,ER(-3),
-ER(-3),-7,3*ER(-3),0,-1,0,2,0,3*ER(-3),-1,0,0,-20,4,-4,0,1,ER(-3),7,
-3*ER(-3),0,1,0,-2,0,1,20,4,-4,0,0,2,0,0,-20,-4,4,0,-2,0,0],[21,-9,3,5,-3,-1,
0,-1,0,2,3,1,0,0,1,2,-1,1,0,-1,0,-1,0,-1,-1,0,-6,0,-1,-1,0,-6,1,1,0,0,0,0,-1,
3,-1,3,0,0,0,0,1,1,-1,-1,-2,-1,-2,0,-1,1,1,3,-1,0,-1,-1,0,-1,1,-2,0,1,1,1,-1,
1,0,3,0,0,-1,0,0,0,-2,1,0,0,-1,1,3,21,0,5,1,-1,-1,3,2,2,-1,0,-6,-6,3,0,0,-1,
-1,0,-1,-9,3,0,3,0,-3,0,-2,0,1,-2,0,1,3,21,1,5,-1,-1,2,0,0,-6,0,3,0,-9,3,-3,0,
0,1,3,21,5,1,-1,2,0,-6,0,3,0,-9,3,-3,0,21,1,5,-1,-9,3,-3,-1,21,1,5,-9,3,-3,
-1],[21,9,3,5,3,1,0,1,0,2,3,1,0,0,1,2,-1,-1,0,1,0,1,0,1,1,0,-6,0,-1,-1,0,-6,
-1,-1,0,0,0,0,1,-3,1,-3,0,0,0,0,1,1,-1,-1,-2,-1,-2,0,-1,-1,-1,-3,-1,0,-1,-1,0,
-1,1,-2,0,-1,-1,-1,1,-1,0,3,0,0,1,0,0,0,-2,1,0,0,-1,1,-3,21,0,5,1,1,1,3,2,2,
-1,0,-6,-6,-3,0,0,1,-1,0,-1,9,3,0,3,0,3,0,-2,0,1,-2,0,1,-3,21,1,5,1,1,2,0,0,
-6,0,-3,0,9,3,3,0,0,1,-3,21,5,1,1,2,0,-6,0,-3,0,9,3,3,0,21,1,5,1,9,3,3,1,21,1,
5,9,3,3,1],[21,11,6,5,2,3,(7+ER(-3))/2,3,(7-ER(-3))/2,-E(3)^2,0,1,
(3+ER(-3))/2,(3-ER(-3))/2,1,-E(3),2,1,-E(3)^2,0,-E(3),0,-E(3)^2,0,0,-E(3),
3*E(3)^2,0,2,2,0,3*E(3),1,1,(-5+3*ER(-3))/2,-E(3)^2,(-5-3*ER(-3))/2,-E(3),0,
2*E(3)^2,0,2*E(3),-E(3)^2,-E(3),(-3-ER(-3))/2,(-3+ER(-3))/2,E(3),E(3)^2,
2*E(3),-E(3)^2,E(3)^2,2*E(3)^2,E(3),0,-E(3),E(3)^2,E(3),2,2*E(3),0,2*E(3)^2,
2*E(3),0,2*E(3)^2,1,1,-1,E(3),E(3),E(3)^2,0,E(3)^2,-1,0,0,ER(-3),0,0,
(-5-3*ER(-3))/2,(-3-ER(-3))/2,1,E(3),-1,-1,-1,E(3),-E(3),21*E(3)^2,-ER(-3),
5*E(3)^2,E(3)^2,3*E(3)^2,3*E(3)^2,0,-E(3),-1,2*E(3)^2,-E(3),3*E(3),3,2*E(3),
(7+ER(-3))/2,-1+2*ER(-3),0,2,(3+ER(-3))/2,2*E(3),11*E(3)^2,0,-1-2*ER(-3),
6*E(3)^2,-1,2*E(3)^2,-1+2*ER(-3),E(3)^2,-E(3)^2,1,E(3),0,E(3)^2,-1,21*E(3),
E(3),5*E(3),3*E(3),3*E(3),-1,-1,-E(3)^2,3,-1-2*ER(-3),2,-ER(-3),11*E(3),
6*E(3),2*E(3),(7-ER(-3))/2,ER(-3),E(3)^2,-E(3)^2,21,5,1,3,-E(3)^2,-E(3),
3*E(3)^2,(-5+3*ER(-3))/2,2*E(3)^2,(-3+ER(-3))/2,11,6,2,(3-ER(-3))/2,21*E(3)^2,
E(3)^2,5*E(3)^2,0,11*E(3)^2,6*E(3)^2,2*E(3)^2,3*E(3)^2,21*E(3),E(3),5*E(3),
11*E(3),6*E(3),2*E(3),3*E(3)],[21,-11,6,5,-2,-3,(-7-ER(-3))/2,-3,
(-7+ER(-3))/2,-E(3)^2,0,1,(3+ER(-3))/2,(3-ER(-3))/2,1,-E(3),2,-1,E(3)^2,0,
E(3),0,E(3)^2,0,0,E(3),3*E(3)^2,0,2,2,0,3*E(3),-1,-1,(5-3*ER(-3))/2,E(3)^2,
(5+3*ER(-3))/2,E(3),0,-2*E(3)^2,0,-2*E(3),E(3)^2,E(3),(-3-ER(-3))/2,
(-3+ER(-3))/2,E(3),E(3)^2,2*E(3),-E(3)^2,E(3)^2,2*E(3)^2,E(3),0,-E(3),-E(3)^2,
-E(3),-2,2*E(3),0,2*E(3)^2,2*E(3),0,2*E(3)^2,1,1,1,-E(3),-E(3),-E(3)^2,0,
-E(3)^2,1,0,0,ER(-3),0,0,(5+3*ER(-3))/2,(-3-ER(-3))/2,1,E(3),1,1,-1,E(3),E(3),
21*E(3)^2,-ER(-3),5*E(3)^2,E(3)^2,-3*E(3)^2,-3*E(3)^2,0,-E(3),-1,2*E(3)^2,
E(3),3*E(3),3,-2*E(3),(-7-ER(-3))/2,1-2*ER(-3),0,2,(3+ER(-3))/2,2*E(3),
-11*E(3)^2,0,1+2*ER(-3),6*E(3)^2,1,-2*E(3)^2,1-2*ER(-3),E(3)^2,E(3)^2,1,E(3),
0,E(3)^2,1,21*E(3),E(3),5*E(3),-3*E(3),-3*E(3),-1,1,E(3)^2,3,1+2*ER(-3),-2,
-ER(-3),-11*E(3),6*E(3),-2*E(3),(-7+ER(-3))/2,ER(-3),E(3)^2,E(3)^2,21,5,1,-3,
-E(3)^2,E(3),3*E(3)^2,(5-3*ER(-3))/2,-2*E(3)^2,(-3+ER(-3))/2,-11,6,-2,
(3-ER(-3))/2,21*E(3)^2,E(3)^2,5*E(3)^2,0,-11*E(3)^2,6*E(3)^2,-2*E(3)^2,
-3*E(3)^2,21*E(3),E(3),5*E(3),-11*E(3),6*E(3),-2*E(3),-3*E(3)],[21,11,6,5,2,3,
(7-ER(-3))/2,3,(7+ER(-3))/2,-E(3),0,1,(3-ER(-3))/2,(3+ER(-3))/2,1,-E(3)^2,2,1,
-E(3),0,-E(3)^2,0,-E(3),0,0,-E(3)^2,3*E(3),0,2,2,0,3*E(3)^2,1,1,
(-5-3*ER(-3))/2,-E(3),(-5+3*ER(-3))/2,-E(3)^2,0,2*E(3),0,2*E(3)^2,-E(3),
-E(3)^2,(-3+ER(-3))/2,(-3-ER(-3))/2,E(3)^2,E(3),2*E(3)^2,-E(3),E(3),2*E(3),
E(3)^2,0,-E(3)^2,E(3),E(3)^2,2,2*E(3)^2,0,2*E(3),2*E(3)^2,0,2*E(3),1,1,-1,
E(3)^2,E(3)^2,E(3),0,E(3),-1,0,0,-ER(-3),0,0,(-5+3*ER(-3))/2,(-3+ER(-3))/2,1,
E(3)^2,-1,-1,-1,E(3)^2,-E(3)^2,21*E(3),ER(-3),5*E(3),E(3),3*E(3),3*E(3),0,
-E(3)^2,-1,2*E(3),-E(3)^2,3*E(3)^2,3,2*E(3)^2,(7-ER(-3))/2,-1-2*ER(-3),0,2,
(3-ER(-3))/2,2*E(3)^2,11*E(3),0,-1+2*ER(-3),6*E(3),-1,2*E(3),-1-2*ER(-3),E(3),
-E(3),1,E(3)^2,0,E(3),-1,21*E(3)^2,E(3)^2,5*E(3)^2,3*E(3)^2,3*E(3)^2,-1,-1,
-E(3),3,-1+2*ER(-3),2,ER(-3),11*E(3)^2,6*E(3)^2,2*E(3)^2,(7+ER(-3))/2,-ER(-3),
E(3),-E(3),21,5,1,3,-E(3),-E(3)^2,3*E(3),(-5-3*ER(-3))/2,2*E(3),(-3-ER(-3))/2,
11,6,2,(3+ER(-3))/2,21*E(3),E(3),5*E(3),0,11*E(3),6*E(3),2*E(3),3*E(3),
21*E(3)^2,E(3)^2,5*E(3)^2,11*E(3)^2,6*E(3)^2,2*E(3)^2,3*E(3)^2],[21,-11,6,5,
-2,-3,(-7+ER(-3))/2,-3,(-7-ER(-3))/2,-E(3),0,1,(3-ER(-3))/2,(3+ER(-3))/2,1,
-E(3)^2,2,-1,E(3),0,E(3)^2,0,E(3),0,0,E(3)^2,3*E(3),0,2,2,0,3*E(3)^2,-1,-1,
(5+3*ER(-3))/2,E(3),(5-3*ER(-3))/2,E(3)^2,0,-2*E(3),0,-2*E(3)^2,E(3),E(3)^2,
(-3+ER(-3))/2,(-3-ER(-3))/2,E(3)^2,E(3),2*E(3)^2,-E(3),E(3),2*E(3),E(3)^2,0,
-E(3)^2,-E(3),-E(3)^2,-2,2*E(3)^2,0,2*E(3),2*E(3)^2,0,2*E(3),1,1,1,-E(3)^2,
-E(3)^2,-E(3),0,-E(3),1,0,0,-ER(-3),0,0,(5-3*ER(-3))/2,(-3+ER(-3))/2,1,E(3)^2,
1,1,-1,E(3)^2,E(3)^2,21*E(3),ER(-3),5*E(3),E(3),-3*E(3),-3*E(3),0,-E(3)^2,-1,
2*E(3),E(3)^2,3*E(3)^2,3,-2*E(3)^2,(-7+ER(-3))/2,1+2*ER(-3),0,2,(3-ER(-3))/2,
2*E(3)^2,-11*E(3),0,1-2*ER(-3),6*E(3),1,-2*E(3),1+2*ER(-3),E(3),E(3),1,E(3)^2,
0,E(3),1,21*E(3)^2,E(3)^2,5*E(3)^2,-3*E(3)^2,-3*E(3)^2,-1,1,E(3),3,1-2*ER(-3),
-2,ER(-3),-11*E(3)^2,6*E(3)^2,-2*E(3)^2,(-7-ER(-3))/2,-ER(-3),E(3),E(3),21,5,
1,-3,-E(3),E(3)^2,3*E(3),(5+3*ER(-3))/2,-2*E(3),(-3-ER(-3))/2,-11,6,-2,
(3+ER(-3))/2,21*E(3),E(3),5*E(3),0,-11*E(3),6*E(3),-2*E(3),-3*E(3),21*E(3)^2,
E(3)^2,5*E(3)^2,-11*E(3)^2,6*E(3)^2,-2*E(3)^2,-3*E(3)^2],[35,-15,8,3,0,-3,-6,
1,-6,0,-1,0,2,2,-1,0,0,0,0,0,0,0,0,0,1,0,8,0,0,3,0,8,1,0,-6,0,-6,0,1,-3,1,-3,
-2,-2,2,2,0,0,3,-1,0,3,0,-1,-1,0,0,-3,0,0,3,3,0,0,3,0,-2,0,1,0,0,1,-2,-1,0,2,
0,-1,-6,2,0,-1,0,0,-1,0,1,35,2,3,3,-3,1,-1,0,0,0,0,8,8,-3,-6,-6,1,3,2,0,-15,
-1,-6,8,0,0,-6,0,0,0,0,0,-1,1,35,3,3,-3,1,0,0,-2,8,-6,-3,2,-15,8,0,-6,2,0,1,
35,3,3,-3,0,-2,8,-6,-3,2,-15,8,0,2,35,3,3,0,-15,8,0,-3,35,3,3,-15,8,0,-3],[35,
15,8,3,0,3,6,-1,6,0,-1,0,2,2,-1,0,0,0,0,0,0,0,0,0,-1,0,8,0,0,3,0,8,-1,0,6,0,6,
0,-1,3,-1,3,2,2,2,2,0,0,3,-1,0,3,0,-1,-1,0,0,3,0,0,3,3,0,0,3,0,2,0,-1,0,0,-1,
2,-1,0,2,0,-1,6,2,0,-1,0,0,-1,0,-1,35,2,3,3,3,-1,-1,0,0,0,0,8,8,3,6,6,-1,3,2,
0,15,-1,6,8,0,0,6,0,0,0,0,0,-1,-1,35,3,3,3,-1,0,0,2,8,6,3,2,15,8,0,6,2,0,-1,
35,3,3,3,0,2,8,6,3,2,15,8,0,2,35,3,3,0,15,8,0,3,35,3,3,15,8,0,3],[35,-5,-1,3,
1,-1,4,-5,4,0,-1,0,-1,-1,-1,0,3,0,1,-1,1,-1,1,-1,1,1,8,0,3,0,0,8,-1,0,4,1,4,1,
-2,-2,1,-2,0,0,-1,-1,0,0,0,-1,0,0,0,2,-1,0,0,-2,3,0,0,0,0,3,3,0,0,0,-1,0,-1,
-1,0,8,0,-1,-1,2,4,-1,0,-1,1,1,-1,0,3,35,-1,3,3,-1,-5,-1,0,0,3,1,8,8,-2,4,4,
-2,0,-1,3,-5,8,4,-1,1,1,4,0,1,0,0,0,-1,3,35,3,3,-1,-5,0,1,0,8,4,-2,-1,-5,-1,1,
4,-1,0,3,35,3,3,-1,0,0,8,4,-2,-1,-5,-1,1,-1,35,3,3,-1,-5,-1,1,-1,35,3,3,-5,-1,
1,-1],[35,5,-1,3,-1,1,-4,5,-4,0,-1,0,-1,-1,-1,0,3,0,-1,1,-1,1,-1,1,-1,-1,8,0,
3,0,0,8,1,0,-4,-1,-4,-1,2,2,-1,2,0,0,-1,-1,0,0,0,-1,0,0,0,2,-1,0,0,2,3,0,0,0,
0,3,3,0,0,0,1,0,1,1,0,8,0,-1,1,2,-4,-1,0,-1,-1,-1,-1,0,-3,35,-1,3,3,1,5,-1,0,
0,3,-1,8,8,2,-4,-4,2,0,-1,3,5,8,-4,-1,-1,-1,-4,0,-1,0,0,0,-1,-3,35,3,3,1,5,0,
-1,0,8,-4,2,-1,5,-1,-1,-4,-1,0,-3,35,3,3,1,0,0,8,-4,2,-1,5,-1,-1,-1,35,3,3,1,
5,-1,-1,1,35,3,3,5,-1,-1,1],[56,-24,11,8,-3,-4,-6,0,-6,2,2,1,2,2,0,2,-1,1,0,
-1,0,-1,0,-1,0,0,2,0,1,2,0,2,0,-1,-6,0,-6,0,0,0,0,0,0,0,2,2,-1,-1,2,0,0,2,0,1,
0,-1,-1,0,-1,0,-2,-2,0,-1,0,0,0,1,0,1,1,0,0,2,0,-2,1,-1,6,-2,0,0,0,0,0,1,0,
-56,-2,-8,0,4,0,-2,-2,-2,1,0,-2,-2,0,6,6,0,-2,-2,1,24,-2,6,-11,0,3,-6,0,0,-1,
0,0,0,0,56,0,8,-4,0,2,0,0,2,-6,0,2,-24,11,-3,6,2,1,0,-56,-8,0,4,-2,0,-2,6,0,
-2,24,-11,3,-2,56,0,8,1,-24,11,-3,-4,-56,0,-8,24,-11,3,4],[56,24,11,8,3,4,6,0,
6,2,2,1,2,2,0,2,-1,-1,0,1,0,1,0,1,0,0,2,0,1,2,0,2,0,1,6,0,6,0,0,0,0,0,0,0,2,2,
-1,-1,2,0,0,2,0,1,0,1,1,0,-1,0,-2,-2,0,-1,0,0,0,-1,0,-1,-1,0,0,2,0,-2,-1,-1,
-6,-2,0,0,0,0,0,1,0,-56,-2,-8,0,-4,0,-2,-2,-2,1,0,-2,-2,0,-6,-6,0,-2,-2,1,-24,
-2,-6,-11,0,-3,6,0,0,-1,0,0,0,0,56,0,8,4,0,2,0,0,2,6,0,2,24,11,3,-6,2,1,0,-56,
-8,0,-4,-2,0,-2,-6,0,-2,-24,-11,-3,-2,56,0,8,-1,24,11,3,4,-56,0,-8,-24,-11,-3,
-4],[56,-16,2,8,-4,0,2,0,2,2,2,1,-1,-1,0,2,2,-1,-1,0,1,0,1,0,0,-1,2,0,-2,-1,0,
2,0,1,2,-1,2,-1,3,-1,0,-1,0,0,-1,-1,-1,-1,-1,0,0,-1,0,-2,0,1,1,1,2,0,1,1,0,2,
0,0,0,-1,0,-1,0,0,0,11,0,1,0,2,-2,1,0,0,1,-1,0,1,0,-56,1,-8,0,0,0,-2,-2,-2,-2,
1,-2,-2,1,-2,-2,-3,1,1,-2,16,-11,-2,-2,1,4,2,0,1,-1,0,0,0,0,56,0,8,0,0,2,-1,0,
2,2,-1,-1,-16,2,-4,-2,-1,1,0,-56,-8,0,0,-2,0,-2,-2,1,1,16,-2,4,1,56,0,8,0,-16,
2,-4,0,-56,0,-8,16,-2,4,0],[56,16,2,8,4,0,-2,0,-2,2,2,1,-1,-1,0,2,2,1,1,0,-1,
0,-1,0,0,1,2,0,-2,-1,0,2,0,-1,-2,1,-2,1,-3,1,0,1,0,0,-1,-1,-1,-1,-1,0,0,-1,0,
-2,0,-1,-1,-1,2,0,1,1,0,2,0,0,0,1,0,1,0,0,0,11,0,1,0,2,2,1,0,0,-1,1,0,1,0,-56,
1,-8,0,0,0,-2,-2,-2,-2,-1,-2,-2,-1,2,2,3,1,1,-2,-16,-11,2,-2,-1,-4,-2,0,-1,-1,
0,0,0,0,56,0,8,0,0,2,1,0,2,-2,1,-1,16,2,4,2,-1,1,0,-56,-8,0,0,-2,0,-2,2,-1,1,
-16,-2,-4,1,56,0,8,0,16,2,4,0,-56,0,-8,-16,-2,-4,0],[70,-20,7,2,1,-2,-2,0,-2,
-4,-2,0,1,1,0,-4,-1,0,1,1,-1,1,-1,1,0,1,16,0,1,-1,0,16,0,0,-2,1,-2,1,3,-5,0,
-5,0,0,1,1,0,0,-1,0,2,-1,2,-1,0,0,0,5,-1,0,1,1,0,-1,2,-2,0,0,0,0,-1,0,0,7,0,
-1,-1,1,2,-1,2,0,-1,1,0,0,0,-70,-1,-2,-2,2,0,2,4,4,1,-1,-16,-16,5,2,2,-3,1,-1,
1,20,-7,2,-7,-1,-1,-2,-2,-1,0,-2,0,0,0,70,2,2,-2,0,-4,1,0,16,-2,-5,1,-20,7,1,
2,1,0,0,-70,-2,-2,2,4,0,-16,2,5,-1,20,-7,-1,-1,70,2,2,-1,-20,7,1,-2,-70,-2,-2,
20,-7,-1,2],[70,20,7,2,-1,2,2,0,2,-4,-2,0,1,1,0,-4,-1,0,-1,-1,1,-1,1,-1,0,-1,
16,0,1,-1,0,16,0,0,2,-1,2,-1,-3,5,0,5,0,0,1,1,0,0,-1,0,2,-1,2,-1,0,0,0,-5,-1,
0,1,1,0,-1,2,-2,0,0,0,0,1,0,0,7,0,-1,1,1,-2,-1,2,0,1,-1,0,0,0,-70,-1,-2,-2,-2,
0,2,4,4,1,1,-16,-16,-5,-2,-2,3,1,-1,1,-20,-7,-2,-7,1,1,2,-2,1,0,-2,0,0,0,70,2,
2,2,0,-4,-1,0,16,2,5,1,20,7,-1,-2,1,0,0,-70,-2,-2,-2,4,0,-16,-2,-5,-1,-20,-7,
1,-1,70,2,2,1,20,7,-1,2,-70,-2,-2,-20,-7,1,-2],[70,-20,7,2,1,-2,-2-3*ER(-3),0,
-2+3*ER(-3),-1,-2,0,(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,-1,-1,0,E(3),1,-E(3)^2,
1,-E(3),1,0,E(3)^2,-11,0,1,2,0,-11,0,0,-2-3*ER(-3),E(3)^2,-2+3*ER(-3),E(3),0,
4,0,4,-ER(-3),ER(-3),(-1-3*ER(-3))/2,(-1+3*ER(-3))/2,0,0,2,0,-1,2,-1,-1,0,0,0,
-4,-1,0,-2,-2,0,-1,2,1,ER(-3),0,0,0,-1,0,-ER(-3),-2,0,(1+3*ER(-3))/2,-1,1,
2-3*ER(-3),(1+3*ER(-3))/2,-1,0,-E(3),E(3)^2,0,0,0,-70,(1-3*ER(-3))/2,-2,-2,2,
0,2,1,1,1,-E(3),11,11,-4,2+3*ER(-3),2-3*ER(-3),0,-2,(1-3*ER(-3))/2,1,20,2,
2+3*ER(-3),-7,-E(3)^2,-1,-2+3*ER(-3),1,-E(3)^2,0,1,0,0,0,70,2,2,-2,0,-1,E(3),
ER(-3),-11,-2-3*ER(-3),4,(-1+3*ER(-3))/2,-20,7,1,2-3*ER(-3),(-1-3*ER(-3))/2,0,
0,-70,-2,-2,2,1,-ER(-3),11,2+3*ER(-3),-4,(1-3*ER(-3))/2,20,-7,-1,
(1+3*ER(-3))/2,70,2,2,-1,-20,7,1,-2,-70,-2,-2,20,-7,-1,2],[70,-20,7,2,1,-2,
-2+3*ER(-3),0,-2-3*ER(-3),-1,-2,0,(-1-3*ER(-3))/2,(-1+3*ER(-3))/2,0,-1,-1,0,
E(3)^2,1,-E(3),1,-E(3)^2,1,0,E(3),-11,0,1,2,0,-11,0,0,-2+3*ER(-3),E(3),
-2-3*ER(-3),E(3)^2,0,4,0,4,ER(-3),-ER(-3),(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,0,
2,0,-1,2,-1,-1,0,0,0,-4,-1,0,-2,-2,0,-1,2,1,-ER(-3),0,0,0,-1,0,ER(-3),-2,0,
(1-3*ER(-3))/2,-1,1,2+3*ER(-3),(1-3*ER(-3))/2,-1,0,-E(3)^2,E(3),0,0,0,-70,
(1+3*ER(-3))/2,-2,-2,2,0,2,1,1,1,-E(3)^2,11,11,-4,2-3*ER(-3),2+3*ER(-3),0,-2,
(1+3*ER(-3))/2,1,20,2,2-3*ER(-3),-7,-E(3),-1,-2-3*ER(-3),1,-E(3),0,1,0,0,0,70,
2,2,-2,0,-1,E(3)^2,-ER(-3),-11,-2+3*ER(-3),4,(-1-3*ER(-3))/2,-20,7,1,
2+3*ER(-3),(-1+3*ER(-3))/2,0,0,-70,-2,-2,2,1,ER(-3),11,2-3*ER(-3),-4,
(1+3*ER(-3))/2,20,-7,-1,(1-3*ER(-3))/2,70,2,2,-1,-20,7,1,-2,-70,-2,-2,20,-7,
-1,2],[70,20,7,2,-1,2,2-3*ER(-3),0,2+3*ER(-3),-1,-2,0,(-1-3*ER(-3))/2,
(-1+3*ER(-3))/2,0,-1,-1,0,-E(3)^2,-1,E(3),-1,E(3)^2,-1,0,-E(3),-11,0,1,2,0,
-11,0,0,2-3*ER(-3),-E(3),2+3*ER(-3),-E(3)^2,0,-4,0,-4,-ER(-3),ER(-3),
(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,0,2,0,-1,2,-1,-1,0,0,0,4,-1,0,-2,-2,0,-1,2,
1,ER(-3),0,0,0,1,0,-ER(-3),-2,0,(1-3*ER(-3))/2,1,1,-2-3*ER(-3),(1-3*ER(-3))/2,
-1,0,E(3)^2,-E(3),0,0,0,-70,(1+3*ER(-3))/2,-2,-2,-2,0,2,1,1,1,E(3)^2,11,11,4,
-2+3*ER(-3),-2-3*ER(-3),0,-2,(1+3*ER(-3))/2,1,-20,2,-2+3*ER(-3),-7,E(3),1,
2+3*ER(-3),1,E(3),0,1,0,0,0,70,2,2,2,0,-1,-E(3)^2,ER(-3),-11,2-3*ER(-3),-4,
(-1-3*ER(-3))/2,20,7,-1,-2-3*ER(-3),(-1+3*ER(-3))/2,0,0,-70,-2,-2,-2,1,
-ER(-3),11,-2+3*ER(-3),4,(1+3*ER(-3))/2,-20,-7,1,(1-3*ER(-3))/2,70,2,2,1,20,7,
-1,2,-70,-2,-2,-20,-7,1,-2],[70,20,7,2,-1,2,2+3*ER(-3),0,2-3*ER(-3),-1,-2,0,
(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,-1,-1,0,-E(3),-1,E(3)^2,-1,E(3),-1,0,
-E(3)^2,-11,0,1,2,0,-11,0,0,2+3*ER(-3),-E(3)^2,2-3*ER(-3),-E(3),0,-4,0,-4,
ER(-3),-ER(-3),(-1-3*ER(-3))/2,(-1+3*ER(-3))/2,0,0,2,0,-1,2,-1,-1,0,0,0,4,-1,
0,-2,-2,0,-1,2,1,-ER(-3),0,0,0,1,0,ER(-3),-2,0,(1+3*ER(-3))/2,1,1,-2+3*ER(-3),
(1+3*ER(-3))/2,-1,0,E(3),-E(3)^2,0,0,0,-70,(1-3*ER(-3))/2,-2,-2,-2,0,2,1,1,1,
E(3),11,11,4,-2-3*ER(-3),-2+3*ER(-3),0,-2,(1-3*ER(-3))/2,1,-20,2,-2-3*ER(-3),
-7,E(3)^2,1,2-3*ER(-3),1,E(3)^2,0,1,0,0,0,70,2,2,2,0,-1,-E(3),-ER(-3),-11,
2+3*ER(-3),-4,(-1+3*ER(-3))/2,20,7,-1,-2+3*ER(-3),(-1-3*ER(-3))/2,0,0,-70,-2,
-2,-2,1,ER(-3),11,-2-3*ER(-3),4,(1-3*ER(-3))/2,-20,-7,1,(1+3*ER(-3))/2,70,2,2,
1,20,7,-1,2,-70,-2,-2,-20,-7,1,-2],[84,16,6,-4,-2,0,(11+7*ER(-3))/2,0,
(11-7*ER(-3))/2,-E(3),0,-1,ER(-3),-ER(-3),0,-E(3)^2,2,1,1,0,-1,0,-1,0,0,1,
-15*E(3),0,-2,2,0,-15*E(3)^2,0,-1,(5-9*ER(-3))/2,E(3)^2,(5+9*ER(-3))/2,E(3),0,
-2*E(3),0,-2*E(3)^2,(3+ER(-3))/2,(3-ER(-3))/2,(3+ER(-3))/2,(3-ER(-3))/2,
E(3)^2,E(3),2*E(3)^2,0,E(3),2*E(3),E(3)^2,0,0,-E(3),-E(3)^2,2,2*E(3)^2,0,
-2*E(3),-2*E(3)^2,0,2*E(3),4,-1,ER(-3),E(3)^2,0,E(3),0,0,-ER(-3),0,0,
(3-ER(-3))/2,0,0,(-5-9*ER(-3))/2,(-3-ER(-3))/2,1,0,-E(3)^2,E(3),0,-E(3)^2,0,
-84*E(3),(3+ER(-3))/2,4*E(3),-4*E(3),0,0,0,E(3)^2,1,-2*E(3),-E(3),15*E(3)^2,
15,2*E(3)^2,(-11-7*ER(-3))/2,8+ER(-3),0,-2,-ER(-3),-2*E(3)^2,-16*E(3),0,
8-ER(-3),-6*E(3),-E(3),2*E(3),-8-ER(-3),-E(3),-E(3)^2,1,-E(3)^2,0,0,0,
84*E(3)^2,4*E(3)^2,-4*E(3)^2,0,0,-1,E(3)^2,(-3-ER(-3))/2,-15,-8+ER(-3),-2,
(-3-ER(-3))/2,16*E(3)^2,6*E(3)^2,-2*E(3)^2,(-11+7*ER(-3))/2,(-3+ER(-3))/2,
-E(3),0,-84,4,-4,0,E(3),(-3+ER(-3))/2,15*E(3),(-5+9*ER(-3))/2,2*E(3),
(-3+ER(-3))/2,-16,-6,2,ER(-3),84*E(3),4*E(3),-4*E(3),0,16*E(3),6*E(3),-2*E(3),
0,-84*E(3)^2,-4*E(3)^2,4*E(3)^2,-16*E(3)^2,-6*E(3)^2,2*E(3)^2,0],[84,-16,6,-4,
2,0,(-11+7*ER(-3))/2,0,(-11-7*ER(-3))/2,-E(3)^2,0,-1,-ER(-3),ER(-3),0,-E(3),2,
-1,-1,0,1,0,1,0,0,-1,-15*E(3)^2,0,-2,2,0,-15*E(3),0,1,(-5-9*ER(-3))/2,-E(3),
(-5+9*ER(-3))/2,-E(3)^2,0,2*E(3)^2,0,2*E(3),(-3+ER(-3))/2,(-3-ER(-3))/2,
(3-ER(-3))/2,(3+ER(-3))/2,E(3),E(3)^2,2*E(3),0,E(3)^2,2*E(3)^2,E(3),0,0,
E(3)^2,E(3),-2,2*E(3),0,-2*E(3)^2,-2*E(3),0,2*E(3)^2,4,-1,ER(-3),-E(3),0,
-E(3)^2,0,0,-ER(-3),0,0,(3+ER(-3))/2,0,0,(5-9*ER(-3))/2,(-3+ER(-3))/2,1,0,
E(3),-E(3)^2,0,-E(3),0,-84*E(3)^2,(3-ER(-3))/2,4*E(3)^2,-4*E(3)^2,0,0,0,E(3),
1,-2*E(3)^2,E(3)^2,15*E(3),15,-2*E(3),(11-7*ER(-3))/2,-8+ER(-3),0,-2,ER(-3),
-2*E(3),16*E(3)^2,0,-8-ER(-3),-6*E(3)^2,E(3)^2,-2*E(3)^2,8-ER(-3),-E(3)^2,
E(3),1,-E(3),0,0,0,84*E(3),4*E(3),-4*E(3),0,0,-1,-E(3),(3-ER(-3))/2,-15,
8+ER(-3),2,(-3+ER(-3))/2,-16*E(3),6*E(3),2*E(3),(11+7*ER(-3))/2,(-3-ER(-3))/2,
-E(3)^2,0,-84,4,-4,0,E(3)^2,(3+ER(-3))/2,15*E(3)^2,(5+9*ER(-3))/2,-2*E(3)^2,
(-3-ER(-3))/2,16,-6,-2,-ER(-3),84*E(3)^2,4*E(3)^2,-4*E(3)^2,0,-16*E(3)^2,
6*E(3)^2,2*E(3)^2,0,-84*E(3),-4*E(3),4*E(3),16*E(3),-6*E(3),-2*E(3),0],[84,16,
6,-4,-2,0,(11-7*ER(-3))/2,0,(11+7*ER(-3))/2,-E(3)^2,0,-1,-ER(-3),ER(-3),0,
-E(3),2,1,1,0,-1,0,-1,0,0,1,-15*E(3)^2,0,-2,2,0,-15*E(3),0,-1,(5+9*ER(-3))/2,
E(3),(5-9*ER(-3))/2,E(3)^2,0,-2*E(3)^2,0,-2*E(3),(3-ER(-3))/2,(3+ER(-3))/2,
(3-ER(-3))/2,(3+ER(-3))/2,E(3),E(3)^2,2*E(3),0,E(3)^2,2*E(3)^2,E(3),0,0,
-E(3)^2,-E(3),2,2*E(3),0,-2*E(3)^2,-2*E(3),0,2*E(3)^2,4,-1,-ER(-3),E(3),0,
E(3)^2,0,0,ER(-3),0,0,(3+ER(-3))/2,0,0,(-5+9*ER(-3))/2,(-3+ER(-3))/2,1,0,
-E(3),E(3)^2,0,-E(3),0,-84*E(3)^2,(3-ER(-3))/2,4*E(3)^2,-4*E(3)^2,0,0,0,E(3),
1,-2*E(3)^2,-E(3)^2,15*E(3),15,2*E(3),(-11+7*ER(-3))/2,8-ER(-3),0,-2,ER(-3),
-2*E(3),-16*E(3)^2,0,8+ER(-3),-6*E(3)^2,-E(3)^2,2*E(3)^2,-8+ER(-3),-E(3)^2,
-E(3),1,-E(3),0,0,0,84*E(3),4*E(3),-4*E(3),0,0,-1,E(3),(-3+ER(-3))/2,-15,
-8-ER(-3),-2,(-3+ER(-3))/2,16*E(3),6*E(3),-2*E(3),(-11-7*ER(-3))/2,
(-3-ER(-3))/2,-E(3)^2,0,-84,4,-4,0,E(3)^2,(-3-ER(-3))/2,15*E(3)^2,
(-5-9*ER(-3))/2,2*E(3)^2,(-3-ER(-3))/2,-16,-6,2,-ER(-3),84*E(3)^2,4*E(3)^2,
-4*E(3)^2,0,16*E(3)^2,6*E(3)^2,-2*E(3)^2,0,-84*E(3),-4*E(3),4*E(3),-16*E(3),
-6*E(3),2*E(3),0],[84,-16,6,-4,2,0,(-11-7*ER(-3))/2,0,(-11+7*ER(-3))/2,-E(3),
0,-1,ER(-3),-ER(-3),0,-E(3)^2,2,-1,-1,0,1,0,1,0,0,-1,-15*E(3),0,-2,2,0,
-15*E(3)^2,0,1,(-5+9*ER(-3))/2,-E(3)^2,(-5-9*ER(-3))/2,-E(3),0,2*E(3),0,
2*E(3)^2,(-3-ER(-3))/2,(-3+ER(-3))/2,(3+ER(-3))/2,(3-ER(-3))/2,E(3)^2,E(3),
2*E(3)^2,0,E(3),2*E(3),E(3)^2,0,0,E(3),E(3)^2,-2,2*E(3)^2,0,-2*E(3),-2*E(3)^2,
0,2*E(3),4,-1,-ER(-3),-E(3)^2,0,-E(3),0,0,ER(-3),0,0,(3-ER(-3))/2,0,0,
(5+9*ER(-3))/2,(-3-ER(-3))/2,1,0,E(3)^2,-E(3),0,-E(3)^2,0,-84*E(3),
(3+ER(-3))/2,4*E(3),-4*E(3),0,0,0,E(3)^2,1,-2*E(3),E(3),15*E(3)^2,15,
-2*E(3)^2,(11+7*ER(-3))/2,-8-ER(-3),0,-2,-ER(-3),-2*E(3)^2,16*E(3),0,
-8+ER(-3),-6*E(3),E(3),-2*E(3),8+ER(-3),-E(3),E(3)^2,1,-E(3)^2,0,0,0,
84*E(3)^2,4*E(3)^2,-4*E(3)^2,0,0,-1,-E(3)^2,(3+ER(-3))/2,-15,8-ER(-3),2,
(-3-ER(-3))/2,-16*E(3)^2,6*E(3)^2,2*E(3)^2,(11-7*ER(-3))/2,(-3+ER(-3))/2,
-E(3),0,-84,4,-4,0,E(3),(3-ER(-3))/2,15*E(3),(5-9*ER(-3))/2,-2*E(3),
(-3+ER(-3))/2,16,-6,-2,ER(-3),84*E(3),4*E(3),-4*E(3),0,-16*E(3),6*E(3),2*E(3),
0,-84*E(3)^2,-4*E(3)^2,4*E(3)^2,16*E(3)^2,-6*E(3)^2,-2*E(3)^2,0],[90,30,9,10,
3,2,3,6,3,1,0,0,0,0,2,1,1,0,0,-1,0,-1,0,-1,0,0,9,-1,1,1,-1,9,0,0,3,0,3,0,3,3,
0,3,-1,-1,0,0,0,0,1,0,1,1,1,0,0,0,0,3,1,-1,1,1,-1,1,-2,1,-1,0,0,0,-1,0,-1,9,
-1,0,-1,0,3,0,1,2,0,0,0,0,2,90,0,10,-2,2,6,0,1,1,1,0,9,9,3,3,3,3,1,0,1,30,9,3,
9,0,3,3,1,0,0,1,-1,2,2,90,-2,10,2,6,1,0,-1,9,3,3,0,30,9,3,3,0,0,2,90,10,-2,2,
1,-1,9,3,3,0,30,9,3,0,90,-2,10,-1,30,9,3,2,90,-2,10,30,9,3,2],[90,-30,9,10,-3,
-2,-3,-6,-3,1,0,0,0,0,2,1,1,0,0,1,0,1,0,1,0,0,9,-1,1,1,-1,9,0,0,-3,0,-3,0,-3,
-3,0,-3,1,1,0,0,0,0,1,0,1,1,1,0,0,0,0,-3,1,-1,1,1,-1,1,-2,1,1,0,0,0,1,0,1,9,
-1,0,1,0,-3,0,1,2,0,0,0,0,-2,90,0,10,-2,-2,-6,0,1,1,1,0,9,9,-3,-3,-3,-3,1,0,1,
-30,9,-3,9,0,-3,-3,1,0,0,1,-1,2,-2,90,-2,10,-2,-6,1,0,1,9,-3,-3,0,-30,9,-3,-3,
0,0,-2,90,10,-2,-2,1,1,9,-3,-3,0,-30,9,-3,0,90,-2,10,1,-30,9,-3,-2,90,-2,10,
-30,9,-3,-2],[105,25,3,9,1,1,(-7-ER(-3))/2,9,(-7+ER(-3))/2,3*E(3)^2,0,0,
(-3-ER(-3))/2,(-3+ER(-3))/2,1,3*E(3),3,0,E(3)^2,E(3),E(3),E(3)^2,E(3)^2,1,0,
E(3),15*E(3)^2,0,3,0,0,15*E(3),1,0,(5-3*ER(-3))/2,E(3)^2,(5+3*ER(-3))/2,E(3),
0,4*E(3)^2,0,4*E(3),E(3)^2,E(3),(3+ER(-3))/2,(3-ER(-3))/2,0,0,0,E(3)^2,E(3)^2,
0,E(3),0,E(3),0,0,4,3*E(3),0,0,0,0,3*E(3)^2,1,1,1,0,E(3),0,1,E(3)^2,1,0,0,
-ER(-3),E(3),0,(5+3*ER(-3))/2,(3+ER(-3))/2,1,E(3),1,1,1,0,E(3),105*E(3)^2,
ER(-3),9*E(3)^2,E(3)^2,E(3)^2,9*E(3)^2,0,3*E(3),3,3*E(3)^2,E(3),15*E(3),15,
4*E(3),(-7-ER(-3))/2,1-2*ER(-3),0,0,(-3-ER(-3))/2,3*E(3),25*E(3)^2,0,
1+2*ER(-3),3*E(3)^2,1,E(3)^2,1-2*ER(-3),E(3)^2,E(3)^2,0,E(3),0,E(3)^2,1,
105*E(3),E(3),9*E(3),E(3),9*E(3),3,1,E(3)^2,15,1+2*ER(-3),4,ER(-3),25*E(3),
3*E(3),E(3),(-7+ER(-3))/2,-ER(-3),0,E(3)^2,105,9,1,1,3*E(3)^2,E(3),15*E(3)^2,
(5-3*ER(-3))/2,4*E(3)^2,(3-ER(-3))/2,25,3,1,(-3+ER(-3))/2,105*E(3)^2,E(3)^2,
9*E(3)^2,E(3)^2,25*E(3)^2,3*E(3)^2,E(3)^2,E(3)^2,105*E(3),E(3),9*E(3),25*E(3),
3*E(3),E(3),E(3)],[105,-35,12,9,-2,-3,-5+ER(-3),-3,-5-ER(-3),0,0,0,
(3-ER(-3))/2,(3+ER(-3))/2,1,0,0,0,E(3),0,E(3)^2,0,E(3),0,0,E(3)^2,-12*E(3)^2,
0,0,0,0,-12*E(3),1,0,1-3*ER(-3),1,1+3*ER(-3),1,0,4*E(3)^2,0,4*E(3),0,0,
-ER(-3),ER(-3),0,0,0,E(3)^2,-2*E(3)^2,0,-2*E(3),0,E(3),0,0,4,0,0,0,0,0,0,1,-2,
0,0,E(3),0,0,E(3)^2,0,0,0,(-3+ER(-3))/2,0,0,1+3*ER(-3),-ER(-3),-2,E(3),E(3)^2,
E(3),1,0,-3*E(3),105*E(3)^2,(-3-ER(-3))/2,9*E(3)^2,E(3)^2,-3*E(3)^2,-3*E(3)^2,
0,0,0,0,1,-12*E(3),-12,4*E(3),-5+ER(-3),4-2*ER(-3),0,0,(3-ER(-3))/2,0,
-35*E(3)^2,0,4+2*ER(-3),12*E(3)^2,E(3),-2*E(3)^2,4-2*ER(-3),-2*E(3)^2,1,0,
-2*E(3),0,E(3)^2,-3,105*E(3),E(3),9*E(3),-3*E(3),-3*E(3),0,E(3)^2,0,-12,
4+2*ER(-3),4,(-3-ER(-3))/2,-35*E(3),12*E(3),-2*E(3),-5-ER(-3),(-3+ER(-3))/2,0,
-3*E(3)^2,105,9,1,-3,0,0,-12*E(3)^2,1-3*ER(-3),4*E(3)^2,ER(-3),-35,12,-2,
(3+ER(-3))/2,105*E(3)^2,E(3)^2,9*E(3)^2,0,-35*E(3)^2,12*E(3)^2,-2*E(3)^2,
-3*E(3)^2,105*E(3),E(3),9*E(3),-35*E(3),12*E(3),-2*E(3),-3*E(3)],[105,-25,3,9,
-1,-1,(7+ER(-3))/2,-9,(7-ER(-3))/2,3*E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,1,
3*E(3),3,0,-E(3)^2,-E(3),-E(3),-E(3)^2,-E(3)^2,-1,0,-E(3),15*E(3)^2,0,3,0,0,
15*E(3),-1,0,(-5+3*ER(-3))/2,-E(3)^2,(-5-3*ER(-3))/2,-E(3),0,-4*E(3)^2,0,
-4*E(3),-E(3)^2,-E(3),(3+ER(-3))/2,(3-ER(-3))/2,0,0,0,E(3)^2,E(3)^2,0,E(3),0,
E(3),0,0,-4,3*E(3),0,0,0,0,3*E(3)^2,1,1,-1,0,-E(3),0,-1,-E(3)^2,-1,0,0,
-ER(-3),-E(3),0,(-5-3*ER(-3))/2,(3+ER(-3))/2,1,E(3),-1,-1,1,0,-E(3),
105*E(3)^2,ER(-3),9*E(3)^2,E(3)^2,-E(3)^2,-9*E(3)^2,0,3*E(3),3,3*E(3)^2,-E(3),
15*E(3),15,-4*E(3),(7+ER(-3))/2,-1+2*ER(-3),0,0,(-3-ER(-3))/2,3*E(3),
-25*E(3)^2,0,-1-2*ER(-3),3*E(3)^2,-1,-E(3)^2,-1+2*ER(-3),E(3)^2,-E(3)^2,0,
E(3),0,E(3)^2,-1,105*E(3),E(3),9*E(3),-E(3),-9*E(3),3,-1,-E(3)^2,15,
-1-2*ER(-3),-4,ER(-3),-25*E(3),3*E(3),-E(3),(7-ER(-3))/2,-ER(-3),0,-E(3)^2,
105,9,1,-1,3*E(3)^2,-E(3),15*E(3)^2,(-5+3*ER(-3))/2,-4*E(3)^2,(3-ER(-3))/2,
-25,3,-1,(-3+ER(-3))/2,105*E(3)^2,E(3)^2,9*E(3)^2,-E(3)^2,-25*E(3)^2,3*E(3)^2,
-E(3)^2,-E(3)^2,105*E(3),E(3),9*E(3),-25*E(3),3*E(3),-E(3),-E(3)],[105,35,12,
9,2,3,5-ER(-3),3,5+ER(-3),0,0,0,(3-ER(-3))/2,(3+ER(-3))/2,1,0,0,0,-E(3),0,
-E(3)^2,0,-E(3),0,0,-E(3)^2,-12*E(3)^2,0,0,0,0,-12*E(3),-1,0,-1+3*ER(-3),-1,
-1-3*ER(-3),-1,0,-4*E(3)^2,0,-4*E(3),0,0,-ER(-3),ER(-3),0,0,0,E(3)^2,
-2*E(3)^2,0,-2*E(3),0,E(3),0,0,-4,0,0,0,0,0,0,1,-2,0,0,-E(3),0,0,-E(3)^2,0,0,
0,(-3+ER(-3))/2,0,0,-1-3*ER(-3),-ER(-3),-2,E(3),-E(3)^2,-E(3),1,0,3*E(3),
105*E(3)^2,(-3-ER(-3))/2,9*E(3)^2,E(3)^2,3*E(3)^2,3*E(3)^2,0,0,0,0,-1,
-12*E(3),-12,-4*E(3),5-ER(-3),-4+2*ER(-3),0,0,(3-ER(-3))/2,0,35*E(3)^2,0,
-4-2*ER(-3),12*E(3)^2,-E(3),2*E(3)^2,-4+2*ER(-3),-2*E(3)^2,-1,0,-2*E(3),0,
E(3)^2,3,105*E(3),E(3),9*E(3),3*E(3),3*E(3),0,-E(3)^2,0,-12,-4-2*ER(-3),-4,
(-3-ER(-3))/2,35*E(3),12*E(3),2*E(3),5+ER(-3),(-3+ER(-3))/2,0,3*E(3)^2,105,9,
1,3,0,0,-12*E(3)^2,-1+3*ER(-3),-4*E(3)^2,ER(-3),35,12,2,(3+ER(-3))/2,
105*E(3)^2,E(3)^2,9*E(3)^2,0,35*E(3)^2,12*E(3)^2,2*E(3)^2,3*E(3)^2,105*E(3),
E(3),9*E(3),35*E(3),12*E(3),2*E(3),3*E(3)],[105,-35,12,9,-2,-3,-5-ER(-3),-3,
-5+ER(-3),0,0,0,(3+ER(-3))/2,(3-ER(-3))/2,1,0,0,0,E(3)^2,0,E(3),0,E(3)^2,0,0,
E(3),-12*E(3),0,0,0,0,-12*E(3)^2,1,0,1+3*ER(-3),1,1-3*ER(-3),1,0,4*E(3),0,
4*E(3)^2,0,0,ER(-3),-ER(-3),0,0,0,E(3),-2*E(3),0,-2*E(3)^2,0,E(3)^2,0,0,4,0,0,
0,0,0,0,1,-2,0,0,E(3)^2,0,0,E(3),0,0,0,(-3-ER(-3))/2,0,0,1-3*ER(-3),ER(-3),-2,
E(3)^2,E(3),E(3)^2,1,0,-3*E(3)^2,105*E(3),(-3+ER(-3))/2,9*E(3),E(3),-3*E(3),
-3*E(3),0,0,0,0,1,-12*E(3)^2,-12,4*E(3)^2,-5-ER(-3),4+2*ER(-3),0,0,
(3+ER(-3))/2,0,-35*E(3),0,4-2*ER(-3),12*E(3),E(3)^2,-2*E(3),4+2*ER(-3),
-2*E(3),1,0,-2*E(3)^2,0,E(3),-3,105*E(3)^2,E(3)^2,9*E(3)^2,-3*E(3)^2,
-3*E(3)^2,0,E(3),0,-12,4-2*ER(-3),4,(-3+ER(-3))/2,-35*E(3)^2,12*E(3)^2,
-2*E(3)^2,-5+ER(-3),(-3-ER(-3))/2,0,-3*E(3),105,9,1,-3,0,0,-12*E(3),
1+3*ER(-3),4*E(3),-ER(-3),-35,12,-2,(3-ER(-3))/2,105*E(3),E(3),9*E(3),0,
-35*E(3),12*E(3),-2*E(3),-3*E(3),105*E(3)^2,E(3)^2,9*E(3)^2,-35*E(3)^2,
12*E(3)^2,-2*E(3)^2,-3*E(3)^2],[105,-25,3,9,-1,-1,(7-ER(-3))/2,-9,
(7+ER(-3))/2,3*E(3),0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,1,3*E(3)^2,3,0,-E(3),
-E(3)^2,-E(3)^2,-E(3),-E(3),-1,0,-E(3)^2,15*E(3),0,3,0,0,15*E(3)^2,-1,0,
(-5-3*ER(-3))/2,-E(3),(-5+3*ER(-3))/2,-E(3)^2,0,-4*E(3),0,-4*E(3)^2,-E(3),
-E(3)^2,(3-ER(-3))/2,(3+ER(-3))/2,0,0,0,E(3),E(3),0,E(3)^2,0,E(3)^2,0,0,-4,
3*E(3)^2,0,0,0,0,3*E(3),1,1,-1,0,-E(3)^2,0,-1,-E(3),-1,0,0,ER(-3),-E(3)^2,0,
(-5+3*ER(-3))/2,(3-ER(-3))/2,1,E(3)^2,-1,-1,1,0,-E(3)^2,105*E(3),-ER(-3),
9*E(3),E(3),-E(3),-9*E(3),0,3*E(3)^2,3,3*E(3),-E(3)^2,15*E(3)^2,15,-4*E(3)^2,
(7-ER(-3))/2,-1-2*ER(-3),0,0,(-3+ER(-3))/2,3*E(3)^2,-25*E(3),0,-1+2*ER(-3),
3*E(3),-1,-E(3),-1-2*ER(-3),E(3),-E(3),0,E(3)^2,0,E(3),-1,105*E(3)^2,E(3)^2,
9*E(3)^2,-E(3)^2,-9*E(3)^2,3,-1,-E(3),15,-1+2*ER(-3),-4,-ER(-3),-25*E(3)^2,
3*E(3)^2,-E(3)^2,(7+ER(-3))/2,ER(-3),0,-E(3),105,9,1,-1,3*E(3),-E(3)^2,
15*E(3),(-5-3*ER(-3))/2,-4*E(3),(3+ER(-3))/2,-25,3,-1,(-3-ER(-3))/2,105*E(3),
E(3),9*E(3),-E(3),-25*E(3),3*E(3),-E(3),-E(3),105*E(3)^2,E(3)^2,9*E(3)^2,
-25*E(3)^2,3*E(3)^2,-E(3)^2,-E(3)^2],[105,25,3,9,1,1,(-7+ER(-3))/2,9,
(-7-ER(-3))/2,3*E(3),0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,1,3*E(3)^2,3,0,E(3),
E(3)^2,E(3)^2,E(3),E(3),1,0,E(3)^2,15*E(3),0,3,0,0,15*E(3)^2,1,0,
(5+3*ER(-3))/2,E(3),(5-3*ER(-3))/2,E(3)^2,0,4*E(3),0,4*E(3)^2,E(3),E(3)^2,
(3-ER(-3))/2,(3+ER(-3))/2,0,0,0,E(3),E(3),0,E(3)^2,0,E(3)^2,0,0,4,3*E(3)^2,0,
0,0,0,3*E(3),1,1,1,0,E(3)^2,0,1,E(3),1,0,0,ER(-3),E(3)^2,0,(5-3*ER(-3))/2,
(3-ER(-3))/2,1,E(3)^2,1,1,1,0,E(3)^2,105*E(3),-ER(-3),9*E(3),E(3),E(3),9*E(3),
0,3*E(3)^2,3,3*E(3),E(3)^2,15*E(3)^2,15,4*E(3)^2,(-7+ER(-3))/2,1+2*ER(-3),0,0,
(-3+ER(-3))/2,3*E(3)^2,25*E(3),0,1-2*ER(-3),3*E(3),1,E(3),1+2*ER(-3),E(3),
E(3),0,E(3)^2,0,E(3),1,105*E(3)^2,E(3)^2,9*E(3)^2,E(3)^2,9*E(3)^2,3,1,E(3),15,
1-2*ER(-3),4,-ER(-3),25*E(3)^2,3*E(3)^2,E(3)^2,(-7-ER(-3))/2,ER(-3),0,E(3),
105,9,1,1,3*E(3),E(3)^2,15*E(3),(5+3*ER(-3))/2,4*E(3),(3+ER(-3))/2,25,3,1,
(-3-ER(-3))/2,105*E(3),E(3),9*E(3),E(3),25*E(3),3*E(3),E(3),E(3),105*E(3)^2,
E(3)^2,9*E(3)^2,25*E(3)^2,3*E(3)^2,E(3)^2,E(3)^2],[105,35,12,9,2,3,5+ER(-3),3,
5-ER(-3),0,0,0,(3+ER(-3))/2,(3-ER(-3))/2,1,0,0,0,-E(3)^2,0,-E(3),0,-E(3)^2,0,
0,-E(3),-12*E(3),0,0,0,0,-12*E(3)^2,-1,0,-1-3*ER(-3),-1,-1+3*ER(-3),-1,0,
-4*E(3),0,-4*E(3)^2,0,0,ER(-3),-ER(-3),0,0,0,E(3),-2*E(3),0,-2*E(3)^2,0,
E(3)^2,0,0,-4,0,0,0,0,0,0,1,-2,0,0,-E(3)^2,0,0,-E(3),0,0,0,(-3-ER(-3))/2,0,0,
-1+3*ER(-3),ER(-3),-2,E(3)^2,-E(3),-E(3)^2,1,0,3*E(3)^2,105*E(3),
(-3+ER(-3))/2,9*E(3),E(3),3*E(3),3*E(3),0,0,0,0,-1,-12*E(3)^2,-12,-4*E(3)^2,
5+ER(-3),-4-2*ER(-3),0,0,(3+ER(-3))/2,0,35*E(3),0,-4+2*ER(-3),12*E(3),-E(3)^2,
2*E(3),-4-2*ER(-3),-2*E(3),-1,0,-2*E(3)^2,0,E(3),3,105*E(3)^2,E(3)^2,9*E(3)^2,
3*E(3)^2,3*E(3)^2,0,-E(3),0,-12,-4+2*ER(-3),-4,(-3+ER(-3))/2,35*E(3)^2,
12*E(3)^2,2*E(3)^2,5-ER(-3),(-3-ER(-3))/2,0,3*E(3),105,9,1,3,0,0,-12*E(3),
-1-3*ER(-3),-4*E(3),-ER(-3),35,12,2,(3-ER(-3))/2,105*E(3),E(3),9*E(3),0,
35*E(3),12*E(3),2*E(3),3*E(3),105*E(3)^2,E(3)^2,9*E(3)^2,35*E(3)^2,12*E(3)^2,
2*E(3)^2,3*E(3)^2],[105,5,3,-7,-1,1,(-5-11*ER(-3))/2,-3,(-5+11*ER(-3))/2,
-E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,1,-E(3),-1,0,-E(3)^2,E(3),-E(3),
E(3)^2,-E(3)^2,1,0,-E(3),15*E(3)^2,0,-1,2,0,15*E(3),-1,0,(19+3*ER(-3))/2,
-E(3)^2,(19-3*ER(-3))/2,-E(3),0,2*E(3)^2,0,2*E(3),E(3)^2,E(3),(3+ER(-3))/2,
(3-ER(-3))/2,0,0,2*E(3),-E(3)^2,-E(3)^2,2*E(3)^2,-E(3),0,-E(3),0,0,2,-E(3),0,
2*E(3)^2,2*E(3),0,-E(3)^2,5,-1,1,0,-E(3),0,1,-E(3)^2,1,0,0,-ER(-3),E(3),0,
(19-3*ER(-3))/2,(3+ER(-3))/2,-1,E(3),-1,-1,-1,0,E(3),105*E(3)^2,ER(-3),
-7*E(3)^2,5*E(3)^2,E(3)^2,-3*E(3)^2,0,-E(3),-1,-E(3)^2,-E(3),15*E(3),15,
2*E(3),(-5-11*ER(-3))/2,-7-4*ER(-3),0,2,(-3-ER(-3))/2,-E(3),5*E(3)^2,0,
-7+4*ER(-3),3*E(3)^2,-1,-E(3)^2,-7-4*ER(-3),-E(3)^2,-E(3)^2,0,-E(3),0,E(3)^2,
1,105*E(3),5*E(3),-7*E(3),E(3),-3*E(3),-1,-1,E(3)^2,15,-7+4*ER(-3),2,ER(-3),
5*E(3),3*E(3),-E(3),(-5+11*ER(-3))/2,-ER(-3),0,E(3)^2,105,-7,5,1,-E(3)^2,E(3),
15*E(3)^2,(19+3*ER(-3))/2,2*E(3)^2,(3-ER(-3))/2,5,3,-1,(-3+ER(-3))/2,
105*E(3)^2,5*E(3)^2,-7*E(3)^2,E(3)^2,5*E(3)^2,3*E(3)^2,-E(3)^2,E(3)^2,
105*E(3),5*E(3),-7*E(3),5*E(3),3*E(3),-E(3),E(3)],[105,-5,3,-7,1,-1,
(5+11*ER(-3))/2,3,(5-11*ER(-3))/2,-E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,1,
-E(3),-1,0,E(3)^2,-E(3),E(3),-E(3)^2,E(3)^2,-1,0,E(3),15*E(3)^2,0,-1,2,0,
15*E(3),1,0,(-19-3*ER(-3))/2,E(3)^2,(-19+3*ER(-3))/2,E(3),0,-2*E(3)^2,0,
-2*E(3),-E(3)^2,-E(3),(3+ER(-3))/2,(3-ER(-3))/2,0,0,2*E(3),-E(3)^2,-E(3)^2,
2*E(3)^2,-E(3),0,-E(3),0,0,-2,-E(3),0,2*E(3)^2,2*E(3),0,-E(3)^2,5,-1,-1,0,
E(3),0,-1,E(3)^2,-1,0,0,-ER(-3),-E(3),0,(-19+3*ER(-3))/2,(3+ER(-3))/2,-1,E(3),
1,1,-1,0,-E(3),105*E(3)^2,ER(-3),-7*E(3)^2,5*E(3)^2,-E(3)^2,3*E(3)^2,0,-E(3),
-1,-E(3)^2,E(3),15*E(3),15,-2*E(3),(5+11*ER(-3))/2,7+4*ER(-3),0,2,
(-3-ER(-3))/2,-E(3),-5*E(3)^2,0,7-4*ER(-3),3*E(3)^2,1,E(3)^2,7+4*ER(-3),
-E(3)^2,E(3)^2,0,-E(3),0,E(3)^2,-1,105*E(3),5*E(3),-7*E(3),-E(3),3*E(3),-1,1,
-E(3)^2,15,7-4*ER(-3),-2,ER(-3),-5*E(3),3*E(3),E(3),(5-11*ER(-3))/2,-ER(-3),0,
-E(3)^2,105,-7,5,-1,-E(3)^2,-E(3),15*E(3)^2,(-19-3*ER(-3))/2,-2*E(3)^2,
(3-ER(-3))/2,-5,3,1,(-3+ER(-3))/2,105*E(3)^2,5*E(3)^2,-7*E(3)^2,-E(3)^2,
-5*E(3)^2,3*E(3)^2,E(3)^2,-E(3)^2,105*E(3),5*E(3),-7*E(3),-5*E(3),3*E(3),E(3),
-E(3)],[105,5,3,-7,-1,1,(-5+11*ER(-3))/2,-3,(-5-11*ER(-3))/2,-E(3),0,0,
(-3+ER(-3))/2,(-3-ER(-3))/2,1,-E(3)^2,-1,0,-E(3),E(3)^2,-E(3)^2,E(3),-E(3),1,
0,-E(3)^2,15*E(3),0,-1,2,0,15*E(3)^2,-1,0,(19-3*ER(-3))/2,-E(3),
(19+3*ER(-3))/2,-E(3)^2,0,2*E(3),0,2*E(3)^2,E(3),E(3)^2,(3-ER(-3))/2,
(3+ER(-3))/2,0,0,2*E(3)^2,-E(3),-E(3),2*E(3),-E(3)^2,0,-E(3)^2,0,0,2,-E(3)^2,
0,2*E(3),2*E(3)^2,0,-E(3),5,-1,1,0,-E(3)^2,0,1,-E(3),1,0,0,ER(-3),E(3)^2,0,
(19+3*ER(-3))/2,(3-ER(-3))/2,-1,E(3)^2,-1,-1,-1,0,E(3)^2,105*E(3),-ER(-3),
-7*E(3),5*E(3),E(3),-3*E(3),0,-E(3)^2,-1,-E(3),-E(3)^2,15*E(3)^2,15,2*E(3)^2,
(-5+11*ER(-3))/2,-7+4*ER(-3),0,2,(-3+ER(-3))/2,-E(3)^2,5*E(3),0,-7-4*ER(-3),
3*E(3),-1,-E(3),-7+4*ER(-3),-E(3),-E(3),0,-E(3)^2,0,E(3),1,105*E(3)^2,
5*E(3)^2,-7*E(3)^2,E(3)^2,-3*E(3)^2,-1,-1,E(3),15,-7-4*ER(-3),2,-ER(-3),
5*E(3)^2,3*E(3)^2,-E(3)^2,(-5-11*ER(-3))/2,ER(-3),0,E(3),105,-7,5,1,-E(3),
E(3)^2,15*E(3),(19-3*ER(-3))/2,2*E(3),(3+ER(-3))/2,5,3,-1,(-3-ER(-3))/2,
105*E(3),5*E(3),-7*E(3),E(3),5*E(3),3*E(3),-E(3),E(3),105*E(3)^2,5*E(3)^2,
-7*E(3)^2,5*E(3)^2,3*E(3)^2,-E(3)^2,E(3)^2],[105,-5,3,-7,1,-1,(5-11*ER(-3))/2,
3,(5+11*ER(-3))/2,-E(3),0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,1,-E(3)^2,-1,0,E(3),
-E(3)^2,E(3)^2,-E(3),E(3),-1,0,E(3)^2,15*E(3),0,-1,2,0,15*E(3)^2,1,0,
(-19+3*ER(-3))/2,E(3),(-19-3*ER(-3))/2,E(3)^2,0,-2*E(3),0,-2*E(3)^2,-E(3),
-E(3)^2,(3-ER(-3))/2,(3+ER(-3))/2,0,0,2*E(3)^2,-E(3),-E(3),2*E(3),-E(3)^2,0,
-E(3)^2,0,0,-2,-E(3)^2,0,2*E(3),2*E(3)^2,0,-E(3),5,-1,-1,0,E(3)^2,0,-1,E(3),
-1,0,0,ER(-3),-E(3)^2,0,(-19-3*ER(-3))/2,(3-ER(-3))/2,-1,E(3)^2,1,1,-1,0,
-E(3)^2,105*E(3),-ER(-3),-7*E(3),5*E(3),-E(3),3*E(3),0,-E(3)^2,-1,-E(3),
E(3)^2,15*E(3)^2,15,-2*E(3)^2,(5-11*ER(-3))/2,7-4*ER(-3),0,2,(-3+ER(-3))/2,
-E(3)^2,-5*E(3),0,7+4*ER(-3),3*E(3),1,E(3),7-4*ER(-3),-E(3),E(3),0,-E(3)^2,0,
E(3),-1,105*E(3)^2,5*E(3)^2,-7*E(3)^2,-E(3)^2,3*E(3)^2,-1,1,-E(3),15,
7+4*ER(-3),-2,-ER(-3),-5*E(3)^2,3*E(3)^2,E(3)^2,(5+11*ER(-3))/2,ER(-3),0,
-E(3),105,-7,5,-1,-E(3),-E(3)^2,15*E(3),(-19+3*ER(-3))/2,-2*E(3),(3+ER(-3))/2,
-5,3,1,(-3-ER(-3))/2,105*E(3),5*E(3),-7*E(3),-E(3),-5*E(3),3*E(3),E(3),-E(3),
105*E(3)^2,5*E(3)^2,-7*E(3)^2,-5*E(3)^2,3*E(3)^2,E(3)^2,-E(3)^2],[120,0,-6,8,
0,0,0,0,0,-4,3,0,0,0,0,-4,2,0,0,0,0,0,0,0,3,0,12,-1,-2,2,-1,12,0,0,0,0,0,0,0,
0,-3,0,0,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,2,1,-2,-2,1,2,0,0,0,0,0,0,0,0,0,-6,-1,
0,0,0,0,0,0,0,0,0,0,0,0,-120,0,-8,0,0,0,-3,4,4,-2,0,-12,-12,0,0,0,0,-2,0,-2,0,
6,0,6,0,0,0,0,0,0,0,1,0,0,120,0,8,0,0,-4,0,0,12,0,0,0,0,-6,0,0,0,0,0,-120,-8,
0,0,4,0,-12,0,0,0,0,6,0,0,120,0,8,0,0,-6,0,0,-120,0,-8,0,6,0,0],[120,0,-6,8,0,
0,0,0,0,-4,3,0,0,0,0,-4,2,0,0,0,0,0,0,0,-3,0,12,-1,-2,2,-1,12,0,0,0,0,0,0,0,0,
3,0,0,0,0,0,0,0,2,0,0,2,0,0,0,0,0,0,2,1,-2,-2,1,2,0,0,0,0,0,0,0,0,0,-6,-1,0,0,
0,0,0,0,0,0,0,0,0,0,-120,0,-8,0,0,0,-3,4,4,-2,0,-12,-12,0,0,0,0,-2,0,-2,0,6,0,
6,0,0,0,0,0,0,0,1,0,0,120,0,8,0,0,-4,0,0,12,0,0,0,0,-6,0,0,0,0,0,-120,-8,0,0,
4,0,-12,0,0,0,0,6,0,0,120,0,8,0,0,-6,0,0,-120,0,-8,0,6,0,0],[120,40,15,8,1,4,
7-ER(-3),0,7+ER(-3),2*E(3),0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,2*E(3)^2,-1,0,E(3),
E(3)^2,-E(3)^2,E(3),-E(3),1,0,E(3)^2,-6*E(3),-E(3),1,2,-E(3)^2,-6*E(3)^2,0,0,
-5-3*ER(-3),E(3),-5+3*ER(-3),E(3)^2,0,-2*E(3),0,-2*E(3)^2,0,0,(-3+ER(-3))/2,
(-3-ER(-3))/2,0,0,2*E(3)^2,0,0,2*E(3),0,0,0,0,0,2,-E(3)^2,E(3)^2,-2*E(3),
-2*E(3)^2,E(3),-E(3),0,0,0,0,0,0,-1,0,0,0,-1,ER(-3),-E(3)^2,0,5-3*ER(-3),
(3-ER(-3))/2,0,0,-1,1,0,0,0,-120*E(3),-ER(-3),-8*E(3),0,-4*E(3),0,0,-2*E(3)^2,
-2,E(3),-E(3)^2,6*E(3)^2,6,2*E(3)^2,-7+ER(-3),2+4*ER(-3),0,-2,(-3+ER(-3))/2,
E(3)^2,-40*E(3),0,2-4*ER(-3),-15*E(3),-1,-E(3),-2-4*ER(-3),0,-E(3),0,0,1,0,0,
120*E(3)^2,0,8*E(3)^2,4*E(3)^2,0,2,1,0,-6,-2+4*ER(-3),-2,ER(-3),40*E(3)^2,
15*E(3)^2,E(3)^2,-7-ER(-3),-ER(-3),0,0,-120,-8,0,-4,-2*E(3),0,6*E(3),
5+3*ER(-3),2*E(3),(3+ER(-3))/2,-40,-15,-1,(-3-ER(-3))/2,120*E(3),0,8*E(3),
-E(3),40*E(3),15*E(3),E(3),4*E(3),-120*E(3)^2,0,-8*E(3)^2,-40*E(3)^2,
-15*E(3)^2,-E(3)^2,-4*E(3)^2],[120,-40,15,8,-1,-4,-7+ER(-3),0,-7-ER(-3),
2*E(3),0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,2*E(3)^2,-1,0,-E(3),-E(3)^2,E(3)^2,
-E(3),E(3),-1,0,-E(3)^2,-6*E(3),-E(3),1,2,-E(3)^2,-6*E(3)^2,0,0,5+3*ER(-3),
-E(3),5-3*ER(-3),-E(3)^2,0,2*E(3),0,2*E(3)^2,0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,
0,0,2*E(3)^2,0,0,2*E(3),0,0,0,0,0,-2,-E(3)^2,E(3)^2,-2*E(3),-2*E(3)^2,E(3),
-E(3),0,0,0,0,0,0,1,0,0,0,-1,ER(-3),E(3)^2,0,-5+3*ER(-3),(3-ER(-3))/2,0,0,1,
-1,0,0,0,-120*E(3),-ER(-3),-8*E(3),0,4*E(3),0,0,-2*E(3)^2,-2,E(3),E(3)^2,
6*E(3)^2,6,-2*E(3)^2,7-ER(-3),-2-4*ER(-3),0,-2,(-3+ER(-3))/2,E(3)^2,40*E(3),0,
-2+4*ER(-3),-15*E(3),1,E(3),2+4*ER(-3),0,E(3),0,0,1,0,0,120*E(3)^2,0,8*E(3)^2,
-4*E(3)^2,0,2,-1,0,-6,2-4*ER(-3),2,ER(-3),-40*E(3)^2,15*E(3)^2,-E(3)^2,
7+ER(-3),-ER(-3),0,0,-120,-8,0,4,-2*E(3),0,6*E(3),-5-3*ER(-3),-2*E(3),
(3+ER(-3))/2,40,-15,1,(-3-ER(-3))/2,120*E(3),0,8*E(3),E(3),-40*E(3),15*E(3),
-E(3),-4*E(3),-120*E(3)^2,0,-8*E(3)^2,40*E(3)^2,-15*E(3)^2,E(3)^2,4*E(3)^2],
[120,40,15,8,1,4,7+ER(-3),0,7-ER(-3),2*E(3)^2,0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,
2*E(3),-1,0,E(3)^2,E(3),-E(3),E(3)^2,-E(3)^2,1,0,E(3),-6*E(3)^2,-E(3)^2,1,2,
-E(3),-6*E(3),0,0,-5+3*ER(-3),E(3)^2,-5-3*ER(-3),E(3),0,-2*E(3)^2,0,-2*E(3),0,
0,(-3-ER(-3))/2,(-3+ER(-3))/2,0,0,2*E(3),0,0,2*E(3)^2,0,0,0,0,0,2,-E(3),E(3),
-2*E(3)^2,-2*E(3),E(3)^2,-E(3)^2,0,0,0,0,0,0,-1,0,0,0,-1,-ER(-3),-E(3),0,
5+3*ER(-3),(3+ER(-3))/2,0,0,-1,1,0,0,0,-120*E(3)^2,ER(-3),-8*E(3)^2,0,
-4*E(3)^2,0,0,-2*E(3),-2,E(3)^2,-E(3),6*E(3),6,2*E(3),-7-ER(-3),2-4*ER(-3),0,
-2,(-3-ER(-3))/2,E(3),-40*E(3)^2,0,2+4*ER(-3),-15*E(3)^2,-1,-E(3)^2,
-2+4*ER(-3),0,-E(3)^2,0,0,1,0,0,120*E(3),0,8*E(3),4*E(3),0,2,1,0,-6,
-2-4*ER(-3),-2,-ER(-3),40*E(3),15*E(3),E(3),-7+ER(-3),ER(-3),0,0,-120,-8,0,-4,
-2*E(3)^2,0,6*E(3)^2,5-3*ER(-3),2*E(3)^2,(3-ER(-3))/2,-40,-15,-1,
(-3+ER(-3))/2,120*E(3)^2,0,8*E(3)^2,-E(3)^2,40*E(3)^2,15*E(3)^2,E(3)^2,
4*E(3)^2,-120*E(3),0,-8*E(3),-40*E(3),-15*E(3),-E(3),-4*E(3)],[120,-40,15,8,
-1,-4,-7-ER(-3),0,-7+ER(-3),2*E(3)^2,0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,2*E(3),
-1,0,-E(3)^2,-E(3),E(3),-E(3)^2,E(3)^2,-1,0,-E(3),-6*E(3)^2,-E(3)^2,1,2,-E(3),
-6*E(3),0,0,5-3*ER(-3),-E(3)^2,5+3*ER(-3),-E(3),0,2*E(3)^2,0,2*E(3),0,0,
(-3-ER(-3))/2,(-3+ER(-3))/2,0,0,2*E(3),0,0,2*E(3)^2,0,0,0,0,0,-2,-E(3),E(3),
-2*E(3)^2,-2*E(3),E(3)^2,-E(3)^2,0,0,0,0,0,0,1,0,0,0,-1,-ER(-3),E(3),0,
-5-3*ER(-3),(3+ER(-3))/2,0,0,1,-1,0,0,0,-120*E(3)^2,ER(-3),-8*E(3)^2,0,
4*E(3)^2,0,0,-2*E(3),-2,E(3)^2,E(3),6*E(3),6,-2*E(3),7+ER(-3),-2+4*ER(-3),0,
-2,(-3-ER(-3))/2,E(3),40*E(3)^2,0,-2-4*ER(-3),-15*E(3)^2,1,E(3)^2,2-4*ER(-3),
0,E(3)^2,0,0,1,0,0,120*E(3),0,8*E(3),-4*E(3),0,2,-1,0,-6,2+4*ER(-3),2,-ER(-3),
-40*E(3),15*E(3),-E(3),7-ER(-3),ER(-3),0,0,-120,-8,0,4,-2*E(3)^2,0,6*E(3)^2,
-5+3*ER(-3),-2*E(3)^2,(3-ER(-3))/2,40,-15,1,(-3+ER(-3))/2,120*E(3)^2,0,
8*E(3)^2,E(3)^2,-40*E(3)^2,15*E(3)^2,-E(3)^2,-4*E(3)^2,-120*E(3),0,-8*E(3),
40*E(3),-15*E(3),E(3),4*E(3)],[126,36,9,10,3,2,0,0,0,-2*E(3),0,1,0,0,0,
-2*E(3)^2,1,1,0,-E(3)^2,0,-E(3),0,-1,0,0,18*E(3),0,-1,-2,0,18*E(3)^2,0,-1,0,0,
0,0,0,6*E(3),0,6*E(3)^2,0,0,0,0,-E(3)^2,-E(3),-2*E(3)^2,0,2*E(3),-2*E(3),
2*E(3)^2,0,0,-E(3),-E(3)^2,-6,E(3)^2,0,2*E(3),2*E(3)^2,0,E(3),2,-2,0,E(3)^2,0,
E(3),1,0,0,0,0,0,E(3)^2,0,0,0,2,0,0,0,0,E(3)^2,0,-126*E(3),0,-10*E(3),-2*E(3),
-2*E(3),0,0,2*E(3)^2,2,-E(3),0,-18*E(3)^2,-18,-6*E(3)^2,0,0,0,2,0,-E(3)^2,
-36*E(3),0,0,-9*E(3),0,-3*E(3),0,-2*E(3),0,-1,-2*E(3)^2,0,0,0,126*E(3)^2,
2*E(3)^2,10*E(3)^2,2*E(3)^2,0,-2,0,0,18,0,6,0,36*E(3)^2,9*E(3)^2,3*E(3)^2,0,0,
E(3),0,-126,-10,-2,-2,2*E(3),0,-18*E(3),0,-6*E(3),0,-36,-9,-3,0,126*E(3),
2*E(3),10*E(3),E(3),36*E(3),9*E(3),3*E(3),2*E(3),-126*E(3)^2,-2*E(3)^2,
-10*E(3)^2,-36*E(3)^2,-9*E(3)^2,-3*E(3)^2,-2*E(3)^2],[126,-36,9,10,-3,-2,0,0,
0,-2*E(3),0,1,0,0,0,-2*E(3)^2,1,-1,0,E(3)^2,0,E(3),0,1,0,0,18*E(3),0,-1,-2,0,
18*E(3)^2,0,1,0,0,0,0,0,-6*E(3),0,-6*E(3)^2,0,0,0,0,-E(3)^2,-E(3),-2*E(3)^2,0,
2*E(3),-2*E(3),2*E(3)^2,0,0,E(3),E(3)^2,6,E(3)^2,0,2*E(3),2*E(3)^2,0,E(3),2,
-2,0,-E(3)^2,0,-E(3),-1,0,0,0,0,0,-E(3)^2,0,0,0,2,0,0,0,0,E(3)^2,0,-126*E(3),
0,-10*E(3),-2*E(3),2*E(3),0,0,2*E(3)^2,2,-E(3),0,-18*E(3)^2,-18,6*E(3)^2,0,0,
0,2,0,-E(3)^2,36*E(3),0,0,-9*E(3),0,3*E(3),0,-2*E(3),0,-1,-2*E(3)^2,0,0,0,
126*E(3)^2,2*E(3)^2,10*E(3)^2,-2*E(3)^2,0,-2,0,0,18,0,-6,0,-36*E(3)^2,
9*E(3)^2,-3*E(3)^2,0,0,E(3),0,-126,-10,-2,2,2*E(3),0,-18*E(3),0,6*E(3),0,36,
-9,3,0,126*E(3),2*E(3),10*E(3),-E(3),-36*E(3),9*E(3),-3*E(3),-2*E(3),
-126*E(3)^2,-2*E(3)^2,-10*E(3)^2,36*E(3)^2,-9*E(3)^2,3*E(3)^2,2*E(3)^2],[126,
36,9,10,3,2,0,0,0,-2*E(3)^2,0,1,0,0,0,-2*E(3),1,1,0,-E(3),0,-E(3)^2,0,-1,0,0,
18*E(3)^2,0,-1,-2,0,18*E(3),0,-1,0,0,0,0,0,6*E(3)^2,0,6*E(3),0,0,0,0,-E(3),
-E(3)^2,-2*E(3),0,2*E(3)^2,-2*E(3)^2,2*E(3),0,0,-E(3)^2,-E(3),-6,E(3),0,
2*E(3)^2,2*E(3),0,E(3)^2,2,-2,0,E(3),0,E(3)^2,1,0,0,0,0,0,E(3),0,0,0,2,0,0,0,
0,E(3),0,-126*E(3)^2,0,-10*E(3)^2,-2*E(3)^2,-2*E(3)^2,0,0,2*E(3),2,-E(3)^2,0,
-18*E(3),-18,-6*E(3),0,0,0,2,0,-E(3),-36*E(3)^2,0,0,-9*E(3)^2,0,-3*E(3)^2,0,
-2*E(3)^2,0,-1,-2*E(3),0,0,0,126*E(3),2*E(3),10*E(3),2*E(3),0,-2,0,0,18,0,6,0,
36*E(3),9*E(3),3*E(3),0,0,E(3)^2,0,-126,-10,-2,-2,2*E(3)^2,0,-18*E(3)^2,0,
-6*E(3)^2,0,-36,-9,-3,0,126*E(3)^2,2*E(3)^2,10*E(3)^2,E(3)^2,36*E(3)^2,
9*E(3)^2,3*E(3)^2,2*E(3)^2,-126*E(3),-2*E(3),-10*E(3),-36*E(3),-9*E(3),
-3*E(3),-2*E(3)],[126,-36,9,10,-3,-2,0,0,0,-2*E(3)^2,0,1,0,0,0,-2*E(3),1,-1,0,
E(3),0,E(3)^2,0,1,0,0,18*E(3)^2,0,-1,-2,0,18*E(3),0,1,0,0,0,0,0,-6*E(3)^2,0,
-6*E(3),0,0,0,0,-E(3),-E(3)^2,-2*E(3),0,2*E(3)^2,-2*E(3)^2,2*E(3),0,0,E(3)^2,
E(3),6,E(3),0,2*E(3)^2,2*E(3),0,E(3)^2,2,-2,0,-E(3),0,-E(3)^2,-1,0,0,0,0,0,
-E(3),0,0,0,2,0,0,0,0,E(3),0,-126*E(3)^2,0,-10*E(3)^2,-2*E(3)^2,2*E(3)^2,0,0,
2*E(3),2,-E(3)^2,0,-18*E(3),-18,6*E(3),0,0,0,2,0,-E(3),36*E(3)^2,0,0,
-9*E(3)^2,0,3*E(3)^2,0,-2*E(3)^2,0,-1,-2*E(3),0,0,0,126*E(3),2*E(3),10*E(3),
-2*E(3),0,-2,0,0,18,0,-6,0,-36*E(3),9*E(3),-3*E(3),0,0,E(3)^2,0,-126,-10,-2,2,
2*E(3)^2,0,-18*E(3)^2,0,6*E(3)^2,0,36,-9,3,0,126*E(3)^2,2*E(3)^2,10*E(3)^2,
-E(3)^2,-36*E(3)^2,9*E(3)^2,-3*E(3)^2,-2*E(3)^2,-126*E(3),-2*E(3),-10*E(3),
36*E(3),-9*E(3),3*E(3),2*E(3)],[140,0,-4,4,0,0,0,0,0,-2,-4,0,2,2,0,-2,4,0,0,0,
0,0,0,0,0,0,-22,0,-4,-2,0,-22,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,-2,0,-2,-2,-2,1,
0,0,0,0,4,0,2,2,0,4,4,2,0,0,0,0,0,0,0,14,0,-2,0,-1,0,-2,-2,0,0,0,0,0,0,-140,
-2,-4,-4,0,0,4,2,2,-4,0,22,22,0,0,0,0,2,-2,-4,0,-14,0,4,0,0,0,2,0,0,2,0,0,0,
140,4,4,0,0,-2,0,0,-22,0,0,2,0,-4,0,0,2,0,0,-140,-4,-4,0,2,0,22,0,0,-2,0,4,0,
-2,140,4,4,0,0,-4,0,0,-140,-4,-4,0,4,0,0],[140,-20,-4,12,-2,0,7,-4,7,-3,5,0,
-1,-1,0,-3,0,0,1,0,1,0,1,0,-1,1,5,0,0,0,0,5,0,0,7,1,7,1,2,-2,-1,-2,-1,-1,-1,
-1,0,0,0,0,1,0,1,-1,0,0,0,-2,0,0,0,0,0,0,4,1,-1,0,0,0,0,0,-1,-4,0,-1,0,-1,7,
-1,1,0,1,1,0,0,-4,140,-1,12,4,0,-4,5,-3,-3,0,1,5,5,-2,7,7,2,0,-1,0,-20,-4,7,
-4,1,-2,7,1,1,0,1,0,0,-4,140,4,12,0,-4,-3,1,-1,5,7,-2,-1,-20,-4,-2,7,-1,0,-4,
140,12,4,0,-3,-1,5,7,-2,-1,-20,-4,-2,-1,140,4,12,0,-20,-4,-2,0,140,4,12,-20,
-4,-2,0],[140,20,-4,12,2,0,-7,4,-7,-3,5,0,-1,-1,0,-3,0,0,-1,0,-1,0,-1,0,1,-1,
5,0,0,0,0,5,0,0,-7,-1,-7,-1,-2,2,1,2,1,1,-1,-1,0,0,0,0,1,0,1,-1,0,0,0,2,0,0,0,
0,0,0,4,1,1,0,0,0,0,0,1,-4,0,-1,0,-1,-7,-1,1,0,-1,-1,0,0,4,140,-1,12,4,0,4,5,
-3,-3,0,-1,5,5,2,-7,-7,-2,0,-1,0,20,-4,-7,-4,-1,2,-7,1,-1,0,1,0,0,4,140,4,12,
0,4,-3,-1,1,5,-7,2,-1,20,-4,2,-7,-1,0,4,140,12,4,0,-3,1,5,-7,2,-1,20,-4,2,-1,
140,4,12,0,20,-4,2,0,140,4,12,20,-4,2,0],[189,-9,0,-3,0,3,-9,-9,-9,3,0,-1,0,0,
1,3,0,1,0,0,0,0,0,0,0,0,27,0,0,0,0,27,-1,1,-9,0,-9,0,0,0,0,0,-1,-1,0,0,-1,-1,
0,1,-1,0,-1,0,1,1,1,0,0,0,0,0,0,0,5,-1,-1,1,-1,1,0,-1,-1,0,0,0,0,0,-9,0,-1,1,
0,0,1,-1,-1,189,0,-3,5,3,-9,0,3,3,0,0,27,27,0,-9,-9,0,0,0,0,-9,0,-9,0,0,0,-9,
-1,0,-1,-1,0,1,-1,189,5,-3,3,-9,3,0,-1,27,-9,0,0,-9,0,0,-9,0,-1,-1,189,-3,5,3,
3,-1,27,-9,0,0,-9,0,0,0,189,5,-3,0,-9,0,0,3,189,5,-3,-9,0,0,3],[189,9,0,-3,0,
-3,9,9,9,3,0,-1,0,0,1,3,0,-1,0,0,0,0,0,0,0,0,27,0,0,0,0,27,1,-1,9,0,9,0,0,0,0,
0,1,1,0,0,-1,-1,0,1,-1,0,-1,0,1,-1,-1,0,0,0,0,0,0,0,5,-1,1,-1,1,-1,0,1,1,0,0,
0,0,0,9,0,-1,1,0,0,1,-1,1,189,0,-3,5,-3,9,0,3,3,0,0,27,27,0,9,9,0,0,0,0,9,0,9,
0,0,0,9,-1,0,-1,-1,0,1,1,189,5,-3,-3,9,3,0,1,27,9,0,0,9,0,0,9,0,-1,1,189,-3,5,
-3,3,1,27,9,0,0,9,0,0,0,189,5,-3,0,9,0,0,-3,189,5,-3,9,0,0,-3],[210,-30,3,2,
-3,2,-3,10,-3,5,3,0,0,0,-2,5,-1,0,0,-1,0,-1,0,-1,1,0,21,0,-1,-1,0,21,0,0,-3,0,
-3,0,1,-3,1,-3,1,1,0,0,0,0,-1,0,1,-1,1,0,0,0,0,-3,-1,0,-1,-1,0,-1,-2,1,1,0,0,
0,-1,0,1,3,0,0,-1,0,-3,0,1,-2,0,0,0,0,-2,210,0,2,-2,2,10,3,5,5,-1,0,21,21,-3,
-3,-3,1,-1,0,-1,-30,3,-3,3,0,-3,-3,1,0,0,1,0,-2,-2,210,-2,2,2,10,5,0,1,21,-3,
-3,0,-30,3,-3,-3,0,0,-2,210,2,-2,2,5,1,21,-3,-3,0,-30,3,-3,0,210,-2,2,-1,-30,
3,-3,2,210,-2,2,-30,3,-3,2],[210,30,3,2,3,-2,3,-10,3,5,3,0,0,0,-2,5,-1,0,0,1,
0,1,0,1,-1,0,21,0,-1,-1,0,21,0,0,3,0,3,0,-1,3,-1,3,-1,-1,0,0,0,0,-1,0,1,-1,1,
0,0,0,0,3,-1,0,-1,-1,0,-1,-2,1,-1,0,0,0,1,0,-1,3,0,0,1,0,3,0,1,-2,0,0,0,0,2,
210,0,2,-2,-2,-10,3,5,5,-1,0,21,21,3,3,3,-1,-1,0,-1,30,3,3,3,0,3,3,1,0,0,1,0,
-2,2,210,-2,2,-2,-10,5,0,-1,21,3,3,0,30,3,3,3,0,0,2,210,2,-2,-2,5,-1,21,3,3,0,
30,3,3,0,210,-2,2,1,30,3,3,-2,210,-2,2,30,3,3,-2],[210,50,15,2,-1,2,
(13-5*ER(-3))/2,-6,(13+5*ER(-3))/2,-E(3)^2,0,0,-ER(-3),ER(-3),-2,-E(3),-1,0,
-1,-E(3),-1,-E(3)^2,-1,-1,0,-1,3*E(3)^2,0,-1,2,0,3*E(3),0,0,(1+9*ER(-3))/2,
-E(3),(1-9*ER(-3))/2,-E(3)^2,0,2*E(3)^2,0,2*E(3),E(3)^2,E(3),(3-ER(-3))/2,
(3+ER(-3))/2,0,0,2*E(3),0,E(3)^2,2*E(3)^2,E(3),0,0,0,0,2,-E(3),0,2*E(3)^2,
2*E(3),0,-E(3)^2,-2,1,1,0,0,0,-1,0,1,0,0,(-3-ER(-3))/2,-E(3),0,(1-9*ER(-3))/2,
(3-ER(-3))/2,1,-2*E(3),-E(3),-E(3)^2,0,0,-2*E(3),210*E(3)^2,(-3+ER(-3))/2,
2*E(3)^2,-2*E(3)^2,2*E(3)^2,-6*E(3)^2,0,-E(3),-1,-E(3)^2,-E(3)^2,3*E(3),3,
2*E(3),(13-5*ER(-3))/2,-7+2*ER(-3),0,2,-ER(-3),-E(3),50*E(3)^2,0,-7-2*ER(-3),
15*E(3)^2,-E(3)^2,-E(3)^2,-7+2*ER(-3),E(3)^2,-E(3),0,E(3),0,-2*E(3)^2,-2,
210*E(3),-2*E(3),2*E(3),2*E(3),-6*E(3),-1,-E(3),E(3)^2,3,-7-2*ER(-3),2,
(-3+ER(-3))/2,50*E(3),15*E(3),-E(3),(13+5*ER(-3))/2,(-3-ER(-3))/2,0,-2*E(3)^2,
210,2,-2,2,-E(3)^2,E(3),3*E(3)^2,(1+9*ER(-3))/2,2*E(3)^2,(3+ER(-3))/2,50,15,
-1,ER(-3),210*E(3)^2,-2*E(3)^2,2*E(3)^2,-E(3)^2,50*E(3)^2,15*E(3)^2,-E(3)^2,
2*E(3)^2,210*E(3),-2*E(3),2*E(3),50*E(3),15*E(3),-E(3),2*E(3)],[210,-50,15,2,
1,-2,(-13+5*ER(-3))/2,6,(-13-5*ER(-3))/2,-E(3)^2,0,0,-ER(-3),ER(-3),-2,-E(3),
-1,0,1,E(3),1,E(3)^2,1,1,0,1,3*E(3)^2,0,-1,2,0,3*E(3),0,0,(-1-9*ER(-3))/2,
E(3),(-1+9*ER(-3))/2,E(3)^2,0,-2*E(3)^2,0,-2*E(3),-E(3)^2,-E(3),(3-ER(-3))/2,
(3+ER(-3))/2,0,0,2*E(3),0,E(3)^2,2*E(3)^2,E(3),0,0,0,0,-2,-E(3),0,2*E(3)^2,
2*E(3),0,-E(3)^2,-2,1,-1,0,0,0,1,0,-1,0,0,(-3-ER(-3))/2,E(3),0,
(-1+9*ER(-3))/2,(3-ER(-3))/2,1,-2*E(3),E(3),E(3)^2,0,0,2*E(3),210*E(3)^2,
(-3+ER(-3))/2,2*E(3)^2,-2*E(3)^2,-2*E(3)^2,6*E(3)^2,0,-E(3),-1,-E(3)^2,E(3)^2,
3*E(3),3,-2*E(3),(-13+5*ER(-3))/2,7-2*ER(-3),0,2,-ER(-3),-E(3),-50*E(3)^2,0,
7+2*ER(-3),15*E(3)^2,E(3)^2,E(3)^2,7-2*ER(-3),E(3)^2,E(3),0,E(3),0,-2*E(3)^2,
2,210*E(3),-2*E(3),2*E(3),-2*E(3),6*E(3),-1,E(3),-E(3)^2,3,7+2*ER(-3),-2,
(-3+ER(-3))/2,-50*E(3),15*E(3),E(3),(-13-5*ER(-3))/2,(-3-ER(-3))/2,0,2*E(3)^2,
210,2,-2,-2,-E(3)^2,-E(3),3*E(3)^2,(-1-9*ER(-3))/2,-2*E(3)^2,(3+ER(-3))/2,-50,
15,1,ER(-3),210*E(3)^2,-2*E(3)^2,2*E(3)^2,E(3)^2,-50*E(3)^2,15*E(3)^2,E(3)^2,
-2*E(3)^2,210*E(3),-2*E(3),2*E(3),-50*E(3),15*E(3),E(3),-2*E(3)],[210,-50,15,
2,1,-2,(-13-5*ER(-3))/2,6,(-13+5*ER(-3))/2,-E(3),0,0,ER(-3),-ER(-3),-2,
-E(3)^2,-1,0,1,E(3)^2,1,E(3),1,1,0,1,3*E(3),0,-1,2,0,3*E(3)^2,0,0,
(-1+9*ER(-3))/2,E(3)^2,(-1-9*ER(-3))/2,E(3),0,-2*E(3),0,-2*E(3)^2,-E(3),
-E(3)^2,(3+ER(-3))/2,(3-ER(-3))/2,0,0,2*E(3)^2,0,E(3),2*E(3),E(3)^2,0,0,0,0,
-2,-E(3)^2,0,2*E(3),2*E(3)^2,0,-E(3),-2,1,-1,0,0,0,1,0,-1,0,0,(-3+ER(-3))/2,
E(3)^2,0,(-1-9*ER(-3))/2,(3+ER(-3))/2,1,-2*E(3)^2,E(3)^2,E(3),0,0,2*E(3)^2,
210*E(3),(-3-ER(-3))/2,2*E(3),-2*E(3),-2*E(3),6*E(3),0,-E(3)^2,-1,-E(3),E(3),
3*E(3)^2,3,-2*E(3)^2,(-13-5*ER(-3))/2,7+2*ER(-3),0,2,ER(-3),-E(3)^2,-50*E(3),
0,7-2*ER(-3),15*E(3),E(3),E(3),7+2*ER(-3),E(3),E(3)^2,0,E(3)^2,0,-2*E(3),2,
210*E(3)^2,-2*E(3)^2,2*E(3)^2,-2*E(3)^2,6*E(3)^2,-1,E(3)^2,-E(3),3,7-2*ER(-3),
-2,(-3-ER(-3))/2,-50*E(3)^2,15*E(3)^2,E(3)^2,(-13+5*ER(-3))/2,(-3+ER(-3))/2,0,
2*E(3),210,2,-2,-2,-E(3),-E(3)^2,3*E(3),(-1+9*ER(-3))/2,-2*E(3),(3-ER(-3))/2,
-50,15,1,-ER(-3),210*E(3),-2*E(3),2*E(3),E(3),-50*E(3),15*E(3),E(3),-2*E(3),
210*E(3)^2,-2*E(3)^2,2*E(3)^2,-50*E(3)^2,15*E(3)^2,E(3)^2,-2*E(3)^2],[210,50,
15,2,-1,2,(13+5*ER(-3))/2,-6,(13-5*ER(-3))/2,-E(3),0,0,ER(-3),-ER(-3),-2,
-E(3)^2,-1,0,-1,-E(3)^2,-1,-E(3),-1,-1,0,-1,3*E(3),0,-1,2,0,3*E(3)^2,0,0,
(1-9*ER(-3))/2,-E(3)^2,(1+9*ER(-3))/2,-E(3),0,2*E(3),0,2*E(3)^2,E(3),E(3)^2,
(3+ER(-3))/2,(3-ER(-3))/2,0,0,2*E(3)^2,0,E(3),2*E(3),E(3)^2,0,0,0,0,2,-E(3)^2,
0,2*E(3),2*E(3)^2,0,-E(3),-2,1,1,0,0,0,-1,0,1,0,0,(-3+ER(-3))/2,-E(3)^2,0,
(1+9*ER(-3))/2,(3+ER(-3))/2,1,-2*E(3)^2,-E(3)^2,-E(3),0,0,-2*E(3)^2,210*E(3),
(-3-ER(-3))/2,2*E(3),-2*E(3),2*E(3),-6*E(3),0,-E(3)^2,-1,-E(3),-E(3),3*E(3)^2,
3,2*E(3)^2,(13+5*ER(-3))/2,-7-2*ER(-3),0,2,ER(-3),-E(3)^2,50*E(3),0,
-7+2*ER(-3),15*E(3),-E(3),-E(3),-7-2*ER(-3),E(3),-E(3)^2,0,E(3)^2,0,-2*E(3),
-2,210*E(3)^2,-2*E(3)^2,2*E(3)^2,2*E(3)^2,-6*E(3)^2,-1,-E(3)^2,E(3),3,
-7+2*ER(-3),2,(-3-ER(-3))/2,50*E(3)^2,15*E(3)^2,-E(3)^2,(13-5*ER(-3))/2,
(-3+ER(-3))/2,0,-2*E(3),210,2,-2,2,-E(3),E(3)^2,3*E(3),(1-9*ER(-3))/2,2*E(3),
(3-ER(-3))/2,50,15,-1,-ER(-3),210*E(3),-2*E(3),2*E(3),-E(3),50*E(3),15*E(3),
-E(3),2*E(3),210*E(3)^2,-2*E(3)^2,2*E(3)^2,50*E(3)^2,15*E(3)^2,-E(3)^2,
2*E(3)^2],[210,20,-3,6,-1,2,-10-2*ER(-3),0,-10+2*ER(-3),0,0,0,(-3-ER(-3))/2,
(-3+ER(-3))/2,0,0,-3,0,-E(3)^2,-E(3)^2,E(3),-E(3),E(3)^2,-1,0,-E(3),-24*E(3),
0,3,0,0,-24*E(3)^2,0,0,2+6*ER(-3),-1,2-6*ER(-3),-1,0,-4*E(3),0,-4*E(3)^2,0,0,
-ER(-3),ER(-3),0,0,0,0,0,0,0,0,0,0,0,4,-3*E(3)^2,0,0,0,0,-3*E(3),6,0,0,0,0,0,
1,0,0,0,0,(-3-ER(-3))/2,E(3)^2,0,-2+6*ER(-3),ER(-3),0,0,E(3),-E(3)^2,0,0,0,
-210*E(3),(-3+ER(-3))/2,-6*E(3),-6*E(3),-2*E(3),0,0,0,0,3*E(3),1,24*E(3)^2,24,
4*E(3)^2,10+2*ER(-3),-8-4*ER(-3),0,0,(3+ER(-3))/2,3*E(3)^2,-20*E(3),0,
-8+4*ER(-3),3*E(3),E(3)^2,E(3),8+4*ER(-3),0,1,0,0,0,0,0,210*E(3)^2,6*E(3)^2,
6*E(3)^2,2*E(3)^2,0,0,-E(3),0,-24,8-4*ER(-3),-4,(3-ER(-3))/2,20*E(3)^2,
-3*E(3)^2,-E(3)^2,10-2*ER(-3),(3+ER(-3))/2,0,0,-210,-6,-6,-2,0,0,24*E(3),
-2-6*ER(-3),4*E(3),-ER(-3),-20,3,1,(3-ER(-3))/2,210*E(3),6*E(3),6*E(3),E(3),
20*E(3),-3*E(3),-E(3),2*E(3),-210*E(3)^2,-6*E(3)^2,-6*E(3)^2,-20*E(3)^2,
3*E(3)^2,E(3)^2,-2*E(3)^2],[210,-20,-3,6,1,-2,10+2*ER(-3),0,10-2*ER(-3),0,0,0,
(-3-ER(-3))/2,(-3+ER(-3))/2,0,0,-3,0,E(3)^2,E(3)^2,-E(3),E(3),-E(3)^2,1,0,
E(3),-24*E(3),0,3,0,0,-24*E(3)^2,0,0,-2-6*ER(-3),1,-2+6*ER(-3),1,0,4*E(3),0,
4*E(3)^2,0,0,-ER(-3),ER(-3),0,0,0,0,0,0,0,0,0,0,0,-4,-3*E(3)^2,0,0,0,0,
-3*E(3),6,0,0,0,0,0,-1,0,0,0,0,(-3-ER(-3))/2,-E(3)^2,0,2-6*ER(-3),ER(-3),0,0,
-E(3),E(3)^2,0,0,0,-210*E(3),(-3+ER(-3))/2,-6*E(3),-6*E(3),2*E(3),0,0,0,0,
3*E(3),-1,24*E(3)^2,24,-4*E(3)^2,-10-2*ER(-3),8+4*ER(-3),0,0,(3+ER(-3))/2,
3*E(3)^2,20*E(3),0,8-4*ER(-3),3*E(3),-E(3)^2,-E(3),-8-4*ER(-3),0,-1,0,0,0,0,0,
210*E(3)^2,6*E(3)^2,6*E(3)^2,-2*E(3)^2,0,0,E(3),0,-24,-8+4*ER(-3),4,
(3-ER(-3))/2,-20*E(3)^2,-3*E(3)^2,E(3)^2,-10+2*ER(-3),(3+ER(-3))/2,0,0,-210,
-6,-6,2,0,0,24*E(3),2+6*ER(-3),-4*E(3),-ER(-3),20,3,-1,(3-ER(-3))/2,210*E(3),
6*E(3),6*E(3),-E(3),-20*E(3),-3*E(3),E(3),-2*E(3),-210*E(3)^2,-6*E(3)^2,
-6*E(3)^2,20*E(3)^2,3*E(3)^2,-E(3)^2,2*E(3)^2],[210,20,-3,6,-1,2,-10+2*ER(-3),
0,-10-2*ER(-3),0,0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,0,0,-3,0,-E(3),-E(3),E(3)^2,
-E(3)^2,E(3),-1,0,-E(3)^2,-24*E(3)^2,0,3,0,0,-24*E(3),0,0,2-6*ER(-3),-1,
2+6*ER(-3),-1,0,-4*E(3)^2,0,-4*E(3),0,0,ER(-3),-ER(-3),0,0,0,0,0,0,0,0,0,0,0,
4,-3*E(3),0,0,0,0,-3*E(3)^2,6,0,0,0,0,0,1,0,0,0,0,(-3+ER(-3))/2,E(3),0,
-2-6*ER(-3),-ER(-3),0,0,E(3)^2,-E(3),0,0,0,-210*E(3)^2,(-3-ER(-3))/2,
-6*E(3)^2,-6*E(3)^2,-2*E(3)^2,0,0,0,0,3*E(3)^2,1,24*E(3),24,4*E(3),
10-2*ER(-3),-8+4*ER(-3),0,0,(3-ER(-3))/2,3*E(3),-20*E(3)^2,0,-8-4*ER(-3),
3*E(3)^2,E(3),E(3)^2,8-4*ER(-3),0,1,0,0,0,0,0,210*E(3),6*E(3),6*E(3),2*E(3),0,
0,-E(3)^2,0,-24,8+4*ER(-3),-4,(3+ER(-3))/2,20*E(3),-3*E(3),-E(3),10+2*ER(-3),
(3-ER(-3))/2,0,0,-210,-6,-6,-2,0,0,24*E(3)^2,-2+6*ER(-3),4*E(3)^2,ER(-3),-20,
3,1,(3+ER(-3))/2,210*E(3)^2,6*E(3)^2,6*E(3)^2,E(3)^2,20*E(3)^2,-3*E(3)^2,
-E(3)^2,2*E(3)^2,-210*E(3),-6*E(3),-6*E(3),-20*E(3),3*E(3),E(3),-2*E(3)],[210,
-20,-3,6,1,-2,10-2*ER(-3),0,10+2*ER(-3),0,0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,0,0,
-3,0,E(3),E(3),-E(3)^2,E(3)^2,-E(3),1,0,E(3)^2,-24*E(3)^2,0,3,0,0,-24*E(3),0,
0,-2+6*ER(-3),1,-2-6*ER(-3),1,0,4*E(3)^2,0,4*E(3),0,0,ER(-3),-ER(-3),0,0,0,0,
0,0,0,0,0,0,0,-4,-3*E(3),0,0,0,0,-3*E(3)^2,6,0,0,0,0,0,-1,0,0,0,0,
(-3+ER(-3))/2,-E(3),0,2+6*ER(-3),-ER(-3),0,0,-E(3)^2,E(3),0,0,0,-210*E(3)^2,
(-3-ER(-3))/2,-6*E(3)^2,-6*E(3)^2,2*E(3)^2,0,0,0,0,3*E(3)^2,-1,24*E(3),24,
-4*E(3),-10+2*ER(-3),8-4*ER(-3),0,0,(3-ER(-3))/2,3*E(3),20*E(3)^2,0,
8+4*ER(-3),3*E(3)^2,-E(3),-E(3)^2,-8+4*ER(-3),0,-1,0,0,0,0,0,210*E(3),6*E(3),
6*E(3),-2*E(3),0,0,E(3)^2,0,-24,-8-4*ER(-3),4,(3+ER(-3))/2,-20*E(3),-3*E(3),
E(3),-10-2*ER(-3),(3-ER(-3))/2,0,0,-210,-6,-6,2,0,0,24*E(3)^2,2-6*ER(-3),
-4*E(3)^2,ER(-3),20,3,-1,(3+ER(-3))/2,210*E(3)^2,6*E(3)^2,6*E(3)^2,-E(3)^2,
-20*E(3)^2,-3*E(3)^2,E(3)^2,-2*E(3)^2,-210*E(3),-6*E(3),-6*E(3),20*E(3),
3*E(3),-E(3),2*E(3)],[280,-40,10,-8,2,0,-4-6*ER(-3),8,-4+6*ER(-3),-2,1,0,
(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,-2,-2,0,-E(3),0,-E(3)^2,0,-E(3),0,-1,
-E(3)^2,10,0,-2,1,0,10,0,0,-4-6*ER(-3),-E(3)^2,-4+6*ER(-3),-E(3),-1,-1,-1,-1,
0,0,(-1-3*ER(-3))/2,(-1+3*ER(-3))/2,0,0,1,0,0,1,0,1,0,0,0,-1,-2,0,1,1,0,-2,0,
0,0,0,0,0,0,0,0,1,0,(-1-3*ER(-3))/2,0,1,-4+6*ER(-3),(-1-3*ER(-3))/2,0,0,-E(3),
-E(3)^2,0,0,0,280,(-1+3*ER(-3))/2,-8,0,0,8,1,-2,-2,-2,-E(3),10,10,-1,
-4-6*ER(-3),-4+6*ER(-3),-1,1,(-1+3*ER(-3))/2,-2,-40,1,-4-6*ER(-3),10,-E(3)^2,
2,-4+6*ER(-3),0,-E(3)^2,0,0,0,0,0,280,0,-8,0,8,-2,-E(3),0,10,-4-6*ER(-3),-1,
(-1+3*ER(-3))/2,-40,10,2,-4+6*ER(-3),(-1-3*ER(-3))/2,0,0,280,-8,0,0,-2,0,10,
-4-6*ER(-3),-1,(-1+3*ER(-3))/2,-40,10,2,(-1-3*ER(-3))/2,280,0,-8,0,-40,10,2,0,
280,0,-8,-40,10,2,0],[280,-40,10,-8,2,0,-4+6*ER(-3),8,-4-6*ER(-3),-2,1,0,
(-1-3*ER(-3))/2,(-1+3*ER(-3))/2,0,-2,-2,0,-E(3)^2,0,-E(3),0,-E(3)^2,0,-1,
-E(3),10,0,-2,1,0,10,0,0,-4+6*ER(-3),-E(3),-4-6*ER(-3),-E(3)^2,-1,-1,-1,-1,0,
0,(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,0,1,0,0,1,0,1,0,0,0,-1,-2,0,1,1,0,-2,0,0,
0,0,0,0,0,0,0,1,0,(-1+3*ER(-3))/2,0,1,-4-6*ER(-3),(-1+3*ER(-3))/2,0,0,-E(3)^2,
-E(3),0,0,0,280,(-1-3*ER(-3))/2,-8,0,0,8,1,-2,-2,-2,-E(3)^2,10,10,-1,
-4+6*ER(-3),-4-6*ER(-3),-1,1,(-1-3*ER(-3))/2,-2,-40,1,-4+6*ER(-3),10,-E(3),2,
-4-6*ER(-3),0,-E(3),0,0,0,0,0,280,0,-8,0,8,-2,-E(3)^2,0,10,-4+6*ER(-3),-1,
(-1-3*ER(-3))/2,-40,10,2,-4-6*ER(-3),(-1+3*ER(-3))/2,0,0,280,-8,0,0,-2,0,10,
-4+6*ER(-3),-1,(-1-3*ER(-3))/2,-40,10,2,(-1+3*ER(-3))/2,280,0,-8,0,-40,10,2,0,
280,0,-8,-40,10,2,0],[280,40,10,-8,-2,0,4+6*ER(-3),-8,4-6*ER(-3),-2,1,0,
(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,-2,-2,0,E(3),0,E(3)^2,0,E(3),0,1,E(3)^2,10,
0,-2,1,0,10,0,0,4+6*ER(-3),E(3)^2,4-6*ER(-3),E(3),1,1,1,1,0,0,(-1-3*ER(-3))/2,
(-1+3*ER(-3))/2,0,0,1,0,0,1,0,1,0,0,0,1,-2,0,1,1,0,-2,0,0,0,0,0,0,0,0,0,1,0,
(-1-3*ER(-3))/2,0,1,4-6*ER(-3),(-1-3*ER(-3))/2,0,0,E(3),E(3)^2,0,0,0,280,
(-1+3*ER(-3))/2,-8,0,0,-8,1,-2,-2,-2,E(3),10,10,1,4+6*ER(-3),4-6*ER(-3),1,1,
(-1+3*ER(-3))/2,-2,40,1,4+6*ER(-3),10,E(3)^2,-2,4-6*ER(-3),0,E(3)^2,0,0,0,0,0,
280,0,-8,0,-8,-2,E(3),0,10,4+6*ER(-3),1,(-1+3*ER(-3))/2,40,10,-2,4-6*ER(-3),
(-1-3*ER(-3))/2,0,0,280,-8,0,0,-2,0,10,4+6*ER(-3),1,(-1+3*ER(-3))/2,40,10,-2,
(-1-3*ER(-3))/2,280,0,-8,0,40,10,-2,0,280,0,-8,40,10,-2,0],[280,40,10,-8,-2,0,
4-6*ER(-3),-8,4+6*ER(-3),-2,1,0,(-1-3*ER(-3))/2,(-1+3*ER(-3))/2,0,-2,-2,0,
E(3)^2,0,E(3),0,E(3)^2,0,1,E(3),10,0,-2,1,0,10,0,0,4-6*ER(-3),E(3),4+6*ER(-3),
E(3)^2,1,1,1,1,0,0,(-1+3*ER(-3))/2,(-1-3*ER(-3))/2,0,0,1,0,0,1,0,1,0,0,0,1,-2,
0,1,1,0,-2,0,0,0,0,0,0,0,0,0,1,0,(-1+3*ER(-3))/2,0,1,4+6*ER(-3),
(-1+3*ER(-3))/2,0,0,E(3)^2,E(3),0,0,0,280,(-1-3*ER(-3))/2,-8,0,0,-8,1,-2,-2,
-2,E(3)^2,10,10,1,4-6*ER(-3),4+6*ER(-3),1,1,(-1-3*ER(-3))/2,-2,40,1,
4-6*ER(-3),10,E(3),-2,4+6*ER(-3),0,E(3),0,0,0,0,0,280,0,-8,0,-8,-2,E(3)^2,0,
10,4-6*ER(-3),1,(-1-3*ER(-3))/2,40,10,-2,4+6*ER(-3),(-1+3*ER(-3))/2,0,0,280,
-8,0,0,-2,0,10,4-6*ER(-3),1,(-1-3*ER(-3))/2,40,10,-2,(-1+3*ER(-3))/2,280,0,-8,
0,40,10,-2,0,280,0,-8,40,10,-2,0],[315,-75,18,11,0,-3,-3,-3,-3,-1,0,0,0,0,-1,
-1,2,0,0,0,0,0,0,0,0,0,-9,0,2,-1,0,-9,-1,0,-3,0,-3,0,3,3,0,3,1,1,0,0,0,0,-1,1,
-1,-1,-1,0,1,0,0,3,2,0,-1,-1,0,2,-1,-1,1,0,-1,0,0,-1,1,-9,0,0,0,0,-3,0,-1,-1,
0,0,1,0,1,315,0,11,-1,-3,-3,0,-1,-1,2,0,-9,-9,3,-3,-3,3,-1,0,2,-75,-9,-3,18,0,
0,-3,-1,0,0,-1,0,-1,1,315,-1,11,-3,-3,-1,0,1,-9,-3,3,0,-75,18,0,-3,0,0,1,315,
11,-1,-3,-1,1,-9,-3,3,0,-75,18,0,0,315,-1,11,0,-75,18,0,-3,315,-1,11,-75,18,0,
-3],[315,75,18,11,0,3,3,3,3,-1,0,0,0,0,-1,-1,2,0,0,0,0,0,0,0,0,0,-9,0,2,-1,0,
-9,1,0,3,0,3,0,-3,-3,0,-3,-1,-1,0,0,0,0,-1,1,-1,-1,-1,0,1,0,0,-3,2,0,-1,-1,0,
2,-1,-1,-1,0,1,0,0,1,-1,-9,0,0,0,0,3,0,-1,-1,0,0,1,0,-1,315,0,11,-1,3,3,0,-1,
-1,2,0,-9,-9,-3,3,3,-3,-1,0,2,75,-9,3,18,0,0,3,-1,0,0,-1,0,-1,-1,315,-1,11,3,
3,-1,0,-1,-9,3,-3,0,75,18,0,3,0,0,-1,315,11,-1,3,-1,-1,-9,3,-3,0,75,18,0,0,
315,-1,11,0,75,18,0,3,315,-1,11,75,18,0,3],[315,-15,-9,11,-3,1,3,9,3,-1,0,0,0,
0,-1,-1,-1,0,0,1,0,1,0,1,0,0,-9,0,-1,2,0,-9,-1,0,3,0,3,0,0,0,0,0,-1,-1,0,0,0,
0,2,1,-1,2,-1,0,1,0,0,0,-1,0,2,2,0,-1,-1,-1,-1,0,-1,0,1,-1,-1,18,0,0,1,0,3,0,
-1,-1,0,0,1,0,5,315,0,11,-1,1,9,0,-1,-1,-1,0,-9,-9,0,3,3,0,2,0,-1,-15,18,3,-9,
0,-3,3,-1,0,0,-1,0,-1,5,315,-1,11,1,9,-1,0,-1,-9,3,0,0,-15,-9,-3,3,0,0,5,315,
11,-1,1,-1,-1,-9,3,0,0,-15,-9,-3,0,315,-1,11,1,-15,-9,-3,1,315,-1,11,-15,-9,
-3,1],[315,15,-9,11,3,-1,-3,-9,-3,-1,0,0,0,0,-1,-1,-1,0,0,-1,0,-1,0,-1,0,0,-9,
0,-1,2,0,-9,1,0,-3,0,-3,0,0,0,0,0,1,1,0,0,0,0,2,1,-1,2,-1,0,1,0,0,0,-1,0,2,2,
0,-1,-1,-1,1,0,1,0,-1,1,1,18,0,0,-1,0,-3,0,-1,-1,0,0,1,0,-5,315,0,11,-1,-1,-9,
0,-1,-1,-1,0,-9,-9,0,-3,-3,0,2,0,-1,15,18,-3,-9,0,3,-3,-1,0,0,-1,0,-1,-5,315,
-1,11,-1,-9,-1,0,1,-9,-3,0,0,15,-9,3,-3,0,0,-5,315,11,-1,-1,-1,1,-9,-3,0,0,15,
-9,3,0,315,-1,11,-1,15,-9,3,-1,315,-1,11,15,-9,3,-1],[315,45,9,-5,-3,1,0,-3,0,
4*E(3)^2,0,0,0,0,-1,4*E(3),1,0,0,E(3),0,E(3)^2,0,1,0,0,-36*E(3)^2,0,1,-2,0,
-36*E(3),1,0,0,0,0,0,0,-6*E(3)^2,0,-6*E(3),0,0,0,0,0,0,-2*E(3),-E(3)^2,0,
-2*E(3)^2,0,0,-E(3),0,0,-6,E(3),0,-2*E(3)^2,-2*E(3),0,E(3)^2,3,0,0,0,E(3),0,1,
E(3)^2,0,0,0,0,E(3),0,0,0,0,-E(3),0,0,-1,0,-3*E(3),315*E(3)^2,0,-5*E(3)^2,
3*E(3)^2,E(3)^2,-3*E(3)^2,0,4*E(3),4,E(3)^2,0,-36*E(3),-36,-6*E(3),0,0,0,-2,0,
E(3),45*E(3)^2,0,0,9*E(3)^2,0,-3*E(3)^2,0,0,0,0,0,0,-E(3)^2,-3,315*E(3),
3*E(3),-5*E(3),E(3),-3*E(3),4,0,0,-36,0,-6,0,45*E(3),9*E(3),-3*E(3),0,0,0,
-3*E(3)^2,315,-5,3,1,4*E(3)^2,0,-36*E(3)^2,0,-6*E(3)^2,0,45,9,-3,0,315*E(3)^2,
3*E(3)^2,-5*E(3)^2,E(3)^2,45*E(3)^2,9*E(3)^2,-3*E(3)^2,E(3)^2,315*E(3),3*E(3),
-5*E(3),45*E(3),9*E(3),-3*E(3),E(3)],[315,-45,9,-5,3,-1,0,3,0,4*E(3)^2,0,0,0,
0,-1,4*E(3),1,0,0,-E(3),0,-E(3)^2,0,-1,0,0,-36*E(3)^2,0,1,-2,0,-36*E(3),-1,0,
0,0,0,0,0,6*E(3)^2,0,6*E(3),0,0,0,0,0,0,-2*E(3),-E(3)^2,0,-2*E(3)^2,0,0,-E(3),
0,0,6,E(3),0,-2*E(3)^2,-2*E(3),0,E(3)^2,3,0,0,0,-E(3),0,-1,-E(3)^2,0,0,0,0,
-E(3),0,0,0,0,-E(3),0,0,-1,0,3*E(3),315*E(3)^2,0,-5*E(3)^2,3*E(3)^2,-E(3)^2,
3*E(3)^2,0,4*E(3),4,E(3)^2,0,-36*E(3),-36,6*E(3),0,0,0,-2,0,E(3),-45*E(3)^2,0,
0,9*E(3)^2,0,3*E(3)^2,0,0,0,0,0,0,-E(3)^2,3,315*E(3),3*E(3),-5*E(3),-E(3),
3*E(3),4,0,0,-36,0,6,0,-45*E(3),9*E(3),3*E(3),0,0,0,3*E(3)^2,315,-5,3,-1,
4*E(3)^2,0,-36*E(3)^2,0,6*E(3)^2,0,-45,9,3,0,315*E(3)^2,3*E(3)^2,-5*E(3)^2,
-E(3)^2,-45*E(3)^2,9*E(3)^2,3*E(3)^2,-E(3)^2,315*E(3),3*E(3),-5*E(3),-45*E(3),
9*E(3),3*E(3),-E(3)],[315,45,9,-5,-3,1,0,-3,0,4*E(3),0,0,0,0,-1,4*E(3)^2,1,0,
0,E(3)^2,0,E(3),0,1,0,0,-36*E(3),0,1,-2,0,-36*E(3)^2,1,0,0,0,0,0,0,-6*E(3),0,
-6*E(3)^2,0,0,0,0,0,0,-2*E(3)^2,-E(3),0,-2*E(3),0,0,-E(3)^2,0,0,-6,E(3)^2,0,
-2*E(3),-2*E(3)^2,0,E(3),3,0,0,0,E(3)^2,0,1,E(3),0,0,0,0,E(3)^2,0,0,0,0,
-E(3)^2,0,0,-1,0,-3*E(3)^2,315*E(3),0,-5*E(3),3*E(3),E(3),-3*E(3),0,4*E(3)^2,
4,E(3),0,-36*E(3)^2,-36,-6*E(3)^2,0,0,0,-2,0,E(3)^2,45*E(3),0,0,9*E(3),0,
-3*E(3),0,0,0,0,0,0,-E(3),-3,315*E(3)^2,3*E(3)^2,-5*E(3)^2,E(3)^2,-3*E(3)^2,4,
0,0,-36,0,-6,0,45*E(3)^2,9*E(3)^2,-3*E(3)^2,0,0,0,-3*E(3),315,-5,3,1,4*E(3),0,
-36*E(3),0,-6*E(3),0,45,9,-3,0,315*E(3),3*E(3),-5*E(3),E(3),45*E(3),9*E(3),
-3*E(3),E(3),315*E(3)^2,3*E(3)^2,-5*E(3)^2,45*E(3)^2,9*E(3)^2,-3*E(3)^2,
E(3)^2],[315,-45,9,-5,3,-1,0,3,0,4*E(3),0,0,0,0,-1,4*E(3)^2,1,0,0,-E(3)^2,0,
-E(3),0,-1,0,0,-36*E(3),0,1,-2,0,-36*E(3)^2,-1,0,0,0,0,0,0,6*E(3),0,6*E(3)^2,
0,0,0,0,0,0,-2*E(3)^2,-E(3),0,-2*E(3),0,0,-E(3)^2,0,0,6,E(3)^2,0,-2*E(3),
-2*E(3)^2,0,E(3),3,0,0,0,-E(3)^2,0,-1,-E(3),0,0,0,0,-E(3)^2,0,0,0,0,-E(3)^2,0,
0,-1,0,3*E(3)^2,315*E(3),0,-5*E(3),3*E(3),-E(3),3*E(3),0,4*E(3)^2,4,E(3),0,
-36*E(3)^2,-36,6*E(3)^2,0,0,0,-2,0,E(3)^2,-45*E(3),0,0,9*E(3),0,3*E(3),0,0,0,
0,0,0,-E(3),3,315*E(3)^2,3*E(3)^2,-5*E(3)^2,-E(3)^2,3*E(3)^2,4,0,0,-36,0,6,0,
-45*E(3)^2,9*E(3)^2,3*E(3)^2,0,0,0,3*E(3),315,-5,3,-1,4*E(3),0,-36*E(3),0,
6*E(3),0,-45,9,3,0,315*E(3),3*E(3),-5*E(3),-E(3),-45*E(3),9*E(3),3*E(3),-E(3),
315*E(3)^2,3*E(3)^2,-5*E(3)^2,-45*E(3)^2,9*E(3)^2,3*E(3)^2,-E(3)^2],[336,-64,
6,16,-4,0,5-ER(-3),0,5+ER(-3),-2*E(3)^2,0,1,(-3+ER(-3))/2,(-3-ER(-3))/2,0,
-2*E(3),-2,1,-E(3),0,-E(3)^2,0,-E(3),0,0,-E(3)^2,-6*E(3)^2,0,-2,-2,0,-6*E(3),
0,1,-1+3*ER(-3),-1,-1-3*ER(-3),-1,0,2*E(3)^2,0,2*E(3),0,0,ER(-3),-ER(-3),E(3),
E(3)^2,-2*E(3),0,0,-2*E(3)^2,0,0,0,E(3)^2,E(3),2,-2*E(3),0,-2*E(3)^2,-2*E(3),
0,-2*E(3)^2,0,0,0,E(3),0,E(3)^2,0,0,0,0,0,(3-ER(-3))/2,0,0,-1-3*ER(-3),ER(-3),
0,0,-E(3)^2,-E(3),0,E(3),0,336*E(3)^2,(3+ER(-3))/2,16*E(3)^2,0,0,0,0,-2*E(3),
-2,-2*E(3)^2,-1,-6*E(3),-6,2*E(3),5-ER(-3),-4+2*ER(-3),0,-2,(-3+ER(-3))/2,
-2*E(3),-64*E(3)^2,0,-4-2*ER(-3),6*E(3)^2,-E(3),-4*E(3)^2,-4+2*ER(-3),0,-1,1,
0,0,0,0,336*E(3),0,16*E(3),0,0,-2,-E(3)^2,0,-6,-4-2*ER(-3),2,(3+ER(-3))/2,
-64*E(3),6*E(3),-4*E(3),5+ER(-3),(3-ER(-3))/2,E(3)^2,0,336,16,0,0,-2*E(3)^2,0,
-6*E(3)^2,-1+3*ER(-3),2*E(3)^2,-ER(-3),-64,6,-4,(-3-ER(-3))/2,336*E(3)^2,0,
16*E(3)^2,0,-64*E(3)^2,6*E(3)^2,-4*E(3)^2,0,336*E(3),0,16*E(3),-64*E(3),
6*E(3),-4*E(3),0],[336,64,6,16,4,0,-5+ER(-3),0,-5-ER(-3),-2*E(3)^2,0,1,
(-3+ER(-3))/2,(-3-ER(-3))/2,0,-2*E(3),-2,-1,E(3),0,E(3)^2,0,E(3),0,0,E(3)^2,
-6*E(3)^2,0,-2,-2,0,-6*E(3),0,-1,1-3*ER(-3),1,1+3*ER(-3),1,0,-2*E(3)^2,0,
-2*E(3),0,0,ER(-3),-ER(-3),E(3),E(3)^2,-2*E(3),0,0,-2*E(3)^2,0,0,0,-E(3)^2,
-E(3),-2,-2*E(3),0,-2*E(3)^2,-2*E(3),0,-2*E(3)^2,0,0,0,-E(3),0,-E(3)^2,0,0,0,
0,0,(3-ER(-3))/2,0,0,1+3*ER(-3),ER(-3),0,0,E(3)^2,E(3),0,E(3),0,336*E(3)^2,
(3+ER(-3))/2,16*E(3)^2,0,0,0,0,-2*E(3),-2,-2*E(3)^2,1,-6*E(3),-6,-2*E(3),
-5+ER(-3),4-2*ER(-3),0,-2,(-3+ER(-3))/2,-2*E(3),64*E(3)^2,0,4+2*ER(-3),
6*E(3)^2,E(3),4*E(3)^2,4-2*ER(-3),0,1,1,0,0,0,0,336*E(3),0,16*E(3),0,0,-2,
E(3)^2,0,-6,4+2*ER(-3),-2,(3+ER(-3))/2,64*E(3),6*E(3),4*E(3),-5-ER(-3),
(3-ER(-3))/2,E(3)^2,0,336,16,0,0,-2*E(3)^2,0,-6*E(3)^2,1-3*ER(-3),-2*E(3)^2,
-ER(-3),64,6,4,(-3-ER(-3))/2,336*E(3)^2,0,16*E(3)^2,0,64*E(3)^2,6*E(3)^2,
4*E(3)^2,0,336*E(3),0,16*E(3),64*E(3),6*E(3),4*E(3),0],[336,-64,6,16,-4,0,
5+ER(-3),0,5-ER(-3),-2*E(3),0,1,(-3-ER(-3))/2,(-3+ER(-3))/2,0,-2*E(3)^2,-2,1,
-E(3)^2,0,-E(3),0,-E(3)^2,0,0,-E(3),-6*E(3),0,-2,-2,0,-6*E(3)^2,0,1,
-1-3*ER(-3),-1,-1+3*ER(-3),-1,0,2*E(3),0,2*E(3)^2,0,0,-ER(-3),ER(-3),E(3)^2,
E(3),-2*E(3)^2,0,0,-2*E(3),0,0,0,E(3),E(3)^2,2,-2*E(3)^2,0,-2*E(3),-2*E(3)^2,
0,-2*E(3),0,0,0,E(3)^2,0,E(3),0,0,0,0,0,(3+ER(-3))/2,0,0,-1+3*ER(-3),-ER(-3),
0,0,-E(3),-E(3)^2,0,E(3)^2,0,336*E(3),(3-ER(-3))/2,16*E(3),0,0,0,0,-2*E(3)^2,
-2,-2*E(3),-1,-6*E(3)^2,-6,2*E(3)^2,5+ER(-3),-4-2*ER(-3),0,-2,(-3-ER(-3))/2,
-2*E(3)^2,-64*E(3),0,-4+2*ER(-3),6*E(3),-E(3)^2,-4*E(3),-4-2*ER(-3),0,-1,1,0,
0,0,0,336*E(3)^2,0,16*E(3)^2,0,0,-2,-E(3),0,-6,-4+2*ER(-3),2,(3-ER(-3))/2,
-64*E(3)^2,6*E(3)^2,-4*E(3)^2,5-ER(-3),(3+ER(-3))/2,E(3),0,336,16,0,0,-2*E(3),
0,-6*E(3),-1-3*ER(-3),2*E(3),ER(-3),-64,6,-4,(-3+ER(-3))/2,336*E(3),0,16*E(3),
0,-64*E(3),6*E(3),-4*E(3),0,336*E(3)^2,0,16*E(3)^2,-64*E(3)^2,6*E(3)^2,
-4*E(3)^2,0],[336,64,6,16,4,0,-5-ER(-3),0,-5+ER(-3),-2*E(3),0,1,(-3-ER(-3))/2,
(-3+ER(-3))/2,0,-2*E(3)^2,-2,-1,E(3)^2,0,E(3),0,E(3)^2,0,0,E(3),-6*E(3),0,-2,
-2,0,-6*E(3)^2,0,-1,1+3*ER(-3),1,1-3*ER(-3),1,0,-2*E(3),0,-2*E(3)^2,0,0,
-ER(-3),ER(-3),E(3)^2,E(3),-2*E(3)^2,0,0,-2*E(3),0,0,0,-E(3),-E(3)^2,-2,
-2*E(3)^2,0,-2*E(3),-2*E(3)^2,0,-2*E(3),0,0,0,-E(3)^2,0,-E(3),0,0,0,0,0,
(3+ER(-3))/2,0,0,1-3*ER(-3),-ER(-3),0,0,E(3),E(3)^2,0,E(3)^2,0,336*E(3),
(3-ER(-3))/2,16*E(3),0,0,0,0,-2*E(3)^2,-2,-2*E(3),1,-6*E(3)^2,-6,-2*E(3)^2,
-5-ER(-3),4+2*ER(-3),0,-2,(-3-ER(-3))/2,-2*E(3)^2,64*E(3),0,4-2*ER(-3),6*E(3),
E(3)^2,4*E(3),4+2*ER(-3),0,1,1,0,0,0,0,336*E(3)^2,0,16*E(3)^2,0,0,-2,E(3),0,
-6,4-2*ER(-3),-2,(3-ER(-3))/2,64*E(3)^2,6*E(3)^2,4*E(3)^2,-5+ER(-3),
(3+ER(-3))/2,E(3),0,336,16,0,0,-2*E(3),0,-6*E(3),1+3*ER(-3),-2*E(3),ER(-3),64,
6,4,(-3+ER(-3))/2,336*E(3),0,16*E(3),0,64*E(3),6*E(3),4*E(3),0,336*E(3)^2,0,
16*E(3)^2,64*E(3)^2,6*E(3)^2,4*E(3)^2,0],[336,16,6,-16,-2,0,1-7*ER(-3),0,
1+7*ER(-3),2*E(3),0,1,(-3-ER(-3))/2,(-3+ER(-3))/2,0,2*E(3)^2,2,1,E(3)^2,0,
-E(3),0,-E(3)^2,0,0,E(3),-6*E(3),0,-2,2,0,-6*E(3)^2,0,-1,-11+3*ER(-3),1,
-11-3*ER(-3),1,0,-2*E(3),0,-2*E(3)^2,0,0,-ER(-3),ER(-3),-E(3)^2,-E(3),
2*E(3)^2,0,0,2*E(3),0,0,0,-E(3),-E(3)^2,2,2*E(3)^2,0,-2*E(3),-2*E(3)^2,0,
2*E(3),0,0,0,E(3)^2,0,E(3),0,0,0,0,0,(-3-ER(-3))/2,0,0,11+3*ER(-3),ER(-3),0,0,
-E(3),E(3)^2,0,E(3)^2,0,-336*E(3),(-3+ER(-3))/2,16*E(3),0,0,0,0,-2*E(3)^2,-2,
-2*E(3),-1,6*E(3)^2,6,2*E(3)^2,-1+7*ER(-3),-10+4*ER(-3),0,-2,(3+ER(-3))/2,
-2*E(3)^2,-16*E(3),0,-10-4*ER(-3),-6*E(3),-E(3)^2,2*E(3),10-4*ER(-3),0,-1,-1,
0,0,0,0,336*E(3)^2,0,-16*E(3)^2,0,0,2,E(3),0,-6,10+4*ER(-3),-2,(3-ER(-3))/2,
16*E(3)^2,6*E(3)^2,-2*E(3)^2,-1-7*ER(-3),(3+ER(-3))/2,E(3),0,-336,16,0,0,
-2*E(3),0,6*E(3),11-3*ER(-3),2*E(3),-ER(-3),-16,-6,2,(3-ER(-3))/2,336*E(3),0,
-16*E(3),0,16*E(3),6*E(3),-2*E(3),0,-336*E(3)^2,0,16*E(3)^2,-16*E(3)^2,
-6*E(3)^2,2*E(3)^2,0],[336,-16,6,-16,2,0,-1-7*ER(-3),0,-1+7*ER(-3),2*E(3)^2,0,
1,(-3+ER(-3))/2,(-3-ER(-3))/2,0,2*E(3),2,-1,-E(3),0,E(3)^2,0,E(3),0,0,-E(3)^2,
-6*E(3)^2,0,-2,2,0,-6*E(3),0,1,11+3*ER(-3),-1,11-3*ER(-3),-1,0,2*E(3)^2,0,
2*E(3),0,0,ER(-3),-ER(-3),-E(3),-E(3)^2,2*E(3),0,0,2*E(3)^2,0,0,0,E(3)^2,E(3),
-2,2*E(3),0,-2*E(3)^2,-2*E(3),0,2*E(3)^2,0,0,0,-E(3),0,-E(3)^2,0,0,0,0,0,
(-3+ER(-3))/2,0,0,-11+3*ER(-3),-ER(-3),0,0,E(3)^2,-E(3),0,E(3),0,-336*E(3)^2,
(-3-ER(-3))/2,16*E(3)^2,0,0,0,0,-2*E(3),-2,-2*E(3)^2,1,6*E(3),6,-2*E(3),
1+7*ER(-3),10+4*ER(-3),0,-2,(3-ER(-3))/2,-2*E(3),16*E(3)^2,0,10-4*ER(-3),
-6*E(3)^2,E(3),-2*E(3)^2,-10-4*ER(-3),0,1,-1,0,0,0,0,336*E(3),0,-16*E(3),0,0,
2,-E(3)^2,0,-6,-10+4*ER(-3),2,(3+ER(-3))/2,-16*E(3),6*E(3),2*E(3),1-7*ER(-3),
(3-ER(-3))/2,E(3)^2,0,-336,16,0,0,-2*E(3)^2,0,6*E(3)^2,-11-3*ER(-3),-2*E(3)^2,
ER(-3),16,-6,-2,(3+ER(-3))/2,336*E(3)^2,0,-16*E(3)^2,0,-16*E(3)^2,6*E(3)^2,
2*E(3)^2,0,-336*E(3),0,16*E(3),16*E(3),-6*E(3),-2*E(3),0],[336,16,6,-16,-2,0,
1+7*ER(-3),0,1-7*ER(-3),2*E(3)^2,0,1,(-3+ER(-3))/2,(-3-ER(-3))/2,0,2*E(3),2,1,
E(3),0,-E(3)^2,0,-E(3),0,0,E(3)^2,-6*E(3)^2,0,-2,2,0,-6*E(3),0,-1,
-11-3*ER(-3),1,-11+3*ER(-3),1,0,-2*E(3)^2,0,-2*E(3),0,0,ER(-3),-ER(-3),-E(3),
-E(3)^2,2*E(3),0,0,2*E(3)^2,0,0,0,-E(3)^2,-E(3),2,2*E(3),0,-2*E(3)^2,-2*E(3),
0,2*E(3)^2,0,0,0,E(3),0,E(3)^2,0,0,0,0,0,(-3+ER(-3))/2,0,0,11-3*ER(-3),
-ER(-3),0,0,-E(3)^2,E(3),0,E(3),0,-336*E(3)^2,(-3-ER(-3))/2,16*E(3)^2,0,0,0,0,
-2*E(3),-2,-2*E(3)^2,-1,6*E(3),6,2*E(3),-1-7*ER(-3),-10-4*ER(-3),0,-2,
(3-ER(-3))/2,-2*E(3),-16*E(3)^2,0,-10+4*ER(-3),-6*E(3)^2,-E(3),2*E(3)^2,
10+4*ER(-3),0,-1,-1,0,0,0,0,336*E(3),0,-16*E(3),0,0,2,E(3)^2,0,-6,10-4*ER(-3),
-2,(3+ER(-3))/2,16*E(3),6*E(3),-2*E(3),-1+7*ER(-3),(3-ER(-3))/2,E(3)^2,0,-336,
16,0,0,-2*E(3)^2,0,6*E(3)^2,11+3*ER(-3),2*E(3)^2,ER(-3),-16,-6,2,(3+ER(-3))/2,
336*E(3)^2,0,-16*E(3)^2,0,16*E(3)^2,6*E(3)^2,-2*E(3)^2,0,-336*E(3),0,16*E(3),
-16*E(3),-6*E(3),2*E(3),0],[336,-16,6,-16,2,0,-1+7*ER(-3),0,-1-7*ER(-3),
2*E(3),0,1,(-3-ER(-3))/2,(-3+ER(-3))/2,0,2*E(3)^2,2,-1,-E(3)^2,0,E(3),0,
E(3)^2,0,0,-E(3),-6*E(3),0,-2,2,0,-6*E(3)^2,0,1,11-3*ER(-3),-1,11+3*ER(-3),-1,
0,2*E(3),0,2*E(3)^2,0,0,-ER(-3),ER(-3),-E(3)^2,-E(3),2*E(3)^2,0,0,2*E(3),0,0,
0,E(3),E(3)^2,-2,2*E(3)^2,0,-2*E(3),-2*E(3)^2,0,2*E(3),0,0,0,-E(3)^2,0,-E(3),
0,0,0,0,0,(-3-ER(-3))/2,0,0,-11-3*ER(-3),ER(-3),0,0,E(3),-E(3)^2,0,E(3)^2,0,
-336*E(3),(-3+ER(-3))/2,16*E(3),0,0,0,0,-2*E(3)^2,-2,-2*E(3),1,6*E(3)^2,6,
-2*E(3)^2,1-7*ER(-3),10-4*ER(-3),0,-2,(3+ER(-3))/2,-2*E(3)^2,16*E(3),0,
10+4*ER(-3),-6*E(3),E(3)^2,-2*E(3),-10+4*ER(-3),0,1,-1,0,0,0,0,336*E(3)^2,0,
-16*E(3)^2,0,0,2,-E(3),0,-6,-10-4*ER(-3),2,(3-ER(-3))/2,-16*E(3)^2,6*E(3)^2,
2*E(3)^2,1+7*ER(-3),(3+ER(-3))/2,E(3),0,-336,16,0,0,-2*E(3),0,6*E(3),
-11+3*ER(-3),-2*E(3),-ER(-3),16,-6,-2,(3-ER(-3))/2,336*E(3),0,-16*E(3),0,
-16*E(3),6*E(3),2*E(3),0,-336*E(3)^2,0,16*E(3)^2,16*E(3)^2,-6*E(3)^2,
-2*E(3)^2,0],[384,64,12,0,-2,0,-8*E(3),0,-8*E(3)^2,0,0,-1,-ER(-3),ER(-3),0,0,
0,-1,1,0,-1,0,-1,0,0,1,24*E(3),E(3),0,0,E(3)^2,24*E(3)^2,0,1,-8,E(3)^2,-8,
E(3),0,4*E(3),0,4*E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,E(3)^2,E(3),0,0,0,0,
0,0,0,E(3),E(3)^2,-4,0,-E(3)^2,0,0,-E(3),0,0,0,0,-E(3)^2,0,-E(3),0,0,0,0,1,
(-3+ER(-3))/2,0,0,8,(3+ER(-3))/2,0,0,-E(3)^2,E(3),0,-E(3)^2,0,-384*E(3),
(-3-ER(-3))/2,0,0,0,0,0,0,0,0,-E(3),-24*E(3)^2,-24,-4*E(3)^2,8*E(3),8*E(3),0,
0,ER(-3),0,-64*E(3),0,8*E(3)^2,-12*E(3),-E(3),2*E(3),-8*E(3),0,-E(3)^2,1,0,-1,
0,0,384*E(3)^2,0,0,0,0,0,E(3)^2,0,24,-8*E(3)^2,4,(3+ER(-3))/2,64*E(3)^2,
12*E(3)^2,-2*E(3)^2,8*E(3)^2,(3-ER(-3))/2,-E(3),0,-384,0,0,0,0,0,-24*E(3),8,
-4*E(3),(3-ER(-3))/2,-64,-12,2,-ER(-3),384*E(3),0,0,0,64*E(3),12*E(3),-2*E(3),
0,-384*E(3)^2,0,0,-64*E(3)^2,-12*E(3)^2,2*E(3)^2,0],[384,-64,12,0,2,0,8*E(3),
0,8*E(3)^2,0,0,-1,-ER(-3),ER(-3),0,0,0,1,-1,0,1,0,1,0,0,-1,24*E(3),E(3),0,0,
E(3)^2,24*E(3)^2,0,-1,8,-E(3)^2,8,-E(3),0,-4*E(3),0,-4*E(3)^2,0,0,
(-3-ER(-3))/2,(-3+ER(-3))/2,E(3)^2,E(3),0,0,0,0,0,0,0,-E(3),-E(3)^2,4,0,
-E(3)^2,0,0,-E(3),0,0,0,0,E(3)^2,0,E(3),0,0,0,0,1,(-3+ER(-3))/2,0,0,-8,
(3+ER(-3))/2,0,0,E(3)^2,-E(3),0,-E(3)^2,0,-384*E(3),(-3-ER(-3))/2,0,0,0,0,0,0,
0,0,E(3),-24*E(3)^2,-24,4*E(3)^2,-8*E(3),-8*E(3),0,0,ER(-3),0,64*E(3),0,
-8*E(3)^2,-12*E(3),E(3),-2*E(3),8*E(3),0,E(3)^2,1,0,-1,0,0,384*E(3)^2,0,0,0,0,
0,-E(3)^2,0,24,8*E(3)^2,-4,(3+ER(-3))/2,-64*E(3)^2,12*E(3)^2,2*E(3)^2,
-8*E(3)^2,(3-ER(-3))/2,-E(3),0,-384,0,0,0,0,0,-24*E(3),-8,4*E(3),(3-ER(-3))/2,
64,-12,-2,-ER(-3),384*E(3),0,0,0,-64*E(3),12*E(3),2*E(3),0,-384*E(3)^2,0,0,
64*E(3)^2,-12*E(3)^2,-2*E(3)^2,0],[384,64,12,0,-2,0,-8*E(3)^2,0,-8*E(3),0,0,
-1,ER(-3),-ER(-3),0,0,0,-1,1,0,-1,0,-1,0,0,1,24*E(3)^2,E(3)^2,0,0,E(3),
24*E(3),0,1,-8,E(3),-8,E(3)^2,0,4*E(3)^2,0,4*E(3),0,0,(-3+ER(-3))/2,
(-3-ER(-3))/2,E(3),E(3)^2,0,0,0,0,0,0,0,E(3)^2,E(3),-4,0,-E(3),0,0,-E(3)^2,0,
0,0,0,-E(3),0,-E(3)^2,0,0,0,0,1,(-3-ER(-3))/2,0,0,8,(3-ER(-3))/2,0,0,-E(3),
E(3)^2,0,-E(3),0,-384*E(3)^2,(-3+ER(-3))/2,0,0,0,0,0,0,0,0,-E(3)^2,-24*E(3),
-24,-4*E(3),8*E(3)^2,8*E(3)^2,0,0,-ER(-3),0,-64*E(3)^2,0,8*E(3),-12*E(3)^2,
-E(3)^2,2*E(3)^2,-8*E(3)^2,0,-E(3),1,0,-1,0,0,384*E(3),0,0,0,0,0,E(3),0,24,
-8*E(3),4,(3-ER(-3))/2,64*E(3),12*E(3),-2*E(3),8*E(3),(3+ER(-3))/2,-E(3)^2,0,
-384,0,0,0,0,0,-24*E(3)^2,8,-4*E(3)^2,(3+ER(-3))/2,-64,-12,2,ER(-3),
384*E(3)^2,0,0,0,64*E(3)^2,12*E(3)^2,-2*E(3)^2,0,-384*E(3),0,0,-64*E(3),
-12*E(3),2*E(3),0],[384,-64,12,0,2,0,8*E(3)^2,0,8*E(3),0,0,-1,ER(-3),-ER(-3),
0,0,0,1,-1,0,1,0,1,0,0,-1,24*E(3)^2,E(3)^2,0,0,E(3),24*E(3),0,-1,8,-E(3),8,
-E(3)^2,0,-4*E(3)^2,0,-4*E(3),0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,E(3),E(3)^2,0,0,
0,0,0,0,0,-E(3)^2,-E(3),4,0,-E(3),0,0,-E(3)^2,0,0,0,0,E(3),0,E(3)^2,0,0,0,0,1,
(-3-ER(-3))/2,0,0,-8,(3-ER(-3))/2,0,0,E(3),-E(3)^2,0,-E(3),0,-384*E(3)^2,
(-3+ER(-3))/2,0,0,0,0,0,0,0,0,E(3)^2,-24*E(3),-24,4*E(3),-8*E(3)^2,-8*E(3)^2,
0,0,-ER(-3),0,64*E(3)^2,0,-8*E(3),-12*E(3)^2,E(3)^2,-2*E(3)^2,8*E(3)^2,0,E(3),
1,0,-1,0,0,384*E(3),0,0,0,0,0,-E(3),0,24,8*E(3),-4,(3-ER(-3))/2,-64*E(3),
12*E(3),2*E(3),-8*E(3),(3+ER(-3))/2,-E(3)^2,0,-384,0,0,0,0,0,-24*E(3)^2,-8,
4*E(3)^2,(3+ER(-3))/2,64,-12,-2,ER(-3),384*E(3)^2,0,0,0,-64*E(3)^2,12*E(3)^2,
2*E(3)^2,0,-384*E(3),0,0,64*E(3),-12*E(3),-2*E(3),0],[384,-64,12,0,2,0,
8*E(3)^2,0,8*E(3),0,0,-1,ER(-3),-ER(-3),0,0,0,1,-1,0,-1,0,-1,0,0,-1,24*E(3)^2,
-E(3)^2,0,0,-E(3),24*E(3),0,1,8,-E(3),8,-E(3)^2,0,-4*E(3)^2,0,-4*E(3),0,0,
(-3+ER(-3))/2,(-3-ER(-3))/2,-E(3),-E(3)^2,0,0,0,0,0,0,0,E(3)^2,E(3),-4,0,
-E(3),0,0,-E(3)^2,0,0,0,0,E(3),0,E(3)^2,0,0,0,0,-1,(3+ER(-3))/2,0,0,8,
(-3+ER(-3))/2,0,0,-E(3),-E(3)^2,0,-E(3),0,384*E(3)^2,(3-ER(-3))/2,0,0,0,0,0,0,
0,0,-E(3)^2,24*E(3),24,-4*E(3),8*E(3)^2,8*E(3)^2,0,0,ER(-3),0,-64*E(3)^2,0,
8*E(3),12*E(3)^2,-E(3)^2,2*E(3)^2,8*E(3)^2,0,-E(3),-1,0,-1,0,0,384*E(3),0,0,0,
0,0,-E(3),0,24,8*E(3),-4,(3-ER(-3))/2,-64*E(3),12*E(3),2*E(3),8*E(3),
(3+ER(-3))/2,-E(3)^2,0,384,0,0,0,0,0,24*E(3)^2,8,-4*E(3)^2,(-3-ER(-3))/2,-64,
12,2,-ER(-3),384*E(3)^2,0,0,0,-64*E(3)^2,12*E(3)^2,2*E(3)^2,0,384*E(3),0,0,
-64*E(3),12*E(3),2*E(3),0],[384,64,12,0,-2,0,-8*E(3)^2,0,-8*E(3),0,0,-1,
ER(-3),-ER(-3),0,0,0,-1,1,0,1,0,1,0,0,1,24*E(3)^2,-E(3)^2,0,0,-E(3),24*E(3),0,
-1,-8,E(3),-8,E(3)^2,0,4*E(3)^2,0,4*E(3),0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,
-E(3),-E(3)^2,0,0,0,0,0,0,0,-E(3)^2,-E(3),4,0,-E(3),0,0,-E(3)^2,0,0,0,0,-E(3),
0,-E(3)^2,0,0,0,0,-1,(3+ER(-3))/2,0,0,-8,(-3+ER(-3))/2,0,0,E(3),E(3)^2,0,
-E(3),0,384*E(3)^2,(3-ER(-3))/2,0,0,0,0,0,0,0,0,E(3)^2,24*E(3),24,4*E(3),
-8*E(3)^2,-8*E(3)^2,0,0,ER(-3),0,64*E(3)^2,0,-8*E(3),12*E(3)^2,E(3)^2,
-2*E(3)^2,-8*E(3)^2,0,E(3),-1,0,-1,0,0,384*E(3),0,0,0,0,0,E(3),0,24,-8*E(3),4,
(3-ER(-3))/2,64*E(3),12*E(3),-2*E(3),-8*E(3),(3+ER(-3))/2,-E(3)^2,0,384,0,0,0,
0,0,24*E(3)^2,-8,4*E(3)^2,(-3-ER(-3))/2,64,12,-2,-ER(-3),384*E(3)^2,0,0,0,
64*E(3)^2,12*E(3)^2,-2*E(3)^2,0,384*E(3),0,0,64*E(3),12*E(3),-2*E(3),0],[384,
-64,12,0,2,0,8*E(3),0,8*E(3)^2,0,0,-1,-ER(-3),ER(-3),0,0,0,1,-1,0,-1,0,-1,0,0,
-1,24*E(3),-E(3),0,0,-E(3)^2,24*E(3)^2,0,1,8,-E(3)^2,8,-E(3),0,-4*E(3),0,
-4*E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,-E(3)^2,-E(3),0,0,0,0,0,0,0,E(3),
E(3)^2,-4,0,-E(3)^2,0,0,-E(3),0,0,0,0,E(3)^2,0,E(3),0,0,0,0,-1,(3-ER(-3))/2,0,
0,8,(-3-ER(-3))/2,0,0,-E(3)^2,-E(3),0,-E(3)^2,0,384*E(3),(3+ER(-3))/2,0,0,0,0,
0,0,0,0,-E(3),24*E(3)^2,24,-4*E(3)^2,8*E(3),8*E(3),0,0,-ER(-3),0,-64*E(3),0,
8*E(3)^2,12*E(3),-E(3),2*E(3),8*E(3),0,-E(3)^2,-1,0,-1,0,0,384*E(3)^2,0,0,0,0,
0,-E(3)^2,0,24,8*E(3)^2,-4,(3+ER(-3))/2,-64*E(3)^2,12*E(3)^2,2*E(3)^2,
8*E(3)^2,(3-ER(-3))/2,-E(3),0,384,0,0,0,0,0,24*E(3),8,-4*E(3),(-3+ER(-3))/2,
-64,12,2,ER(-3),384*E(3),0,0,0,-64*E(3),12*E(3),2*E(3),0,384*E(3)^2,0,0,
-64*E(3)^2,12*E(3)^2,2*E(3)^2,0],[384,64,12,0,-2,0,-8*E(3),0,-8*E(3)^2,0,0,-1,
-ER(-3),ER(-3),0,0,0,-1,1,0,1,0,1,0,0,1,24*E(3),-E(3),0,0,-E(3)^2,24*E(3)^2,0,
-1,-8,E(3)^2,-8,E(3),0,4*E(3),0,4*E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,
-E(3)^2,-E(3),0,0,0,0,0,0,0,-E(3),-E(3)^2,4,0,-E(3)^2,0,0,-E(3),0,0,0,0,
-E(3)^2,0,-E(3),0,0,0,0,-1,(3-ER(-3))/2,0,0,-8,(-3-ER(-3))/2,0,0,E(3)^2,E(3),
0,-E(3)^2,0,384*E(3),(3+ER(-3))/2,0,0,0,0,0,0,0,0,E(3),24*E(3)^2,24,4*E(3)^2,
-8*E(3),-8*E(3),0,0,-ER(-3),0,64*E(3),0,-8*E(3)^2,12*E(3),E(3),-2*E(3),
-8*E(3),0,E(3)^2,-1,0,-1,0,0,384*E(3)^2,0,0,0,0,0,E(3)^2,0,24,-8*E(3)^2,4,
(3+ER(-3))/2,64*E(3)^2,12*E(3)^2,-2*E(3)^2,-8*E(3)^2,(3-ER(-3))/2,-E(3),0,384,
0,0,0,0,0,24*E(3),-8,4*E(3),(-3+ER(-3))/2,64,12,-2,ER(-3),384*E(3),0,0,0,
64*E(3),12*E(3),-2*E(3),0,384*E(3)^2,0,0,64*E(3)^2,12*E(3)^2,-2*E(3)^2,0],
[420,-60,6,4,0,0,3,4,3,1,-3,0,0,0,0,1,-2,0,0,0,0,0,0,0,1,0,-39,0,-2,-2,0,-39,
0,0,3,0,3,0,-2,6,1,6,-1,-1,0,0,0,0,-2,0,1,-2,1,0,0,0,0,6,-2,0,-2,-2,0,-2,4,1,
-1,0,0,0,0,0,-1,6,0,0,0,0,3,0,1,0,0,0,0,0,-4,420,0,4,4,0,4,-3,1,1,-2,0,-39,
-39,6,3,3,-2,-2,0,-2,-60,6,3,6,0,0,3,1,0,0,1,0,0,-4,420,4,4,0,4,1,0,-1,-39,3,
6,0,-60,6,0,3,0,0,-4,420,4,4,0,1,-1,-39,3,6,0,-60,6,0,0,420,4,4,0,-60,6,0,0,
420,4,4,-60,6,0,0],[420,60,6,4,0,0,-3,-4,-3,1,-3,0,0,0,0,1,-2,0,0,0,0,0,0,0,
-1,0,-39,0,-2,-2,0,-39,0,0,-3,0,-3,0,2,-6,-1,-6,1,1,0,0,0,0,-2,0,1,-2,1,0,0,0,
0,-6,-2,0,-2,-2,0,-2,4,1,1,0,0,0,0,0,1,6,0,0,0,0,-3,0,1,0,0,0,0,0,4,420,0,4,4,
0,-4,-3,1,1,-2,0,-39,-39,-6,-3,-3,2,-2,0,-2,60,6,-3,6,0,0,-3,1,0,0,1,0,0,4,
420,4,4,0,-4,1,0,1,-39,-3,-6,0,60,6,0,-3,0,0,4,420,4,4,0,1,1,-39,-3,-6,0,60,6,
0,0,420,4,4,0,60,6,0,0,420,4,4,60,6,0,0],[420,0,6,-20,0,0,0,0,0,-2,6,0,0,0,0,
-2,-2,0,0,0,0,0,0,0,0,0,42,0,2,-2,0,42,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-2,0,
-2,-2,-2,0,0,0,0,0,-2,0,2,2,0,-2,4,2,0,0,0,0,0,0,0,6,0,0,0,0,0,0,-2,0,0,0,0,0,
0,-420,0,20,-4,0,0,-6,2,2,2,0,-42,-42,0,0,0,0,2,0,2,0,-6,0,-6,0,0,0,2,0,0,2,0,
0,0,420,4,-20,0,0,-2,0,0,42,0,0,0,0,6,0,0,0,0,0,-420,20,-4,0,2,0,-42,0,0,0,0,
-6,0,0,420,4,-20,0,0,6,0,0,-420,-4,20,0,-6,0,0],[420,80,12,12,2,0,
(1+5*ER(-3))/2,0,(1-5*ER(-3))/2,-3*E(3),0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,0,
-3*E(3)^2,0,0,-E(3),0,E(3)^2,0,E(3),0,0,-E(3)^2,-21*E(3),0,0,0,0,-21*E(3)^2,0,
0,(7-3*ER(-3))/2,-E(3),(7+3*ER(-3))/2,-E(3)^2,0,-4*E(3),0,-4*E(3)^2,
(-3-ER(-3))/2,(-3+ER(-3))/2,(3-ER(-3))/2,(3+ER(-3))/2,0,0,0,0,-E(3),0,-E(3)^2,
0,0,0,0,4,0,0,0,0,0,0,-4,1,-ER(-3),0,0,0,0,0,ER(-3),0,0,-ER(-3),0,0,
(-7-3*ER(-3))/2,(-3+ER(-3))/2,-1,0,1,-1,0,0,0,-420*E(3),ER(-3),-12*E(3),
4*E(3),0,0,0,3*E(3)^2,3,0,E(3)^2,21*E(3)^2,21,4*E(3)^2,(-1-5*ER(-3))/2,
4-ER(-3),0,0,(3-ER(-3))/2,0,-80*E(3),0,4+ER(-3),-12*E(3),1,-2*E(3),-4+ER(-3),
E(3),E(3),0,E(3)^2,0,0,0,420*E(3)^2,-4*E(3)^2,12*E(3)^2,0,0,-3,-1,
(3+ER(-3))/2,-21,-4-ER(-3),-4,-ER(-3),80*E(3)^2,12*E(3)^2,2*E(3)^2,
(-1+5*ER(-3))/2,ER(-3),0,0,-420,-12,4,0,3*E(3),(3-ER(-3))/2,21*E(3),
(-7+3*ER(-3))/2,4*E(3),(-3-ER(-3))/2,-80,-12,-2,(3+ER(-3))/2,420*E(3),-4*E(3),
12*E(3),0,80*E(3),12*E(3),2*E(3),0,-420*E(3)^2,4*E(3)^2,-12*E(3)^2,-80*E(3)^2,
-12*E(3)^2,-2*E(3)^2,0],[420,-80,12,12,-2,0,(-1+5*ER(-3))/2,0,(-1-5*ER(-3))/2,
-3*E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,0,-3*E(3),0,0,E(3)^2,0,-E(3),0,
-E(3)^2,0,0,E(3),-21*E(3)^2,0,0,0,0,-21*E(3),0,0,(-7-3*ER(-3))/2,E(3)^2,
(-7+3*ER(-3))/2,E(3),0,4*E(3)^2,0,4*E(3),(3-ER(-3))/2,(3+ER(-3))/2,
(3+ER(-3))/2,(3-ER(-3))/2,0,0,0,0,-E(3)^2,0,-E(3),0,0,0,0,-4,0,0,0,0,0,0,-4,1,
-ER(-3),0,0,0,0,0,ER(-3),0,0,ER(-3),0,0,(7-3*ER(-3))/2,(-3-ER(-3))/2,-1,0,-1,
1,0,0,0,-420*E(3)^2,-ER(-3),-12*E(3)^2,4*E(3)^2,0,0,0,3*E(3),3,0,-E(3),
21*E(3),21,-4*E(3),(1-5*ER(-3))/2,-4-ER(-3),0,0,(3+ER(-3))/2,0,80*E(3)^2,0,
-4+ER(-3),-12*E(3)^2,-1,2*E(3)^2,4+ER(-3),E(3)^2,-E(3)^2,0,E(3),0,0,0,
420*E(3),-4*E(3),12*E(3),0,0,-3,1,(-3+ER(-3))/2,-21,4-ER(-3),4,ER(-3),
-80*E(3),12*E(3),-2*E(3),(1+5*ER(-3))/2,-ER(-3),0,0,-420,-12,4,0,3*E(3)^2,
(-3-ER(-3))/2,21*E(3)^2,(7+3*ER(-3))/2,-4*E(3)^2,(-3+ER(-3))/2,80,-12,2,
(3-ER(-3))/2,420*E(3)^2,-4*E(3)^2,12*E(3)^2,0,-80*E(3)^2,12*E(3)^2,-2*E(3)^2,
0,-420*E(3),4*E(3),-12*E(3),80*E(3),-12*E(3),2*E(3),0],[420,80,12,12,2,0,
(1-5*ER(-3))/2,0,(1+5*ER(-3))/2,-3*E(3)^2,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,0,
-3*E(3),0,0,-E(3)^2,0,E(3),0,E(3)^2,0,0,-E(3),-21*E(3)^2,0,0,0,0,-21*E(3),0,0,
(7+3*ER(-3))/2,-E(3)^2,(7-3*ER(-3))/2,-E(3),0,-4*E(3)^2,0,-4*E(3),
(-3+ER(-3))/2,(-3-ER(-3))/2,(3+ER(-3))/2,(3-ER(-3))/2,0,0,0,0,-E(3)^2,0,-E(3),
0,0,0,0,4,0,0,0,0,0,0,-4,1,ER(-3),0,0,0,0,0,-ER(-3),0,0,ER(-3),0,0,
(-7+3*ER(-3))/2,(-3-ER(-3))/2,-1,0,1,-1,0,0,0,-420*E(3)^2,-ER(-3),-12*E(3)^2,
4*E(3)^2,0,0,0,3*E(3),3,0,E(3),21*E(3),21,4*E(3),(-1+5*ER(-3))/2,4+ER(-3),0,0,
(3+ER(-3))/2,0,-80*E(3)^2,0,4-ER(-3),-12*E(3)^2,1,-2*E(3)^2,-4-ER(-3),E(3)^2,
E(3)^2,0,E(3),0,0,0,420*E(3),-4*E(3),12*E(3),0,0,-3,-1,(3-ER(-3))/2,-21,
-4+ER(-3),-4,ER(-3),80*E(3),12*E(3),2*E(3),(-1-5*ER(-3))/2,-ER(-3),0,0,-420,
-12,4,0,3*E(3)^2,(3+ER(-3))/2,21*E(3)^2,(-7-3*ER(-3))/2,4*E(3)^2,
(-3+ER(-3))/2,-80,-12,-2,(3-ER(-3))/2,420*E(3)^2,-4*E(3)^2,12*E(3)^2,0,
80*E(3)^2,12*E(3)^2,2*E(3)^2,0,-420*E(3),4*E(3),-12*E(3),-80*E(3),-12*E(3),
-2*E(3),0],[420,-80,12,12,-2,0,(-1-5*ER(-3))/2,0,(-1+5*ER(-3))/2,-3*E(3),0,0,
(-3+ER(-3))/2,(-3-ER(-3))/2,0,-3*E(3)^2,0,0,E(3),0,-E(3)^2,0,-E(3),0,0,E(3)^2,
-21*E(3),0,0,0,0,-21*E(3)^2,0,0,(-7+3*ER(-3))/2,E(3),(-7-3*ER(-3))/2,E(3)^2,0,
4*E(3),0,4*E(3)^2,(3+ER(-3))/2,(3-ER(-3))/2,(3-ER(-3))/2,(3+ER(-3))/2,0,0,0,0,
-E(3),0,-E(3)^2,0,0,0,0,-4,0,0,0,0,0,0,-4,1,ER(-3),0,0,0,0,0,-ER(-3),0,0,
-ER(-3),0,0,(7+3*ER(-3))/2,(-3+ER(-3))/2,-1,0,-1,1,0,0,0,-420*E(3),ER(-3),
-12*E(3),4*E(3),0,0,0,3*E(3)^2,3,0,-E(3)^2,21*E(3)^2,21,-4*E(3)^2,
(1+5*ER(-3))/2,-4+ER(-3),0,0,(3-ER(-3))/2,0,80*E(3),0,-4-ER(-3),-12*E(3),-1,
2*E(3),4-ER(-3),E(3),-E(3),0,E(3)^2,0,0,0,420*E(3)^2,-4*E(3)^2,12*E(3)^2,0,0,
-3,1,(-3-ER(-3))/2,-21,4+ER(-3),4,-ER(-3),-80*E(3)^2,12*E(3)^2,-2*E(3)^2,
(1-5*ER(-3))/2,ER(-3),0,0,-420,-12,4,0,3*E(3),(-3+ER(-3))/2,21*E(3),
(7-3*ER(-3))/2,-4*E(3),(-3-ER(-3))/2,80,-12,2,(3+ER(-3))/2,420*E(3),-4*E(3),
12*E(3),0,-80*E(3),12*E(3),-2*E(3),0,-420*E(3)^2,4*E(3)^2,-12*E(3)^2,
80*E(3)^2,-12*E(3)^2,2*E(3)^2,0],[420,20,-6,4,2,0,(-11-5*ER(-3))/2,-12,
(-11+5*ER(-3))/2,E(3)^2,0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,E(3),-2,0,-E(3),0,
-E(3)^2,0,-E(3),0,0,-E(3)^2,33*E(3)^2,0,-2,-2,0,33*E(3),0,0,(13-3*ER(-3))/2,
-1,(13+3*ER(-3))/2,-1,0,2*E(3)^2,0,2*E(3),-E(3)^2,-E(3),-ER(-3),ER(-3),0,0,
-2*E(3),0,E(3)^2,-2*E(3)^2,E(3),0,0,0,0,2,-2*E(3),0,-2*E(3)^2,-2*E(3),0,
-2*E(3)^2,4,1,-1,0,0,0,0,0,-1,0,0,(-3+ER(-3))/2,0,0,(13+3*ER(-3))/2,-ER(-3),1,
0,-E(3)^2,-E(3),0,0,-4*E(3),420*E(3)^2,(-3-ER(-3))/2,4*E(3)^2,4*E(3)^2,0,
-12*E(3)^2,0,E(3),1,-2*E(3)^2,-1,33*E(3),33,2*E(3),(-11-5*ER(-3))/2,
-1-4*ER(-3),0,-2,(3-ER(-3))/2,-2*E(3),20*E(3)^2,0,-1+4*ER(-3),-6*E(3)^2,-E(3),
2*E(3)^2,-1-4*ER(-3),E(3)^2,-1,0,E(3),0,0,-4,420*E(3),4*E(3),4*E(3),0,
-12*E(3),1,-E(3)^2,-E(3)^2,33,-1+4*ER(-3),2,(-3-ER(-3))/2,20*E(3),-6*E(3),
2*E(3),(-11+5*ER(-3))/2,(-3+ER(-3))/2,0,-4*E(3)^2,420,4,4,0,E(3)^2,-E(3),
33*E(3)^2,(13-3*ER(-3))/2,2*E(3)^2,ER(-3),20,-6,2,(3+ER(-3))/2,420*E(3)^2,
4*E(3)^2,4*E(3)^2,0,20*E(3)^2,-6*E(3)^2,2*E(3)^2,0,420*E(3),4*E(3),4*E(3),
20*E(3),-6*E(3),2*E(3),0],[420,-20,-6,4,-2,0,(11+5*ER(-3))/2,12,
(11-5*ER(-3))/2,E(3)^2,0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,E(3),-2,0,E(3),0,
E(3)^2,0,E(3),0,0,E(3)^2,33*E(3)^2,0,-2,-2,0,33*E(3),0,0,(-13+3*ER(-3))/2,1,
(-13-3*ER(-3))/2,1,0,-2*E(3)^2,0,-2*E(3),E(3)^2,E(3),-ER(-3),ER(-3),0,0,
-2*E(3),0,E(3)^2,-2*E(3)^2,E(3),0,0,0,0,-2,-2*E(3),0,-2*E(3)^2,-2*E(3),0,
-2*E(3)^2,4,1,1,0,0,0,0,0,1,0,0,(-3+ER(-3))/2,0,0,(-13-3*ER(-3))/2,-ER(-3),1,
0,E(3)^2,E(3),0,0,4*E(3),420*E(3)^2,(-3-ER(-3))/2,4*E(3)^2,4*E(3)^2,0,
12*E(3)^2,0,E(3),1,-2*E(3)^2,1,33*E(3),33,-2*E(3),(11+5*ER(-3))/2,1+4*ER(-3),
0,-2,(3-ER(-3))/2,-2*E(3),-20*E(3)^2,0,1-4*ER(-3),-6*E(3)^2,E(3),-2*E(3)^2,
1+4*ER(-3),E(3)^2,1,0,E(3),0,0,4,420*E(3),4*E(3),4*E(3),0,12*E(3),1,E(3)^2,
E(3)^2,33,1-4*ER(-3),-2,(-3-ER(-3))/2,-20*E(3),-6*E(3),-2*E(3),
(11-5*ER(-3))/2,(-3+ER(-3))/2,0,4*E(3)^2,420,4,4,0,E(3)^2,E(3),33*E(3)^2,
(-13+3*ER(-3))/2,-2*E(3)^2,ER(-3),-20,-6,-2,(3+ER(-3))/2,420*E(3)^2,4*E(3)^2,
4*E(3)^2,0,-20*E(3)^2,-6*E(3)^2,-2*E(3)^2,0,420*E(3),4*E(3),4*E(3),-20*E(3),
-6*E(3),-2*E(3),0],[420,20,-6,4,2,0,(-11+5*ER(-3))/2,-12,(-11-5*ER(-3))/2,
E(3),0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,E(3)^2,-2,0,-E(3)^2,0,-E(3),0,-E(3)^2,0,
0,-E(3),33*E(3),0,-2,-2,0,33*E(3)^2,0,0,(13+3*ER(-3))/2,-1,(13-3*ER(-3))/2,-1,
0,2*E(3),0,2*E(3)^2,-E(3),-E(3)^2,ER(-3),-ER(-3),0,0,-2*E(3)^2,0,E(3),-2*E(3),
E(3)^2,0,0,0,0,2,-2*E(3)^2,0,-2*E(3),-2*E(3)^2,0,-2*E(3),4,1,-1,0,0,0,0,0,-1,
0,0,(-3-ER(-3))/2,0,0,(13-3*ER(-3))/2,ER(-3),1,0,-E(3),-E(3)^2,0,0,-4*E(3)^2,
420*E(3),(-3+ER(-3))/2,4*E(3),4*E(3),0,-12*E(3),0,E(3)^2,1,-2*E(3),-1,
33*E(3)^2,33,2*E(3)^2,(-11+5*ER(-3))/2,-1+4*ER(-3),0,-2,(3+ER(-3))/2,
-2*E(3)^2,20*E(3),0,-1-4*ER(-3),-6*E(3),-E(3)^2,2*E(3),-1+4*ER(-3),E(3),-1,0,
E(3)^2,0,0,-4,420*E(3)^2,4*E(3)^2,4*E(3)^2,0,-12*E(3)^2,1,-E(3),-E(3),33,
-1-4*ER(-3),2,(-3+ER(-3))/2,20*E(3)^2,-6*E(3)^2,2*E(3)^2,(-11-5*ER(-3))/2,
(-3-ER(-3))/2,0,-4*E(3),420,4,4,0,E(3),-E(3)^2,33*E(3),(13+3*ER(-3))/2,2*E(3),
-ER(-3),20,-6,2,(3-ER(-3))/2,420*E(3),4*E(3),4*E(3),0,20*E(3),-6*E(3),2*E(3),
0,420*E(3)^2,4*E(3)^2,4*E(3)^2,20*E(3)^2,-6*E(3)^2,2*E(3)^2,0],[420,-20,-6,4,
-2,0,(11-5*ER(-3))/2,12,(11+5*ER(-3))/2,E(3),0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,
E(3)^2,-2,0,E(3)^2,0,E(3),0,E(3)^2,0,0,E(3),33*E(3),0,-2,-2,0,33*E(3)^2,0,0,
(-13-3*ER(-3))/2,1,(-13+3*ER(-3))/2,1,0,-2*E(3),0,-2*E(3)^2,E(3),E(3)^2,
ER(-3),-ER(-3),0,0,-2*E(3)^2,0,E(3),-2*E(3),E(3)^2,0,0,0,0,-2,-2*E(3)^2,0,
-2*E(3),-2*E(3)^2,0,-2*E(3),4,1,1,0,0,0,0,0,1,0,0,(-3-ER(-3))/2,0,0,
(-13+3*ER(-3))/2,ER(-3),1,0,E(3),E(3)^2,0,0,4*E(3)^2,420*E(3),(-3+ER(-3))/2,
4*E(3),4*E(3),0,12*E(3),0,E(3)^2,1,-2*E(3),1,33*E(3)^2,33,-2*E(3)^2,
(11-5*ER(-3))/2,1-4*ER(-3),0,-2,(3+ER(-3))/2,-2*E(3)^2,-20*E(3),0,1+4*ER(-3),
-6*E(3),E(3)^2,-2*E(3),1-4*ER(-3),E(3),1,0,E(3)^2,0,0,4,420*E(3)^2,4*E(3)^2,
4*E(3)^2,0,12*E(3)^2,1,E(3),E(3),33,1+4*ER(-3),-2,(-3+ER(-3))/2,-20*E(3)^2,
-6*E(3)^2,-2*E(3)^2,(11+5*ER(-3))/2,(-3-ER(-3))/2,0,4*E(3),420,4,4,0,E(3),
E(3)^2,33*E(3),(-13-3*ER(-3))/2,-2*E(3),-ER(-3),-20,-6,-2,(3-ER(-3))/2,
420*E(3),4*E(3),4*E(3),0,-20*E(3),-6*E(3),-2*E(3),0,420*E(3)^2,4*E(3)^2,
4*E(3)^2,-20*E(3)^2,-6*E(3)^2,-2*E(3)^2,0],[504,-96,18,8,0,0,-6,0,-6,2,0,-1,0,
0,0,2,2,-1,0,0,0,0,0,0,0,0,18,0,-2,-1,0,18,0,1,-6,0,-6,0,-3,-3,0,-3,0,0,0,0,1,
1,-1,0,0,-1,0,0,0,1,1,3,2,0,1,1,0,2,0,0,0,-1,0,-1,0,0,0,-9,0,0,0,0,6,0,0,0,0,
0,0,-1,0,-504,0,-8,0,0,0,0,-2,-2,-2,0,-18,-18,3,6,6,3,1,0,-2,96,9,6,-18,0,0,
-6,0,0,1,0,0,0,0,504,0,8,0,0,2,0,0,18,-6,-3,0,-96,18,0,6,0,-1,0,-504,-8,0,0,
-2,0,-18,6,3,0,96,-18,0,0,504,0,8,0,-96,18,0,0,-504,0,-8,96,-18,0,0],[504,96,
18,8,0,0,6,0,6,2,0,-1,0,0,0,2,2,1,0,0,0,0,0,0,0,0,18,0,-2,-1,0,18,0,-1,6,0,6,
0,3,3,0,3,0,0,0,0,1,1,-1,0,0,-1,0,0,0,-1,-1,-3,2,0,1,1,0,2,0,0,0,1,0,1,0,0,0,
-9,0,0,0,0,-6,0,0,0,0,0,0,-1,0,-504,0,-8,0,0,0,0,-2,-2,-2,0,-18,-18,-3,-6,-6,
-3,1,0,-2,-96,9,-6,-18,0,0,6,0,0,1,0,0,0,0,504,0,8,0,0,2,0,0,18,6,3,0,96,18,0,
-6,0,-1,0,-504,-8,0,0,-2,0,-18,-6,-3,0,-96,-18,0,0,504,0,8,0,96,18,0,0,-504,0,
-8,-96,-18,0,0],[504,-24,-9,8,-3,4,-6,0,-6,2,0,-1,0,0,0,2,-1,1,0,1,0,1,0,1,0,
0,18,0,1,2,0,18,0,-1,-6,0,-6,0,0,0,0,0,0,0,0,0,1,1,2,0,0,2,0,0,0,-1,-1,0,-1,0,
-2,-2,0,-1,0,0,0,1,0,1,-1,0,0,18,0,0,-1,0,6,0,0,0,0,0,0,-1,0,-504,0,-8,0,-4,0,
0,-2,-2,1,0,-18,-18,0,6,6,0,-2,0,1,24,-18,6,9,0,3,-6,0,0,1,0,0,0,0,504,0,8,4,
0,2,0,0,18,-6,0,0,-24,-9,-3,6,0,-1,0,-504,-8,0,-4,-2,0,-18,6,0,0,24,9,3,0,504,
0,8,-1,-24,-9,-3,4,-504,0,-8,24,9,3,-4],[504,24,-9,8,3,-4,6,0,6,2,0,-1,0,0,0,
2,-1,-1,0,-1,0,-1,0,-1,0,0,18,0,1,2,0,18,0,1,6,0,6,0,0,0,0,0,0,0,0,0,1,1,2,0,
0,2,0,0,0,1,1,0,-1,0,-2,-2,0,-1,0,0,0,-1,0,-1,1,0,0,18,0,0,1,0,-6,0,0,0,0,0,0,
-1,0,-504,0,-8,0,4,0,0,-2,-2,1,0,-18,-18,0,-6,-6,0,-2,0,1,-24,-18,-6,9,0,-3,6,
0,0,1,0,0,0,0,504,0,8,-4,0,2,0,0,18,6,0,0,24,-9,3,-6,0,-1,0,-504,-8,0,4,-2,0,
-18,-6,0,0,-24,9,-3,0,504,0,8,1,24,-9,3,-4,-504,0,-8,-24,9,-3,4],[540,0,0,-12,
0,0,0,0,0,-6*E(3),0,0,0,0,0,-6*E(3)^2,0,0,0,0,0,0,0,0,0,0,54*E(3),-E(3),0,0,
-E(3)^2,54*E(3)^2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-2*E(3),0,-2*E(3)^2,0,0,
0,0,0,0,E(3)^2,0,0,E(3),0,4,2,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,-2,0,0,0,0,0,0,
-540*E(3),0,12*E(3),-4*E(3),0,0,0,6*E(3)^2,6,0,0,-54*E(3)^2,-54,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,2*E(3),0,0,2*E(3)^2,1,0,0,540*E(3)^2,4*E(3)^2,-12*E(3)^2,0,0,-6,
0,0,54,0,0,0,0,0,0,0,0,0,0,-540,12,-4,0,6*E(3),0,-54*E(3),0,0,0,0,0,0,0,
540*E(3),4*E(3),-12*E(3),0,0,0,0,0,-540*E(3)^2,-4*E(3)^2,12*E(3)^2,0,0,0,0],
[540,0,0,-12,0,0,0,0,0,-6*E(3)^2,0,0,0,0,0,-6*E(3),0,0,0,0,0,0,0,0,0,0,
54*E(3)^2,-E(3)^2,0,0,-E(3),54*E(3),0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
-2*E(3)^2,0,-2*E(3),0,0,0,0,0,0,E(3),0,0,E(3)^2,0,4,2,0,0,0,0,0,0,0,0,-1,0,0,
0,0,0,-2,0,0,0,0,0,0,-540*E(3)^2,0,12*E(3)^2,-4*E(3)^2,0,0,0,6*E(3),6,0,0,
-54*E(3),-54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2*E(3)^2,0,0,2*E(3),1,0,0,540*E(3),
4*E(3),-12*E(3),0,0,-6,0,0,54,0,0,0,0,0,0,0,0,0,0,-540,12,-4,0,6*E(3)^2,0,
-54*E(3)^2,0,0,0,0,0,0,0,540*E(3)^2,4*E(3)^2,-12*E(3)^2,0,0,0,0,0,-540*E(3),
-4*E(3),12*E(3),0,0,0,0],[540,0,0,-12,0,0,9*ER(-3),0,-9*ER(-3),3,0,0,0,0,0,3,
0,0,0,0,0,0,0,0,0,0,-27,-1,0,0,-1,-27,0,0,9*ER(-3),0,-9*ER(-3),0,0,0,0,0,
-ER(-3),ER(-3),0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,1,0,0,1,0,4,-1,ER(-3),0,0,0,0,0,
-ER(-3),0,-1,0,0,0,9*ER(-3),0,1,0,0,0,0,0,0,-540,0,12,-4,0,0,0,-3,-3,0,0,27,
27,0,-9*ER(-3),9*ER(-3),0,0,0,0,0,0,-9*ER(-3),0,0,0,-9*ER(-3),-1,0,0,-1,1,0,0,
540,4,-12,0,0,3,0,ER(-3),-27,9*ER(-3),0,0,0,0,0,9*ER(-3),0,0,0,-540,12,-4,0,
-3,-ER(-3),27,-9*ER(-3),0,0,0,0,0,0,540,4,-12,0,0,0,0,0,-540,-4,12,0,0,0,0],
[540,0,0,-12,0,0,-9*ER(-3),0,9*ER(-3),3,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,-27,
-1,0,0,-1,-27,0,0,-9*ER(-3),0,9*ER(-3),0,0,0,0,0,ER(-3),-ER(-3),0,0,0,0,0,0,1,
0,1,0,0,0,0,0,0,1,0,0,1,0,4,-1,-ER(-3),0,0,0,0,0,ER(-3),0,-1,0,0,0,-9*ER(-3),
0,1,0,0,0,0,0,0,-540,0,12,-4,0,0,0,-3,-3,0,0,27,27,0,9*ER(-3),-9*ER(-3),0,0,0,
0,0,0,9*ER(-3),0,0,0,9*ER(-3),-1,0,0,-1,1,0,0,540,4,-12,0,0,3,0,-ER(-3),-27,
-9*ER(-3),0,0,0,0,0,-9*ER(-3),0,0,0,-540,12,-4,0,-3,ER(-3),27,9*ER(-3),0,0,0,
0,0,0,540,4,-12,0,0,0,0,0,-540,-4,12,0,0,0,0],[560,-80,2,16,-2,0,10,0,10,-2,2,
0,-1,-1,0,-2,-2,0,1,0,-1,0,-1,0,0,1,-34,0,2,-2,0,-34,0,0,10,1,10,1,0,4,0,4,0,
0,-1,-1,0,0,-2,0,0,-2,0,1,0,0,0,-4,-2,0,2,2,0,-2,0,0,0,0,0,0,0,0,0,2,0,1,0,-1,
-10,1,0,0,-1,1,0,0,0,-560,1,-16,0,0,0,-2,2,2,2,-1,34,34,-4,-10,-10,0,2,1,2,80,
-2,-10,-2,-1,2,10,0,-1,0,0,0,0,0,560,0,16,0,0,-2,1,0,-34,10,4,-1,-80,2,-2,-10,
-1,0,0,-560,-16,0,0,2,0,34,-10,-4,1,80,-2,2,1,560,0,16,0,-80,2,-2,0,-560,0,
-16,80,-2,2,0],[560,80,2,16,2,0,-10,0,-10,-2,2,0,-1,-1,0,-2,-2,0,-1,0,1,0,1,0,
0,-1,-34,0,2,-2,0,-34,0,0,-10,-1,-10,-1,0,-4,0,-4,0,0,-1,-1,0,0,-2,0,0,-2,0,1,
0,0,0,4,-2,0,2,2,0,-2,0,0,0,0,0,0,0,0,0,2,0,1,0,-1,10,1,0,0,1,-1,0,0,0,-560,1,
-16,0,0,0,-2,2,2,2,1,34,34,4,10,10,0,2,1,2,-80,-2,10,-2,1,-2,-10,0,1,0,0,0,0,
0,560,0,16,0,0,-2,-1,0,-34,-10,-4,-1,80,2,2,10,-1,0,0,-560,-16,0,0,2,0,34,10,
4,1,-80,-2,-2,1,560,0,16,0,80,2,2,0,-560,0,-16,-80,-2,-2,0],[560,0,2,-16,0,0,
0,0,0,-4,2,0,2,2,0,-4,2,0,0,0,0,0,0,0,0,0,20,0,2,-4,0,20,0,0,0,0,0,0,0,0,0,0,
0,0,2,2,0,0,-4,0,0,-4,0,-1,0,0,0,0,2,0,-4,-4,0,2,0,0,0,0,0,0,0,0,0,20,0,2,0,
-1,0,2,0,0,0,0,0,0,0,560,2,-16,0,0,0,2,-4,-4,2,0,20,20,0,0,0,0,-4,2,2,0,20,0,
2,0,0,0,0,0,0,0,0,0,0,560,0,-16,0,0,-4,0,0,20,0,0,2,0,2,0,0,2,0,0,560,-16,0,0,
-4,0,20,0,0,2,0,2,0,2,560,0,-16,0,0,2,0,0,560,0,-16,0,2,0,0],[560,0,2,-16,0,0,
-6*ER(-3),0,6*ER(-3),2,2,0,-1,-1,0,2,2,0,ER(-3),0,-ER(-3),0,ER(-3),0,0,
-ER(-3),-34,0,2,2,0,-34,0,0,-6*ER(-3),-ER(-3),6*ER(-3),ER(-3),0,0,0,0,0,0,-1,
-1,0,0,2,0,0,2,0,-1,0,0,0,0,2,0,2,2,0,2,0,0,0,0,0,0,0,0,0,2,0,-1,0,-1,
6*ER(-3),-1,0,0,ER(-3),-ER(-3),0,0,0,560,-1,-16,0,0,0,2,2,2,2,ER(-3),-34,-34,
0,-6*ER(-3),6*ER(-3),0,2,-1,2,0,2,-6*ER(-3),2,-ER(-3),0,6*ER(-3),0,-ER(-3),0,
0,0,0,0,560,0,-16,0,0,2,ER(-3),0,-34,-6*ER(-3),0,-1,0,2,0,6*ER(-3),-1,0,0,560,
-16,0,0,2,0,-34,-6*ER(-3),0,-1,0,2,0,-1,560,0,-16,0,0,2,0,0,560,0,-16,0,2,0,
0],[560,0,2,-16,0,0,6*ER(-3),0,-6*ER(-3),2,2,0,-1,-1,0,2,2,0,-ER(-3),0,ER(-3),
0,-ER(-3),0,0,ER(-3),-34,0,2,2,0,-34,0,0,6*ER(-3),ER(-3),-6*ER(-3),-ER(-3),0,
0,0,0,0,0,-1,-1,0,0,2,0,0,2,0,-1,0,0,0,0,2,0,2,2,0,2,0,0,0,0,0,0,0,0,0,2,0,-1,
0,-1,-6*ER(-3),-1,0,0,-ER(-3),ER(-3),0,0,0,560,-1,-16,0,0,0,2,2,2,2,-ER(-3),
-34,-34,0,6*ER(-3),-6*ER(-3),0,2,-1,2,0,2,6*ER(-3),2,ER(-3),0,-6*ER(-3),0,
ER(-3),0,0,0,0,0,560,0,-16,0,0,2,-ER(-3),0,-34,6*ER(-3),0,-1,0,2,0,-6*ER(-3),
-1,0,0,560,-16,0,0,2,0,-34,6*ER(-3),0,-1,0,2,0,-1,560,0,-16,0,0,2,0,0,560,0,
-16,0,2,0,0],[630,-60,9,-14,3,2,-6,0,-6,-2,0,0,0,0,0,-2,1,0,0,-1,0,-1,0,-1,0,
0,-18,0,-1,1,0,-18,0,0,-6,0,-6,0,3,3,0,3,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,-3,1,0,
-1,-1,0,1,-6,0,0,0,0,0,1,0,0,9,0,0,1,0,6,0,0,0,0,0,0,0,0,-630,0,14,6,-2,0,0,2,
2,-1,0,18,18,-3,6,6,-3,-1,0,-1,60,-9,6,-9,0,-3,-6,0,0,0,0,0,0,0,630,-6,-14,2,
0,-2,0,0,-18,-6,3,0,-60,9,3,6,0,0,0,-630,14,6,-2,2,0,18,6,-3,0,60,-9,-3,0,630,
-6,-14,1,-60,9,3,2,-630,6,14,60,-9,-3,-2],[630,60,9,-14,-3,-2,6,0,6,-2,0,0,0,
0,0,-2,1,0,0,1,0,1,0,1,0,0,-18,0,-1,1,0,-18,0,0,6,0,6,0,-3,-3,0,-3,0,0,0,0,0,
0,1,0,0,1,0,0,0,0,0,3,1,0,-1,-1,0,1,-6,0,0,0,0,0,-1,0,0,9,0,0,-1,0,-6,0,0,0,0,
0,0,0,0,-630,0,14,6,2,0,0,2,2,-1,0,18,18,3,-6,-6,3,-1,0,-1,-60,-9,-6,-9,0,3,6,
0,0,0,0,0,0,0,630,-6,-14,-2,0,-2,0,0,-18,6,-3,0,60,9,-3,-6,0,0,0,-630,14,6,2,
2,0,18,-6,3,0,-60,-9,3,0,630,-6,-14,-1,60,9,-3,-2,-630,6,14,-60,-9,3,2],[630,
30,-9,6,-3,2,(-21-3*ER(-3))/2,6,(-21+3*ER(-3))/2,-3*E(3)^2,0,0,0,0,-2,-3*E(3),
3,0,0,-E(3),0,-E(3)^2,0,-1,0,0,9*E(3)^2,0,3,0,0,9*E(3),0,0,(15-9*ER(-3))/2,0,
(15+9*ER(-3))/2,0,0,0,0,0,-E(3)^2,-E(3),0,0,0,0,0,0,-E(3)^2,0,-E(3),0,0,0,0,0,
3*E(3),0,0,0,0,3*E(3)^2,2,-1,-1,0,0,0,-1,0,-1,0,0,0,-E(3),0,(15+9*ER(-3))/2,0,
-1,-2*E(3),0,0,0,0,2*E(3),630*E(3)^2,0,6*E(3)^2,2*E(3)^2,2*E(3)^2,6*E(3)^2,0,
-3*E(3),-3,3*E(3)^2,0,9*E(3),9,0,(-21-3*ER(-3))/2,3-6*ER(-3),0,0,0,3*E(3),
30*E(3)^2,0,3+6*ER(-3),-9*E(3)^2,0,-3*E(3)^2,3-6*ER(-3),-E(3)^2,0,0,-E(3),0,
-2*E(3)^2,2,630*E(3),2*E(3),6*E(3),2*E(3),6*E(3),-3,0,-E(3)^2,9,3+6*ER(-3),0,
0,30*E(3),-9*E(3),-3*E(3),(-21+3*ER(-3))/2,0,0,2*E(3)^2,630,6,2,2,-3*E(3)^2,
-E(3),9*E(3)^2,(15-9*ER(-3))/2,0,0,30,-9,-3,0,630*E(3)^2,2*E(3)^2,6*E(3)^2,
-E(3)^2,30*E(3)^2,-9*E(3)^2,-3*E(3)^2,2*E(3)^2,630*E(3),2*E(3),6*E(3),30*E(3),
-9*E(3),-3*E(3),2*E(3)],[630,-30,-9,6,3,-2,(21+3*ER(-3))/2,-6,(21-3*ER(-3))/2,
-3*E(3)^2,0,0,0,0,-2,-3*E(3),3,0,0,E(3),0,E(3)^2,0,1,0,0,9*E(3)^2,0,3,0,0,
9*E(3),0,0,(-15+9*ER(-3))/2,0,(-15-9*ER(-3))/2,0,0,0,0,0,E(3)^2,E(3),0,0,0,0,
0,0,-E(3)^2,0,-E(3),0,0,0,0,0,3*E(3),0,0,0,0,3*E(3)^2,2,-1,1,0,0,0,1,0,1,0,0,
0,E(3),0,(-15-9*ER(-3))/2,0,-1,-2*E(3),0,0,0,0,-2*E(3),630*E(3)^2,0,6*E(3)^2,
2*E(3)^2,-2*E(3)^2,-6*E(3)^2,0,-3*E(3),-3,3*E(3)^2,0,9*E(3),9,0,
(21+3*ER(-3))/2,-3+6*ER(-3),0,0,0,3*E(3),-30*E(3)^2,0,-3-6*ER(-3),-9*E(3)^2,0,
3*E(3)^2,-3+6*ER(-3),-E(3)^2,0,0,-E(3),0,-2*E(3)^2,-2,630*E(3),2*E(3),6*E(3),
-2*E(3),-6*E(3),-3,0,E(3)^2,9,-3-6*ER(-3),0,0,-30*E(3),-9*E(3),3*E(3),
(21-3*ER(-3))/2,0,0,-2*E(3)^2,630,6,2,-2,-3*E(3)^2,E(3),9*E(3)^2,
(-15+9*ER(-3))/2,0,0,-30,-9,3,0,630*E(3)^2,2*E(3)^2,6*E(3)^2,E(3)^2,
-30*E(3)^2,-9*E(3)^2,3*E(3)^2,-2*E(3)^2,630*E(3),2*E(3),6*E(3),-30*E(3),
-9*E(3),3*E(3),-2*E(3)],[630,30,-9,6,-3,2,(-21+3*ER(-3))/2,6,(-21-3*ER(-3))/2,
-3*E(3),0,0,0,0,-2,-3*E(3)^2,3,0,0,-E(3)^2,0,-E(3),0,-1,0,0,9*E(3),0,3,0,0,
9*E(3)^2,0,0,(15+9*ER(-3))/2,0,(15-9*ER(-3))/2,0,0,0,0,0,-E(3),-E(3)^2,0,0,0,
0,0,0,-E(3),0,-E(3)^2,0,0,0,0,0,3*E(3)^2,0,0,0,0,3*E(3),2,-1,-1,0,0,0,-1,0,-1,
0,0,0,-E(3)^2,0,(15-9*ER(-3))/2,0,-1,-2*E(3)^2,0,0,0,0,2*E(3)^2,630*E(3),0,
6*E(3),2*E(3),2*E(3),6*E(3),0,-3*E(3)^2,-3,3*E(3),0,9*E(3)^2,9,0,
(-21+3*ER(-3))/2,3+6*ER(-3),0,0,0,3*E(3)^2,30*E(3),0,3-6*ER(-3),-9*E(3),0,
-3*E(3),3+6*ER(-3),-E(3),0,0,-E(3)^2,0,-2*E(3),2,630*E(3)^2,2*E(3)^2,6*E(3)^2,
2*E(3)^2,6*E(3)^2,-3,0,-E(3),9,3-6*ER(-3),0,0,30*E(3)^2,-9*E(3)^2,-3*E(3)^2,
(-21-3*ER(-3))/2,0,0,2*E(3),630,6,2,2,-3*E(3),-E(3)^2,9*E(3),(15+9*ER(-3))/2,
0,0,30,-9,-3,0,630*E(3),2*E(3),6*E(3),-E(3),30*E(3),-9*E(3),-3*E(3),2*E(3),
630*E(3)^2,2*E(3)^2,6*E(3)^2,30*E(3)^2,-9*E(3)^2,-3*E(3)^2,2*E(3)^2],[630,-30,
-9,6,3,-2,(21-3*ER(-3))/2,-6,(21+3*ER(-3))/2,-3*E(3),0,0,0,0,-2,-3*E(3)^2,3,0,
0,E(3)^2,0,E(3),0,1,0,0,9*E(3),0,3,0,0,9*E(3)^2,0,0,(-15-9*ER(-3))/2,0,
(-15+9*ER(-3))/2,0,0,0,0,0,E(3),E(3)^2,0,0,0,0,0,0,-E(3),0,-E(3)^2,0,0,0,0,0,
3*E(3)^2,0,0,0,0,3*E(3),2,-1,1,0,0,0,1,0,1,0,0,0,E(3)^2,0,(-15+9*ER(-3))/2,0,
-1,-2*E(3)^2,0,0,0,0,-2*E(3)^2,630*E(3),0,6*E(3),2*E(3),-2*E(3),-6*E(3),0,
-3*E(3)^2,-3,3*E(3),0,9*E(3)^2,9,0,(21-3*ER(-3))/2,-3-6*ER(-3),0,0,0,3*E(3)^2,
-30*E(3),0,-3+6*ER(-3),-9*E(3),0,3*E(3),-3-6*ER(-3),-E(3),0,0,-E(3)^2,0,
-2*E(3),-2,630*E(3)^2,2*E(3)^2,6*E(3)^2,-2*E(3)^2,-6*E(3)^2,-3,0,E(3),9,
-3+6*ER(-3),0,0,-30*E(3)^2,-9*E(3)^2,3*E(3)^2,(21+3*ER(-3))/2,0,0,-2*E(3),630,
6,2,-2,-3*E(3),E(3)^2,9*E(3),(-15-9*ER(-3))/2,0,0,-30,-9,3,0,630*E(3),2*E(3),
6*E(3),E(3),-30*E(3),-9*E(3),3*E(3),-2*E(3),630*E(3)^2,2*E(3)^2,6*E(3)^2,
-30*E(3)^2,-9*E(3)^2,3*E(3)^2,-2*E(3)^2],[630,60,-9,18,3,-2,(-15-3*ER(-3))/2,
0,(-15+3*ER(-3))/2,3*E(3),0,0,0,0,0,3*E(3)^2,3,0,0,E(3)^2,0,E(3),0,1,0,0,
9*E(3),0,-3,0,0,9*E(3)^2,0,0,(3+9*ER(-3))/2,0,(3-9*ER(-3))/2,0,0,0,0,0,
(3+ER(-3))/2,(3-ER(-3))/2,0,0,0,0,0,0,-E(3),0,-E(3)^2,0,0,0,0,0,3*E(3)^2,0,0,
0,0,3*E(3),2,1,ER(-3),0,0,0,-1,0,-ER(-3),0,0,0,-E(3)^2,0,(-3+9*ER(-3))/2,0,-1,
0,0,0,0,0,0,-630*E(3),0,-18*E(3),-2*E(3),2*E(3),0,0,-3*E(3)^2,-3,-3*E(3),0,
-9*E(3)^2,-9,0,(15+3*ER(-3))/2,-6-3*ER(-3),0,0,0,-3*E(3)^2,-60*E(3),0,
-6+3*ER(-3),9*E(3),0,-3*E(3),6+3*ER(-3),E(3),0,0,E(3)^2,0,0,0,630*E(3)^2,
2*E(3)^2,18*E(3)^2,-2*E(3)^2,0,3,0,(-3-ER(-3))/2,9,6-3*ER(-3),0,0,60*E(3)^2,
-9*E(3)^2,3*E(3)^2,(15-3*ER(-3))/2,0,0,0,-630,-18,-2,2,-3*E(3),(-3+ER(-3))/2,
-9*E(3),(-3-9*ER(-3))/2,0,0,-60,9,-3,0,630*E(3),2*E(3),18*E(3),-E(3),60*E(3),
-9*E(3),3*E(3),-2*E(3),-630*E(3)^2,-2*E(3)^2,-18*E(3)^2,-60*E(3)^2,9*E(3)^2,
-3*E(3)^2,2*E(3)^2],[630,-60,-9,18,-3,2,(15-3*ER(-3))/2,0,(15+3*ER(-3))/2,
3*E(3)^2,0,0,0,0,0,3*E(3),3,0,0,-E(3),0,-E(3)^2,0,-1,0,0,9*E(3)^2,0,-3,0,0,
9*E(3),0,0,(-3+9*ER(-3))/2,0,(-3-9*ER(-3))/2,0,0,0,0,0,(-3+ER(-3))/2,
(-3-ER(-3))/2,0,0,0,0,0,0,-E(3)^2,0,-E(3),0,0,0,0,0,3*E(3),0,0,0,0,3*E(3)^2,2,
1,ER(-3),0,0,0,1,0,-ER(-3),0,0,0,E(3),0,(3+9*ER(-3))/2,0,-1,0,0,0,0,0,0,
-630*E(3)^2,0,-18*E(3)^2,-2*E(3)^2,-2*E(3)^2,0,0,-3*E(3),-3,-3*E(3)^2,0,
-9*E(3),-9,0,(-15+3*ER(-3))/2,6-3*ER(-3),0,0,0,-3*E(3),60*E(3)^2,0,6+3*ER(-3),
9*E(3)^2,0,3*E(3)^2,-6+3*ER(-3),E(3)^2,0,0,E(3),0,0,0,630*E(3),2*E(3),18*E(3),
2*E(3),0,3,0,(3-ER(-3))/2,9,-6-3*ER(-3),0,0,-60*E(3),-9*E(3),-3*E(3),
(-15-3*ER(-3))/2,0,0,0,-630,-18,-2,-2,-3*E(3)^2,(3+ER(-3))/2,-9*E(3)^2,
(3-9*ER(-3))/2,0,0,60,9,3,0,630*E(3)^2,2*E(3)^2,18*E(3)^2,E(3)^2,-60*E(3)^2,
-9*E(3)^2,-3*E(3)^2,2*E(3)^2,-630*E(3),-2*E(3),-18*E(3),60*E(3),9*E(3),3*E(3),
-2*E(3)],[630,60,-9,18,3,-2,(-15+3*ER(-3))/2,0,(-15-3*ER(-3))/2,3*E(3)^2,0,0,
0,0,0,3*E(3),3,0,0,E(3),0,E(3)^2,0,1,0,0,9*E(3)^2,0,-3,0,0,9*E(3),0,0,
(3-9*ER(-3))/2,0,(3+9*ER(-3))/2,0,0,0,0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,0,0,0,0,
0,-E(3)^2,0,-E(3),0,0,0,0,0,3*E(3),0,0,0,0,3*E(3)^2,2,1,-ER(-3),0,0,0,-1,0,
ER(-3),0,0,0,-E(3),0,(-3-9*ER(-3))/2,0,-1,0,0,0,0,0,0,-630*E(3)^2,0,
-18*E(3)^2,-2*E(3)^2,2*E(3)^2,0,0,-3*E(3),-3,-3*E(3)^2,0,-9*E(3),-9,0,
(15-3*ER(-3))/2,-6+3*ER(-3),0,0,0,-3*E(3),-60*E(3)^2,0,-6-3*ER(-3),9*E(3)^2,0,
-3*E(3)^2,6-3*ER(-3),E(3)^2,0,0,E(3),0,0,0,630*E(3),2*E(3),18*E(3),-2*E(3),0,
3,0,(-3+ER(-3))/2,9,6+3*ER(-3),0,0,60*E(3),-9*E(3),3*E(3),(15+3*ER(-3))/2,0,0,
0,-630,-18,-2,2,-3*E(3)^2,(-3-ER(-3))/2,-9*E(3)^2,(-3+9*ER(-3))/2,0,0,-60,9,
-3,0,630*E(3)^2,2*E(3)^2,18*E(3)^2,-E(3)^2,60*E(3)^2,-9*E(3)^2,3*E(3)^2,
-2*E(3)^2,-630*E(3),-2*E(3),-18*E(3),-60*E(3),9*E(3),-3*E(3),2*E(3)],[630,-60,
-9,18,-3,2,(15+3*ER(-3))/2,0,(15-3*ER(-3))/2,3*E(3),0,0,0,0,0,3*E(3)^2,3,0,0,
-E(3)^2,0,-E(3),0,-1,0,0,9*E(3),0,-3,0,0,9*E(3)^2,0,0,(-3-9*ER(-3))/2,0,
(-3+9*ER(-3))/2,0,0,0,0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,0,0,0,0,0,0,-E(3),0,
-E(3)^2,0,0,0,0,0,3*E(3)^2,0,0,0,0,3*E(3),2,1,-ER(-3),0,0,0,1,0,ER(-3),0,0,0,
E(3)^2,0,(3-9*ER(-3))/2,0,-1,0,0,0,0,0,0,-630*E(3),0,-18*E(3),-2*E(3),-2*E(3),
0,0,-3*E(3)^2,-3,-3*E(3),0,-9*E(3)^2,-9,0,(-15-3*ER(-3))/2,6+3*ER(-3),0,0,0,
-3*E(3)^2,60*E(3),0,6-3*ER(-3),9*E(3),0,3*E(3),-6-3*ER(-3),E(3),0,0,E(3)^2,0,
0,0,630*E(3)^2,2*E(3)^2,18*E(3)^2,2*E(3)^2,0,3,0,(3+ER(-3))/2,9,-6+3*ER(-3),0,
0,-60*E(3)^2,-9*E(3)^2,-3*E(3)^2,(-15+3*ER(-3))/2,0,0,0,-630,-18,-2,-2,
-3*E(3),(3-ER(-3))/2,-9*E(3),(3+9*ER(-3))/2,0,0,60,9,3,0,630*E(3),2*E(3),
18*E(3),E(3),-60*E(3),-9*E(3),-3*E(3),2*E(3),-630*E(3)^2,-2*E(3)^2,-18*E(3)^2,
60*E(3)^2,9*E(3)^2,3*E(3)^2,-2*E(3)^2],[720,0,-18,16,0,0,0,0,0,4*E(3)^2,0,0,0,
0,0,4*E(3),-2,0,0,0,0,0,0,0,0,0,-36*E(3)^2,-E(3)^2,-2,4,-E(3),-36*E(3),0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,4*E(3),0,0,4*E(3)^2,0,0,0,0,0,0,-2*E(3),-E(3),
4*E(3)^2,4*E(3),-E(3)^2,-2*E(3)^2,0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,
0,0,720*E(3)^2,0,16*E(3)^2,0,0,0,0,4*E(3),4,-2*E(3)^2,0,-36*E(3),-36,0,0,0,0,
4,0,-2*E(3),0,0,0,-18*E(3)^2,0,0,0,0,0,0,0,-1,0,0,720*E(3),0,16*E(3),0,0,4,0,
0,-36,0,0,0,0,-18*E(3),0,0,0,0,0,720,16,0,0,4*E(3)^2,0,-36*E(3)^2,0,0,0,0,-18,
0,0,720*E(3)^2,0,16*E(3)^2,0,0,-18*E(3)^2,0,0,720*E(3),0,16*E(3),0,-18*E(3),0,
0],[720,0,-18,16,0,0,0,0,0,4*E(3),0,0,0,0,0,4*E(3)^2,-2,0,0,0,0,0,0,0,0,0,
-36*E(3),-E(3),-2,4,-E(3)^2,-36*E(3)^2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
4*E(3)^2,0,0,4*E(3),0,0,0,0,0,0,-2*E(3)^2,-E(3)^2,4*E(3),4*E(3)^2,-E(3),
-2*E(3),0,0,0,0,0,0,0,0,0,0,-1,0,0,0,0,0,0,0,0,0,0,0,0,720*E(3),0,16*E(3),0,0,
0,0,4*E(3)^2,4,-2*E(3),0,-36*E(3)^2,-36,0,0,0,0,4,0,-2*E(3)^2,0,0,0,-18*E(3),
0,0,0,0,0,0,0,-1,0,0,720*E(3)^2,0,16*E(3)^2,0,0,4,0,0,-36,0,0,0,0,-18*E(3)^2,
0,0,0,0,0,720,16,0,0,4*E(3),0,-36*E(3),0,0,0,0,-18,0,0,720*E(3),0,16*E(3),0,0,
-18*E(3),0,0,720*E(3)^2,0,16*E(3)^2,0,-18*E(3)^2,0,0],[729,-81,0,9,0,3,0,-9,0,
0,0,-1,0,0,1,0,0,-1,0,0,0,0,0,0,0,0,0,1,0,0,1,0,1,-1,0,0,0,0,0,0,0,0,0,0,0,0,
-1,-1,0,-1,0,0,0,0,-1,-1,-1,0,0,1,0,0,1,0,-3,0,0,-1,1,-1,0,1,0,0,1,0,0,0,0,0,
0,1,0,0,-1,-1,3,729,0,9,-3,3,-9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-81,0,0,0,0,0,0,0,
0,-1,0,1,1,3,729,-3,9,3,-9,0,0,0,0,0,0,0,-81,0,0,0,0,-1,3,729,9,-3,3,0,0,0,0,
0,0,-81,0,0,0,729,-3,9,0,-81,0,0,3,729,-3,9,-81,0,0,3],[729,81,0,9,0,-3,0,9,0,
0,0,-1,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,1,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,
-1,-1,0,-1,0,0,0,0,-1,1,1,0,0,1,0,0,1,0,-3,0,0,1,-1,1,0,-1,0,0,1,0,0,0,0,0,0,
1,0,0,-1,-1,-3,729,0,9,-3,-3,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,81,0,0,0,0,0,0,0,0,
-1,0,1,1,-3,729,-3,9,-3,9,0,0,0,0,0,0,0,81,0,0,0,0,-1,-3,729,9,-3,-3,0,0,0,0,
0,0,81,0,0,0,729,-3,9,0,81,0,0,-3,729,-3,9,81,0,0,-3],[729,-81,0,9,0,3,0,-9,0,
0,0,-1,0,0,1,0,0,-1,0,0,0,0,0,0,0,0,0,E(3)^2,0,0,E(3),0,1,-1,0,0,0,0,0,0,0,0,
0,0,0,0,-E(3),-E(3)^2,0,-E(3)^2,0,0,0,0,-E(3),-E(3)^2,-E(3),0,0,E(3),0,0,
E(3)^2,0,-3,0,0,-E(3),E(3),-E(3)^2,0,E(3)^2,0,0,1,0,0,0,0,0,0,E(3),0,0,-1,
-E(3),3*E(3),729*E(3)^2,0,9*E(3)^2,-3*E(3)^2,3*E(3)^2,-9*E(3)^2,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,-81*E(3)^2,0,0,0,0,0,0,0,0,-1,0,1,E(3)^2,3,729*E(3),-3*E(3),
9*E(3),3*E(3),-9*E(3),0,0,0,0,0,0,0,-81*E(3),0,0,0,0,-E(3)^2,3*E(3)^2,729,9,
-3,3,0,0,0,0,0,0,-81,0,0,0,729*E(3)^2,-3*E(3)^2,9*E(3)^2,0,-81*E(3)^2,0,0,
3*E(3)^2,729*E(3),-3*E(3),9*E(3),-81*E(3),0,0,3*E(3)],[729,81,0,9,0,-3,0,9,0,
0,0,-1,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,E(3)^2,0,0,E(3),0,-1,1,0,0,0,0,0,0,0,0,0,
0,0,0,-E(3),-E(3)^2,0,-E(3)^2,0,0,0,0,-E(3),E(3)^2,E(3),0,0,E(3),0,0,E(3)^2,0,
-3,0,0,E(3),-E(3),E(3)^2,0,-E(3)^2,0,0,1,0,0,0,0,0,0,E(3),0,0,-1,-E(3),
-3*E(3),729*E(3)^2,0,9*E(3)^2,-3*E(3)^2,-3*E(3)^2,9*E(3)^2,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,81*E(3)^2,0,0,0,0,0,0,0,0,-1,0,1,E(3)^2,-3,729*E(3),-3*E(3),9*E(3),
-3*E(3),9*E(3),0,0,0,0,0,0,0,81*E(3),0,0,0,0,-E(3)^2,-3*E(3)^2,729,9,-3,-3,0,
0,0,0,0,0,81,0,0,0,729*E(3)^2,-3*E(3)^2,9*E(3)^2,0,81*E(3)^2,0,0,-3*E(3)^2,
729*E(3),-3*E(3),9*E(3),81*E(3),0,0,-3*E(3)],[729,-81,0,9,0,3,0,-9,0,0,0,-1,0,
0,1,0,0,-1,0,0,0,0,0,0,0,0,0,E(3),0,0,E(3)^2,0,1,-1,0,0,0,0,0,0,0,0,0,0,0,0,
-E(3)^2,-E(3),0,-E(3),0,0,0,0,-E(3)^2,-E(3),-E(3)^2,0,0,E(3)^2,0,0,E(3),0,-3,
0,0,-E(3)^2,E(3)^2,-E(3),0,E(3),0,0,1,0,0,0,0,0,0,E(3)^2,0,0,-1,-E(3)^2,
3*E(3)^2,729*E(3),0,9*E(3),-3*E(3),3*E(3),-9*E(3),0,0,0,0,0,0,0,0,0,0,0,0,0,0,
-81*E(3),0,0,0,0,0,0,0,0,-1,0,1,E(3),3,729*E(3)^2,-3*E(3)^2,9*E(3)^2,3*E(3)^2,
-9*E(3)^2,0,0,0,0,0,0,0,-81*E(3)^2,0,0,0,0,-E(3),3*E(3),729,9,-3,3,0,0,0,0,0,
0,-81,0,0,0,729*E(3),-3*E(3),9*E(3),0,-81*E(3),0,0,3*E(3),729*E(3)^2,
-3*E(3)^2,9*E(3)^2,-81*E(3)^2,0,0,3*E(3)^2],[729,81,0,9,0,-3,0,9,0,0,0,-1,0,0,
1,0,0,1,0,0,0,0,0,0,0,0,0,E(3),0,0,E(3)^2,0,-1,1,0,0,0,0,0,0,0,0,0,0,0,0,
-E(3)^2,-E(3),0,-E(3),0,0,0,0,-E(3)^2,E(3),E(3)^2,0,0,E(3)^2,0,0,E(3),0,-3,0,
0,E(3)^2,-E(3)^2,E(3),0,-E(3),0,0,1,0,0,0,0,0,0,E(3)^2,0,0,-1,-E(3)^2,
-3*E(3)^2,729*E(3),0,9*E(3),-3*E(3),-3*E(3),9*E(3),0,0,0,0,0,0,0,0,0,0,0,0,0,
0,81*E(3),0,0,0,0,0,0,0,0,-1,0,1,E(3),-3,729*E(3)^2,-3*E(3)^2,9*E(3)^2,
-3*E(3)^2,9*E(3)^2,0,0,0,0,0,0,0,81*E(3)^2,0,0,0,0,-E(3),-3*E(3),729,9,-3,-3,
0,0,0,0,0,0,81,0,0,0,729*E(3),-3*E(3),9*E(3),0,81*E(3),0,0,-3*E(3),729*E(3)^2,
-3*E(3)^2,9*E(3)^2,81*E(3)^2,0,0,-3*E(3)^2],[756,36,0,-12,0,0,9*E(3),-12,
9*E(3)^2,3*E(3)^2,0,1,0,0,0,3*E(3),0,1,0,0,0,0,0,0,0,0,27*E(3)^2,0,0,0,0,
27*E(3),0,1,9*E(3)^2,0,9*E(3),0,0,0,0,0,E(3)^2,E(3),0,0,E(3),E(3)^2,0,0,
-E(3)^2,0,-E(3),0,0,E(3)^2,E(3),0,0,0,0,0,0,0,-4,-1,1,E(3),0,E(3)^2,0,0,1,0,0,
0,0,0,9*E(3),0,-1,0,0,0,0,E(3),4*E(3),756*E(3)^2,0,-12*E(3)^2,-4*E(3)^2,0,
-12*E(3)^2,0,3*E(3),3,0,0,27*E(3),27,0,9*E(3),9,0,0,0,0,36*E(3)^2,0,9,0,0,0,9,
-E(3)^2,0,1,-E(3),0,0,4,756*E(3),-4*E(3),-12*E(3),0,-12*E(3),3,0,E(3)^2,27,9,
0,0,36*E(3),0,0,9*E(3)^2,0,E(3)^2,4*E(3)^2,756,-12,-4,0,3*E(3)^2,E(3),
27*E(3)^2,9*E(3)^2,0,0,36,0,0,0,756*E(3)^2,-4*E(3)^2,-12*E(3)^2,0,36*E(3)^2,0,
0,0,756*E(3),-4*E(3),-12*E(3),36*E(3),0,0,0],[756,-36,0,-12,0,0,-9*E(3),12,
-9*E(3)^2,3*E(3)^2,0,1,0,0,0,3*E(3),0,-1,0,0,0,0,0,0,0,0,27*E(3)^2,0,0,0,0,
27*E(3),0,-1,-9*E(3)^2,0,-9*E(3),0,0,0,0,0,-E(3)^2,-E(3),0,0,E(3),E(3)^2,0,0,
-E(3)^2,0,-E(3),0,0,-E(3)^2,-E(3),0,0,0,0,0,0,0,-4,-1,-1,-E(3),0,-E(3)^2,0,0,
-1,0,0,0,0,0,-9*E(3),0,-1,0,0,0,0,E(3),-4*E(3),756*E(3)^2,0,-12*E(3)^2,
-4*E(3)^2,0,12*E(3)^2,0,3*E(3),3,0,0,27*E(3),27,0,-9*E(3),-9,0,0,0,0,
-36*E(3)^2,0,-9,0,0,0,-9,-E(3)^2,0,1,-E(3),0,0,-4,756*E(3),-4*E(3),-12*E(3),0,
12*E(3),3,0,-E(3)^2,27,-9,0,0,-36*E(3),0,0,-9*E(3)^2,0,E(3)^2,-4*E(3)^2,756,
-12,-4,0,3*E(3)^2,-E(3),27*E(3)^2,-9*E(3)^2,0,0,-36,0,0,0,756*E(3)^2,
-4*E(3)^2,-12*E(3)^2,0,-36*E(3)^2,0,0,0,756*E(3),-4*E(3),-12*E(3),-36*E(3),0,
0,0],[756,36,0,-12,0,0,9*E(3)^2,-12,9*E(3),3*E(3),0,1,0,0,0,3*E(3)^2,0,1,0,0,
0,0,0,0,0,0,27*E(3),0,0,0,0,27*E(3)^2,0,1,9*E(3),0,9*E(3)^2,0,0,0,0,0,E(3),
E(3)^2,0,0,E(3)^2,E(3),0,0,-E(3),0,-E(3)^2,0,0,E(3),E(3)^2,0,0,0,0,0,0,0,-4,
-1,1,E(3)^2,0,E(3),0,0,1,0,0,0,0,0,9*E(3)^2,0,-1,0,0,0,0,E(3)^2,4*E(3)^2,
756*E(3),0,-12*E(3),-4*E(3),0,-12*E(3),0,3*E(3)^2,3,0,0,27*E(3)^2,27,0,
9*E(3)^2,9,0,0,0,0,36*E(3),0,9,0,0,0,9,-E(3),0,1,-E(3)^2,0,0,4,756*E(3)^2,
-4*E(3)^2,-12*E(3)^2,0,-12*E(3)^2,3,0,E(3),27,9,0,0,36*E(3)^2,0,0,9*E(3),0,
E(3),4*E(3),756,-12,-4,0,3*E(3),E(3)^2,27*E(3),9*E(3),0,0,36,0,0,0,756*E(3),
-4*E(3),-12*E(3),0,36*E(3),0,0,0,756*E(3)^2,-4*E(3)^2,-12*E(3)^2,36*E(3)^2,0,
0,0],[756,-36,0,-12,0,0,-9*E(3)^2,12,-9*E(3),3*E(3),0,1,0,0,0,3*E(3)^2,0,-1,0,
0,0,0,0,0,0,0,27*E(3),0,0,0,0,27*E(3)^2,0,-1,-9*E(3),0,-9*E(3)^2,0,0,0,0,0,
-E(3),-E(3)^2,0,0,E(3)^2,E(3),0,0,-E(3),0,-E(3)^2,0,0,-E(3),-E(3)^2,0,0,0,0,0,
0,0,-4,-1,-1,-E(3)^2,0,-E(3),0,0,-1,0,0,0,0,0,-9*E(3)^2,0,-1,0,0,0,0,E(3)^2,
-4*E(3)^2,756*E(3),0,-12*E(3),-4*E(3),0,12*E(3),0,3*E(3)^2,3,0,0,27*E(3)^2,27,
0,-9*E(3)^2,-9,0,0,0,0,-36*E(3),0,-9,0,0,0,-9,-E(3),0,1,-E(3)^2,0,0,-4,
756*E(3)^2,-4*E(3)^2,-12*E(3)^2,0,12*E(3)^2,3,0,-E(3),27,-9,0,0,-36*E(3)^2,0,
0,-9*E(3),0,E(3),-4*E(3),756,-12,-4,0,3*E(3),-E(3)^2,27*E(3),-9*E(3),0,0,-36,
0,0,0,756*E(3),-4*E(3),-12*E(3),0,-36*E(3),0,0,0,756*E(3)^2,-4*E(3)^2,
-12*E(3)^2,-36*E(3)^2,0,0,0],[840,40,-3,-8,1,-4,7-ER(-3),0,7+ER(-3),-2*E(3),0,
0,(3-ER(-3))/2,(3+ER(-3))/2,0,-2*E(3)^2,1,0,E(3),-E(3)^2,-E(3)^2,-E(3),-E(3),
-1,0,E(3)^2,-42*E(3),0,-1,-2,0,-42*E(3)^2,0,0,-5-3*ER(-3),E(3),-5+3*ER(-3),
E(3)^2,0,-2*E(3),0,-2*E(3)^2,0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,0,0,-2*E(3)^2,0,
0,-2*E(3),0,0,0,0,0,2,E(3)^2,0,2*E(3),2*E(3)^2,0,E(3),0,0,0,0,0,0,1,0,0,0,0,
ER(-3),E(3)^2,0,5-3*ER(-3),(3-ER(-3))/2,0,0,-1,1,0,0,0,-840*E(3),-ER(-3),
8*E(3),0,4*E(3),0,0,2*E(3)^2,2,-E(3),-E(3)^2,42*E(3)^2,42,2*E(3)^2,-7+ER(-3),
2+4*ER(-3),0,2,(-3+ER(-3))/2,-E(3)^2,-40*E(3),0,2-4*ER(-3),3*E(3),-1,-E(3),
-2-4*ER(-3),0,-E(3),0,0,0,0,0,840*E(3)^2,0,-8*E(3)^2,-4*E(3)^2,0,-2,1,0,-42,
-2+4*ER(-3),-2,ER(-3),40*E(3)^2,-3*E(3)^2,E(3)^2,-7-ER(-3),-ER(-3),0,0,-840,8,
0,4,2*E(3),0,42*E(3),5+3*ER(-3),2*E(3),(3+ER(-3))/2,-40,3,-1,(-3-ER(-3))/2,
840*E(3),0,-8*E(3),E(3),40*E(3),-3*E(3),E(3),-4*E(3),-840*E(3)^2,0,8*E(3)^2,
-40*E(3)^2,3*E(3)^2,-E(3)^2,4*E(3)^2],[840,-40,-3,-8,-1,4,-7-ER(-3),0,
-7+ER(-3),-2*E(3)^2,0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,-2*E(3),1,0,-E(3)^2,E(3),
E(3),E(3)^2,E(3)^2,1,0,-E(3),-42*E(3)^2,0,-1,-2,0,-42*E(3),0,0,5-3*ER(-3),
-E(3)^2,5+3*ER(-3),-E(3),0,2*E(3)^2,0,2*E(3),0,0,(-3-ER(-3))/2,(-3+ER(-3))/2,
0,0,-2*E(3),0,0,-2*E(3)^2,0,0,0,0,0,-2,E(3),0,2*E(3)^2,2*E(3),0,E(3)^2,0,0,0,
0,0,0,-1,0,0,0,0,-ER(-3),-E(3),0,-5-3*ER(-3),(3+ER(-3))/2,0,0,1,-1,0,0,0,
-840*E(3)^2,ER(-3),8*E(3)^2,0,-4*E(3)^2,0,0,2*E(3),2,-E(3)^2,E(3),42*E(3),42,
-2*E(3),7+ER(-3),-2+4*ER(-3),0,2,(-3-ER(-3))/2,-E(3),40*E(3)^2,0,-2-4*ER(-3),
3*E(3)^2,1,E(3)^2,2-4*ER(-3),0,E(3)^2,0,0,0,0,0,840*E(3),0,-8*E(3),4*E(3),0,
-2,-1,0,-42,2+4*ER(-3),2,-ER(-3),-40*E(3),-3*E(3),-E(3),7-ER(-3),ER(-3),0,0,
-840,8,0,-4,2*E(3)^2,0,42*E(3)^2,-5+3*ER(-3),-2*E(3)^2,(3-ER(-3))/2,40,3,1,
(-3+ER(-3))/2,840*E(3)^2,0,-8*E(3)^2,-E(3)^2,-40*E(3)^2,-3*E(3)^2,-E(3)^2,
4*E(3)^2,-840*E(3),0,8*E(3),40*E(3),3*E(3),E(3),-4*E(3)],[840,40,-3,-8,1,-4,
7+ER(-3),0,7-ER(-3),-2*E(3)^2,0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,-2*E(3),1,0,
E(3)^2,-E(3),-E(3),-E(3)^2,-E(3)^2,-1,0,E(3),-42*E(3)^2,0,-1,-2,0,-42*E(3),0,
0,-5+3*ER(-3),E(3)^2,-5-3*ER(-3),E(3),0,-2*E(3)^2,0,-2*E(3),0,0,(-3-ER(-3))/2,
(-3+ER(-3))/2,0,0,-2*E(3),0,0,-2*E(3)^2,0,0,0,0,0,2,E(3),0,2*E(3)^2,2*E(3),0,
E(3)^2,0,0,0,0,0,0,1,0,0,0,0,-ER(-3),E(3),0,5+3*ER(-3),(3+ER(-3))/2,0,0,-1,1,
0,0,0,-840*E(3)^2,ER(-3),8*E(3)^2,0,4*E(3)^2,0,0,2*E(3),2,-E(3)^2,-E(3),
42*E(3),42,2*E(3),-7-ER(-3),2-4*ER(-3),0,2,(-3-ER(-3))/2,-E(3),-40*E(3)^2,0,
2+4*ER(-3),3*E(3)^2,-1,-E(3)^2,-2+4*ER(-3),0,-E(3)^2,0,0,0,0,0,840*E(3),0,
-8*E(3),-4*E(3),0,-2,1,0,-42,-2-4*ER(-3),-2,-ER(-3),40*E(3),-3*E(3),E(3),
-7+ER(-3),ER(-3),0,0,-840,8,0,4,2*E(3)^2,0,42*E(3)^2,5-3*ER(-3),2*E(3)^2,
(3-ER(-3))/2,-40,3,-1,(-3+ER(-3))/2,840*E(3)^2,0,-8*E(3)^2,E(3)^2,40*E(3)^2,
-3*E(3)^2,E(3)^2,-4*E(3)^2,-840*E(3),0,8*E(3),-40*E(3),3*E(3),-E(3),4*E(3)],
[840,-40,-3,-8,-1,4,-7+ER(-3),0,-7-ER(-3),-2*E(3),0,0,(3-ER(-3))/2,
(3+ER(-3))/2,0,-2*E(3)^2,1,0,-E(3),E(3)^2,E(3)^2,E(3),E(3),1,0,-E(3)^2,
-42*E(3),0,-1,-2,0,-42*E(3)^2,0,0,5+3*ER(-3),-E(3),5-3*ER(-3),-E(3)^2,0,
2*E(3),0,2*E(3)^2,0,0,(-3+ER(-3))/2,(-3-ER(-3))/2,0,0,-2*E(3)^2,0,0,-2*E(3),0,
0,0,0,0,-2,E(3)^2,0,2*E(3),2*E(3)^2,0,E(3),0,0,0,0,0,0,-1,0,0,0,0,ER(-3),
-E(3)^2,0,-5+3*ER(-3),(3-ER(-3))/2,0,0,1,-1,0,0,0,-840*E(3),-ER(-3),8*E(3),0,
-4*E(3),0,0,2*E(3)^2,2,-E(3),E(3)^2,42*E(3)^2,42,-2*E(3)^2,7-ER(-3),
-2-4*ER(-3),0,2,(-3+ER(-3))/2,-E(3)^2,40*E(3),0,-2+4*ER(-3),3*E(3),1,E(3),
2+4*ER(-3),0,E(3),0,0,0,0,0,840*E(3)^2,0,-8*E(3)^2,4*E(3)^2,0,-2,-1,0,-42,
2-4*ER(-3),2,ER(-3),-40*E(3)^2,-3*E(3)^2,-E(3)^2,7+ER(-3),-ER(-3),0,0,-840,8,
0,-4,2*E(3),0,42*E(3),-5-3*ER(-3),-2*E(3),(3+ER(-3))/2,40,3,1,(-3-ER(-3))/2,
840*E(3),0,-8*E(3),-E(3),-40*E(3),-3*E(3),-E(3),4*E(3),-840*E(3)^2,0,8*E(3)^2,
40*E(3)^2,3*E(3)^2,E(3)^2,-4*E(3)^2],[840,80,6,-8,-4,0,8*E(3),0,8*E(3)^2,
4*E(3),0,0,ER(-3),-ER(-3),0,4*E(3)^2,-2,0,-1,0,1,0,1,0,0,-1,12*E(3),0,2,-2,0,
12*E(3)^2,0,0,8,-E(3)^2,8,-E(3),0,2*E(3),0,2*E(3)^2,0,0,(3+ER(-3))/2,
(3-ER(-3))/2,0,0,-2*E(3)^2,0,0,-2*E(3),0,0,0,0,0,-2,-2*E(3)^2,0,2*E(3),
2*E(3)^2,0,-2*E(3),0,0,0,0,0,0,0,0,0,0,0,(3-ER(-3))/2,0,0,-8,(-3-ER(-3))/2,0,
0,E(3)^2,-E(3),0,0,0,-840*E(3),(3+ER(-3))/2,8*E(3),0,0,0,0,-4*E(3)^2,-4,
2*E(3),E(3),-12*E(3)^2,-12,-2*E(3)^2,-8*E(3),-8*E(3),0,2,-ER(-3),2*E(3)^2,
-80*E(3),0,-8*E(3)^2,-6*E(3),E(3),4*E(3),8*E(3),0,E(3)^2,0,0,0,0,0,840*E(3)^2,
0,-8*E(3)^2,0,0,4,-E(3)^2,0,12,8*E(3)^2,2,(-3-ER(-3))/2,80*E(3)^2,6*E(3)^2,
-4*E(3)^2,-8*E(3)^2,(-3+ER(-3))/2,0,0,-840,8,0,0,-4*E(3),0,-12*E(3),-8,
-2*E(3),(-3+ER(-3))/2,-80,-6,4,ER(-3),840*E(3),0,-8*E(3),0,80*E(3),6*E(3),
-4*E(3),0,-840*E(3)^2,0,8*E(3)^2,-80*E(3)^2,-6*E(3)^2,4*E(3)^2,0],[840,-80,6,
-8,4,0,-8*E(3)^2,0,-8*E(3),4*E(3)^2,0,0,-ER(-3),ER(-3),0,4*E(3),-2,0,1,0,-1,0,
-1,0,0,1,12*E(3)^2,0,2,-2,0,12*E(3),0,0,-8,E(3),-8,E(3)^2,0,-2*E(3)^2,0,
-2*E(3),0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,0,-2*E(3),0,0,-2*E(3)^2,0,0,0,0,0,2,
-2*E(3),0,2*E(3)^2,2*E(3),0,-2*E(3)^2,0,0,0,0,0,0,0,0,0,0,0,(3+ER(-3))/2,0,0,
8,(-3+ER(-3))/2,0,0,-E(3),E(3)^2,0,0,0,-840*E(3)^2,(3-ER(-3))/2,8*E(3)^2,0,0,
0,0,-4*E(3),-4,2*E(3)^2,-E(3)^2,-12*E(3),-12,2*E(3),8*E(3)^2,8*E(3)^2,0,2,
ER(-3),2*E(3),80*E(3)^2,0,8*E(3),-6*E(3)^2,-E(3)^2,-4*E(3)^2,-8*E(3)^2,0,
-E(3),0,0,0,0,0,840*E(3),0,-8*E(3),0,0,4,E(3),0,12,-8*E(3),-2,(-3+ER(-3))/2,
-80*E(3),6*E(3),4*E(3),8*E(3),(-3-ER(-3))/2,0,0,-840,8,0,0,-4*E(3)^2,0,
-12*E(3)^2,8,2*E(3)^2,(-3-ER(-3))/2,80,-6,-4,-ER(-3),840*E(3)^2,0,-8*E(3)^2,0,
-80*E(3)^2,6*E(3)^2,4*E(3)^2,0,-840*E(3),0,8*E(3),80*E(3),-6*E(3),-4*E(3),0],
[840,80,6,-8,-4,0,8*E(3)^2,0,8*E(3),4*E(3)^2,0,0,-ER(-3),ER(-3),0,4*E(3),-2,0,
-1,0,1,0,1,0,0,-1,12*E(3)^2,0,2,-2,0,12*E(3),0,0,8,-E(3),8,-E(3)^2,0,2*E(3)^2,
0,2*E(3),0,0,(3-ER(-3))/2,(3+ER(-3))/2,0,0,-2*E(3),0,0,-2*E(3)^2,0,0,0,0,0,-2,
-2*E(3),0,2*E(3)^2,2*E(3),0,-2*E(3)^2,0,0,0,0,0,0,0,0,0,0,0,(3+ER(-3))/2,0,0,
-8,(-3+ER(-3))/2,0,0,E(3),-E(3)^2,0,0,0,-840*E(3)^2,(3-ER(-3))/2,8*E(3)^2,0,0,
0,0,-4*E(3),-4,2*E(3)^2,E(3)^2,-12*E(3),-12,-2*E(3),-8*E(3)^2,-8*E(3)^2,0,2,
ER(-3),2*E(3),-80*E(3)^2,0,-8*E(3),-6*E(3)^2,E(3)^2,4*E(3)^2,8*E(3)^2,0,E(3),
0,0,0,0,0,840*E(3),0,-8*E(3),0,0,4,-E(3),0,12,8*E(3),2,(-3+ER(-3))/2,80*E(3),
6*E(3),-4*E(3),-8*E(3),(-3-ER(-3))/2,0,0,-840,8,0,0,-4*E(3)^2,0,-12*E(3)^2,-8,
-2*E(3)^2,(-3-ER(-3))/2,-80,-6,4,-ER(-3),840*E(3)^2,0,-8*E(3)^2,0,80*E(3)^2,
6*E(3)^2,-4*E(3)^2,0,-840*E(3),0,8*E(3),-80*E(3),-6*E(3),4*E(3),0],[840,-80,6,
-8,4,0,-8*E(3),0,-8*E(3)^2,4*E(3),0,0,ER(-3),-ER(-3),0,4*E(3)^2,-2,0,1,0,-1,0,
-1,0,0,1,12*E(3),0,2,-2,0,12*E(3)^2,0,0,-8,E(3)^2,-8,E(3),0,-2*E(3),0,
-2*E(3)^2,0,0,(3+ER(-3))/2,(3-ER(-3))/2,0,0,-2*E(3)^2,0,0,-2*E(3),0,0,0,0,0,2,
-2*E(3)^2,0,2*E(3),2*E(3)^2,0,-2*E(3),0,0,0,0,0,0,0,0,0,0,0,(3-ER(-3))/2,0,0,
8,(-3-ER(-3))/2,0,0,-E(3)^2,E(3),0,0,0,-840*E(3),(3+ER(-3))/2,8*E(3),0,0,0,0,
-4*E(3)^2,-4,2*E(3),-E(3),-12*E(3)^2,-12,2*E(3)^2,8*E(3),8*E(3),0,2,-ER(-3),
2*E(3)^2,80*E(3),0,8*E(3)^2,-6*E(3),-E(3),-4*E(3),-8*E(3),0,-E(3)^2,0,0,0,0,0,
840*E(3)^2,0,-8*E(3)^2,0,0,4,E(3)^2,0,12,-8*E(3)^2,-2,(-3-ER(-3))/2,
-80*E(3)^2,6*E(3)^2,4*E(3)^2,8*E(3)^2,(-3+ER(-3))/2,0,0,-840,8,0,0,-4*E(3),0,
-12*E(3),8,2*E(3),(-3+ER(-3))/2,80,-6,-4,ER(-3),840*E(3),0,-8*E(3),0,-80*E(3),
6*E(3),4*E(3),0,-840*E(3)^2,0,8*E(3)^2,80*E(3)^2,-6*E(3)^2,-4*E(3)^2,0],[896,
-64,-4,0,2,0,8,0,8,0,-4,1,-1,-1,0,0,0,1,-1,0,-1,0,-1,0,0,-1,32,0,0,0,0,32,0,1,
8,-1,8,-1,0,-4,0,-4,0,0,-1,-1,1,1,0,0,0,0,0,-1,0,1,1,-4,0,0,0,0,0,0,0,0,0,1,0,
1,0,0,0,-4,0,-1,0,-1,8,-1,0,0,-1,-1,0,1,0,896,-1,0,0,0,0,-4,0,0,0,-1,32,32,-4,
8,8,0,0,-1,0,-64,-4,8,-4,-1,2,8,0,-1,1,0,0,0,0,896,0,0,0,0,0,-1,0,32,8,-4,-1,
-64,-4,2,8,-1,1,0,896,0,0,0,0,0,32,8,-4,-1,-64,-4,2,-1,896,0,0,0,-64,-4,2,0,
896,0,0,-64,-4,2,0],[896,64,-4,0,-2,0,-8,0,-8,0,-4,1,-1,-1,0,0,0,-1,1,0,1,0,1,
0,0,1,32,0,0,0,0,32,0,-1,-8,1,-8,1,0,4,0,4,0,0,-1,-1,1,1,0,0,0,0,0,-1,0,-1,-1,
4,0,0,0,0,0,0,0,0,0,-1,0,-1,0,0,0,-4,0,-1,0,-1,-8,-1,0,0,1,1,0,1,0,896,-1,0,0,
0,0,-4,0,0,0,1,32,32,4,-8,-8,0,0,-1,0,64,-4,-8,-4,1,-2,-8,0,1,1,0,0,0,0,896,0,
0,0,0,0,1,0,32,-8,4,-1,64,-4,-2,-8,-1,1,0,896,0,0,0,0,0,32,-8,4,-1,64,-4,-2,
-1,896,0,0,0,64,-4,-2,0,896,0,0,64,-4,-2,0],[896,-64,-4,0,2,0,8,0,8,0,-4,1,-1,
-1,0,0,0,1,-1,0,1,0,1,0,0,-1,32,0,0,0,0,32,0,-1,8,-1,8,-1,0,-4,0,-4,0,0,-1,-1,
-1,-1,0,0,0,0,0,1,0,-1,-1,4,0,0,0,0,0,0,0,0,0,1,0,1,0,0,0,-4,0,1,0,-1,-8,1,0,
0,1,-1,0,1,0,-896,1,0,0,0,0,4,0,0,0,1,-32,-32,4,-8,-8,0,0,1,0,64,4,-8,4,1,-2,
8,0,1,-1,0,0,0,0,896,0,0,0,0,0,-1,0,32,8,-4,-1,-64,-4,2,-8,-1,1,0,-896,0,0,0,
0,0,-32,-8,4,1,64,4,-2,1,896,0,0,0,-64,-4,2,0,-896,0,0,64,4,-2,0],[896,64,-4,
0,-2,0,-8,0,-8,0,-4,1,-1,-1,0,0,0,-1,1,0,-1,0,-1,0,0,1,32,0,0,0,0,32,0,1,-8,1,
-8,1,0,4,0,4,0,0,-1,-1,-1,-1,0,0,0,0,0,1,0,1,1,-4,0,0,0,0,0,0,0,0,0,-1,0,-1,0,
0,0,-4,0,1,0,-1,8,1,0,0,-1,1,0,1,0,-896,1,0,0,0,0,4,0,0,0,-1,-32,-32,-4,8,8,0,
0,1,0,-64,4,8,4,-1,2,-8,0,-1,-1,0,0,0,0,896,0,0,0,0,0,1,0,32,-8,4,-1,64,-4,-2,
8,-1,1,0,-896,0,0,0,0,0,-32,8,-4,1,-64,4,2,1,896,0,0,0,64,-4,-2,0,-896,0,0,
-64,4,2,0],[945,45,0,-15,0,-3,-9*E(3),-3,-9*E(3)^2,-3*E(3)^2,0,0,0,0,1,
-3*E(3),0,0,0,0,0,0,0,0,0,0,-27*E(3)^2,0,0,0,0,-27*E(3),1,0,-9*E(3)^2,0,
-9*E(3),0,0,0,0,0,-E(3)^2,-E(3),0,0,0,0,0,E(3)^2,E(3)^2,0,E(3),0,E(3),0,0,0,0,
0,0,0,0,0,1,1,-1,0,E(3),0,0,E(3)^2,-1,0,0,0,0,0,-9*E(3),0,1,E(3),0,0,1,0,
5*E(3),945*E(3)^2,0,-15*E(3)^2,E(3)^2,-3*E(3)^2,-3*E(3)^2,0,-3*E(3),-3,0,0,
-27*E(3),-27,0,-9*E(3),-9,0,0,0,0,45*E(3)^2,0,-9,0,0,0,-9,E(3)^2,0,0,E(3),0,
E(3)^2,5,945*E(3),E(3),-15*E(3),-3*E(3),-3*E(3),-3,0,-E(3)^2,-27,-9,0,0,
45*E(3),0,0,-9*E(3)^2,0,0,5*E(3)^2,945,-15,1,-3,-3*E(3)^2,-E(3),-27*E(3)^2,
-9*E(3)^2,0,0,45,0,0,0,945*E(3)^2,E(3)^2,-15*E(3)^2,0,45*E(3)^2,0,0,-3*E(3)^2,
945*E(3),E(3),-15*E(3),45*E(3),0,0,-3*E(3)],[945,-45,0,-15,0,3,9*E(3),3,
9*E(3)^2,-3*E(3)^2,0,0,0,0,1,-3*E(3),0,0,0,0,0,0,0,0,0,0,-27*E(3)^2,0,0,0,0,
-27*E(3),-1,0,9*E(3)^2,0,9*E(3),0,0,0,0,0,E(3)^2,E(3),0,0,0,0,0,E(3)^2,E(3)^2,
0,E(3),0,E(3),0,0,0,0,0,0,0,0,0,1,1,1,0,-E(3),0,0,-E(3)^2,1,0,0,0,0,0,9*E(3),
0,1,E(3),0,0,1,0,-5*E(3),945*E(3)^2,0,-15*E(3)^2,E(3)^2,3*E(3)^2,3*E(3)^2,0,
-3*E(3),-3,0,0,-27*E(3),-27,0,9*E(3),9,0,0,0,0,-45*E(3)^2,0,9,0,0,0,9,E(3)^2,
0,0,E(3),0,E(3)^2,-5,945*E(3),E(3),-15*E(3),3*E(3),3*E(3),-3,0,E(3)^2,-27,9,0,
0,-45*E(3),0,0,9*E(3)^2,0,0,-5*E(3)^2,945,-15,1,3,-3*E(3)^2,E(3),-27*E(3)^2,
9*E(3)^2,0,0,-45,0,0,0,945*E(3)^2,E(3)^2,-15*E(3)^2,0,-45*E(3)^2,0,0,3*E(3)^2,
945*E(3),E(3),-15*E(3),-45*E(3),0,0,3*E(3)],[945,45,0,-15,0,-3,-9*E(3)^2,-3,
-9*E(3),-3*E(3),0,0,0,0,1,-3*E(3)^2,0,0,0,0,0,0,0,0,0,0,-27*E(3),0,0,0,0,
-27*E(3)^2,1,0,-9*E(3),0,-9*E(3)^2,0,0,0,0,0,-E(3),-E(3)^2,0,0,0,0,0,E(3),
E(3),0,E(3)^2,0,E(3)^2,0,0,0,0,0,0,0,0,0,1,1,-1,0,E(3)^2,0,0,E(3),-1,0,0,0,0,
0,-9*E(3)^2,0,1,E(3)^2,0,0,1,0,5*E(3)^2,945*E(3),0,-15*E(3),E(3),-3*E(3),
-3*E(3),0,-3*E(3)^2,-3,0,0,-27*E(3)^2,-27,0,-9*E(3)^2,-9,0,0,0,0,45*E(3),0,-9,
0,0,0,-9,E(3),0,0,E(3)^2,0,E(3),5,945*E(3)^2,E(3)^2,-15*E(3)^2,-3*E(3)^2,
-3*E(3)^2,-3,0,-E(3),-27,-9,0,0,45*E(3)^2,0,0,-9*E(3),0,0,5*E(3),945,-15,1,-3,
-3*E(3),-E(3)^2,-27*E(3),-9*E(3),0,0,45,0,0,0,945*E(3),E(3),-15*E(3),0,
45*E(3),0,0,-3*E(3),945*E(3)^2,E(3)^2,-15*E(3)^2,45*E(3)^2,0,0,-3*E(3)^2],
[945,-45,0,-15,0,3,9*E(3)^2,3,9*E(3),-3*E(3),0,0,0,0,1,-3*E(3)^2,0,0,0,0,0,0,
0,0,0,0,-27*E(3),0,0,0,0,-27*E(3)^2,-1,0,9*E(3),0,9*E(3)^2,0,0,0,0,0,E(3),
E(3)^2,0,0,0,0,0,E(3),E(3),0,E(3)^2,0,E(3)^2,0,0,0,0,0,0,0,0,0,1,1,1,0,
-E(3)^2,0,0,-E(3),1,0,0,0,0,0,9*E(3)^2,0,1,E(3)^2,0,0,1,0,-5*E(3)^2,945*E(3),
0,-15*E(3),E(3),3*E(3),3*E(3),0,-3*E(3)^2,-3,0,0,-27*E(3)^2,-27,0,9*E(3)^2,9,
0,0,0,0,-45*E(3),0,9,0,0,0,9,E(3),0,0,E(3)^2,0,E(3),-5,945*E(3)^2,E(3)^2,
-15*E(3)^2,3*E(3)^2,3*E(3)^2,-3,0,E(3),-27,9,0,0,-45*E(3)^2,0,0,9*E(3),0,0,
-5*E(3),945,-15,1,3,-3*E(3),E(3)^2,-27*E(3),9*E(3),0,0,-45,0,0,0,945*E(3),
E(3),-15*E(3),0,-45*E(3),0,0,3*E(3),945*E(3)^2,E(3)^2,-15*E(3)^2,-45*E(3)^2,0,
0,3*E(3)^2],[1260,0,-18,4,0,0,0,0,0,-2*E(3),0,0,0,0,0,-2*E(3)^2,-2,0,0,0,0,0,
0,0,0,0,18*E(3),0,2,4,0,18*E(3)^2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4*E(3)^2,0,
2*E(3),4*E(3),2*E(3)^2,0,0,0,0,0,-2*E(3)^2,0,-4*E(3),-4*E(3)^2,0,-2*E(3),-4,
-2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,-1260*E(3),0,-4*E(3),4*E(3),0,0,
0,2*E(3)^2,2,2*E(3),0,-18*E(3)^2,-18,0,0,0,0,-4,0,2*E(3)^2,0,0,0,18*E(3),0,0,
0,-2*E(3),0,0,-2*E(3)^2,0,0,0,1260*E(3)^2,-4*E(3)^2,4*E(3)^2,0,0,-2,0,0,18,0,
0,0,0,-18*E(3)^2,0,0,0,0,0,-1260,-4,4,0,2*E(3),0,-18*E(3),0,0,0,0,18,0,0,
1260*E(3),-4*E(3),4*E(3),0,0,-18*E(3),0,0,-1260*E(3)^2,4*E(3)^2,-4*E(3)^2,0,
18*E(3)^2,0,0],[1260,0,-18,4,0,0,0,0,0,-2*E(3)^2,0,0,0,0,0,-2*E(3),-2,0,0,0,0,
0,0,0,0,0,18*E(3)^2,0,2,4,0,18*E(3),0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,4*E(3),0,
2*E(3)^2,4*E(3)^2,2*E(3),0,0,0,0,0,-2*E(3),0,-4*E(3)^2,-4*E(3),0,-2*E(3)^2,-4,
-2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,0,0,0,-1260*E(3)^2,0,-4*E(3)^2,
4*E(3)^2,0,0,0,2*E(3),2,2*E(3)^2,0,-18*E(3),-18,0,0,0,0,-4,0,2*E(3),0,0,0,
18*E(3)^2,0,0,0,-2*E(3)^2,0,0,-2*E(3),0,0,0,1260*E(3),-4*E(3),4*E(3),0,0,-2,0,
0,18,0,0,0,0,-18*E(3),0,0,0,0,0,-1260,-4,4,0,2*E(3)^2,0,-18*E(3)^2,0,0,0,0,18,
0,0,1260*E(3)^2,-4*E(3)^2,4*E(3)^2,0,0,-18*E(3)^2,0,0,-1260*E(3),4*E(3),
-4*E(3),0,18*E(3),0,0],[1280,0,-16,0,0,0,0,0,0,0,2,0,2,2,0,0,0,0,0,0,0,0,0,0,
0,0,-16,-1,0,0,-1,-16,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,2,0,0,0,0,0,
-1,0,0,-1,0,0,0,0,0,0,0,0,0,0,-16,-1,2,0,2,0,2,0,0,0,0,0,0,0,1280,2,0,0,0,0,2,
0,0,0,0,-16,-16,0,0,0,0,0,2,0,0,-16,0,-16,0,0,0,0,0,0,0,-1,0,0,1280,0,0,0,0,0,
0,0,-16,0,0,2,0,-16,0,0,2,0,0,1280,0,0,0,0,0,-16,0,0,2,0,-16,0,2,1280,0,0,0,0,
-16,0,0,1280,0,0,0,-16,0,0],[1280,0,-16,0,0,0,0,0,0,0,2,0,2,2,0,0,0,0,0,0,0,0,
0,0,0,0,-16,1,0,0,1,-16,0,0,0,0,0,0,0,0,0,0,0,0,2,2,0,0,0,0,0,0,0,-2,0,0,0,0,
0,-1,0,0,-1,0,0,0,0,0,0,0,0,0,0,-16,1,-2,0,2,0,-2,0,0,0,0,0,0,0,-1280,-2,0,0,
0,0,-2,0,0,0,0,16,16,0,0,0,0,0,-2,0,0,16,0,16,0,0,0,0,0,0,0,-1,0,0,1280,0,0,0,
0,0,0,0,-16,0,0,2,0,-16,0,0,2,0,0,-1280,0,0,0,0,0,16,0,0,-2,0,16,0,-2,1280,0,
0,0,0,-16,0,0,-1280,0,0,0,16,0,0]]);

CHEVIE.AddData("CharTable","G34",function()local res;
  res:= rec(size:=39191040, order:=39191040,
  identifier:="G34", name:="G34",
  powermap:=CHEVIE.RawData("PowerMaps","G34"),
  irreducibles:=CHEVIE.RawData("Irr","G34"),
  irredinfo:=List(CHEVIE.RawData("CharInfo","G34")().charparams,x->
    rec(charparam:=x,charname:=CHEVIE.RawData("CharName","G34")(x,rec()))),
  galomorphisms:=Group( (  7,  9)( 10, 16)( 13, 14)( 19, 26)( 20, 22)( 21, 23)
  ( 27, 32)( 28, 31)( 35, 37)( 36, 38)( 40, 42)( 43, 44)( 45, 46)( 47, 48)
  ( 49, 52)( 50, 55)( 51, 53)( 56, 57)( 59, 64)( 60, 63)( 61, 62)( 67, 73)
  ( 68, 70)( 69, 72)( 76, 89)( 77,158)( 79,148)( 80,150)( 82,120)( 83,112)
  ( 84,128)( 86,139)( 87,140)( 88,163)( 90,165)( 91,164)( 92,169)( 93,126)
  ( 95,145)( 97,107)( 98,116)( 99,147)(101,149)(102,137)(103,110)(106,154)
  (108,166)(111,167)(113,168)(114,131)(115,118)(122,155)(123,156)(124,157)
  (125,162)(129,146)(133,138)(134,159)(135,160)(136,161) ),
  text:="origin: Dixon's Algorithm");
  Inherit(res,CHEVIE.RawData("ClassInfo","G34"));
  res.centralizers:=List(res.classes,x->res.order/x);
  return CHEVIE.compat.MakeCharacterTable(res);
end);

CHEVIE.AddData("HeckeRepresentation","G34",function(para,i)
  local r,p,f1,f6,f15,f20,rep; r:=para[1][1];p:=para[1][2];
  f1:=function(p)return List([1..6],x->[[p]]);end;
  f6:=function(p,r,a)return
    [[[r,0,0,0,0,0],[-r,p,0,0,0,0],[0,0,p,0,0,0],
      [0,0,0,p,0,0],[0,0,0,0,p,0],[0,0,0,0,0,p]],
     [[p,p,0,0,0,0],[0,r,0,0,0,0],[0,a*p,p,0,0,0],
      [0,p,0,p,0,0],[0,0,0,0,p,0],[0,0,0,0,0,p]],
     [[p,0,0,0,0,0],[0,p,-a^2*r,0,0,0],[0,0,r,0,0,0],
      [0,0,-r,p,0,0],[0,0,0,0,p,0],[0,0,0,0,0,p]],
     [[p,0,0,0,0,0],[0,p,0,-r,0,0],[0,0,p,p,0,0],
      [0,0,0,r,0,0],[0,0,0,-r,p,0],[0,0,0,0,0,p]],
     [[p,0,0,0,0,0],[0,p,0,0,0,0],[0,0,p,0,0,0],
      [0,0,0,p,p,0],[0,0,0,0,r,0],[0,0,0,0,-r,p]],
     [[p,0,0,0,0,0],[0,p,0,0,0,0],[0,0,p,0,0,0],
      [0,0,0,p,0,0],[0,0,0,0,p,p],[0,0,0,0,0,r]]]*p^0*r^0;end;
  f15:=function(p,r,a)return List(f6(p,r,a),x->ExteriorPower(x,2)/p);end;
  f20:=function(p,r,a)return List(f6(p,r,a),x->ExteriorPower(x,3)/p^2);end;
  rep:=[[f1,r],[f1,p],
        [f6,r,p,E(3)^2],[f6,p,r,E(3)^2],[f6,r,p,E(3)],[f6,p,r,E(3)],
        [f15,p,r,E(3)^2],[f15,r,p,E(3)^2],[f15,p,r,E(3)],[f15,r,p,E(3)],
        [f20,r,p,E(3)],[f20,p,r,E(3)]];
  if IsBound(rep[i]) then 
    return ApplyFunc(rep[i][1],rep[i]{[2..Length(rep[i])]});
  else return false;fi;
end);

CHEVIE.AddData("Representation","G34",function(i)local r,f;
  r:=CHEVIE.RawData("HeckeRepresentation","G34")(List([1..6],x->[1,-1]),i);
  f:=i->CHEVIE.RawData("Representation","G34")(i);
  if r<>false then return r;
  elif i=15 then return List(f(3),x->SymmetricPower(x,2));
  elif i=16 then return -f(15);
  elif i=17 then return ComplexConjugate(f(15));
  elif i=18 then return -f(17);
  elif i=23 then return List(f(4),x->SymmetricPower(x,3));
  elif i=24 then return -f(23);
  elif i=29 then return List(f(4),x->SchurFunctor(x,[2,1]));
  elif i=30 then return ComplexConjugate(f(29));
  elif i=31 then return -f(30);
  elif i=32 then return -f(29);
  elif i=33 then return -f(36);
  elif i=34 then return List(f(3),x->SchurFunctor(x,[2,1,1,1]));
  elif i=35 then return -f(34);
  elif i=36 then return ComplexConjugate(f(34));
  elif i=39 then return List(f(5),x->SchurFunctor(x,[2,2]));
  elif i=41 then return -f(39);
  elif i=44 then return -f(45);
  elif i=45 then return ComplexConjugate(f(39));
  elif i=47 then return List(f(10),x->ExteriorPower(x,2));
  elif i=48 then return -f(47);
  elif i=49 then return ComplexConjugate(f(47));
  elif i=50 then return -f(49);
  elif i=57 then return Zip(f(3),f(14),KroneckerMatrix);
  elif i=58 then return -f(57);
  elif i=59 then return ComplexConjugate(f(57));
  elif i=60 then return -f(59);
  elif i=66 then return -f(67);
  elif i=67 then return List(f(13),x->ExteriorPower(x,2));
  elif i=68 then return List(f(17),x->ExteriorPower(x,2));
  elif i=69 then return -f(68);
  elif i=70 then return -f(71);
  elif i=71 then return ComplexConjugate(f(68));
  elif i=72 then return Zip(f(3),f(22),KroneckerMatrix);
  elif i=73 then return -f(72);
  elif i=74 then return ComplexConjugate(f(72));
  elif i=75 then return -f(74);
  elif i=84 then return Zip(f(7),f(13),KroneckerMatrix);
  elif i=85 then return -f(84);
  elif i=87 then return -f(86);
  elif i=86 then return ComplexConjugate(f(84));
  elif i=88 then return Zip(f(5),f(25),KroneckerMatrix);
  elif i=89 then return -f(88);
  elif i=90 then return ComplexConjugate(f(88));
  elif i=91 then return -f(90);
  elif i=92 then return List(f(5),x->SchurFunctor(x,[3,1,1]));
  elif i=93 then return -f(94);
  elif i=94 then return ComplexConjugate(f(92));
  elif i=95 then return -f(92);
  elif i=106 then return Zip(f(11),f(13),KroneckerMatrix);
  elif i=107 then return List(f(5),x->SchurFunctor(x,[3,2]));
  elif i=108 then return ComplexConjugate(f(110));
  elif i=109 then return -f(108);
  elif i=110 then return -f(107);
  elif i=138 then return Zip(f(5),f(51),KroneckerMatrix);
  elif i=139 then return ComplexConjugate(f(138));
  elif i=154 then return Zip(f(9),f(25),KroneckerMatrix);
  elif i=155 then return -f(156);
  elif i=156 then return ComplexConjugate(f(154));
  elif i=157 then return -f(154);
  else return false;
  fi;
end);

CHEVIE.AddData("vpolfakedegrees","G34",[ [ [ 1 ], 0 ], [ [ 1 ], 126 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
          1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 ], 5 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
          1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1 ], 89 ],
  [ [ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
          1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1 ], 1 ],
  [ [ 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0,
          1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1 ], 85 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0,
          0, 0, 1, 0, 0, 0, 0, 0, 1 ], 58 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0,
          0, 0, 1, 0, 0, 0, 0, 0, 1 ], 16 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 1, 0, 0, 0, 0, 0, 1 ], 56 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 1, 0, 0, 0, 0, 0, 1 ], 14 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1 ], 33 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1 ], 33 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1 ], 60 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 2, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 1 ], 6 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 1, 0, 0, 0, 0, 0, 1 ], 4 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 1, 0, 0, 0, 0, 0, 1 ], 70 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 2, 0, 0, 0, 0, 0, 1 ], 2 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0,
          0, 0, 2, 0, 0, 0, 0, 0, 1 ], 68 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0,
          5, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 4, 0, 0, 0,
          0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 60 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0,
          5, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 4, 0, 0, 0,
          0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 6 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
          4, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 4, 0, 0, 0,
          0, 0, 4, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1, 0,
          0, 0, 0, 0, 1 ], 36 ],
  [ [ 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0,
          4, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 4, 0, 0, 0,
          0, 0, 4, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1, 0,
          0, 0, 0, 0, 1 ], 18 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          7, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 7, 0, 0, 0,
          0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 57],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          7, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 7, 0, 0, 0,
          0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 3 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
          6, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 7, 0, 0, 0,
          0, 0, 6, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 45 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
          6, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 7, 0, 0, 0,
          0, 0, 6, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 9 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 9, 0, 0, 0,
          0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 45 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 9, 0, 0, 0,
          0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 9 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 9, 0, 0, 0,
          0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 45 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 9, 0, 0, 0,
          0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 45 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 9, 0, 0, 0,
          0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 9 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 9, 0, 0, 0,
          0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0,
          0, 0, 0, 0, 1 ], 9 ],
  [ [ 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 10, 0, 0,
          0, 0, 0, 9, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2,
          0, 0, 0, 0, 0, 1 ], 17 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 11, 0, 0,
          0, 0, 0, 10, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 3,
          0, 0, 0, 0, 0, 2 ], 37 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          9, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 11, 0, 0,
          0, 0, 0, 10, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 3,
          0, 0, 0, 0, 0, 2 ], 13 ],
  [ [ 2, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 10, 0, 0,
          0, 0, 0, 9, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2,
          0, 0, 0, 0, 0, 1 ], 41 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 12, 0, 0,
          0, 0, 0, 10, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 3,
          0, 0, 0, 0, 0, 1 ], 6 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 12, 0, 0,
          0, 0, 0, 10, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 3,
          0, 0, 0, 0, 0, 1 ], 48 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          11, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 12, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 4,
          0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 10 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          11, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 4,
          0, 0, 0, 0, 0, 2 ], 46 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          11, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 12, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 4,
          0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 40 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          11, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 4,
          0, 0, 0, 0, 0, 2 ], 4 ],
  [ [ 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 13, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 13, 0,
          0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
          2, 0, 0, 0, 0, 0, 1 ], 50 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 13, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5,
          0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 38 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 13, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5,
          0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 8 ],
  [ [ 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 13, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 13, 0,
          0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0,
          2, 0, 0, 0, 0, 0, 1 ], 8 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          11, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 12, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 4,
          0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 22 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          11, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 12, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 4,
          0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 28 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 13, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5,
          0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 20 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 14, 0, 0,
          0, 0, 0, 13, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 5,
          0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 26 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 16, 0, 0,
          0, 0, 0, 15, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0,
          7, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 21 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 16, 0, 0,
          0, 0, 0, 15, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0,
          7, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 21 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 13, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 16, 0,
          0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          4, 0, 0, 0, 0, 0, 2 ], 5 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 13, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 16, 0,
          0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0,
          4, 0, 0, 0, 0, 0, 2 ], 47 ],
  [ [ 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0,
          0, 14, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 16, 0,
          0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 1 ], 7 ],
  [ [ 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0,
          0, 14, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 16, 0,
          0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0,
          3, 0, 0, 0, 0, 0, 1 ], 49 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          12, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 17, 0, 0,
          0, 0, 0, 16, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0,
          6, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 5 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          12, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 17, 0, 0,
          0, 0, 0, 16, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0,
          6, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 41 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 13, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 17, 0,
          0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          5, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 7 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 13, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 17, 0,
          0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          5, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 43 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          12, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 18, 0, 0,
          0, 0, 0, 18, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 21 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          12, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 18, 0, 0,
          0, 0, 0, 18, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 30 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0,
          12, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 18, 0, 0,
          0, 0, 0, 18, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0,
          8, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 12 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 25, 0,
          0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 11, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 24 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 25, 0,
          0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 11, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 18 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 28, 0,
          0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 12, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 30 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 28, 0,
          0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 12, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 12 ],
  [ [ 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 22, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 28, 0,
          0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0,
          0, 8, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 10 ],
  [ [ 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 22, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0, 0, 28, 0,
          0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0,
          0, 8, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 40 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0,
          0, 20, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 29, 0,
          0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 10, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2 ], 38 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0,
          0, 20, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 29, 0,
          0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 10, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2 ], 8 ],
  [ [ 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0,
          0, 20, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 27, 0,
          0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 10, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 17 ],
  [ [ 2, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0,
          0, 20, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 27, 0,
          0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 10, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 1 ], 29 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 27, 0,
          0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0,
          0, 14, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2 ], 13 ],
  [ [ 1, 0, 0, 0, 0, 0, 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 27, 0,
          0, 0, 0, 0, 28, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0,
          0, 14, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 2 ], 25 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 38, 0,
          0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 30 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 38, 0,
          0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 30 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 38, 0,
          0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 12 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 38, 0,
          0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 16, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 12 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 43, 0,
          0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 36 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 43, 0,
          0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 6 ],
  [ [ 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 41, 0,
          0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2 ], 24 ],
  [ [ 2, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 41, 0,
          0, 0, 0, 0, 40, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 2 ], 18 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 42, 0,
          0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 10 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 42, 0,
          0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 28 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 30, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 42, 0,
          0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 15, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 14 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 30, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 42, 0,
          0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 15, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 32 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 30, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 34 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 30, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 10 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 32 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 8 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 17 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 30, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 25 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 30, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 19 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 45, 0,
          0, 0, 0, 0, 44, 0, 0, 0, 0, 0, 38, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 23 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0,
          0, 33, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 52, 0,
          0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 1 ], 11 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 51, 0,
          0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3 ], 29 ],
  [ [ 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 37, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 51, 0,
          0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 13 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 52, 0,
          0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 33, 0, 0, 0, 0,
          0, 23, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 31 ],
  [ [ 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 37, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 51, 0,
          0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0,
          0, 18, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 1 ], 34 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 52, 0,
          0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 33, 0, 0, 0, 0,
          0, 23, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 10 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0,
          0, 33, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 52, 0,
          0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0,
          0, 21, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 1 ], 32 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 47, 0, 0, 0, 0, 0, 51, 0,
          0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0,
          0, 27, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3 ], 8 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 30 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 12 ],
  [ [ 2, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 24, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 2 ], 21 ],
  [ [ 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0,
          0, 20, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 11 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3 ], 31 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 40, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3 ], 7 ],
  [ [ 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 28, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 32, 0, 0, 0, 0,
          0, 20, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 1 ], 35 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 3, 0, 0,
          0, 0, 0, 1 ], 16 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 56, 0,
          0, 0, 0, 0, 54, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 3, 0, 0,
          0, 0, 0, 1 ], 22 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 54, 0,
          0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 14 ],
  [ [ 1, 0, 0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0,
          0, 28, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 54, 0,
          0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 51, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0,
          0, 32, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 20 ],
  [ [ 2, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0,
          0, 43, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 68, 0,
          0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0,
          0, 29, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 2 ], 33 ],
  [ [ 2, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 29, 0, 0, 0, 0,
          0, 43, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 68, 0,
          0, 0, 0, 0, 65, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0,
          0, 29, 0, 0, 0, 0, 0, 16, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 2 ], 9 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 66, 0,
          0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 21 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 66, 0,
          0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 60, 0, 0, 0, 0, 0, 49, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 23, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 15 ],
  [ [ 1, 0, 0, 0, 0, 0, 4, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 70, 0,
          0, 0, 0, 0, 72, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0,
          0, 41, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 6, 0,
          0, 0, 0, 0, 1 ], 17 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 41, 0, 0, 0, 0, 0, 56, 0, 0, 0, 0, 0, 66, 0, 0, 0, 0, 0, 72, 0,
          0, 0, 0, 0, 70, 0, 0, 0, 0, 0, 63, 0, 0, 0, 0, 0, 50, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 4, 0,
          0, 0, 0, 0, 1 ], 19 ],
  [ [ 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 46, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 72, 0,
          0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0,
          0, 31, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3 ], 21 ],
  [ [ 3, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 46, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 72, 0,
          0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0,
          0, 31, 0, 0, 0, 0, 0, 18, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 3 ], 21 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 74, 0,
          0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 27 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 74, 0,
          0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 9 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 74, 0,
          0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 18 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 74, 0,
          0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 18 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 74, 0,
          0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 67, 0, 0, 0, 0, 0, 55, 0, 0, 0, 0,
          0, 40, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 18 ],
  [ [ 3, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 54, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 84, 0,
          0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 3 ], 27 ],
  [ [ 3, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 54, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 84, 0,
          0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 69, 0, 0, 0, 0, 0, 54, 0, 0, 0, 0,
          0, 36, 0, 0, 0, 0, 0, 21, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 3 ], 15 ],
  [ [ 2, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 83, 0,
          0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 16 ],
  [ [ 2, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 83, 0,
          0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 22 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 82, 0,
          0, 0, 0, 0, 83, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 7, 0,
          0, 0, 0, 0, 2 ], 14 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 82, 0,
          0, 0, 0, 0, 83, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 7, 0,
          0, 0, 0, 0, 2 ], 20 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 82, 0,
          0, 0, 0, 0, 83, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 7, 0,
          0, 0, 0, 0, 2 ], 11 ],
  [ [ 2, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 83, 0,
          0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 25 ],
  [ [ 2, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 83, 0,
          0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 13 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 59, 0, 0, 0, 0, 0, 73, 0, 0, 0, 0, 0, 82, 0,
          0, 0, 0, 0, 83, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0,
          0, 48, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 7, 0,
          0, 0, 0, 0, 2 ], 23 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0,
          0, 45, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 92, 0,
          0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 76, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 10, 0,
          0, 0, 0, 0, 3 ], 16 ],
  [ [ 3, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 76, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 95, 0,
          0, 0, 0, 0, 92, 0, 0, 0, 0, 0, 81, 0, 0, 0, 0, 0, 64, 0, 0, 0, 0,
          0, 45, 0, 0, 0, 0, 0, 27, 0, 0, 0, 0, 0, 13, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 20 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 49, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 85, 0, 0, 0, 0, 0, 95, 0,
          0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0,
          0, 55, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 8, 0,
          0, 0, 0, 0, 2 ], 24 ],
  [ [ 2, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 55, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 97, 0,
          0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 85, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0,
          0, 49, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 12 ],
  [ [ 4, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0,
          0, 62, 0, 0, 0, 0, 0, 80, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 97, 0,
          0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 80, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 4 ], 28],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0,
          0, 49, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0, 0, 85, 0, 0, 0, 0, 0, 95, 0,
          0, 0, 0, 0, 97, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0,
          0, 55, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 8, 0,
          0, 0, 0, 0, 2 ], 10 ],
  [ [ 2, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 36, 0, 0, 0, 0,
          0, 55, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 97, 0,
          0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 85, 0, 0, 0, 0, 0, 68, 0, 0, 0, 0,
          0, 49, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 5, 0,
          0, 0, 0, 0, 1 ], 26 ],
  [ [ 4, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 42, 0, 0, 0, 0,
          0, 62, 0, 0, 0, 0, 0, 80, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 97, 0,
          0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 80, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0,
          0, 42, 0, 0, 0, 0, 0, 24, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 4 ], 14],
  [ [ 2, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 100, 0,
          0, 0, 0, 0, 99, 0, 0, 0, 0, 0, 88, 0, 0, 0, 0, 0, 71, 0, 0, 0, 0,
          0, 50, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 6, 0,
          0, 0, 0, 0, 1 ], 16 ],
  [ [ 2, 0, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 100, 0,
          0, 0, 0, 0, 99, 0, 0, 0, 0, 0, 88, 0, 0, 0, 0, 0, 71, 0, 0, 0, 0,
          0, 50, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 6, 0,
          0, 0, 0, 0, 1 ], 22 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 50, 0, 0, 0, 0, 0, 71, 0, 0, 0, 0, 0, 88, 0, 0, 0, 0, 0, 99, 0,
          0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 8, 0,
          0, 0, 0, 0, 2 ], 14 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 50, 0, 0, 0, 0, 0, 71, 0, 0, 0, 0, 0, 88, 0, 0, 0, 0, 0, 99, 0,
          0, 0, 0, 0, 100, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 77, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 37, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 8, 0,
          0, 0, 0, 0, 2 ], 20 ],
  [ [ 3, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0,
          0, 68, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 112,
          0, 0, 0, 0, 0, 108, 0, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 75, 0, 0, 0,
          0, 0, 52, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 5,
          0, 0, 0, 0, 0, 1 ], 17 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 52, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 108, 0,
          0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0,
          0, 68, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 11, 0,
          0, 0, 0, 0, 3 ], 19 ],
  [ [ 1, 0, 0, 0, 0, 0, 5, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0,
          0, 52, 0, 0, 0, 0, 0, 75, 0, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 108, 0,
          0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0,
          0, 68, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 11, 0,
          0, 0, 0, 0, 3 ], 13 ],
  [ [ 3, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 45, 0, 0, 0, 0,
          0, 68, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 105, 0, 0, 0, 0, 0, 112,
          0, 0, 0, 0, 0, 108, 0, 0, 0, 0, 0, 95, 0, 0, 0, 0, 0, 75, 0, 0, 0,
          0, 0, 52, 0, 0, 0, 0, 0, 31, 0, 0, 0, 0, 0, 15, 0, 0, 0, 0, 0, 5,
          0, 0, 0, 0, 0, 1 ], 23 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0,
          0, 56, 0, 0, 0, 0, 0, 79, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 110, 0,
          0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 86, 0, 0, 0, 0,
          0, 64, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 9, 0,
          0, 0, 0, 0, 2 ], 11 ],
  [ [ 2, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0,
          0, 64, 0, 0, 0, 0, 0, 86, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 112,
          0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 79, 0, 0, 0,
          0, 0, 56, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 6,
          0, 0, 0, 0, 0, 1 ], 25 ],
  [ [ 2, 0, 0, 0, 0, 0, 9, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0,
          0, 64, 0, 0, 0, 0, 0, 86, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 112,
          0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 79, 0, 0, 0,
          0, 0, 56, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 6,
          0, 0, 0, 0, 0, 1 ], 13 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0,
          0, 56, 0, 0, 0, 0, 0, 79, 0, 0, 0, 0, 0, 98, 0, 0, 0, 0, 0, 110, 0,
          0, 0, 0, 0, 112, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 86, 0, 0, 0, 0,
          0, 64, 0, 0, 0, 0, 0, 41, 0, 0, 0, 0, 0, 22, 0, 0, 0, 0, 0, 9, 0,
          0, 0, 0, 0, 2 ], 23 ],
  [ [ 3, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0,
          0, 70, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 119,
          0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 82, 0, 0, 0,
          0, 0, 58, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 6,
          0, 0, 0, 0, 0, 1 ], 24 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 116,
          0, 0, 0, 0, 0, 119, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 93, 0, 0, 0,
          0, 0, 70, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 11,
          0, 0, 0, 0, 0, 3 ], 12 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0,
          0, 58, 0, 0, 0, 0, 0, 82, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 116,
          0, 0, 0, 0, 0, 119, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 93, 0, 0, 0,
          0, 0, 70, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 11,
          0, 0, 0, 0, 0, 3 ], 21 ],
  [ [ 3, 0, 0, 0, 0, 0, 11, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0,
          0, 70, 0, 0, 0, 0, 0, 93, 0, 0, 0, 0, 0, 111, 0, 0, 0, 0, 0, 119,
          0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 103, 0, 0, 0, 0, 0, 82, 0, 0, 0,
          0, 0, 58, 0, 0, 0, 0, 0, 35, 0, 0, 0, 0, 0, 17, 0, 0, 0, 0, 0, 6,
          0, 0, 0, 0, 0, 1 ], 15 ],
  [ [ 3, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0,
          0, 72, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 125,
          0, 0, 0, 0, 0, 124, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 89, 0, 0, 0,
          0, 0, 63, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 7,
          0, 0, 0, 0, 0, 1 ], 16 ],
  [ [ 3, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0,
          0, 72, 0, 0, 0, 0, 0, 96, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 125,
          0, 0, 0, 0, 0, 124, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 89, 0, 0, 0,
          0, 0, 63, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 7,
          0, 0, 0, 0, 0, 1 ], 22 ],
  [ [ 1, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0,
          0, 63, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 124,
          0, 0, 0, 0, 0, 125, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 96, 0, 0, 0,
          0, 0, 72, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 10,
          0, 0, 0, 0, 0, 3 ], 14 ],
  [ [ 1, 0, 0, 0, 0, 0, 7, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0, 0, 39, 0, 0, 0, 0,
          0, 63, 0, 0, 0, 0, 0, 89, 0, 0, 0, 0, 0, 110, 0, 0, 0, 0, 0, 124,
          0, 0, 0, 0, 0, 125, 0, 0, 0, 0, 0, 116, 0, 0, 0, 0, 0, 96, 0, 0, 0,
          0, 0, 72, 0, 0, 0, 0, 0, 46, 0, 0, 0, 0, 0, 25, 0, 0, 0, 0, 0, 10,
          0, 0, 0, 0, 0, 3 ], 20 ],
  [ [ 2, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0,
          0, 84, 0, 0, 0, 0, 0, 118, 0, 0, 0, 0, 0, 146, 0, 0, 0, 0, 0, 164,
          0, 0, 0, 0, 0, 166, 0, 0, 0, 0, 0, 154, 0, 0, 0, 0, 0, 128, 0, 0,
          0, 0, 0, 96, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0,
          14, 0, 0, 0, 0, 0, 4 ], 17 ],
  [ [ 4, 0, 0, 0, 0, 0, 14, 0, 0, 0, 0, 0, 34, 0, 0, 0, 0, 0, 62, 0, 0, 0, 0,
          0, 96, 0, 0, 0, 0, 0, 128, 0, 0, 0, 0, 0, 154, 0, 0, 0, 0, 0, 166,
          0, 0, 0, 0, 0, 164, 0, 0, 0, 0, 0, 146, 0, 0, 0, 0, 0, 118, 0, 0,
          0, 0, 0, 84, 0, 0, 0, 0, 0, 52, 0, 0, 0, 0, 0, 26, 0, 0, 0, 0, 0,
          10, 0, 0, 0, 0, 0, 2 ], 19 ],
  [ [ 3, 0, 0, 0, 0, 0, 12, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0,
          0, 91, 0, 0, 0, 0, 0, 125, 0, 0, 0, 0, 0, 153, 0, 0, 0, 0, 0, 168,
          0, 0, 0, 0, 0, 168, 0, 0, 0, 0, 0, 153, 0, 0, 0, 0, 0, 125, 0, 0,
          0, 0, 0, 91, 0, 0, 0, 0, 0, 58, 0, 0, 0, 0, 0, 30, 0, 0, 0, 0, 0,
          12, 0, 0, 0, 0, 0, 3 ], 18 ],
  [ [ 1, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 20, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0,
          0, 74, 0, 0, 0, 0, 0, 109, 0, 0, 0, 0, 0, 140, 0, 0, 0, 0, 0, 162,
          0, 0, 0, 0, 0, 170, 0, 0, 0, 0, 0, 162, 0, 0, 0, 0, 0, 140, 0, 0,
          0, 0, 0, 109, 0, 0, 0, 0, 0, 74, 0, 0, 0, 0, 0, 43, 0, 0, 0, 0, 0,
          20, 0, 0, 0, 0, 0, 6, 0, 0, 0, 0, 0, 1 ], 15 ] ]);

if not IsBound(CHEVIE.families) then ReadChv("unip/families");fi;

# the group <a^7, b^6, bab^-1a^-3>
# a:=AbstractGenerator("a");b:=AbstractGenerator("b");
# f42:=Group(a,b)/[a^7, b^6, b*a*b^-1*a^-3];
# F42:= OperationCosetsFpGroup(f42,Subgroup(f42,[f42.2]));
CHEVIE.families.F42:=rec(
name:="Q(F42)",TeXName:="Q(F_{42})",
x:=[ (), (), (), (), (), (), (), (2,3,7)(4,5,6), (2,3,7)(4,5,6),
  (2,3,7)(4,5,6), (2,3,7)(4,5,6), (2,3,7)(4,5,6), (2,3,7)(4,5,6),
  (2,4,7,6,3,5), (2,4,7,6,3,5), (2,4,7,6,3,5), (2,4,7,6,3,5), (2,4,7,6,3,5),
  (2,4,7,6,3,5), (2,5,3,6,7,4), (2,5,3,6,7,4), (2,5,3,6,7,4), (2,5,3,6,7,4),
  (2,5,3,6,7,4), (2,5,3,6,7,4), (2,6)(3,4)(5,7), (2,6)(3,4)(5,7),
  (2,6)(3,4)(5,7), (2,6)(3,4)(5,7), (2,6)(3,4)(5,7), (2,6)(3,4)(5,7),
  (2,7,3)(4,6,5), (2,7,3)(4,6,5), (2,7,3)(4,6,5), (2,7,3)(4,6,5),
  (2,7,3)(4,6,5), (2,7,3)(4,6,5), (1,2,3,5,7,4,6), (1,2,3,5,7,4,6),
  (1,2,3,5,7,4,6), (1,2,3,5,7,4,6), (1,2,3,5,7,4,6), (1,2,3,5,7,4,6),
  (1,2,3,5,7,4,6) ],
y:=[ (), (2,3,7)(4,5,6), (2,4,7,6,3,5), (2,5,3,6,7,4), (2,6)(3,4)(5,7),
  (2,7,3)(4,6,5), (1,2,3,5,7,4,6), (), (2,3,7)(4,5,6), (2,4,7,6,3,5),
  (2,5,3,6,7,4), (2,6)(3,4)(5,7), (2,7,3)(4,6,5), (), (2,3,7)(4,5,6),
  (2,4,7,6,3,5), (2,5,3,6,7,4), (2,6)(3,4)(5,7), (2,7,3)(4,6,5), (),
  (2,3,7)(4,5,6), (2,4,7,6,3,5), (2,5,3,6,7,4), (2,6)(3,4)(5,7),
  (2,7,3)(4,6,5), (), (2,3,7)(4,5,6), (2,4,7,6,3,5), (2,5,3,6,7,4),
  (2,6)(3,4)(5,7), (2,7,3)(4,6,5), (), (2,3,7)(4,5,6), (2,4,7,6,3,5),
  (2,5,3,6,7,4), (2,6)(3,4)(5,7), (2,7,3)(4,6,5), (), (1,2,3,5,7,4,6),
  (1,3,7,6,2,5,4), (1,4,5,2,6,7,3), (1,5,6,3,4,2,7), (1,6,4,7,5,3,2),
  (1,7,2,4,3,6,5) ],
yLabels:=["1a","3a","6a", "6b", "2a", "3b", "7a", "1a", "3a", "6a", "6b", "2a",
  "3b", "1a", "3a", "6a", "6b", "2a", "3b", "1a", "3a", "6a", "6b", "2a",
  "3b", "1a", "3a", "6a", "6b", "2a", "3b", "1a", "3a", "6a", "6b", "2a",
  "3b", "1a", "7a", "7b", "7c", "7d", "7e", "7f" ],
chi:=[[1,1,1,1,1,1,1],[1,1,-1,-1,-1,1,1],[1,E(3)^2,-E(3)^2,-E(3),-1,E(3),1],
 [1,E(3),-E(3),-E(3)^2,-1,E(3)^2,1],[1,E(3)^2,E(3)^2,E(3),1,E(3),1],
 [1,E(3),E(3),E(3)^2,1,E(3)^2,1],[6,0,0,0,0,0,-1],
 [1,1,1,1,1,1],[1,1,-1,-1,-1,1],[1,E(3),E(3),E(3)^2,1,E(3)^2],
 [1,E(3),-E(3),-E(3)^2,-1,E(3)^2],[1,E(3)^2,E(3)^2,E(3),1,E(3)],
 [1,E(3)^2,-E(3)^2,-E(3),-1,E(3)],
 [1,1,1,1,1,1],[1,1,-1,-1,-1,1],[1,E(3),E(3),E(3)^2,1,E(3)^2],
 [1,E(3),-E(3),-E(3)^2,-1,E(3)^2],[1,E(3)^2,E(3)^2,E(3),1,E(3)],
 [1,E(3)^2,-E(3)^2,-E(3),-1,E(3)],
 [1,1,1,1,1,1],[1,1,-1,-1,-1,1],[1,E(3),E(3),E(3)^2,1,E(3)^2],
 [1,E(3),-E(3),-E(3)^2,-1,E(3)^2],[1,E(3)^2,E(3)^2,E(3),1,E(3)],
 [1,E(3)^2,-E(3)^2,-E(3),-1,E(3)],
 [1,1,1,1,1,1],[1,1,-1,-1,-1,1],[1,E(3),E(3),E(3)^2,1,E(3)^2],
 [1,E(3),-E(3),-E(3)^2,-1,E(3)^2],[1,E(3)^2,E(3)^2,E(3),1,E(3)],
 [1,E(3)^2,-E(3)^2,-E(3),-1,E(3)],
 [1,1,1,1,1,1],[1,1,-1,-1,-1,1],[1,E(3),E(3),E(3)^2,1,E(3)^2],
 [1,E(3),-E(3),-E(3)^2,-1,E(3)^2],[1,E(3)^2,E(3)^2,E(3),1,E(3)],
 [1,E(3)^2,-E(3)^2,-E(3),-1,E(3)],
 [1,1,1,1,1,1,1],
 [1,E(7),E(7)^2,E(7)^5,E(7)^3,E(7)^6,E(7)^4],
 [1,E(7)^2,E(7)^4,E(7)^3,E(7)^6,E(7)^5,E(7)],
 [1,E(7)^3,E(7)^6,E(7),E(7)^2,E(7)^4,E(7)^5],
 [1,E(7)^4,E(7),E(7)^6,E(7)^5,E(7)^3,E(7)^2],
 [1,E(7)^5,E(7)^3,E(7)^4,E(7),E(7)^2,E(7)^6],
 [1,E(7)^6,E(7)^5,E(7)^2,E(7)^4,E(7),E(7)^3]],
charLabels:=["(1,1)","(1,-1)","(1,-E3^2)",
             "(1,-E3)","(1,E3^2)","(1,E3)","(1,r)",
 "(g6^4,1)","(g6^4,-1)","(g6^4,E3)","(g6^4,-E3)","(g6^4,E3^2)","(g6^4,-E3^2)",
 "(g6,1)","(g6,-1)","(g6,E3)","(g6,-E3)","(g6,E3^2)","(g6,-E3^2)",
 "(g6^3,1)","(g6^3,-1)","(g6^3,E3)","(g6^3,-E3)","(g6^3,E3^2)","(g6^3,-E3^2)",
 "(g6^2,1)","(g6^2,-1)","(g6^2,E3)","(g6^2,-E3)","(g6^2,E3^2)","(g6^2,-E3^2)",
 "(g6^5,1)","(g6^5,-1)","(g6^5,E3)","(g6^5,-E3)","(g6^5,E3^2)","(g6^5,-E3^2)",
 "(g7,1)","(g7,E7)","(g7,E7^2)","(g7,E7^3)","(g7,E7^4)","(g7,E7^5)",
 "(g7,E7^6)"],
TeXCharLabels:=["(1,1)","(1,-1)","(1,-\\zeta_3^2)","(1,-\\zeta_3)",
"(1,\\zeta_3^2)","(1,\\zeta_3)","(1,r)","(g_6^4,1)","(g_6^4,-1)",
"(g_6^4,\\zeta_3)","(g_6^4,-\\zeta_3)","(g_6^4,\\zeta_3^2)",
"(g_6^4,-\\zeta_3^2)","(g_6,1)","(g_6,-1)","(g_6,\\zeta_3)","(g_6,-\\zeta_3)",
"(g_6,\\zeta_3^2)","(g_6,-\\zeta_3^2)","(g_6^3,1)","(g_6^3,-1)",
"(g_6^3,\\zeta_3)","(g_6^3,-\\zeta_3)","(g_6^3,\\zeta_3^2)",
"(g_6^3,-\\zeta_3^2)","(g_6^2,1)","(g_6^2,-1)","(g_6^2,\\zeta_3)",
"(g_6^2,-\\zeta_3)","(g_6^2,\\zeta_3^2)","(g_6^2,-\\zeta_3^2)","(g_6^5,1)",
"(g_6^5,-1)","(g_6^5,\\zeta_3)","(g_6^5,-\\zeta_3)","(g_6^5,\\zeta_3^2)",
"(g_6^5,-\\zeta_3^2)","(g_7,1)","(g_7,\\zeta_7)","(g_7,\\zeta_7^2)",
"(g_7,\\zeta_7^3)","(g_7,\\zeta_7^4)","(g_7,\\zeta_7^5)","(g_7,\\zeta_7^6)"],
eigenvalues:=[ 1, 1, 1, 1, 1, 1, 1, 1, 1, E(3), E(3), E(3)^2, E(3)^2, 1, -1,
  E(3), -E(3), E(3)^2, -E(3)^2, 1, -1, E(3)^2, -E(3)^2, E(3), -E(3), 1, -1,
  1, -1, 1, -1, 1, 1, E(3)^2, E(3)^2, E(3), E(3), 1, E(7), E(7)^2, E(7)^3,
  E(7)^4, E(7)^5, E(7)^6 ],
Mellin:=
[[1/42,1/6,1/6,1/6,1/6,1/6,1/7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0],[1/42,1/6,-1/6,-1/6,-1/6,1/6,1/7,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[1/42,E(3)/6,
-E(3)/6,-E(3)^2/6,-1/6,E(3)^2/6,1/7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[1/42,E(3)^2/6,-E(3)^2/6,-E(3)/6,-1/6,E(3)/6,
1/7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0],[1/42,E(3)/6,E(3)/6,E(3)^2/6,1/6,E(3)^2/6,1/7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[1/42,E(3)^2/6,E(3)^2/6,E(3)/6,
1/6,E(3)/6,1/7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0],[1/7,0,0,0,0,0,-1/7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,1/6,1/6,1/6,1/6,1/6,1/6,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,1/6,1/6,
-1/6,-1/6,-1/6,1/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0],[0,0,0,0,0,0,0,1/6,E(3)^2/6,E(3)^2/6,E(3)/6,1/6,E(3)/6,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,1/6,E(3)^2/6,
-E(3)^2/6,-E(3)/6,-1/6,E(3)/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0],[0,0,0,0,0,0,0,1/6,E(3)/6,E(3)/6,E(3)^2/6,1/6,E(3)^2/6,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,1/6,
E(3)/6,-E(3)/6,-E(3)^2/6,-1/6,E(3)^2/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,1/6,1/6,1/6,1/6,1/6,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,
1/6,1/6,-1/6,-1/6,-1/6,1/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)^2/6,E(3)^2/6,E(3)/6,1/6,E(3)/6,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,
E(3)^2/6,-E(3)^2/6,-E(3)/6,-1/6,E(3)/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)/6,E(3)/6,E(3)^2/6,1/6,
E(3)^2/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,
0,0,0,0,0,1/6,E(3)/6,-E(3)/6,-E(3)^2/6,-1/6,E(3)^2/6,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,1/6,1/6,
1/6,1/6,1/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,1/6,1/6,-1/6,-1/6,-1/6,1/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)^2/6,E(3)^2/6,E(3)/6,1/6,
E(3)/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,1/6,E(3)^2/6,-E(3)^2/6,-E(3)/6,-1/6,E(3)/6,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)/6,E(3)/6,
E(3)^2/6,1/6,E(3)^2/6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)/6,-E(3)/6,-E(3)^2/6,-1/6,E(3)^2/6,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
1/6,1/6,1/6,1/6,1/6,1/6,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,1/6,1/6,-1/6,-1/6,-1/6,1/6,0,0,0,0,0,0,0,0,0,0,0,0,0],
[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)^2/6,E(3)^2/6,
E(3)/6,1/6,E(3)/6,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,1/6,E(3)^2/6,-E(3)^2/6,-E(3)/6,-1/6,E(3)/6,0,0,0,0,0,0,0,0,
0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)/6,
E(3)/6,E(3)^2/6,1/6,E(3)^2/6,0,0,0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)/6,-E(3)/6,-E(3)^2/6,-1/6,E(3)^2/6,0,0,
0,0,0,0,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,1/6,1/6,1/6,1/6,1/6,1/6,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,1/6,-1/6,-1/6,-1/6,1/6,0,0,0,0,0,0,0],[0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)^2/6,
E(3)^2/6,E(3)/6,1/6,E(3)/6,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)^2/6,-E(3)^2/6,-E(3)/6,-1/6,E(3)/6,0,0,0,
0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,
E(3)/6,E(3)/6,E(3)^2/6,1/6,E(3)^2/6,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/6,E(3)/6,-E(3)/6,-E(3)^2/6,-1/6,
E(3)^2/6,0,0,0,0,0,0,0],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,1/7,1/7,1/7,1/7,1/7,1/7,1/7],[0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/7,E(7)^6/7,E(7)^5/7,
E(7)^2/7,E(7)^4/7,E(7)/7,E(7)^3/7],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/7,E(7)^5/7,E(7)^3/7,E(7)^4/7,E(7)/7,
E(7)^2/7,E(7)^6/7],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,1/7,E(7)^4/7,E(7)/7,E(7)^6/7,E(7)^5/7,E(7)^3/7,E(7)^2/7],[0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/7,
E(7)^3/7,E(7)^6/7,E(7)/7,E(7)^2/7,E(7)^4/7,E(7)^5/7],[0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/7,E(7)^2/7,E(7)^4/7,
E(7)^3/7,E(7)^6/7,E(7)^5/7,E(7)/7],[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1/7,E(7)/7,E(7)^2/7,E(7)^5/7,E(7)^3/7,
E(7)^6/7,E(7)^4/7]],
group:=Group( (1,2,3,5,7,4,6), (2,4,7,6,3,5) ),
fourierMat:=
[ [ 1/42, 1/42, 1/42, 1/42, 1/42, 1/42, 1/7, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6,
      1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6,
      1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/7, 1/7, 1/7, 1/7,
      1/7, 1/7, 1/7 ],
  [ 1/42, 1/42, 1/42, 1/42, 1/42, 1/42, 1/7, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6,
      -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, -1/6,
      -1/6, -1/6, -1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/7,
      1/7, 1/7, 1/7, 1/7, 1/7, 1/7 ],
  [ 1/42, 1/42, 1/42, 1/42, 1/42, 1/42, 1/7, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2,
      -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2,
      -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6,
      -1/6, -1/6, -1/6, -1/6, -1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3),
      1/6*E(3), 1/6*E(3), 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, 1/7 ],
  [ 1/42, 1/42, 1/42, 1/42, 1/42, 1/42, 1/7, 1/6*E(3), 1/6*E(3), 1/6*E(3),
      1/6*E(3), 1/6*E(3), 1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3),
      -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2,
      -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2, -1/6, -1/6, -1/6, -1/6, -1/6,
      -1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3)^2, 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, 1/7 ],
  [ 1/42, 1/42, 1/42, 1/42, 1/42, 1/42, 1/7, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3),
      1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6, 1/6, 1/6, 1/6,
      1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/7, 1/7,
      1/7, 1/7, 1/7, 1/7, 1/7 ],
  [ 1/42, 1/42, 1/42, 1/42, 1/42, 1/42, 1/7, 1/6*E(3), 1/6*E(3), 1/6*E(3),
      1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3),
      1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/7, 1/7,
      1/7, 1/7, 1/7, 1/7, 1/7 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, 6/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7, -1/7, -1/7,
      -1/7, -1/7, -1/7, -1/7 ],
  [ 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6, 1/6,
      1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3),
      1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3),
      1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2,
      1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 0, 0,
      0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6, 1/6,
      1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, -1/6, -1/6, -1/6*E(3),
      -1/6*E(3), -1/6*E(3)^2, -1/6*E(3)^2, -1/6, -1/6, -1/6*E(3), -1/6*E(3),
      -1/6*E(3)^2, -1/6*E(3)^2, -1/6, -1/6, -1/6*E(3), -1/6*E(3),
      -1/6*E(3)^2, -1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2,
      1/6*E(3)^2, 0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3),
      1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3),
      1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6,
      1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3), 0, 0,
      0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3),
      1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, -1/6*E(3), -1/6*E(3),
      -1/6*E(3)^2, -1/6*E(3)^2, -1/6, -1/6, -1/6*E(3)^2, -1/6*E(3)^2, -1/6,
      -1/6, -1/6*E(3), -1/6*E(3), -1/6, -1/6, -1/6*E(3), -1/6*E(3),
      -1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 1/6*E(3),
      1/6*E(3), 0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6,
      1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2,
      1/6, 1/6, 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 0, 0, 0, 0, 0, 0,
      0 ],
  [ 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6, 1/6, 1/6*E(3), 1/6*E(3), -1/6*E(3)^2, -1/6*E(3)^2,
      -1/6, -1/6, -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3), -1/6*E(3)^2,
      -1/6*E(3)^2, -1/6, -1/6, -1/6, -1/6, -1/6*E(3), -1/6*E(3), -1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6, 1/6, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6, -1/6,
      1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3),
      -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3),
      1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2,
      0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6, -1/6,
      1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, -1/6, 1/6, -1/6*E(3),
      1/6*E(3), -1/6*E(3)^2, 1/6*E(3)^2, -1/6, 1/6, -1/6*E(3), 1/6*E(3),
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6, 1/6, -1/6*E(3), 1/6*E(3), -1/6*E(3)^2,
      1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3),
      -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3),
      1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6,
      1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3),
      0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3),
      -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, -1/6*E(3), 1/6*E(3),
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6, 1/6, -1/6*E(3)^2, 1/6*E(3)^2, -1/6, 1/6,
      -1/6*E(3), 1/6*E(3), -1/6, 1/6, -1/6*E(3), 1/6*E(3), -1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3), 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2,
      1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6, -1/6, 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6,
      0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 0, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3), -1/6*E(3), -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6, 1/6, -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3)^2,
      1/6*E(3)^2, -1/6, 1/6, -1/6, 1/6, -1/6*E(3), 1/6*E(3), -1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3), -1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6, -1/6,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2,
      1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3),
      -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3), -1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6, -1/6,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), -1/6, 1/6, -1/6*E(3)^2,
      1/6*E(3)^2, -1/6*E(3), 1/6*E(3), -1/6, 1/6, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3), 1/6*E(3), -1/6, 1/6, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3),
      1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3), -1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3),
      -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3),
      1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3),
      -1/6*E(3), 1/6, -1/6, 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3),
      -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6, -1/6, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3), -1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3),
      -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3), 1/6*E(3),
      -1/6, 1/6, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3),
      1/6*E(3), -1/6, 1/6, -1/6, 1/6, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3),
      1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6, -1/6, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3), -1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2,
      1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3), -1/6*E(3), 1/6, -1/6,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3),
      -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6*E(3), -1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3), -1/6*E(3), 1/6, -1/6, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3), 1/6*E(3), -1/6, 1/6, -1/6*E(3), 1/6*E(3), -1/6, 1/6,
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6, 1/6, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3),
      1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6*E(3)^2, -1/6*E(3)^2, 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 0, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6,
      -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6,
      1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 0, 0, 0, 0, 0,
      0, 0 ],
  [ 1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 0, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6,
      -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6,
      1/6, -1/6, 1/6, -1/6, 1/6, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6, 0, 0, 0, 0,
      0, 0, 0 ],
  [ 1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 0, 1/6*E(3), -1/6*E(3), 1/6*E(3),
      -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3),
      -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6, -1/6, 1/6, -1/6, 1/6, -1/6,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3)^2, 0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 0, 1/6*E(3), -1/6*E(3), 1/6*E(3),
      -1/6*E(3), 1/6*E(3), -1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3),
      1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6, 1/6, -1/6, 1/6, -1/6, 1/6,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3)^2, 0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 0, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2,
      1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3), -1/6*E(3),
      1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6, -1/6, 1/6, -1/6, 1/6,
      -1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, -1/6, -1/6, -1/6, 1/6, 1/6, 0, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2,
      -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3), 1/6*E(3),
      -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6, 1/6, -1/6, 1/6, -1/6,
      1/6, 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 1/6*E(3), -1/6*E(3), 0,
      0, 0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6, 1/6,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3),
      1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 0, 0,
      0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6, 1/6,
      1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3), -1/6, -1/6, -1/6*E(3)^2,
      -1/6*E(3)^2, -1/6*E(3), -1/6*E(3), -1/6, -1/6, -1/6*E(3)^2,
      -1/6*E(3)^2, -1/6*E(3), -1/6*E(3), -1/6, -1/6, -1/6*E(3)^2,
      -1/6*E(3)^2, -1/6*E(3), -1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3), 1/6*E(3), 0, 0, 0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3),
      1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6,
      1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3),
      1/6*E(3), 1/6, 1/6, 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3),
      1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6, 1/6, 0, 0,
      0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3),
      1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, -1/6*E(3), -1/6*E(3), -1/6,
      -1/6, -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3),
      -1/6*E(3), -1/6, -1/6, -1/6, -1/6, -1/6*E(3)^2, -1/6*E(3)^2, -1/6*E(3),
      -1/6*E(3), 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6, 1/6, 0, 0,
      0, 0, 0, 0, 0 ],
  [ 1/6, 1/6, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2,
      1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 1/6*E(3), 1/6*E(3),
      1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2, 1/6*E(3)^2, 0, 0, 0, 0, 0, 0,
      0 ],
  [ 1/6, 1/6, 1/6*E(3), 1/6*E(3)^2, 1/6*E(3), 1/6*E(3)^2, 0, 1/6*E(3)^2,
      1/6*E(3)^2, 1/6*E(3), 1/6*E(3), 1/6, 1/6, -1/6*E(3)^2, -1/6*E(3)^2,
      -1/6*E(3), -1/6*E(3), -1/6, -1/6, -1/6*E(3), -1/6*E(3), -1/6, -1/6,
      -1/6*E(3)^2, -1/6*E(3)^2, -1/6, -1/6, -1/6*E(3)^2, -1/6*E(3)^2,
      -1/6*E(3), -1/6*E(3), 1/6*E(3), 1/6*E(3), 1/6, 1/6, 1/6*E(3)^2,
      1/6*E(3)^2, 0, 0, 0, 0, 0, 0, 0 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 6/7, -1/7, -1/7,
      -1/7, -1/7, -1/7, -1/7 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7,
      2/7*E(7)+1/7*E(7)^2+1/7*E(7)^5+2/7*E(7)^6,
      1/7*E(7)+2/7*E(7)^3+2/7*E(7)^4+1/7*E(7)^6,
      -2/7*E(7)-2/7*E(7)^2-2/7*E(7)^5-2/7*E(7)^6,
      2/7*E(7)^2+1/7*E(7)^3+1/7*E(7)^4+2/7*E(7)^5,
      -2/7*E(7)^2-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^5,
      -2/7*E(7)-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^6 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7,
      1/7*E(7)+2/7*E(7)^3+2/7*E(7)^4+1/7*E(7)^6,
      2/7*E(7)^2+1/7*E(7)^3+1/7*E(7)^4+2/7*E(7)^5,
      -2/7*E(7)-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^6,
      2/7*E(7)+1/7*E(7)^2+1/7*E(7)^5+2/7*E(7)^6,
      -2/7*E(7)-2/7*E(7)^2-2/7*E(7)^5-2/7*E(7)^6,
      -2/7*E(7)^2-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^5 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7,
      -2/7*E(7)-2/7*E(7)^2-2/7*E(7)^5-2/7*E(7)^6,
      -2/7*E(7)-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^6,
      1/7*E(7)+2/7*E(7)^3+2/7*E(7)^4+1/7*E(7)^6,
      -2/7*E(7)^2-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^5,
      2/7*E(7)+1/7*E(7)^2+1/7*E(7)^5+2/7*E(7)^6,
      2/7*E(7)^2+1/7*E(7)^3+1/7*E(7)^4+2/7*E(7)^5 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7,
      2/7*E(7)^2+1/7*E(7)^3+1/7*E(7)^4+2/7*E(7)^5,
      2/7*E(7)+1/7*E(7)^2+1/7*E(7)^5+2/7*E(7)^6,
      -2/7*E(7)^2-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^5,
      1/7*E(7)+2/7*E(7)^3+2/7*E(7)^4+1/7*E(7)^6,
      -2/7*E(7)-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^6,
      -2/7*E(7)-2/7*E(7)^2-2/7*E(7)^5-2/7*E(7)^6 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7,
      -2/7*E(7)^2-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^5,
      -2/7*E(7)-2/7*E(7)^2-2/7*E(7)^5-2/7*E(7)^6,
      2/7*E(7)+1/7*E(7)^2+1/7*E(7)^5+2/7*E(7)^6,
      -2/7*E(7)-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^6,
      2/7*E(7)^2+1/7*E(7)^3+1/7*E(7)^4+2/7*E(7)^5,
      1/7*E(7)+2/7*E(7)^3+2/7*E(7)^4+1/7*E(7)^6 ],
  [ 1/7, 1/7, 1/7, 1/7, 1/7, 1/7, -1/7, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1/7,
      -2/7*E(7)-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^6,
      -2/7*E(7)^2-2/7*E(7)^3-2/7*E(7)^4-2/7*E(7)^5,
      2/7*E(7)^2+1/7*E(7)^3+1/7*E(7)^4+2/7*E(7)^5,
      -2/7*E(7)-2/7*E(7)^2-2/7*E(7)^5-2/7*E(7)^6,
      1/7*E(7)+2/7*E(7)^3+2/7*E(7)^4+1/7*E(7)^6,
      2/7*E(7)+1/7*E(7)^2+1/7*E(7)^5+2/7*E(7)^6 ] ],
special:=1);

CHEVIE.AddData("UnipotentCharacters","G34",
function()
  local J,r;J:=E(3);r:=ER(-3);
  return rec(
    harishChandra:=[
    rec(relativeType:=rec(series:="ST",indices:=[1..6],rank:=6,ST:=34),
        levi:=[],parameterExponents:=[1,1,1,1,1,1],
         charNumbers:=[1..169],
	eigenvalue:=1, cuspidalName:="",
        TeXCuspidalName:=""),
    rec(relativeType:=rec(series:="ST",indices:=[6,5,1],rank:=3,ST:=26),
        levi:=[2..4],
        parameterExponents:=[1,3],
        charNumbers:=[170,171,340,341,325,324,342,326,220,185,219,186,216,274,
          249,226,184,173,334,332,251,225,183,174,335,333,232,253,299,310,
          189,208,231,255,298,309,190,209,197,198,280,
          281,282,279,245,224,247,223],  ## (197,198) allowed !!
        ## charNumbers changed 26.2.2003 by Gunter
	eigenvalue:=J, cuspidalName:="G3,3,3[E3]",
        TeXCuspidalName:="G_{3,3,3}[\\zeta_{3}]"),
    rec(relativeType:=rec(series:="ST",indices:=[6,5,1],rank:=3,ST:=26),
        levi:=[2..4],
        parameterExponents:=[1,[0,3,3]],
       charNumbers:=[347,348,192,191,175,176,193,177,330,301,331,300,244,302,
          278,252,338,337,187,181,277,250,339,336,188,182,256,284,207,218,
          311,322,254,283,206,217,312,323,314,315,229,
          228,227,230,276,248,275,246],  ## (314,315) allowed !!
        ## charNumbers changed 26.2.2003 by Gunter
	eigenvalue:=J^2, cuspidalName:="G3,3,3[E3^2]",
        TeXCuspidalName:="G_{3,3,3}[\\zeta_{3}^2]"),
    rec(relativeType:=rec(series:="ST",indices:=[4,6],rank:=2,p:=6,q:=1),
        levi:=[1,2,3,348],
        parameterExponents:=[[5,4,1,0,1,4],4],
        charNumbers:=[235,194,236,273,237,195,286,259,289,257,205,343,328,313,
	  258,346,327,288,344,260,285,172,179,233,287,234,178],
	eigenvalue:=-1, cuspidalName:="D4",
        TeXCuspidalName:="D_4"),
    rec(relativeType:=rec(series:="ST",indices:=[6],rank:=1,p:=6,q:=1),
        levi:=[1..5],
        parameterExponents:=[[0,5,0,7,2,7]],
        charNumbers:=[316,221,317,199,296,200],
	eigenvalue:=E(4), cuspidalName:="G33[I]",
        TeXCuspidalName:="G_{33}[i]"),
    rec(relativeType:=rec(series:="ST",indices:=[6],rank:=1,p:=6,q:=1),
        levi:=[1..5],
        parameterExponents:=[[0,5,0,7,2,7]],
        charNumbers:=[318,222,319,201,297,202],
	eigenvalue:=-E(4), cuspidalName:="G33[-I]",
        TeXCuspidalName:="G_{33}[-i]"),
    rec(relativeType:=rec(series:="ST",indices:=[6],rank:=1,p:=6,q:=1),
        levi:=[1..5],
        parameterExponents:=[[0,7,8,3,8,7]],
        charNumbers:=[345,263,239,329,238,261],
	eigenvalue:=-J, cuspidalName:="G33[-E3]",
        TeXCuspidalName:="G_{33}[-\\zeta_3]"),
    rec(relativeType:=rec(series:="ST",indices:=[6],rank:=1,p:=6,q:=1),
        levi:=[1..5],
        parameterExponents:=[[8,1,0,5,0,1]],
        charNumbers:=[180,262,291,196,290,264],
	eigenvalue:=-J^2, cuspidalName:="G33[-E3^2]",
        TeXCuspidalName:="G_{33}[-\\zeta_3^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[265], eigenvalue:=1, cuspidalName:="G34[1]",
        TeXCuspidalName:="G_{34}[1]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[266], eigenvalue:=-1, cuspidalName:="G34[-1]",
        TeXCuspidalName:="G_{34}[-1]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[294], eigenvalue:=J, cuspidalName:="G34[J]",
        TeXCuspidalName:="G_{34}[\\zeta_{3}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[295], eigenvalue:=J, cuspidalName:="G34^2[J]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{3}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[242], eigenvalue:=J^2, cuspidalName:="G34[J^2]",
        TeXCuspidalName:="G_{34}[\\zeta_{3}^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[243], eigenvalue:=J^2, cuspidalName:="G34^2[J^2]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{3}^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[292], eigenvalue:=-J, cuspidalName:="G34[-J]",
        TeXCuspidalName:="G_{34}[-\\zeta_{3}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[293], eigenvalue:=-J, cuspidalName:="G34^2[-J]",
        TeXCuspidalName:="G_{34}^2[-\\zeta_{3}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[240], eigenvalue:=-J^2, cuspidalName:="G34[-J^2]",
        TeXCuspidalName:="G_{34}[-\\zeta_{3}^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[241], eigenvalue:=-J^2, cuspidalName:="G34^2[-J^2]",
        TeXCuspidalName:="G_{34}^2[-\\zeta_{3}^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[267], eigenvalue:=E(7), cuspidalName:="G34[E7]",
        TeXCuspidalName:="G_{34}[\\zeta_{7}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[268], eigenvalue:=E(7)^2, cuspidalName:="G34[E7^2]",
        TeXCuspidalName:="G_{34}[\\zeta_{7}^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[269], eigenvalue:=E(7)^3, cuspidalName:="G34[E7^3]",
        TeXCuspidalName:="G_{34}[\\zeta_{7}^3]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[270], eigenvalue:=E(7)^4, cuspidalName:="G34[E7^4]",
        TeXCuspidalName:="G_{34}[\\zeta_{7}^4]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[271], eigenvalue:=E(7)^5, cuspidalName:="G34[E7^5]",
        TeXCuspidalName:="G_{34}[\\zeta_{7}^5]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[272], eigenvalue:=E(7)^6, cuspidalName:="G34[E7^6]",
        TeXCuspidalName:="G_{34}[\\zeta_{7}^6]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[212], eigenvalue:=E(9), cuspidalName:="G34[E9]",
        TeXCuspidalName:="G_{34}[\\zeta_{9}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[214], eigenvalue:=E(9), cuspidalName:="G34^2[E9]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{9}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[307], eigenvalue:=E(9)^2, cuspidalName:="G34[E9^2]",
        TeXCuspidalName:="G_{34}[\\zeta_{9}^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[303], eigenvalue:=E(9)^2, cuspidalName:="G34^2[E9^2]",
        TeXCuspidalName:="G_{34}^2[\\zeta_9^2]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[210], eigenvalue:=E(9)^4, cuspidalName:="G34[E9^4]",
        TeXCuspidalName:="G_{34}[\\zeta_9^4]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[215], eigenvalue:=E(9)^4, cuspidalName:="G34^2[E9^4]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{9}^4]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[304], eigenvalue:=E(9)^5, cuspidalName:="G34[E9^5]",
        TeXCuspidalName:="G_{34}[\\zeta_9^5]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[305], eigenvalue:=E(9)^5, cuspidalName:="G34^2[E9^5]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{9}^5]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[211], eigenvalue:=E(9)^7, cuspidalName:="G34[E9^7]",
        TeXCuspidalName:="G_{34}[\\zeta_9^7]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[213], eigenvalue:=E(9)^7, cuspidalName:="G34^2[E9^7]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{9}^7]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[306], eigenvalue:=E(9)^8, cuspidalName:="G34[E9^8]",
        TeXCuspidalName:="G_{34}^6[\\zeta_{9}^8]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[308], eigenvalue:=E(9)^8, cuspidalName:="G34^2[E9^8]",
        TeXCuspidalName:="G_{34}^2[\\zeta_{9}^8]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[203], eigenvalue:=E(12)^7, cuspidalName:="G34[E12^7]",
        TeXCuspidalName:="G_{34}[\\zeta_{12}^7]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[320], eigenvalue:=E(12)^11, cuspidalName:="G34[E12^11]",
        TeXCuspidalName:="G_{34}^7[\\zeta_{12}^{11}]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[204], eigenvalue:=-E(12)^7, cuspidalName:="G34[-E12^7]",
        TeXCuspidalName:="G_{34}[-\\zeta_{12}^7]"),
    rec(relativeType:=rec(series:="A",indices:=[],rank:=0),
levi:=[1..6], parameterExponents:=[],
        charNumbers:=[321], eigenvalue:=-E(12)^11, cuspidalName:="G34[-E12^11]",
        TeXCuspidalName:="G_{34}[-\\zeta_{12}^{11}]")],
 families:=[
   Family("C1",[1]),
   Family(ConjugateFamily(CHEVIE.families.X(3)),[5,3,170]),   #I3^3
   Family(ConjugateFamily(CHEVIE.families.X(3)),[17,15,171]),   #I3^3
   Family("C2",[24,14,20,172]),  #D4
   Family(CartesianFamilies(CHEVIE.families.X(3),ConjugateFamily("X5")),
     [42,55,178,174,8,10,53,179,173,46,176,177,180,37,175],
     rec(delta1:=[1,1,-1,1,1,1,1,-1,1,1,1,1,-1,1,1])),  #G_33
   Family(CHEVIE.families.QZ(3),[26,59,57,31,183,181,32,182,184],
     rec(delta1:=[1,1,1,-1,1,-1,-1,1,-1],special:=3,cospecial:=2)),  #I4^3
   Family(CHEVIE.families.QZ(3),[81,68,71,45,185,188,39,187,186],
                         rec(delta1:=[1,1,1,1,-1,-1,1,1,1])), #I5^3
   Family(CartesianFamilies(CHEVIE.families.X(3),ConjugateFamily("X5")),
     [109,89,194,190,35,33,91,195,189,107,192,193,196,116,191],
     rec(delta1:=[1,1,1,1,-1,-1,1,1,1,1,1,1,-1,1,1])),
   # C2 changed to C2d Gunter 22/9/99, then to C2h on 26.2.2003:
   Family(CartesianFamilies(ConjugateFamily(CHEVIE.families.X(3)),"C2d"),
     [ 103, 96, 199, 201, 101, 98, 200, 202, 198, 197, 203, 204 ],
     rec(delta1:=[ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, -1, -1 ])),
   Family("C1",[28]),
   Family("C2",[124,63,105,205]),  #D4
   Family(CHEVIE.families.QZ(3),[22,86,84,79,208,206,78,207,209],
     rec(delta1:=[1,1,1,-1,1,-1,-1,1,-1],special:=3,cospecial:=2)),  #I4^3
   Family(ConjugateFamily("Z9"),[141,215,213,145,214,212,143,211,210],
     rec(special:=7,cospecial:=1)),
   Family(ConjugateFamily(CHEVIE.families.X(3)),[134,136,216]),  #I3^3
   Family(CHEVIE.families.QZ(3),[129,156,154,72,219,217,74,218,220],
     rec(delta1:=[1,1,1,-1,-1,-1,-1,1,1],special:=3,cospecial:=2)),
   Family("C1",[67]),
   # C2 changed to C2d Gunter 22/9/99, then to C2h on 26.2.2003:
   Family("C2d",[159, 161,221,222]),  #G_33
   Family(CHEVIE.families.QZ(6),[65,94,148,118,146,92,49,241,225,234,227,238,
     162,232,243,152,224,229,83,237,113,235,111,236,164,230,223,150,242,231,47,
     239,228,233,226,240],
     rec(delta1:=[1,-1,-1,1,-1,-1,1,1,1,1,-1,1,1,-1,1,1,-1,-1,-1,-1,
     -1,-1,-1,-1,1,1,1,1,-1,1,1,-1,1,1,-1,-1],special:=16,cospecial:=28)),
   Family(CHEVIE.families.X(3),[132,130,244]),  #\bar I3^3
   Family("F42",[169,265,122,121,12,11,52,166,119,249,245,252,248,139,
    257,253,261,256,264,138,258,254,262,255,263,168,266,127,259,126,260,167,
    120,250,246,251,247,51,267,268,269,270,271,272],
    rec(delta1:=[1,-1,-1,-1,1,1,1,1,1,-1,-1,-1,-1, 1, 1, 1, 1, 1, 1, 1, 1,
    -1,-1,-1,-1,1,-1,1,-1,1,-1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 ])),
   Family("C2",[125,61,106,273]),  #D4
   Family(ConjugateFamily(CHEVIE.families.X(3)),[133,131,274]),  #I3^3
   Family(CHEVIE.families.QZ(6),[117,149,93,64,95,147,50,290,279,286,277,293,151,295,
    284,163,281,276,82,288,112,287,114,289,153,275,282,165,283,294,48,292,278,
    285,280,291],
    rec(delta1:=[1,-1,-1,1,-1,-1,-1,-1,1,-1,-1,-1,1,1, -1, 1, -1, -1, 1, 1,
    1,1,1,1,1,1,1,1,1,-1,-1,1,1,-1,-1,1],special:=13,cospecial:=25)),
   # C2 changed to C2d Gunter 22/9/99, the to C2h on 26.2.2003:
   Family("C2d",[160, 158,296,297]),  #G_33
   Family("C1",[66]),
   Family(CHEVIE.families.QZ(3),[128,73,75,157,298,301,155,300,299],
     rec(delta1:=[1,-1,-1,1,-1,1,1,-1,1],special:=4,cospecial:=7)),
   Family(CHEVIE.families.X(3),[137,135,302]),
# order changed by JM 22/10/99 from [144,142,140,303,307,305,304,306,308]
   Family("Z9",[140,304,303,144,308,306,142,307,305],rec(special:=1,cospecial:=4)),
   Family(CHEVIE.families.QZ(3),[21,77,76,85,309,312,87,311,310],
     rec(delta1:=[1,-1,-1,1,-1,-1,1,1,1],special:=4,cospecial:=7)), #\bar I4^3
   Family("C2",[123,62,104,313]),  #D4
   Family("C1",[27]),
   # C2 changed to C2d Gunter 22/9/99, then to C2h on 26.2.2003:
   Family(CartesianFamilies(CHEVIE.families.X(3),"C2d"),
    [ 97, 102, 316, 318, 99, 100, 317, 319, 315, 314, 320, 321 ],
     rec(delta1:=[ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, -1, -1 ])),
   Family(CartesianFamilies(ConjugateFamily(CHEVIE.families.X(3)),"X5"),
     [108,88,327,323,34,36,90,328,322,110,325,326,329,115,324],
     rec(delta1:=[1,1,1,1,-1,-1,1,1,1,1,1,1,-1,1,1])),
   Family(CHEVIE.families.QZ(3),[80,69,70,41,332,331,44,330,333],
                         rec(delta1:=[1,1,1,1,1,1,1,-1,-1])),  #\bar I3^5
   Family(CHEVIE.families.QZ(3),[25,30,29,58,334,337,60,336,335],
     rec(delta1:=[1,-1,-1,1,-1,-1,1,1,1],special:=4,cospecial:=7)), #\bar I3^4
   Family(CartesianFamilies(ConjugateFamily(CHEVIE.families.X(3)),"X5"),
     [40,56,343,339,7,9,54,344,338,43,341,342,345,38,340],
     rec(delta1:=[1,1,-1,1,1,1,1,-1,1,1,1,1,-1,1,1])),
   Family("C2",[23,13,19,346]),  #D4
   Family(CHEVIE.families.X(3),[18,16,347]), #\bar I3^3
   Family(CHEVIE.families.X(3),[6,4,348]), #\bar I3^3
   Family("C1",[2])],
 a:=[0,126,1,85,1,85,46,4,46,4,15,15,57,3,2,68,2,68,57,3,28,10,57,3,41,5,45,9,
  41,41,5,5,7,31,7,31,4,46,6,46,36,4,46,36,6,4,13,19,13,19,15,15,4,46,4,46,5,41,
  5,41,18,27,9,19,13,30,12,6,36,36,6,11,23,11,23,28,28,10,10,36,6,19,13,10,28,
  10,28,31,7,31,7,13,19,13,19,8,29,8,29,29,8,29,8,27,9,18,7,31,7,31,13,19,13,19,
  31,7,19,13,15,15,15,15,27,9,18,15,15,23,11,14,20,14,20,11,23,11,23,15,15,24,
  10,24,10,24,10,13,19,13,19,13,19,13,19,11,23,11,23,21,12,21,12,13,19,13,19,15,
  15,15,15,1,2,3,4,4,4,4,4,4,4,4,5,5,5,5,6,6,6,6,7,7,7,7,7,7,7,7,8,8,8,8,8,8,8,
  8,9,10,10,10,10,10,10,10,10,10,10,11,11,11,11,11,12,12,13,13,13,13,13,13,13,
  13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,15,15,15,15,15,15,15,15,15,15,15,
  15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,18,20,19,19,19,19,19,19,
  19,19,19,19,19,19,19,19,19,19,19,19,19,19,19,21,21,23,23,23,23,23,24,24,24,
  24,24,24,28,28,28,28,27,29,29,29,29,29,29,29,29,31,31,31,31,31,31,31,31,36,
  36,36,36,41,41,41,41,46,46,46,46,46,46,46,46,57,68,85],
 A:=[0,126,41,125,41,125,122,80,122,80,111,111,123,69,58,124,58,124,123,69,116,
  98,123,69,121,85,117,81,121,121,85,85,95,119,95,119,80,122,90,122,120,80,122,
  120,90,80,107,113,107,113,111,111,80,122,80,122,85,121,85,121,108,117,99,113,
  107,114,96,90,120,120,90,103,115,103,115,116,116,98,98,120,90,113,107,98,116,
  98,116,119,95,119,95,107,113,107,113,97,118,97,118,118,97,118,97,117,99,108,
  95,119,95,119,107,113,107,113,119,95,113,107,111,111,111,111,117,99,108,111,
  111,115,103,106,112,106,112,103,115,103,115,111,111,116,102,116,102,116,102,
  107,113,107,113,107,113,107,113,103,115,103,115,114,105,114,105,107,113,107,
  113,111,111,111,111,41,58,69,80,80,80,80,80,80,80,80,85,85,85,85,90,90,90,90,
  95,95,95,95,95,95,95,95,97,97,97,97,97,97,97,97,99,98,98,98,98,102,102,102,
  102,102,102,103,103,103,103,103,105,105,107,107,107,107,107,107,107,107,107,
  107,107,107,107,107,107,107,107,107,107,107,107,106,111,111,111,111,111,111,
  111,111,111,111,111,111,111,111,111,111,111,111,111,111,111,111,111,111,111,
  111,111,111,108,112,113,113,113,113,113,113,113,113,113,113,113,113,113,113,
  113,113,113,113,113,113,113,114,114,115,115,115,115,115,116,116,116,116,116,
  116,116,116,116,116,117,118,118,118,118,118,118,118,118,119,119,119,119,119,
  119,119,119,120,120,120,120,121,121,121,121,122,122,122,122,122,122,122,122,
  123,124,125]);
end);

# for the next function see
# Conway & Sloane Math.Proc.Camb.Phil.Soc. 93(1983) p.437
# and Orlik, Contemporary Math. vol. 90 (1989) p. 226
CHEVIE.AddData("Invariants","G34",function()local r;
 r:=ComplexReflectionGroup(34).roots; return [
 function(x,y,z,t,u,v) return Sum(r,a->([x,y,z,t,u,v]*a)^6)/1944;end,
 function(x,y,z,t,u,v) return Sum(r,a->([x,y,z,t,u,v]*a)^12)/3888;end,
 function(x,y,z,t,u,v) return Sum(r,a->([x,y,z,t,u,v]*a)^18)/1944;end,
 function(x,y,z,t,u,v) return Sum(r,a->([x,y,z,t,u,v]*a)^24)/7776;end,
 function(x,y,z,t,u,v) return Sum(r,a->([x,y,z,t,u,v]*a)^30)/1944;end,
 function(x,y,z,t,u,v) return Sum(r,a->([x,y,z,t,u,v]*a)^42)/1944;end];
end);
